\name{SurvKit4R-package}
\alias{SurvKit4R-package}
\alias{SurvKit4R}
\docType{package}
\title{
R interface for the Survival Kit
}
\description{
This is an R interface for the Survival Kit program, 
 originally written in Fortran 90. The R package creates parameter files according to specific requirements, sorts data sets and executes pre compiled Survival Kit
 programs from the R working directory.
}
\details{
\tabular{ll}{
Package: \tab SKit4R\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2016-03-02\cr
License: \tab GPL (version 3 or later)\cr
LazyLoad: \tab yes\cr
}
The package consists of an over arching function (SKit4R) which calls other functions such as prepare4R, coxWei4R, sortSKit and GramChar. The main idea is to run the Survival Kit interface using the over arching function, which benefits from a number of simplifications for the cost of accepting default input and output file names. All sub functions are usable separately as well, sortSKit and GramChar even outside of the context of the Survival Kit program.
}
\author{
Vincent Ducrocq, Johann Soelkner, Gabor Meszaros \cr
Maintainer: Gabor Meszaros <gabor.meszaros@boku.ac.at>
}
\references{
The source code, compiled executable files, manual, reference paper and support programs for the Survival Kit can be found at: http://www.nas.boku.ac.at/nuwi/the-survival-kit/ \cr
The preferred citation of the software including the usage of the R interface is: \cr
Meszaros, G., Soelkner, J., Ducrocq, V. (2013): The Survival Kit: Software to analyze survival data including possibly correlated random effects. Computer Methods and Programs in Biomedicine, 110(3): 503-510. DOI:10.1016/j.cmpb.2013.01.010
}
