\name{sortSKit}
\alias{sortSKit}
\title{
sortSKit
}
\description{
Function sortSKit was primarily intended to create an alternative option to sort data files for the Survival Kit  (Ducrocq and Soelkner, 1998), when using the COX program. Later it was extended to sort text files with sorting criteria up to three columns (both ascending and descending order).
}
\usage{
sortSKit(inputFile, outputFile = "sorted.txt", mode = "default", 
strata = 0, order1 = 0, order2 = 0, order3 = 0, wdNew = " ", 
wdSetBack = TRUE)
}
\arguments{
  \item{inputFile}{
The name of the file needs to be sorted. Must exist in the R working directory.
}
  \item{outputFile}{
The name of the sorted file created by the function. If this file already exists, it will be overwritten without any further warning! If no filename is specified, an output file "sorted.txt" will be created.
}
  \item{mode}{
There are two possibilities:
\emph{"default"}  Column numbers for sorting specified by the user. If no \emph{mode} is specified, this option will be used.
\emph{"cox"} This sorts the \emph{input\_file} according to the requirements of the Survival Kits' COX program, without need to specify anything else. Use the \emph{strata} keyword in case of stratified survival analysis. 
}
  \item{strata}{
Sets the number of column for the strata variable required if STRATA statement is used in the COX program (check Survival Kit manual for details). This statement works only in the \emph{"cox"} mode. If you need to sort for one column only, use keyword \emph{order1} instead.
}
  \item{order1}{
User defined numbers corresponding to column 1 to be sorted. A positive to value results to an ascending, a negative value to a descending sort. These statements work only in the \emph{"default"} mode.
}
  \item{order2}{
User defined numbers corresponding to column 2 to be sorted. A positive to value results to an ascending, a negative value to a descending sort. These statements work only in the \emph{"default"} mode.
}
  \item{order3}{
User defined numbers corresponding to column 3 to be sorted. A positive to value results to an ascending, a negative value to a descending sort. These statements work only in the \emph{"default"} mode.
}
  \item{wdNew}{
Sets the R working directory to one specified by the user (for example: "C:/newDirectory").
}
  \item{wdSetBack}{
If FALSE is specified here, the R working directory remains the same as set in \emph{wdNew}. 
}
}
\author{
Gabor Meszaros <gabor.meszaros@boku.ac.at> \cr
University of Natural Resources and Life Sciences, Vienna \cr
Division of Livestock Sciences, Vienna, Austria
}
\references{
The source code, compiled executable files, manual, reference paper and support programs for the Survival Kit can be found at: http://www.nas.boku.ac.at/nuwi/the-survival-kit/ \cr
The preferred citation of the software including the usage of the R interface is: \cr
Meszaros, G., Soelkner, J., Ducrocq, V. (2013): The Survival Kit: Software to analyze survival data including possibly correlated random effects. Computer Methods and Programs in Biomedicine, 110(3): 503-510. DOI:10.1016/j.cmpb.2013.01.010
}

