      SUBROUTINE BASELINE(NDIM1,NBASE,NSURV,NKAPLAN,BETA1)
C***********************************************************************
C  BASELINE      *                                    *  11 / 10 /1993 *
C***********************************************************************
C  COMPUTE THE BASELINE CUMLATIVE HAZARD XLAMB0(T) AND THE SURVIVOR    *
C     FUNCTION S0(T) USING BRESLOW'S FORMULA (BRESLOW, 1974)           *
C***********************************************************************
c
      use parinclu2
c
      implicit none
      integer,allocatable :: irest(:)  !IREST(NSTIMAX)
      integer,allocatable :: iresq(:)  !IRESQ(NSTIMAX)
      real*8,allocatable :: rest(:)    !REST(NSTIMAX)
      real*8,allocatable :: LOGT(:),LOGLOGS0(:)       !all NTIMMAX
      real*8,allocatable :: XLAMB0(:),S0(:),VARS0(:)  !all NTIMMAX
      integer,allocatable :: IRANGE(:,:)                !IRANGE(2,0:MXSTRA)
      integer,allocatable :: JRANGE(:,:)                !JRANGE(2,0:MXSTRA)
      integer,allocatable :: NPERM(:)   	            !NPERM(NRECMAX)  
      real*8,allocatable :: XRESI(:)                    !XRESI(NRECMAX)
	  
      INTEGER NDIM1,NSURV,NBASE,NKAPLAN
      INTEGER IDICHO,ILT,ILT2,IHT,KLT,KLT2,IDIF,IMID,IS,IQ,IT,JST
      INTEGER I,J,JJ,K,K2,KK,N,ICODE,ISTR
      INTEGER IPRESTR,LTAB,IFAIL,IPRETIM,ISUP
C
      INTEGER IANI,IANIPREV,NEXTJUMP
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c added on October 9, 1997
      INTEGER NRESI
      REAL*8 XRISK,XCEN,XDIE,TOTDIE,XIC,XMART,XDEV
      REAL*8 S,DLOGS,EXPEC
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      INTEGER IC_PREV,NS_PREV
C
C
      REAL*8 REG(20),BETA1(*) 
      REAL*8 CUM_RISK,CUM_RIS2,CUM_RSKP,U,UMINUS,W,WMINUS,XFAIL,XCOV,R
      REAL*8 XSTIME,XL_PREV,SX,SX2
C
!      EQUIVALENCE (INFO(1,1),KREC(1))
!      EQUIVALENCE (INFO2(1,1),KREC2(1))
!      EQUIVALENCE (IDATA(1,1),XDATA(1,1))
!      EQUIVALENCE (IDATA2(1,1),XDATA2(1,1))
C

      allocate(IREST(NSTIMAX))
      allocate(IRESQ(NSTIMAX)) 
      allocate(REST(NSTIMAX))
      allocate( XLAMB0(NTIMMAX),S0(NTIMMAX),VARS0(NTIMMAX) )
      allocate( LOGT(NTIMMAX),LOGLOGS0(NTIMMAX) )
      allocate( IRANGE(2,0:MXSTRA),JRANGE(2,0:MXSTRA) )	  
      allocate( NPERM(NRECMAX),XRESI(NRECMAX))

C-----------------------------------------------------------------------
C  INITIALIZATION
C-----------------------------------------------------------------------
C
      XFAIL = 0.D0
      IPRESTR=0
      CUM_RISK = 0.D0
      IPRETIM = 0
      IT = 0
      IRANGE(2,0) = 0
	  
cR output file for plotting in R	  
      if (useR) then
        OPEN(50,file='RKaplan.txt' ,status='unknown')
        OPEN(51,file='RBaseline.txt' ,status='unknown')
      endif
C
C-----------------------------------------------------------------------
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IF (nstor.ne.1)
     + OPEN(4,file=file(9),status='old',FORM='UNFORMATTED')

  100 IF (NSTOR.NE.1) THEN
       READ(4,END=199) NREC,LTAB,
     +  ((blockb%info(i,j),i=1,3),j=1,nrecmax),
     +  ((blockb%idata(i,j),i=1,mxef_used),j=1,nrecmax),
     +	((blockb%xdata(i,j),i=1,mxef_used),j=1,nrecmax)
      ENDIF
C
C-----------------------------------------------------------------------
C   FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
      DO 190 I=1,NREC
C
C-----------------------------------------------------------------------
C   IF FIRST RECORD :
C       IRANGE(1,*) = STRATUM LABEL = blockb%info(3,I)
C       IRANGE(2,*) = INDEX OF LARGEST TIME OF S0(T)
C-----------------------------------------------------------------------
       IF (IPRETIM.EQ.0) THEN
       ISTR=1
       IRANGE(1,ISTR)= blockb%info(3,I)
       ENDIF
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD WAS THE LAST RECORD WITH TIME = IPRETIM
C   UPDATE XLAMB0(T) AND XJUMP(T)
C   XFAIL IS THE NUMBER FAILING AT TIME IPRETIM
C-----------------------------------------------------------------------
       IF ((blockb%info(1,I).NE.IPRETIM).AND.(IPRETIM.NE.0)) THEN
       IF ((CUM_RISK.GT.1.D-10).AND.(XFAIL.NE.0)) THEN
            IT=IT+1
            IF (IT.GT.NTIMMAX) THEN
             WRITE(6,9000) NTIMMAX
             STOP
            ENDIF
            XJUMP(IT)= IPRETIM
            XLAMB0(IT) = XFAIL / CUM_RISK
            IF (NKAPLAN.EQ.1) THEN
             S0(IT) = 1.D0 - XLAMB0(IT)
             IF (CUM_RISK.NE.XFAIL)
     +        VARS0(IT) = XFAIL / ((CUM_RISK - XFAIL)*CUM_RISK)
            ENDIF
            XFAIL = 0.D0
       ENDIF
       ENDIF
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD HAS A DIFFERENT STRATUM ID ==> NEW STRATUM
C   SET TO ZERO THE LAST (=TIME 0) CONTRIBUTION TO XLAMB0
C   INITIALIZE CUM_RISK (CUMULATIVE RISK FOR ALL ANIMALS)
C-----------------------------------------------------------------------
       IPRETIM =blockb%info(1,I)
       ICODE = blockb%info(2,I)
       IF (NSTRATA.GT.1) THEN
       IF (blockb%info(3,I).NE.IPRESTR) THEN
             IF (IPRESTR.NE.0) THEN
             IT = IT + 1
             IF (IT.GT.NTIMMAX) THEN
                  WRITE(6,9000) NTIMMAX
                  STOP
             ENDIF
             XJUMP(IT)= 0
             XLAMB0(IT) = 0.D0
             S0(IT) = 0.D0
             VARS0(IT) = 0.D0
             IRANGE(2,ISTR)= IT
C
             CUM_RISK = 0.D0
             ISTR= ISTR + 1
             IF (ISTR.GT.MXSTRA) THEN
             WRITE(6,9010) MXSTRA
             STOP
             ENDIF
             IRANGE(1,ISTR)= blockb%info(3,I)
             ENDIF
             IPRESTR=blockb%info(3,I)
       ENDIF
       ENDIF
       IF (NKAPLAN.EQ.1) THEN
       IF (ICODE.GE.0) CUM_RISK= CUM_RISK + 1.D0
       IF (ICODE.EQ.-2) CUM_RISK= CUM_RISK - 1.D0
       GOTO 189
       ENDIF
C-----------------------------------------------------------------------
C   U = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C   UMINUS = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT AFTER CHANGE
C-----------------------------------------------------------------------
       U = 0.D0
       UMINUS = 0.D0
C-----------------------------------------------------------------------
C        IPLUS1/2 = 0 FOR TIME-INDEPENDENT COVARIATES
C             ==> CONTRIBUTES TO U (AND TO UMINUS IF NOT LAST RECORD)
C        IPLUS1/2 = +1 FOR TIME-DEPENDENT (BEFORE CHANGE)
C             ==> CONTRIBUTES TO U EXCEPT IF LEFT TRUNCATED RECORD
C        IPLUS1/2 = -1 FOR TIME-DEPENDENT (AFTER CHANGE)
C             ==> CONTRIBUTES TO UMINUS IF NOT LAST RECORD
C     FIRST, IR1 CONTINUOUS COVARIATES, THEN IR2 DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => EXP(Z'* BETA1) WILL BE = 0
C-----------------------------------------------------------------------
       K = 0
       DO 35 J=1,IR1
       IF (IANAL1(J).NE.0) THEN
            XCOV = blockb%xdata(J,I)
            IF (IPLUS1(J).GT.0) THEN
             K = K+1
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
             IF (ICODE.GE.-1) U = U + R
            ELSE IF (IPLUS1(J).EQ.0) THEN
             K = K+1
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement :
c            U = U + R
c was corrected on October 16, 1996 for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.NE.-2) U = U + R
             IF (ICODE.LT.0) UMINUS= UMINUS + R
            ELSE IF (ICODE.LT.0) THEN
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
             UMINUS = UMINUS + R
            ENDIF
       ENDIF
   35     CONTINUE
       DO 36 J=1,IR2
       JJ = J + IR1
       IF (IANAL2(J).NE.0) THEN
            K = blockb%idata(JJ,I)
            IF (IPLUS2(J).GT.0) THEN
             IF (ICODE.GE.-1) U = U + BETA1(K)
            ELSE IF (IPLUS2(J).EQ.0) THEN
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement :
c            U = U + BETA1(K)
c was corrected on October 16, 1996 for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.NE.-2) U = U + BETA1(K)
             IF (ICODE.LT.0) UMINUS = UMINUS + BETA1(K)
            ELSE IF (ICODE.LT.0) THEN
             UMINUS = UMINUS + BETA1(K)
            ENDIF
       ENDIF
   36     CONTINUE
C
C-----------------------------------------------------------------------
C   COMPUTE W = EXP(U) AND WMINUS = EXP(UMINUS) AND UPDATE CUM_RISK
C            DEPENDING ON CODE
C-----------------------------------------------------------------------
       W = 0.D0
       WMINUS = 0.D0
       IF (U.GT.-20.D0) W = DEXP(U)
       IF (ICODE.GE.0) THEN
       CUM_RISK = CUM_RISK + W
       ELSE IF (ICODE.EQ.-1) THEN
       IF (UMINUS.GT.-20.D0) WMINUS = DEXP(UMINUS)
       CUM_RISK = CUM_RISK + W - WMINUS
       ELSE IF (ICODE.LE.-2) THEN
       IF (UMINUS.GT.-20.D0) WMINUS = DEXP(UMINUS)
       CUM_RISK = CUM_RISK - WMINUS
       ENDIF
C
  189   IF (ICODE.GE.1) XFAIL = XFAIL + 1.D0
C
  190 CONTINUE
      IF (NSTOR.NE.1) GOTO 100
  199 IF (NSTOR.NE.1) CLOSE(4)
C
C-----------------------------------------------------------------------
C   LAST "TRUE" CONTRIBUTION TO XLAMB0(T)
C-----------------------------------------------------------------------
      IF ((CUM_RISK.GT.1.D-10).AND.(XFAIL.NE.0)) THEN
       IT=IT+1
       IF (IT.GT.NTIMMAX) THEN
       WRITE(6,9000) NTIMMAX
       STOP
       ENDIF
       XJUMP(IT)= IPRETIM
       XLAMB0(IT) = XFAIL / CUM_RISK
       IF (NKAPLAN.EQ.1) THEN
       S0(IT) = 1.D0 - XLAMB0(IT)
       VARS0(IT) = XFAIL / ((CUM_RISK - XFAIL)*CUM_RISK)
       ENDIF
      ENDIF
C-----------------------------------------------------------------------
C   SET TO ZERO THE LAST (=TIME 0) CONTRIBUTION TO XLAMB0
C-----------------------------------------------------------------------
      IT=IT+1
      IF (IT.GT.NTIMMAX) THEN
       WRITE(6,9000) NTIMMAX
       STOP
      ENDIF
      XJUMP(IT)= 0
      XLAMB0(IT) = 0.D0
      S0(IT) = 0.D0
      VARS0(IT) = 0.D0
      IRANGE(2,ISTR) = IT
C
C-----------------------------------------------------------------------
C   CUMULATE THE CONTRIBUTIONS TO XLAMB0 AND COMPUTE S0(T)
C   IF KAPLAN-MEIER (NKAPLAN=1) MULTIPLY CONTRIBUTIONS TO S0,
C          AND COMPUTES NELSON'S ESTIMATE AND A 95% INTERVAL
C          FOR S0(T) (KALBFLEISH AND PRENTICE P13-15)
C   PRINT IF NBASE IS NOT 0
C-----------------------------------------------------------------------
      IF (NBASE.NE.0) WRITE(12,9015)
      IF (NKAPLAN.EQ.1) WRITE(12,9018)
      DO 250 I=1,ISTR
       IF (NBASE.NE.0) THEN 
          WRITE(12,9040)I,TRIM(LABEL(ISTRVAR)),
     +                    (IOLCODST(I,J),J=1,NCOL(0)) 
          WRITE(12,9041)
          WRITE(12,9046)
cR output file for plotting in R
          if (useR) write(51,9046)
       ENDIF
       IF (NKAPLAN.EQ.1) THEN
          WRITE(12,9042) I,TRIM(LABEL(ISTRVAR)),
     +           (IOLCODST(I,J),J=1,NCOL(0))
          WRITE(12,9043)
          WRITE(12,9044)
cR output file for plotting in R
          if (useR) write(50,9044)
       ENDIF
       K = IRANGE(2,I)
       K2 = IRANGE(2,I-1)+1
       S0(K) = DEXP(-XLAMB0(K))
       N = 0
       DO 200 J=K-1,K2,-1
       IF (XJUMP(J).LT.1.D-4) GOTO 200
       N = N+1
       XLAMB0(J) = XLAMB0(J) + XLAMB0(J+1)
       LOGT(J)= DLOG(XJUMP(J))
       LOGLOGS0(J)= DLOG(XLAMB0(J))
       IF (NKAPLAN.NE.1) THEN
             S0(J) = DEXP(-XLAMB0(J))
             IF (NBASE.NE.0) THEN
              KK = INT(XJUMP(J)+0.05)
              WRITE(12,9050) KK,XLAMB0(J),S0(J)
cR output file for plotting in R
              if (useR) write(51,9050) KK,XLAMB0(J),S0(J)
             ENDIF
       ELSE
             IF (S0(J+1).LT.1.D-8) GOTO 200
             KK = INT(XJUMP(J)+0.05)
             S0(J) = S0(J) * S0(J+1)
             IF (S0(J).GT.1.D-8) THEN
             U = DLOG(S0(J))
             VARS0(J) = VARS0(J) + VARS0(J+1)
             R = DSQRT(VARS0(J)) / DABS(U)
             LOGLOGS0(J)= DLOG(-U)
             W = DEXP(DEXP(-1.96D0* R)* U)
             U = DEXP(DEXP(1.96D0* R)* U)
             ELSE
             U = 0.D0
             W = 0.D0
             ENDIF
             WRITE(12,9052) KK,S0(J),U,W,XLAMB0(J)
cR output file for plotting in R
        if (useR) write(50,9052) KK,S0(J),U,W,XLAMB0(J)
       ENDIF
  200     CONTINUE

  250 CONTINUE
      IF (NKAPLAN.EQ.1) RETURN
C-----------------------------------------------------------------------
C   FUTURE RECORDS :
C-----------------------------------------------------------------------
      IF (NSURV.EQ.1) THEN
C-----------------------------------------------------------------------
C  RETURN IF NO INTEREST IN THE SURVIVOR CURVE OF PARTICULAR ANIMALS
C-----------------------------------------------------------------------
        IF (NALL_TIM.EQ.0.AND.NQUANT.EQ.0.AND.NSTIME.EQ.0) RETURN
C-----------------------------------------------------------------------
C   COMPUTATION OF (PART OF) THE SURVIVOR CURVE FOR ANIMALS IN FILE 3
C
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IANIPREV=-999
      IT = 0
      WRITE(13,9100)
  300 IF (NSTOR.NE.1) THEN
       OPEN(7,file=file(10),FORM='UNFORMATTED')
       READ(7,END=399) NREC2,LTAB,
     +  ((blockb2%info2(i,j),i=1,4),j=1,nrecmax2),
     +  ((blockb2%idata2(i,j),i=1,mxef_used),j=1,nrecmax2),
     +	((blockb2%xdata2(i,j),i=1,mxef_used),j=1,nrecmax2)
       ENDIF
C
C-----------------------------------------------------------------------
C      FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
       DO 390 I=1,NREC2
       IANI=blockb2%info2(4,I)
       IF (IANI.NE.IANIPREV) THEN
            NSTR = MAX(1,blockb2%info2(3,I))
            ILT = IRANGE(2,NSTR)
            IHT = IRANGE(2,NSTR-1)+1
            CUM_RSKP = 0.D0
            XL_PREV = 0.D0
            ISUP = 0
            IS = 1
            IQ = 1
            IF (IANIPREV.NE.-999) THEN
             WRITE(13,*) ' '
             DO 270 J = 1,IT
             WRITE(13,9120) IANIPREV,IREST(J),REST(J)
             REST(J)=0.D0
  270         CONTINUE
             DO 275 J = 1,NQUANT
             WRITE(13,9110) IANIPREV,SQUANT(J),IRESQ(J)
             IRESQ(J)=0
  275         CONTINUE
             IT = 0
            ENDIF
            IANIPREV = IANI
       ENDIF
c       NEXTJUMP =blockb2%info2(1,I)
       NEXTJUMP =MIN(blockb2%info2(1,I),INT(XJUMP(IHT)+0.5))
       ICODE = blockb2%info2(2,I)
C-----------------------------------------------------------------------
C   U = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C-----------------------------------------------------------------------
       U = 0.D0
C-----------------------------------------------------------------------
C        IPLUS1/2 = 0 FOR TIME-INDEPENDENT COVARIATES
C        IPLUS1/2 = +1 FOR TIME-DEPENDENT (BEFORE CHANGE)
C             ==> CONTRIBUTES TO U
C        IPLUS1/2 = -1 FOR TIME-DEPENDENT (AFTER CHANGE)
C             ==> NOT RELEVANT HERE
C     FIRST, IR1 CONTINUOUS COVARIATES, THEN IR2 DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => EXP(Z'* BETA1) WILL BE = 0
C-----------------------------------------------------------------------
       K = 0
       DO 305 J=1,IR1
       IF (IANAL1(J).NE.0) THEN
             XCOV = blockb2%xdata2(J,I)
             IF (IPLUS1(J).GE.0) THEN
             K = K+1
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
             U = U + R
             ENDIF
       ENDIF
  305     CONTINUE
       DO 306 J=1,IR2
            JJ = J + IR1
            IF (IANAL2(J).NE.0) THEN
             K = blockb2%idata2(JJ,I)
             IF (IPLUS2(J).GE.0) U = U + BETA1(K)
            ENDIF
  306     CONTINUE
C
C-----------------------------------------------------------------------
C  COMPUTE W = EXP(U)
C-----------------------------------------------------------------------
       W = 0.D0
       IF (U.GT.-20.D0) W = DEXP(U)
C
C-----------------------------------------------------------------------
C  IF THERE ARE SPECIFIC TIMES IN VECTOR ISTIME FOR WHICH S(T) IS TO
C        BE COMPUTED (I.E., IF NSTIME>0)
C    ==> CHECK WHETHER THE FIRST ONE (ISTIME(IS)) IS LESS THAN NEXTJUMP
C        COMPUTE  S(MIN( ISTIME(IS), NEXTJUMP))
C-----------------------------------------------------------------------
  310     IF ((NSTIME.EQ.0).OR.(IS.GT.NSTIME)) GOTO 320
       IF (ISTIME(IS).LT.NEXTJUMP) THEN
             XSTIME = DBLE(ISTIME(IS))
             JST = 1
C
C-----------------------------------------------------------------------
C   XSTIME = NEXT ELEMENT IN VECTOR ISTIME
C   SEARCH FOR XSTIME IN VECTOR XJUMP = SEARCH FOR THE INDEX IND FOR
C   WHICH XJUMP(IND) IS AS LARGE AS POSSIBLE BUT < OR = TO XSTIME
C   USE DICHOTOMOUS SEARCH FUNCTION IDICHO. IF IDICHO() = KLT = 0,
C   XSTIME IS LARGER THAN THE LARGEST TIME FOR THIS STRATUM
C    => XLAMB0(XSTIME) LARGER THAN OR EQUAL (INDICATED BY ISUP=1)
C   TO XLAMB0(KLT) OTHERWISE XLAMB0(XSTIME) = XLAMB0(KLT)
C-----------------------------------------------------------------------
             KLT = IDICHO(ILT,IHT,XSTIME)
             IF (KLT.EQ.0) THEN
             ISUP = 1
             CUM_RISK = CUM_RSKP + W * (XLAMB0(IHT) - XL_PREV)
             SX = DEXP( - CUM_RISK)
             ELSE
             CUM_RISK = CUM_RSKP + W * (XLAMB0(KLT) - XL_PREV)
             SX = DEXP( - CUM_RISK)
             ENDIF
             goto 325
       Endif
  320        XSTIME = DBLE(NEXTJUMP)
             JST = 0
             IF (ISTIME(IS).EQ.NEXTJUMP) JST=2
C
C-----------------------------------------------------------------------
C   AS BEFORE WITH XSTIME = NEXTJUMP
C-----------------------------------------------------------------------
             KLT = IDICHO(ILT,IHT,XSTIME)
             IF (KLT.EQ.0) THEN
             ISUP = 1
             CUM_RISK = CUM_RSKP + W * (XLAMB0(IHT) - XL_PREV)
             SX = DEXP( - CUM_RISK)
             ELSE
             CUM_RISK = CUM_RSKP + W * (XLAMB0(KLT) - XL_PREV)
             SX = DEXP( - CUM_RISK)
             ENDIF
C-----------------------------------------------------------------------
C  IF NQUANT>0 AND IQ <=NQUANT, THERE ARE QUANTILES TO BE COMPUTED
C  CHECK WHETHER SX IS SMALLER THAN SQUANT(IQ)
C  IF THE ANSWER IS YES, SEARCH FOR THE TIME XSTIME2<= XSTIME SUCH THAT
C  S(XSTIME2-1) > SQUANT(IQ) AND S(XTIME2)<= SQUANT(IQ)
C-----------------------------------------------------------------------
  325     ILT2 = ILT
       KLT2 = KLT
       IMID = KLT2
       IF ((NQUANT.EQ.0).OR.(IQ.GT.NQUANT)) GOTO 340
       IF (SX.LE.SQUANT(IQ)) THEN
             IDIF = ILT2- KLT2
             K = INT(XJUMP(IMID)+0.5)
             IF (IDIF.LE.1) THEN
             IRESQ(IQ) = K
             IQ = IQ + 1
             GOTO 325
             ENDIF
  330        IDIF = ILT2 - KLT2
             IF (IDIF.LE.1) THEN
             IF (SX2.GT.SQUANT(IQ)) IMID = IMID-1
             K = INT(XJUMP(IMID)+0.5)
             IRESQ(IQ) = K
             IQ = IQ + 1
             GOTO 325
             ELSE
             IMID = ILT2 - IDIF/2
             CUM_RIS2 = CUM_RSKP + W * (XLAMB0(IMID) - XL_PREV)
             SX2 = DEXP( - CUM_RIS2)
             IF (SX2.LE.SQUANT(IQ)) THEN
                  KLT2 = IMID
                  GOTO 330
             ELSE
                  ILT2 = IMID
                  GOTO 330
             ENDIF
             ENDIF
       ELSE IF (ISUP.EQ.1) THEN
             K = INT(XJUMP(IHT)+0.5)
             WRITE(13,9130) K,SX,SQUANT(IQ),IANI
             IRESQ(IQ) = K
             IQ = NQUANT + 1
       ENDIF
C
  340     IF (JST.GE.1) THEN
            IF (ISUP.EQ.1) THEN
             K = INT(XJUMP(IHT)+0.5)
             WRITE(13,9140) ISTIME(IS),K
             IS = NSTIME
            ENDIF
            IT = IT + 1
            IREST(IT) = ISTIME(IS)
            REST(IT) = SX
            IS = IS + 1
            ILT = KLT
            IF (JST.EQ.2.AND.ISUP.NE.1) THEN
             CUM_RSKP = CUM_RISK
             XL_PREV = XLAMB0(ILT)
             GOTO 390
            ELSE
             GOTO 310
            ENDIF
       ELSE
            IF (NALL_TIM.EQ.1) THEN
             IF (ISUP.EQ.1) THEN
             K = INT(XJUMP(IHT)+0.5)
             WRITE(13,9140) NEXTJUMP,K
             ENDIF
             IT = IT + 1
             IREST(IT) = NEXTJUMP
             REST(IT) = SX
            ENDIF
            ILT = KLT
            CUM_RSKP = CUM_RISK
            XL_PREV = XLAMB0(ILT)
       ENDIF
C
  390   CONTINUE
       IF (NSTOR.NE.1) GOTO 300
C
  399   IF (NSTOR.NE.1) CLOSE(7)
       WRITE(13,*) ' '
       DO 370 J = 1,IT
       WRITE(13,9120) IANI,IREST(J),REST(J)
  370   CONTINUE
       DO 375 J = 1,NQUANT
       WRITE(13,9110) IANI,SQUANT(J),IRESQ(J)
  375   CONTINUE
C
C-----------------------------------------------------------------------
C   RESIDUALS :
C-----------------------------------------------------------------------
      ELSE
C-----------------------------------------------------------------------
C   COMPUTATION OF GENERALIZED RESIDUALS FOR ANIMALS IN FILE 3
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IANIPREV=-999
      IS = 0
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c added on October 9, 1997
      NRESI=0
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 500  IF (NSTOR.NE.1) THEN
       OPEN(7,file=file(10),FORM='UNFORMATTED')
       READ(7,END=599) NREC2,LTAB,
     +  ((blockb2%info2(i,j),i=1,4),j=1,nrecmax2),
     +  ((blockb2%idata2(i,j),i=1,mxef_used),j=1,nrecmax2),
     +	((blockb2%xdata2(i,j),i=1,mxef_used),j=1,nrecmax2)
       IF (NSTRATA.GT.1) WRITE(13,9520) MAX(1,blockb2%info2(3,1))
       WRITE(13,9505)
 9505  FORMAT(1X,'TIME   ANIMAL  CENSORING  STRATUM GENERALIZED ',
     +      '   MARTINGALE       DEVIANCE ',/1X,
     +      '                  CODE              RESIDUAL   ',
     +      '    RESIDUAL       RESIDUAL')
      ENDIF
C
C-----------------------------------------------------------------------
C   FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
       DO 590 I=1,NREC2
         IANI=blockb2%info2(4,I)
         IF (IANI.NE.IANIPREV) THEN
            NSTR = MAX(1,blockb2%info2(3,I))
            ILT = IRANGE(2,NSTR)
            IHT = IRANGE(2,NSTR-1)+1
            IF (IANIPREV.NE.-999.AND.IS.NE.1) THEN
              IF (NSTOR.NE.1) THEN
                XIC = DBLE(IC_PREV)
                XMART = XIC -CUM_RSKP
                XDEV = -2.D0 * (XMART +XIC * DLOG(XIC-XMART))
                XDEV=DSQRT(XDEV)
                IF (XMART.LT.0.D0) XDEV=-XDEV
                WRITE(13,9500) IPRETIM,IANIPREV,IC_PREV,NS_PREV,
     +             CUM_RSKP,XMART,XDEV
 9500           FORMAT(I5,1X,I8,1X,I7,3X,I5,3(1X,F14.7))
               IF (NSTRATA.GT.1) THEN
                  IF (NSTR.NE.NS_PREV) THEN
                     WRITE(13,9520) NSTR
                     WRITE(13,9505)
                  ENDIF
                ENDIF
              ELSE
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c added on October 9, 1997
                NRESI=NRESI+1
                blockb2%info2(1,NRESI)=IANIPREV
                blockb2%info2(2,NRESI)=IC_PREV
                blockb2%info2(3,NRESI)=NS_PREV
                XRESI(NRESI)=CUM_RSKP
                IF (JRANGE(1,NS_PREV).EQ.0) JRANGE(1,NS_PREV)=NRESI
                JRANGE(2,NS_PREV)=NRESI
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
              ENDIF
            ENDIF
            CUM_RSKP = 0.D0
            XL_PREV = 0.D0
            ISUP = 0
            IS = 0
            IANIPREV = IANI
         ELSE IF (IS.EQ.1) THEN
           GOTO 590
         ENDIF
         ICODE = blockb2%info2(2,I)
         IF (ICODE.EQ.-2) THEN
           IS=1
           GOTO 590
         ENDIF
         NEXTJUMP =blockb2%info2(1,I)
C-----------------------------------------------------------------------
C   U = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C-----------------------------------------------------------------------
         U = 0.D0
C-----------------------------------------------------------------------
C        IPLUS1/2 = 0 FOR TIME-INDEPENDENT COVARIATES
C        IPLUS1/2 = +1 FOR TIME-DEPENDENT (BEFORE CHANGE)
C             ==> CONTRIBUTES TO U
C        IPLUS1/2 = -1 FOR TIME-DEPENDENT (AFTER CHANGE)
C             ==> NOT RELEVANT HERE
C     FIRST, IR1 CONTINUOUS COVARIATES, THEN IR2 DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => EXP(Z'* BETA1) WILL BE = 0
C-----------------------------------------------------------------------
         K = 0
         DO 505 J=1,IR1
           IF (IANAL1(J).NE.0) THEN
             XCOV = blockb2%xdata2(J,I)
             IF (IPLUS1(J).GE.0) THEN
               K = K+1
               R = BETA1(K) * XCOV
               IF (BETA1(K).LE.-999.D0) R = -999.9D0
               U = U + R
             ENDIF
           ENDIF
  505    CONTINUE
         DO 506 J=1,IR2
            JJ = J + IR1
            IF (IANAL2(J).NE.0) THEN
              K = blockb2%idata2(JJ,I)
              IF (IPLUS2(J).GE.0) U = U + BETA1(K)
            ENDIF
  506    CONTINUE
C
C-----------------------------------------------------------------------
C  COMPUTE W = EXP(U)
C-----------------------------------------------------------------------
         W = 0.D0
         IF (U.GT.-20.D0) W = DEXP(U)
C
C-----------------------------------------------------------------------
C   COMPUTE CONTRIBUTION BETWEEN PREVIOUS TIME AND NEXTJUMP
C-----------------------------------------------------------------------
         XSTIME = DBLE(NEXTJUMP)
         IPRETIM = NEXTJUMP
C
         KLT = IDICHO(ILT,IHT,XSTIME)
         IF (KLT.EQ.0) THEN
           ISUP = 1
           CUM_RISK = CUM_RSKP + W * (XLAMB0(IHT) - XL_PREV)
         ELSE
           CUM_RISK = CUM_RSKP + W * (XLAMB0(KLT) - XL_PREV)
         ENDIF
C-----------------------------------------------------------------------
         ILT = KLT
         CUM_RSKP = CUM_RISK
         XL_PREV = XLAMB0(ILT)
         IC_PREV = ICODE
         NS_PREV = NSTR
C
  590   CONTINUE
       IF (NSTOR.NE.1) GOTO 500
C
  599   IF (NSTOR.NE.1) CLOSE(7)
        IF (IANIPREV.NE.-999.AND.IS.NE.1) THEN
          IF (NSTOR.NE.1) THEN
            XIC = DBLE(IC_PREV)
            XMART = XIC -CUM_RSKP
            XDEV = -2.D0 * (XMART +XIC * DLOG(XIC-XMART))
            XDEV=DSQRT(XDEV)
            IF (XMART.LT.0.D0) XDEV=-XDEV
            WRITE(13,9500) IPRETIM,IANIPREV,IC_PREV,NS_PREV,
     +             CUM_RSKP,XMART,XDEV
          ELSE
C
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c added on October 9, 1997
            NRESI=NRESI+1
            blockb2%info2(1,NRESI)=IANIPREV
            blockb2%info2(2,NRESI)=IC_PREV
            blockb2%info2(3,NRESI)=NS_PREV
            XRESI(NRESI)=CUM_RSKP
            IF (JRANGE(1,NS_PREV).EQ.0) JRANGE(1,NS_PREV)=NRESI
            JRANGE(2,NS_PREV)=NRESI
            DO 600 I=1,MAX(1,NSTRATA)
               IF (NSTRATA.GT.1) WRITE(13,9520) I
               WRITE(13,9521)
 9520          FORMAT(/1X,' FOR STATUM ',I3)
 9521          FORMAT(1X,' ANIMALS  TOTAL   FAILURE RESIDUALS',
     +         '   S(RES)  -LOG S(RES)  EXPECTED',
     +         /1X,' AT RISK  FAILED',40X,'  ORDER STAT.')
               ILT=JRANGE(1,I)
               IHT=JRANGE(2,I)
               IDIF = IHT-ILT+1
               IS=1
               CALL DPSORT(XRESI(ILT),IDIF,NPERM(ILT),IS,IQ)
               XDIE=0.D0
               XCEN=0.D0
               TOTDIE=0.D0
               XRISK=DBLE(IDIF)
               S=1.D0
	       EXPEC=0.D0
               DO 620 JJ=ILT,IHT
                 J=NPERM(JJ)
                 W=XRESI(J)
                 IF (blockb2%info2(2,J).EQ.1)THEN
                   XDIE=XDIE+1.D0
                 ELSE
                   XCEN=XCEN+1.D0
                 ENDIF
                 IF (W.NE.XRESI(NPERM(JJ+1)).AND.XDIE.GT.0.D0) THEN
                   S= S * (1.D0 -XDIE/XRISK)
                   DLOGS=-DLOG(S)
		   EXPEC = EXPEC+XDIE/XRISK
                   TOTDIE = TOTDIE + XDIE
                   WRITE(13,9510) INT(XRISK),INT(TOTDIE),INT(XDIE),
     +                        W,S,DLOGS,EXPEC
 9510              FORMAT(1X,2I7,I8,2X,4(F10.7,1X))
                   XDIE=0.D0
                   XCEN=0.D0
                 ENDIF
                 XRISK=MAX(1.D0,XRISK -1.D0)
  620          CONTINUE
  600       CONTINUE
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
          ENDIF
        ENDIF
        CLOSE(13)
      ENDIF
cR output file for plotting in R	  
      if (useR) then
        close(50)
        close(51)
      endif	  
C-----------------------------------------------------------------------

 9000 FORMAT(/1X,'THERE WERE MORE DISTINCT TIMES WHERE S0(T) CHANGES',
     +    ' THAN THE MAXIMUM ALLOWED: ',I6,/
     +     5X,' THE BASELINE SURVIVOR FUNCTION CANNOT BE COMPUTED',/
     +     5X,' CHECK DATA OR INCREASE PARAMETER NTIMMAX')
 9010 FORMAT(/1X,'THERE WERE MORE STRATA ',
     +   ' THAN THE MAXIMUM ALLOWED: ',I6,/
     +     5X,' THE BASELINE SURVIVOR FUNCTION CANNOT BE COMPUTED',/
     +     5X,'CHECK DATA OR INCREASE PARAMETER NSTRAMAX')
 9015 FORMAT(/7X,'******* BASELINE  ********')
 9018 FORMAT(/7X,'******* KAPLAN-MEIER ESTIMATES ********')
 9040 FORMAT(/3X,' CUMULATIVE HAZARD FUNCTION AND',
     + ' SURVIVOR FUNCTION FOR STRATUM ',I3,' : ',A,'=',
     +  3(I4,2X))
 9041 FORMAT(1X,'      TIME     CUMULATIVE       SURVIVOR',
     +   /1X,'                  HAZARD        FUNCTION ')
 9042   FORMAT(/5X,' KAPLAN-MEIER SURVIVOR CURVE, 95% CONFIDENCE ',
     +  'INTERVAL ',/5X,' AND NELSON ESTIMATE OF THE CUMULATIVE HAZARD',
     +  ' FUNCTION FOR STRATUM ',I3,' : ',A,'=',3(I4,2X) )
 9043   FORMAT(1X,
     +  '      TIME       SURVIVOR          LOWER          UPPER',
     +  '     CUMULATIVE',/1X,
     +  '                 FUNCTION          BOUND          BOUND',
     +  '        HAZARD ')
 9044   FORMAT(
     +   10X,'0',8X,'1.00000',8X,'1.00000',8X,'1.00000',8X,'0.00000')
 9045 FORMAT(/17X,'*******  KAPLAN   ********'///10X,
     + 'PLOT OF LOG S(T) AGAINST T FOR STRATUM ',I3,/)
 9046 FORMAT(10X,'0',8X,'0.00000',8X,'1.00000')
 9050      FORMAT(1X,5X,I5,5X,F10.5,5X,F10.5)
 9052      FORMAT(1X,5X,I5,4(5X,F10.5,5X,F10.5))
 9055 FORMAT(/17X,'*******  KAPLAN   ********'///10X,
     + 'PLOT OF LOG(-LOG S(T)) AGAINST LOG(T) FOR STRATUM ',I3,/)
 9100   FORMAT(/1X,' ANIMAL  //  AT TIME T =    S(T) =   //   S(T)',
     +    ' REACHES:   AT TIME T = // ')
 9110   FORMAT(1X,I8,35X,F8.5,8X,I6)
 9120   FORMAT(1X,I8,8X,I6,3X,F8.5)
 9130 FORMAT(1X,'WARNING: AT THE LARGEST TIME =',I6,' FOR S0(T) OF ',
     + 'THIS STRATUM, THE SURVIVOR CURVE HAS A VALUE = ',
     + F8.5,' LARGER THAN THE QUANTILE VALUE REQUESTED = ',F8.5,
     +' FOR ANIMAL ',I8)
 9140 FORMAT(1X,'WARNING: TIME T =',I6,' FOR WHICH S(T) IS REQUIRED',
     + ' IS LARGER THAN THE LARGEST TIME = ',I6,' FOR S0(T)')
C

      deallocate(irest,IRESQ,REST)
      deallocate( XLAMB0,S0,VARS0,LOGT,LOGLOGS0 )
      deallocate(irange, jrange)
      deallocate( NPERM,XRESI)

      RETURN
C***********************************************************************
      END
      FUNCTION IDICHO(ILT,IHT,XSTIME)
C***********************************************************************
C  IDICO         *                                    *  14 / 10 /1993 *
C***********************************************************************
C   DICHOTOMOUS SEARCH IN A LIST GIVEN THE INDICES OF THE LOWEST (ILT) *
C   AND THE LARGEST (IHT) ELEMENT OF THE LIST                          *
C   NOTE : HERE ILT > IHT BECAUSE XJUMP IS SORTED IN DESCENDING ORDER  *
C   SEARCH FOR XSTIME IN VECTOR XJUMP = SEARCH FOR THE INDEX IND FOR   *
C   WHICH XJUMP(IND) IS AS LARGE AS POSSIBLE BUT < OR = TO XSTIME      *
C***********************************************************************
c
      use parinclu2
c
      implicit none
      INTEGER IDICHO,ILT,IHT,KLT,KHT,KDIF,KMID
      REAL*8 XSTIME
C
C
      IF (XJUMP(IHT).LT.XSTIME) THEN
C-----------------------------------------------------------------------
C   XSTIME IS LARGER THAN THE LARGEST TIME FOR THIS STRATUM
C    => S(XSTIME) SMALLER THAN OR EQUAL TO S0(IHT)
C      (THIS IS INDICATED BY GIVING A VALUE OF 0 TO IDICHO
C-----------------------------------------------------------------------
       IDICHO = 0
       RETURN
      ELSE IF (XJUMP(ILT).EQ.XSTIME) THEN
C-----------------------------------------------------------------------
C    => PARTICULAR CASES
C-----------------------------------------------------------------------
       IDICHO = ILT
       RETURN
      ELSE IF (XJUMP(IHT).EQ.XSTIME) THEN
       IDICHO = IHT
       RETURN
      ELSE
C-----------------------------------------------------------------------
C   XSTIME IS BETWEEN XJUMP(ILT) (CURRENT TIME) AND XJUMP(IHT)
C    => DIVIDE INTERVAL BY 2 AND CHECK FOR THE VALUE OF XJUMP()
C-----------------------------------------------------------------------
       KLT = ILT
       KHT = IHT
    5   KDIF = KLT - KHT
       IF (KDIF.LE.1) THEN
C-----------------------------------------------------------------------
C   THERE IS NO OTHER JUMP BETWEEN KLT AND KHT
C    =>  S0(XSTIME)  = S0(KLT)
C-----------------------------------------------------------------------
       IDICHO = KLT
       RETURN
       ELSE
       KMID = KHT + KDIF/2
C-----------------------------------------------------------------------
C   THREE POSSIBILITIES : XJUMP(KMID) = XSTIME ==> S0(XSTIME)= S0(KMID)
C          XJUMP(KMID) < XSTIME ==> REPLACE KLT BY KMID
C          XJUMP(KMID) > XSTIME ==> REPLACE KHT BY KMID
C-----------------------------------------------------------------------
       IF (XJUMP(KMID).EQ.XSTIME) THEN
             IDICHO = KMID
             RETURN
       ELSE IF (XJUMP(KMID).LT.XSTIME) THEN
             KLT = KMID
             GOTO 5
       ELSE
             KHT = KMID
             GOTO 5
       ENDIF
       ENDIF
      ENDIF
C
C***********************************************************************
      END
