      program cox   
C//////////////////////////////////////////////////////////////////////*
C  COX           *                                    *  23 / 09 /1997 *
C                *                        Version 2.0 of December 2003 *
C//////////////////////////////////////////////////////////////////////*
c
      use parinclu2
c
      implicit none
      real*8,allocatable :: storbeta(:,:,:) !STORBETA(NDIMAX,0:NPGAUSS,0:NPGAUSS)
      real*8,allocatable :: GRADF(:)        !GRADF(NDIMAX)
      real*8,allocatable :: std(:)          !STD(NDIMAX2)
      integer,allocatable :: idf(:,:)       !IDF(0:MXEF,2)
      real*8,allocatable :: XLIK(:,:)       !XLIK(0:MXEF,2)

      INTEGER I,II,I1,I2,IM1,IW,IWL,J,JJ,K,KK,N1,ISUP,JOB,NOLDS
      INTEGER IFAIL,NSTATE,NCTEST,NSTD,NBASE,NSURV,NCONS
      INTEGER IUSER(3)
      INTEGER KITER,N,ITGAUSS,ICODE
      INTEGER NPRINT,ICHECK,NKAPLAN
      INTEGER NSTATUS,NOPTION
      INTEGER INDXS(20)
C
      REAL TIM00,TIM1,SECOND2
      REAL*8 F,W,W1,W2,W3,XINTER,BSOL,E1,SUM,OBJ,LOB,UPB
      REAL*8 BEST(20),DFMIN,R2M,XS(20)
      REAL*8 DLDET
      REAL*8 XNORM,XCHI2,XCHI2L,XPROB,XPROBL,XSTD,XRISK
      REAL*8 WGAUSS(5,5),XGAUSS(5,5),XMOM(0:3,0:3),XMOMP(0:2,0:2)
      REAL*8 OBJ0,XMUK(2),XMUKM1(2),SIGK(3),SIGKM1(3)
      REAL*8 R1,R2,VAL(2,2),GVAL,T(2,2),JACOB,ERR(20,21)
      logical flag
      EXTERNAL FTOMIN,FTOMIN2
C
      CHARACTER*8 PARNAME,PARNAME2(2),PARLAB(2)
      CHARACTER*12 VARTYP,LABEL2(3)
C
      COMMON /CSTEP/ ERR
C
C-----------------------------------------------------------------------
C   ROOTS USED IN THE GAUSS-HERMITE QUADRATURE
C-----------------------------------------------------------------------
      DATA((WGAUSS(J,I),J=1,5),I=3,5)/
     + 0.417771379105166318,1.67108551642066683,0.417771379105166318,0.,
     + 0.,0.114993714684505977,1.13832042263099442,
     + 1.13832042263099487,0.114993714684505977,0.,
     + 0.0282181455332160026,0.556661785214017657,
     + 1.33686841313653382,0.556661785214018656,0.02821814553321600266/
      DATA((XGAUSS(J,I),J=1,5),I=3,5)/
     + -1.73205080756887786,0.D0,1.73205080756887786,0.,0.,
     + -2.33441421833897689,-0.741963784302725915,
     + 0.741963784302725360,2.33441421833897689,0.,
     + -2.85697001387280558,-1.35562617997426593,0.D0,
     + 1.35562617997426460,2.85697001387280558/
C-----------------------------------------------------------------------
C   SPECIFICATION AND CHANGE OF FORMER PARAMETERS WITH KEYWORDS
C-----------------------------------------------------------------------
! default value for NDIMAX2
      NDIMAX2=NDIMAX
! changing values if keyword specified
      call parchange
C-----------------------------------------------------------------------
C   Allocation of variables after their final value is known
C-----------------------------------------------------------------------	  
!LOCALS
      allocate(STORBETA(NDIMAX,0:NPGAUSS,0:NPGAUSS))	
      allocate(GRADF(NDIMAX))
      allocate(std(ndimax2))
      allocate(IDF(0:MXEF,2),XLIK(0:MXEF,2))

	  
!GLOBALS
      allocate(ISTIME(NSTIMAX),SQUANT(NSTIMAX))
      allocate(XJUMP(NTIMMAX),IOLCODST(MXSTRA,3))
      allocate(IRANK(NDIMAX),IOLDCODE(NDIMAX,4),NFAIL(NDIMAX))
      allocate(ICONS(0:NDIMAX),IPEDIG(4,NDIMAX),BETA(NDIMAX))
      allocate(DC_RISK(NDIMAX))
      allocate(HESS(NDIMAX,NDIMAX))
      allocate(D2C_RISK(NDIMAX,NDIMAX))
	  
      allocate(ICOVTYP(MXEF),NCOL(0:MXEF),IMOD(MXEF),ITRAIT1(MXEF))
      allocate(IND(MXEF),ITRAIT2(MXEF),IFIRST(MXEF),ILAST(MXEF))
      allocate(ITEST(MXEF),IANAL1(MXEF),IANAL2(MXEF),IPLUS1(MXEF))
      allocate(IPLUS2(MXEF),NCOEF(0:MXEF),ICOEF(0:MXEF),ISAME(0:MXEF))
      allocate(IGAM(0:MXEF,3),INOR(0:MXEF,3))
      allocate(XCOEF(MXEF),XAV(MXEF),XSQ(MXEF))
      allocate(XGAM(0:MXEF),XNOR(0:MXEF),BOUND(0:MXEF,3),LABEL(0:MXEF))
      allocate(icorr(MXEF,2))
C-----------------------------------------------------------------------
C STEP 1 : READ MODEL SPECIFICATION , INITIALIZATION
C          CHECK INPUT FILE, COMPUTES ELEMENTARY STATISTICS
C          PREPARE WORKING FILE FOR SUBROUTINE FCOX
C-----------------------------------------------------------------------
C
      TIM00 = SECOND2()
      CALL INIT(NDIM,NCTEST,NSTD,NPRINT,NBASE,NSURV,NCONS,NKAPLAN,NOLDS,
     +          BETA)
      LABEL2(1)='(CONTINUOUS)'
      LABEL2(2)='(DISCRETE)  '
      LABEL2(3)='NO COVARIATE'
      NOPTION=0
      ICHECK=0
C-----------------------------------------------------------------------
C STEP 2 : FIND OR CHECK CONSTRAINTS
C-----------------------------------------------------------------------
      IF (NCOVMOD.EQ.0) GOTO 80
      WRITE(6,9100)
      WRITE(12,9100)
C-----------------------------------------------------------------------
C IF NCONS = -1, LOOK FOR CONSTRAINTS
C-----------------------------------------------------------------------
      IF (NCONS.EQ.-1) THEN
       DO 10 I=1,NDIM
            IF (NFAIL(I).NE.0) BETA(I) = 0.05D0 * MOD(I,5)
  10   CONTINUE
       NOPTION=90
       CALL FCOX2(BETA,F,GRADF,STD,DLDET,NSTATUS,NOPTION,NDIM)
       NOPTION=0
C       CALL CHOLESKY(HESS,NDIMAX,NDIM,J,0)
C-----------------------------------------------------------------------
C IF NCONS = 2, CHECK THAT THE CONSTRAINTS SUPPLIED BY THE USER ARE
C VALID
C-----------------------------------------------------------------------
      ELSE IF (NCONS.EQ.2) THEN
       DO 20 I=1,NDIM
            IF (NFAIL(I).NE.0) BETA(I) = 0.05D0 * MOD(I,5)
  20    CONTINUE
       NOPTION=100
       ICHECK = 1
       CALL FCOX2(BETA,F,GRADF,STD,DLDET,NSTATUS,NOPTION,NDIM)
       NOPTION=0
      ENDIF
C
C-----------------------------------------------------------------------
C PRINT CONSTRAINTS
C-----------------------------------------------------------------------
      IF ((NCONS.EQ.-2).OR.(ICONS(0).EQ.0)) THEN
       WRITE(6,9105)
       WRITE(12,9105)
      ELSE IF (NCONS.EQ.-1) THEN
       WRITE(6,9110)
       WRITE(12,9110)
      ELSE IF (NCONS.EQ.0) THEN
       WRITE(6,9112)
       WRITE(12,9112)
      ELSE IF (NCONS.GT.0) THEN
       WRITE(6,9115)
       WRITE(12,9115)
       IF (ICHECK.NE.0) WRITE(6,9116)
       IF (ICHECK.NE.0) WRITE(12,9116)
      ENDIF
      IF (NCONS.NE.-1.OR.NCONS.NE.2) WRITE(6,9117)
      IF (NCONS.NE.-1.OR.NCONS.NE.2) WRITE(12,9117)
      DO 100 K=1,ICONS(0)
       I = ICONS(K)
       DO 110 J=1,NCOVMOD
       II = IMOD(J)
c       IF (ISAME(II).NE.0) GOTO 110
       IF (I.LT.IFIRST(II).OR.I.GT.ILAST(II)) GOTO 110
            KK = IRANK(I)
            IF (NCOL(II).EQ.1) THEN
             WRITE(6,9120) LABEL(II),IOLDCODE(KK,1)
             WRITE(12,9120) LABEL(II),IOLDCODE(KK,1)
            ELSE IF (NCOL(II).EQ.2) THEN
             WRITE(6,9121) LABEL(II),IOLDCODE(KK,1),IOLDCODE(KK,2)
             WRITE(12,9121) LABEL(II),IOLDCODE(KK,1),IOLDCODE(KK,2)
            ELSE
             WRITE(6,9122) LABEL(II),(IOLDCODE(KK,II),II=1,3)
             WRITE(12,9122) LABEL(II),(IOLDCODE(KK,II),II=1,3)
            ENDIF
  110   CONTINUE
  100 CONTINUE
C-----------------------------------------------------------------------
C PRINT IF PROBLEMS
C-----------------------------------------------------------------------
      IF (NCONS.GE.2) THEN
       IF (ICONS(0).LT.JJ) THEN
       ISUP = JJ-ICONS(0)
       WRITE(6,9130) ISUP
       WRITE(12,9130) ISUP
       ENDIF
C
       DO 95 I=1,NDIM
       IF (NFAIL(I).NE.0) BETA(I) = 0.D0
   95   CONTINUE
      ENDIF
C     IF (NCONS.GE.2.AND.ISUP.EQ.1) STOP
C
 9100 FORMAT(/7X,'******* CONSTRAINTS ******')
 9105 FORMAT(/1X,' NO CONSTRAINTS IMPOSED')
 9110 FORMAT(/1X,' THE SOLUTION FOR THE FOLLOWING (RECODED)',
     +   ' LEVELS IS SET TO 0:'/)
 9112 FORMAT(/1X,' THE SOLUTION FOR THE FOLLOWING (RECODED)',
     +   ' LEVELS IS SET TO 0:',
     + /1X,' (= LEVEL WITH LARGEST NUMBER OF UNCENSORED FAILURES ',
     + 'FOR EACH EFFECT)',/)
 9115 FORMAT(/1X,' THE SOLUTION FOR THE FOLLOWING (RECODED)',
     +   ' LEVELS IS SET TO 0:')
 9116 FORMAT(/1X,'( THE COHERENCY OF THESE CONSTRAINTS IS VERIFIED)',/)
 9117 FORMAT(1X,'(WARNING : THE VALIDITY OF THESE CONSTRAINTS ',
     +'IS NOT CHECKED.',
     + /1X,' IN CASE THEY ARE MORE DEPENDENCIES,',/1X,' THE DEGREES ',
     +'OF FREEDOM IN THE TEST(S) BELOW ARE INCORRECT)'/)
 9120 FORMAT(1X,'  EFFECT ',A8,' LEVEL ',I8)
 9121 FORMAT(1X,'  EFFECT ',A8,' LEVEL ',I8,' * ',I6)
 9122 FORMAT(1X,'  EFFECT ',A8,' LEVEL ',I8,' * ',I6,' *',I6)
 9130 FORMAT(1X,I3,' EXTRA CONSTRAINTS COULD HAVE BEEN ADDED ',/
     + 1X,' USE "CONSTRAINTS FIND" OPTION OR SPECIFY ',
     + 'NEW CONSTRAINTS TO GET A CORRECT NUMBER OF DEGREES OF FREEDOM')
 9135 FORMAT(1X,' THERE MAY BE AN INCORRECT CONSTRAINT IMPOSED FOR ',
     + 'EFFECT ',A8,' RECODED LEVEL ',I8)
 9136 FORMAT(1X,' THERE MAY BE AN INCORRECT CONSTRAINT IMPOSED FOR ',
     + 'EFFECT ',A8,' RECODED LEVEL ',I8,' * ',I6)
 9137 FORMAT(1X,' THERE MAY BE AN INCORRECT CONSTRAINT IMPOSED FOR ',
     + 'EFFECT ',A8,' RECODED LEVEL ',I8,' * ',I6,' * ',I6)
C
C-----------------------------------------------------------------------
C STEP 3 : CALL THE MAXIMIZATION SUBROUTINE
C-----------------------------------------------------------------------
   80 IFAIL = 0
      IUSER(3)=-1
C
C-----------------------------------------------------------------------
C COMPUTE FCOX WITH NO COVARIATE
C-----------------------------------------------------------------------
      DO 120 J=1,IR1
       IANAL1(J)=0
  120 CONTINUE
      DO 130 J=1,IR2
       IANAL2(J)=0
  130 CONTINUE
      DO 15 I=1,NDIM
        IF (NFAIL(I).NE.0) BETA(I) = 0.D0
  15  CONTINUE
      CALL FCOX(BETA,F,GRADF,NDIM,NSTATE,IUSER)
      IDF(0,1) = 0
      XLIK(0,1) = 2.D0 * F
      IF (NOLDS.GT.1) THEN
         WRITE(6,*) 'READ OLD SOLUTIONS'
         ICODE=2
         CALL RWBACKUP(ICODE,FILE(7))
         WRITE(6,844) (BETA(I),I=1,MIN(50,NDIM))
         IF (NDIM.GT.50) THEN
           WRITE(6,*) '...'
           WRITE(6,844) (BETA(I),I=MAX(51,NDIM-3),NDIM)
         ENDIF
844      FORMAT(1X,10F7.2)
      ENDIF
      IF (NCOVMOD.EQ.0) THEN
        K=0
        GOTO 750
      ENDIF
C
C-----------------------------------------------------------------------
C IF TEST = SEQUENTIAL, ADD ONE EFFECT AT A TIME
C-----------------------------------------------------------------------
      IF (NCTEST.GE.2.AND.NCTEST.LE.4) THEN
        IF (NCTEST.LT.4) THEN
          JJ=1
        ELSE
          JJ=NCOVMOD
          DO 148 I=1,NCOVMOD
            K=IMOD(I)
            IF (ITEST(K).NE.0) JJ=MIN(I,JJ)
  148     CONTINUE
          DO 150 I=1,JJ-1
            K = IMOD(I)
            DO 152 J=1,IR1
              IF (ITRAIT1(J).EQ.K) THEN
                IANAL1(J)=1
              ENDIF
  152       CONTINUE
            DO 154 J=1,IR2
              IF (ITRAIT2(J).EQ.K) THEN
                IANAL2(J)=1
              ENDIF
  154       CONTINUE
  150     CONTINUE
        ENDIF
        IF (NCTEST.EQ.4) THEN
          CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
          WRITE(6,9030) ITOEV,TOTIM
          WRITE(12,9030) ITOEV,TOTIM
        ENDIF
        IDF(K,1) = IUSER(1)
        XLIK(K,1) = 2.D0 * F
        DO 158 I=JJ,NCOVMOD
        K = IMOD(I)
        DO 160 J=1,IR1
          IF (ITRAIT1(J).EQ.K) THEN
             IANAL1(J)=1
          ENDIF
  160   CONTINUE
        DO 161 J=1,IR2
          IF (ITRAIT2(J).EQ.K) THEN
             IANAL2(J)=1
          ENDIF
  161   CONTINUE
        IF (I.LT.NCOVMOD) THEN
          CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
          WRITE(6,9030) ITOEV,TOTIM
          WRITE(12,9030) ITOEV,TOTIM
          IDF(K,1) = IUSER(1)
          XLIK(K,1) = 2.D0 * F
          IF (I.EQ.NCOVMOD-1) THEN
             KK= IMOD(NCOVMOD)
             IDF(KK,2) = IDF(K,1)
             XLIK(KK,2) = XLIK(K,1)
          ENDIF
        ENDIF
  158  CONTINUE
      ENDIF
C-----------------------------------------------------------------------
C IF TEST = LAST, DELETE ONE EFFECT AT A TIME
C-----------------------------------------------------------------------
      IF ((NCTEST.EQ.1).OR.(NCTEST.GE.3)) THEN
       DO 170 I=1,NCOVMOD
         DO 175 JJ=1,NDIM
            IF (NFAIL(JJ).NE.0) BETA(JJ)=0.D0
  175    CONTINUE
         K = IMOD(I)
         IF (NCTEST.EQ.3.AND.I.EQ.NCOVMOD.AND.I.GT.1) GOTO 170
         IF (ITEST(K).NE.0.OR.NCTEST.EQ.1) THEN
           DO 180 J=1,IR1
            IF (ITRAIT1(J).EQ.K) THEN
              IANAL1(J)=0
              DO 185 JJ=IFIRST(K),ILAST(K)
               IF (NFAIL(JJ).NE.0) BETA(JJ)=0.D0
  185         CONTINUE
            ELSE
              IANAL1(J)=1
            ENDIF
  180      CONTINUE
           DO 190 J=1,IR2
             IF (ITRAIT2(J).EQ.K) THEN
               IANAL2(J)=0
               DO 195 JJ=IFIRST(K),ILAST(K)
                  IF (NFAIL(JJ).NE.0) BETA(JJ)=0.D0
  195          CONTINUE
             ELSE
               IANAL2(J)=1
             ENDIF
  190      CONTINUE
           CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
           WRITE(6,9030) ITOEV,TOTIM
           WRITE(12,9030) ITOEV,TOTIM
           IDF(K,2) = IUSER(1)
           XLIK(K,2) = 2.D0 * F
         ENDIF
  170   CONTINUE
      ENDIF
C-----------------------------------------------------------------------
C LAST ONE = FULL MODEL
C-----------------------------------------------------------------------
      DO 200 J=1,IR1
       IANAL1(J)=1
  200 CONTINUE
      DO 205 J=1,IR2
       IANAL2(J)=1
  205 CONTINUE
      IF (NPEST.EQ.0) THEN
        CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
      ELSE IF (NPEST.GE.1) THEN
         JJ=0
         DO 202 J=1,MAXRAND
          IF (BOUND(J,1).GT.0.D0) JJ=J
  202   CONTINUE
        IF (NPEST.GE.100) IUSER(3)=1
C        CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
        IF (JJ.NE.0) THEN
          LOB=BOUND(JJ,1)
          UPB=BOUND(JJ,2)
        ENDIF
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        NTRACE=+2
        NFMAX=200
        NFLAT=1
        NXTRA=1
        KW=12
        NPARMI=0
        flag=.false.
        DO J=1,MAXRAND
           IF (IGAM(J,1).GE.1) THEN
             NPARMI=NPARMI+1
             XS(NPARMI)=XGAM(J)
             INDXS(NPARMI)=J
             IF (IGAM(J,1).EQ.2) THEN
                MASK(NPARMI)=0
             ELSE
                MASK(NPARMI)=1
             ENDIF
c            XMAX(NPARMI)=10000.
c            XMIN(NPARMI)=1.
c            DELTX(NPARMI)=5.
c            DELMIN(NPARMI)=0.1
             XMAX(NPARMI)=1.
             XMIN(NPARMI)=0.
             DELTX(NPARMI)=0.05
             DELMIN(NPARMI)=0.0001
           ENDIF
           IF (INOR(J,1).GE.1) THEN
             NPARMI=NPARMI+1
             XS(NPARMI)=XNOR(J)
             INDXS(NPARMI)=J
             IF (INOR(J,1).EQ.2) THEN
                MASK(NPARMI)=0
             ELSE
                MASK(NPARMI)=1
             ENDIF
             XMAX(NPARMI)=1.
             XMIN(NPARMI)=0.
             DELTX(NPARMI)=0.05
             DELMIN(NPARMI)=0.0001*(1.d0/precorr_mul)
C TWO EFFECTS WITH NORMAL DISTRIBUTIONS ARE CORRELATED
C ==> FIND BEST zeta (=log((1-corr)/(2*(1+corr)))
             IF (ICORR(J,1).GT.0) THEN
c                NPARMI=NPARMI+1
                flag=.true.
                XS(3)=zeta
                INDXS(3)=0
                IF (estcor) THEN
                  MASK(3)=0
                ELSE
                  MASK(3)=1
                ENDIF  
c [-5,+5] for zeta <=> ([-0.99,+0.99] for corr (more or less!)
                XMAX(3)=5.
                XMIN(3)=-5.
                DELTX(3)=0.1
                DELMIN(3)=0.01*(1.d0/precorr_mul)
             ENDIF   
           ENDIF
        ENDDO
        IF (NPARMI.EQ.1.AND.BOUND(JJ,3).NE.0.) THEN
           BEST(JJ)=DFMIN(LOB,UPB,FTOMIN,BOUND(JJ,3),OBJ)
           XS(1)=BEST(JJ)
           IF (IGAM(JJ,1).GE.1) THEN
             PARNAME='LOGGAMMA'
             XGAM(JJ)=BEST(JJ)
           ELSE
             PARNAME='NORMAL  '
             XNOR(JJ)=BEST(JJ)
           ENDIF
           IF (BEST(JJ).NE.0.D0) THEN
             WRITE(6,206) PARNAME,LOB,UPB,BEST(JJ)
             WRITE(12,206) PARNAME,LOB,UPB,BEST(JJ)
           ENDIF
  206   FORMAT(1X,' THE ESTIMATED VARIANCE PARAMETER FOR THE ',A9,
     +      ' DISTRIBUTION ',/10X,' IS BETWEEN ',F10.5,
     +    ' AND ',F10.5,/1X,' THE BEST VALUE FOUND IS ',F10.5)
        ELSE
c If the correlation coefficient is used NPARMI is increased
           IF (flag) NPARMI=NPARMI+1
           CALL DFMIN2(NPARMI,INDXS,XS,OBJ)
c          CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
           NPARMI=0
           DO J=1,MAXRAND
             IF (IGAM(J,1).EQ.2) THEN
               NPARMI=NPARMI+1
               XGAM(INDXS(NPARMI))=XS(NPARMI)
               BEST(J)=XGAM(INDXS(NPARMI))
               PARNAME='LOGGAMMA'
               PARNAME2(NPARMI)='LOGGAMMA'
               PARLAB(NPARMI)=LABEL(J)
               WRITE(6,266) PARNAME,BEST(J),PARLAB(NPARMI)
               WRITE(12,266) PARNAME,BEST(J),PARLAB(NPARMI)
             ENDIF
  266   FORMAT(1X,' THE ESTIMATED VARIANCE PARAMETER FOR THE ',A9,
     +      ' DISTRIBUTION IS ',F10.5,' (EFFECT ',A8,')')
             IF (INOR(J,1).EQ.2) THEN
               NPARMI=NPARMI+1
               XNOR(INDXS(NPARMI))=XS(NPARMI)
               BEST(J)=XNOR(INDXS(NPARMI))
               PARNAME='NORMAL'
               PARNAME2(NPARMI)='NORMAL'
               PARLAB(NPARMI)=LABEL(J)
               WRITE(6,266) PARNAME,BEST(J),PARLAB(NPARMI)
               WRITE(12,266) PARNAME,BEST(J),PARLAB(NPARMI)
             ENDIF
           ENDDO
           if (corrflag) then
             W=exp(zeta)
             corr= (1.d0-2.d0*W)/(1.d0+2.d0*W)
             WRITE(6,267) corr 
             WRITE(12,267) corr 
  267   FORMAT(1X,' THE CORRELATION BETWEEN THE TWO EFFECTS IS ',F10.5)
           endif  
          ENDIF
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C
       IF (NPEST.GE.100) THEN
         DO 690 J=1,NDIM
           STORBETA(J,0,0)=BETA(J)
  690    CONTINUE
         OBJ0= OBJ
c#
         IF (NPARMI.EQ.1) THEN 
           WRITE(6,207) PARNAME,NPGAUSS
           WRITE(12,207) PARNAME,NPGAUSS
  207      FORMAT(/1X,' ESTIMATION OF THE MOMENTS OF THE MARGINAL ',
     +  'POSTERIOR DISTRIBUTION ',/1X,' OF THE ',A8,' DISTRIBUTION',
     +  ' USING GAUSS-HERMITE INTEGRATION WITH',I2,' POINTS')
c initialize variables for MOMENTS statement in case of 1 RANDOM var.	 
           DO I=1,NPARMI
             XMUKM1(I)=DLOG(XS(I))
             SIGKM1(I)= DABS(XMUKM1(I)/10.D0)
             WRITE(6,*) ' INITIAL ESTIMATE OF MU(',I,') =   ',XMUKM1(I)
             WRITE(6,*) ' INITIAL ESTIMATE OF SIGMA(',I,') =',SIGKM1(I)
           ENDDO
c          WRITE(6,*) ' INITIAL ESTIMATE OF MU =   ',XMUKM1(NPARMI)
c          WRITE(6,*) ' INITIAL ESTIMATE OF SIGMA =',SIGKM1(NPARMI)
       KITER=0
       DO 700 ITGAUSS=1,NITER_GAUSS
         IF (KITER.EQ.1) GOTO 700
         WRITE(6,704) ITGAUSS
         WRITE(12,704) ITGAUSS
 704     FORMAT(/1X,' ITERATION ',I2,' OF GAUSS-HERMITE INTEGRATION')
         DO 705 N=0,3
           XMOM(N,0)=0.D0
 705     CONTINUE
         XMUK(1)=0.D0
         SIGK(1)=0.D0
         DO 710 I=1,NPGAUSS
           VAL(1,1)=XMUKM1(1)+ SIGKM1(1) * XGAUSS(I,NPGAUSS)
           VAL(2,1) = 0.5D0 * XGAUSS(I,NPGAUSS) * XGAUSS(I,NPGAUSS)
           W= DEXP(VAL(1,1))
           IF (IGAM(JJ,1).GE.1) THEN
             XGAM(JJ) = W
           ELSE
             XNOR(JJ) = W
           ENDIF
           WRITE(6,716) W
           WRITE(12,716) W
  716      FORMAT(1X,' EVALUATION AT VARIANCE PARAMETER = ',F10.5)
           IF (ITGAUSS.GT.1) THEN
             DO 712 J=1,NDIM
               BETA(J)=STORBETA(J,I,0)
  712        CONTINUE
           ENDIF
           CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
           DO 714 J=1,NDIM
             STORBETA(J,I,0)=BETA(J)
  714      CONTINUE
           GVAL =  OBJ0 - OBJ
           WRITE(6,*) 'PARAMETER ',W,' OBJ= ',OBJ
           R1= SIGKM1(1) * VAL(1,1) * DEXP(VAL(1,1) + VAL(2,1) + GVAL)
           R2= R1 * VAL(1,1)
           XMUK(1) = XMUK(1) + WGAUSS(I,NPGAUSS) * R1
           SIGK(1) = SIGK(1) + WGAUSS(I,NPGAUSS) * R2
           DO 720 N=0,3
              W = SIGKM1(1) 
     +           *DEXP((N+1.D0) * VAL(1,1) + VAL(2,1) + GVAL)
              XMOM(N,0)=XMOM(N,0) + WGAUSS(I,NPGAUSS) * W
 720       CONTINUE
 710       CONTINUE
           XMUK(1) =XMUK(1) / XMOM(0,0)
           SIGK(1) =SIGK(1) / XMOM(0,0)
           SIGK(1) = DSQRT(SIGK(1) - XMUK(1) * XMUK(1))
           WRITE(6,711) XMUK(1),SIGK(1)
 711       FORMAT(1X,' STANDARDIZING PARAMETERS:',2F15.4)
           WRITE(6,*)' INTEGRATION CONSTANT = ',XMOM(0,0)
           DO 730 N=1,3
              XMOM(N,0)=XMOM(N,0)/XMOM(0,0)
 730       CONTINUE
           XMOM(3,0) = XMOM(3,0) - 3.D0 * XMOM(1,0)* XMOM(2,0)
     +          + 2.D0 * XMOM(1,0)**3
           XMOM(2,0) = DSQRT(XMOM(2,0) - XMOM(1,0) * XMOM(1,0))
           XMOM(3,0) = XMOM(3,0) / (XMOM(2,0)**3)
           WRITE(6,734) (XMOM(I,0),I=1,3)
           WRITE(12,734) (XMOM(I,0),I=1,3)
 734       FORMAT(/1X,'      MEAN     STANDARD DEVIATION',
     +      '  SKEWNESS   ',/1X,2(F13.5,1X),F12.3)
c           W = DABS(XMOM(1,1) - XMOMP(1,1))/XMOM(1,1)
c           W2 = DABS(XMOM(2,1) - XMOMP(2,1))/XMOM(2,1)
           W = DABS(XMOM(1,0) - XMOMP(1,0))/XMOM(1,0)
           W2 = DABS(XMOM(2,0) - XMOMP(2,0))/XMOM(2,0)
           IF (MAX(W,W2).LT.1.D-3) THEN
               WRITE(6,*) 'CONVERGENCE REACHED, EVALUATION AT THE MODE'
               KITER=1
           ENDIF
           XMOMP(1,0) = XMOM(1,0)
           XMOMP(2,0) = XMOM(2,0)
           XMUKM1(1)=XMUK(1)
           SIGKM1(1)=SIGK(1)
 700    CONTINUE
         DO 740 J=1,NDIM
           BETA(J)=STORBETA(J,0,0)
  740    CONTINUE
         IF (IGAM(JJ,1).GE.1) THEN
           XGAM(JJ)=BEST(JJ)
         ELSE
           XNOR(JJ)=BEST(JJ)
         ENDIF
C?
        ELSE IF (NPARMI.EQ.2) THEN
             WRITE(6,209) (PARNAME2(J),J=1,2),NPGAUSS
             WRITE(12,209) (PARNAME2(J),J=1,2),NPGAUSS
  209      FORMAT(/1X,' ESTIMATION OF THE MOMENTS OF THE MARGINAL ',
     +     'POSTERIOR DISTRIBUTIONS ',/1X,' OF THE ',A8,' AND ',A8,
     +' DISTRIBUTION USING GAUSS-HERMITE INTEGRATION WITH',I2,' POINTS')
           DO 800 I=1,NPARMI
             XMUKM1(I)=DLOG(XS(I))
             SIGKM1(I)= DABS(XMUKM1(I)/10.D0)
             WRITE(6,*) ' INITIAL ESTIMATE OF MU(',I,') =   ',XMUKM1(I)
             WRITE(6,*) ' INITIAL ESTIMATE OF SIGMA(',I,') =',SIGKM1(I)
  800      CONTINUE
           SIGKM1(3)= 0.D0
           T(1,1)=SIGKM1(1)
           T(2,1)=SIGKM1(3)/T(1,1)
           T(2,2)=DSQRT(SIGKM1(2)*SIGKM1(2)-T(2,1)*T(2,1))
           JACOB=T(1,1)*T(2,2)
c          print*,'T=',T(1,1),T(2,1),T(2,2)
c         ENDIF
       KITER=0
       DO 801 ITGAUSS=1,NITER_GAUSS
         IF (KITER.EQ.1) GOTO 801
         WRITE(6,704) ITGAUSS
         WRITE(12,704) ITGAUSS
         DO 805 N=0,3
           IF (N.NE.0) THEN
             IF (N.NE.3) XMUK(N)=0.D0
             SIGK(N)=0.D0
           ENDIF
           DO 805 N1=0,3
             XMOM(N,N1)=0.D0
 805     CONTINUE
         DO 810 I=1,NPGAUSS
           DO 811 I2=1,NPGAUSS
             VAL(1,1)=XMUKM1(1)+ T(1,1) * XGAUSS(I,NPGAUSS)
             VAL(1,2)=XMUKM1(2)+ T(2,1) * XGAUSS(I,NPGAUSS) 
     +                      +T(2,2)* XGAUSS(I2,NPGAUSS)
             VAL(2,1)= 0.5D0 * XGAUSS(I,NPGAUSS) * XGAUSS(I,NPGAUSS)
             VAL(2,2)= 0.5D0 * XGAUSS(I2,NPGAUSS) * XGAUSS(I2,NPGAUSS)

             W1= DEXP(VAL(1,1))
             IF (PARNAME2(1).EQ.'LOGGAMMA') THEN
               XGAM(INDXS(1))=W1 
             ELSE
               XNOR(INDXS(1))=W1 
             ENDIF
             W2= DEXP(VAL(1,2))
             IF (PARNAME2(2).EQ.'LOGGAMMA') THEN
               XGAM(INDXS(2))=W2 
             ELSE
               XNOR(INDXS(2))=W2 
             ENDIF

           WRITE(6,816) W1,W2
           WRITE(12,816) W1,W2
  816      FORMAT(1X,' EVALUATION AT VARIANCE PARAMETER = ',2(F10.5,2X))
           IF (ITGAUSS.GT.1) THEN
             DO 812 J=1,NDIM
               BETA(J)=STORBETA(J,I,I2)
  812        CONTINUE
           ENDIF
           CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
           DO 814 J=1,NDIM
             STORBETA(J,I,I2)=BETA(J)
  814      CONTINUE
           GVAL =  OBJ0 - OBJ
           WRITE(6,*) 'PARAMETERS ',W1,W2,' OBJ= ',OBJ
           W = DEXP(VAL(1,1) + VAL(2,1) + VAL(1,2) + VAL(2,2) + GVAL)
           W = W * WGAUSS(I,NPGAUSS) * WGAUSS(I2,NPGAUSS)
           R1= JACOB * VAL(1,1) * W 
           R2= R1 * VAL(1,1)
           XMUK(1) = XMUK(1) +  R1
           SIGK(1) = SIGK(1) +  R2
           R1= JACOB * VAL(1,2) * W 
           R2= R1 * VAL(1,2)
           XMUK(2) = XMUK(2) + R1
           SIGK(2) = SIGK(2) + R2
           R2= JACOB * VAL(1,1) * VAL(1,2) * W
           SIGK(3) = SIGK(3) + R2
           DO 820 N=0,3
             DO 820 N1=0,3
              W = JACOB  * DEXP((N+1.D0) * VAL(1,1) + VAL(2,1) 
     +               + (N1+1.D0) * VAL(1,2) + VAL(2,2) + GVAL)
              XMOM(N,N1)=XMOM(N,N1) + WGAUSS(I,NPGAUSS) 
     +                * WGAUSS(I2,NPGAUSS) * W 
 820       CONTINUE
 811       CONTINUE
 810       CONTINUE
           DO 861 I=1,NPARMI
             XMUK(I) =XMUK(I) / XMOM(0,0)
             SIGK(I) =SIGK(I) / XMOM(0,0)
 861       CONTINUE
           SIGK(1) = DSQRT(SIGK(1) - XMUK(1) * XMUK(1))
           SIGK(2) = DSQRT(SIGK(2) - XMUK(2) * XMUK(2))
           SIGK(3) = SIGK(3) / XMOM(0,0)
           SIGK(3) = SIGK(3) - XMUK(1) * XMUK(2)
           W = SIGK(3)/(SIGK(1)*SIGK(2))
           T(1,1)=SIGK(1)
           T(2,1)=SIGK(3)/T(1,1)
           T(2,2)=DSQRT(SIGK(2)*SIGK(2)-T(2,1)*T(2,1))
           JACOB=T(1,1)*T(2,2)
           WRITE(6,819) XMUK(1),SIGK(1)
           WRITE(6,819) XMUK(2),SIGK(2)
 819       FORMAT(1X,' STANDARDIZING PARAMETERS:',2F15.4)
           WRITE(6,*) ' CORRELATION ',W
           WRITE(6,*)' INTEGRATION CONSTANT = ',XMOM(0,0)
           DO 830 N=0,3
             DO 831 N1=0,3
              IF (N.EQ.0.AND.N1.EQ.0) cycle
              XMOM(N,N1)=XMOM(N,N1)/XMOM(0,0)
 831       CONTINUE
 830       CONTINUE
           XMOM(3,0) = XMOM(3,0) - 3.D0 * XMOM(1,0)* XMOM(2,0)
     +          + 2.D0 * XMOM(1,0)**3
           XMOM(2,0) = DSQRT(XMOM(2,0) - XMOM(1,0) * XMOM(1,0))
           XMOM(3,0) = XMOM(3,0) / (XMOM(2,0)**3)
           XMOM(0,3) = XMOM(0,3) - 3.D0 * XMOM(0,1)* XMOM(0,2)
     +          + 2.D0 * XMOM(0,1)**3
           XMOM(0,2) = DSQRT(XMOM(0,2) - XMOM(0,1) * XMOM(0,1))
           XMOM(0,3) = XMOM(0,3) / (XMOM(0,2)**3)
           XMOM(1,1) = XMOM(1,1) - XMOM(1,0) * XMOM(0,1)
           XMOM(1,1) = XMOM(1,1) /(XMOM(2,0) * XMOM (0,2))
 835   FORMAT(/1X,'MOMENTS OF THE MARGINAL POSTERIOR DISTRIBUTIONS',
     +       /1X,'      MEAN       STD    SKEWNESS       ',
     +      'MEAN       STD     SKEWNESS CORRELATION',
     +        /1X,7(F10.4,1X))
        WRITE(6,835) (XMOM(I,0),I=1,3),(XMOM(0,I),I=1,3),XMOM(1,1)
        WRITE(12,835) (XMOM(I,0),I=1,3),(XMOM(0,I),I=1,3),XMOM(1,1)
  
           W = DABS(XMOM(1,0) - XMOMP(1,0))/XMOM(1,0)
           W1 = DABS(XMOM(2,0) - XMOMP(2,0))/XMOM(2,0)
           W2 = DABS(XMOM(0,1) - XMOMP(0,1))/XMOM(0,1)
           W3 = DABS(XMOM(0,2) - XMOMP(0,2))/XMOM(0,2)
           IF (MAX(W,W1,W2,W3).LT.1.D-2) THEN
               WRITE(6,*) 'CONVERGENCE REACHED, EVALUATION AT THE MODE'
               KITER=1
           ENDIF
           XMOMP(1,0) = XMOM(1,0)
           XMOMP(2,0) = XMOM(2,0)
           XMOMP(0,1) = XMOM(0,1)
           XMOMP(0,2) = XMOM(0,2)
           XMUKM1(1)=XMUK(1)
           XMUKM1(2)=XMUK(2)
           SIGKM1(1)=SIGK(1)
           SIGKM1(2)=SIGK(2)
           SIGKM1(3)=SIGK(3)
 801    CONTINUE
         DO 840 J=1,NDIM
           BETA(J)=STORBETA(J,0,0)
 840     CONTINUE
         DO J=1,MAXRAND
            IF (IGAM(J,1).GE.1) THEN
               XGAM(J)=BEST(J)
            ENDIF
            IF (INOR(J,1).GE.1) THEN
               NPARMI=NPARMI+1
               XNOR(J)=BEST(J)
            ENDIF
         ENDDO
       ENDIF
C
       ENDIF
       CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
      ENDIF
C
      WRITE(6,9030) ITOEV,TOTIM
      WRITE(12,9030) ITOEV,TOTIM
      K = IMOD(NCOVMOD)
  750 XLIK(K,1) = 2.D0 * F
      IDF(K,1) = IUSER(1)
      XCHI2 = XLIK(0,1) - XLIK(K,1)
      IW = IDF(K,1)
      W = DBLE(IW)
      IF (XCHI2.LT.0.D0.OR.IW.EQ.0) THEN
       XPROB = 0.D0
      ELSE
        CALL CHSCDF(XCHI2,IW,XPROB)
        XPROB = 1.D0 - XPROB
      ENDIF
C
C-----------------------------------------------------------------------
C PRINT RESULTS
C-----------------------------------------------------------------------
CR prints out results to a file to plot them in R
      if (useR .and. NPEST.ge.100) then
        OPEN(52,file='RMoments.txt' ,status='unknown')
        write(52,*) (XMOM(I,0),I=1,3),(XMOM(0,I),I=1,3)
        close(52)
      endif
	
      XNORM = 0.D0
      DO 300 J=1,NDIM
       XNORM = XNORM + GRADF(J) * GRADF(J)
  300 CONTINUE
      XNORM = 2.D0 * DSQRT(XNORM)/DBLE(NDIM)
      WRITE(12,9000)
      F = 2.D0 * F
      WRITE(12,9005) F
      IF (NCOVMOD.NE.0) THEN
        WRITE(12,9010) XNORM
        WRITE(12,9012) XCHI2,IW,XPROB
        JJ=1
        DO 308 K=1,NCOVMOD
          KK = IMOD(K)
          IF (KK.NE.I.AND.(IGAM(KK,1).GE.1.OR.INOR(KK,1).GE.1)) JJ=0
  308   CONTINUE
        IF (JJ.EQ.1) THEN
           R2M = 1.D0 - DEXP (- XCHI2 /DBLE(NTOT))
           WRITE(12,9013) R2M
        ENDIF
      ENDIF
      IF (NCTEST.GE.2.AND.NCTEST.LE.4) THEN
       WRITE(12,9015)
       WRITE(12,9018) LABEL2(3),IDF(0,1),XLIK(0,1)
       IM1=0
       DO 310 J=1,NCOVMOD
       I = IMOD(J)
       IF (J.GT.1) THEN
          IM1 = IMOD(J-1)
       ELSE
          IM1 = 0
       ENDIF
       IF (XLIK(I,1).EQ.0.D0) THEN
         WRITE(12,9022) LABEL(I)
         IDF(I,1) = IDF(IM1,1)
         XLIK(I,1) = XLIK(IM1,1)
         GOTO 310
       ENDIF
       IW = IDF(I,1) - IDF(IM1,1)
       XCHI2 = XLIK(IM1,1) - XLIK(I,1)
       IF (IW.GT.0) THEN
         IF (XCHI2.LE.0.D0) THEN
            XPROB = 0.D0
         ELSE
            W = DBLE(IW)
            CALL CHSCDF(XCHI2,IW,XPROB)
            XPROB = 1.D0 - XPROB
         ENDIF
       ELSE
         XPROB = 0.D0
       ENDIF
      IF (IGAM(I,1).EQ.0.AND.INOR(I,1).EQ.0) THEN
        R2M = XLIK(0,1) - XLIK(I,1)
        R2M = 1.D0 - DEXP (- R2M /DBLE(NTOT))
        WRITE(12,9019) LABEL(I),IDF(I,1),XLIK(I,1),XCHI2,IW,XPROB,
     +         R2M
      ELSE
        WRITE(12,9021) LABEL(I),IDF(I,1),XLIK(I,1),XCHI2
      ENDIF
        IF (J.EQ.NCOVMOD) THEN
          XCHI2L=XCHI2
          IWL = IW
          XPROBL=XPROB
        ENDIF
        IM1=I
  310   CONTINUE
      ENDIF
      IF ((NCTEST.EQ.1).OR.(NCTEST.GE.3)) THEN
       WRITE(12,9016)
       DO 320 J=1,NCOVMOD
       I = IMOD(J)
       IF (IDF(I,2).EQ.0) GOTO 320
       II = IMOD(NCOVMOD)
       IW= IDF(II,1) - IDF(I,2)
       W = DBLE(IW)
       IF (IW.GT.0.D0) THEN
          XCHI2 = XLIK(I,2) - XLIK(II,1)
          IF (XCHI2.LT.0.D0) THEN
            XPROB = 0.D0
          ELSE
            CALL CHSCDF(XCHI2,IW,XPROB)
            XPROB = 1.D0 - XPROB
          ENDIF
       ELSE
          XCHI2 = 0.D0
          XPROB = 0.D0
       ENDIF
       IF (IGAM(I,1).EQ.0.AND.INOR(I,1).EQ.0)THEN
         R2M = XLIK(0,1) - XLIK(I,2)
         R2M = 1.D0 - DEXP (- R2M /DBLE(NTOT))
         WRITE(12,9019) LABEL(I),IDF(I,2),XLIK(I,2),XCHI2,IW,XPROB,
     +               R2M
       ELSE
          WRITE(12,9021) LABEL(I),IDF(I,2),XLIK(I,2),XCHI2
       ENDIF
  320   CONTINUE
      ENDIF
 9000 FORMAT(/7X,'*******  RESULTS  ********')
 9005 FORMAT(/1X,' -2 LOG LIKELIHOOD                       ',G20.10)
 9010 FORMAT(1X,' STANDARDIZED NORM OF GRAD(-2 LOG L) = ',F15.5)
 9012 FORMAT(/7X,'*******  TESTS    ********',//1X,
     +' LIKELIHOOD RATIO TEST FOR H0: BETA = 0 ',/1X,
     +' MODEL CHI2 = ',G15.7,' WITH ',I7,' DF   (PROB >CHI2 =',F10.4,
     +')')
 9013 FORMAT('  R2 OF MADDALA (=MEASURE OF EXPLAINED VARIATION) = ',
     + F7.4)
 9015 FORMAT(/1X,' LIKELIHOOD RATIO TESTS : SEQUENTIAL ',/1X,
     +' VARIABLE    TOTAL        -2 LOG LIK     CHI2    ',
     +' DELTA    PROB   R2 OF',/1X,
     +'   Z          DF          INCLUDING Z             ',
     +'  DF     >CHI2  MADDALA'/)
 9016 FORMAT(/1X,' LIKELIHOOD RATIO TESTS : LAST       ',/1X,
     +' VARIABLE    TOTAL        -2 LOG LIK     CHI2    ',
     +' DELTA    PROB   R2 OF',/1X,
     +'   Z         DF          EXCLUDING Z              ',
     +'  DF     >CHI2  MADDALA'/)
 9018 FORMAT(3X,A12,I2,9X,G15.10)
 9019 FORMAT(3X,A8,I6,9X,G15.10,1X,G10.5,I4,2X,F6.4,2X,F6.4)
 9021 FORMAT(3X,A8,I6,9X,G15.10,1X,G10.5,'   *  (RANDOM)')
 9022 FORMAT(3X,A8,' +')
 9030 FORMAT(/1X,' CONVERGENCE AFTER',I6,
     +    ' EVALUATIONS OF FUNCTION FCOX IN ',F10.2,' SECONDS')
C
      XINTER = 0.D0
      IF (NSTD.NE.1) THEN
C-----------------------------------------------------------------------
C NSTD <>1 ==> DO NOT COMPUTE STANDARD ERRORS
C-----------------------------------------------------------------------
       IF (NCOVMOD.NE.0) WRITE(12,9038)
       DO 330 J=1,NCOVMOD
            II = IMOD(J)
            IF (ISAME(II).NE.0) GOTO 330
            IF (ICOVTYP(II).LE.0) THEN
             VARTYP = LABEL2(1)
            ELSE
             VARTYP = LABEL2(2)
            ENDIF
            WRITE(12,9040) J,LABEL(II),VARTYP
            DO 335 I=IFIRST(II),ILAST(II)
             KK = IOLDCODE(I,4)
             IF (KK.EQ.0) GOTO 335
             K = IFIRST(II) + KK - 1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on october 21, 1996 (= group of unknown parents)
             IF (IOLDCODE(I,4).LT.0) K = ILAST(II) + IOLDCODE(I,4) +1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             BSOL = BETA(K)
             IF (ICOVTYP(II).LE.0) THEN
                BSOL = BSOL / XSQ(J)
                XINTER = XINTER + XAV(J) * BSOL
             ENDIF
             IF (BSOL.GT.-20.D0) THEN
               XRISK = DEXP(BSOL)
             ELSE
               XRISK = 0.D0
             ENDIF
             IF (NCOL(II).EQ.1) THEN
               IF (ICOVTYP(II).LE.0) THEN
                  WRITE(12,9045) IOLDCODE(I,1),BSOL,NFAIL(K)
               ELSE
                  WRITE(12,9044) IOLDCODE(I,1),BSOL,XRISK,NFAIL(K)
               ENDIF
             ELSE IF (NCOL(II).EQ.2) THEN
               WRITE(12,9043) IOLDCODE(I,1),IOLDCODE(I,2),
     +                       BSOL,XRISK,NFAIL(K)
             ELSE
              WRITE(12,9042) IOLDCODE(I,1),IOLDCODE(I,2),IOLDCODE(I,3)
     +                      ,BSOL,XRISK,NFAIL(K)
             ENDIF
  335       CONTINUE
  330    CONTINUE
 9038    FORMAT(/7X,'******* SOLUTIONS ********',//4X,
     +'          COVARIATE                ESTIMATE       RISK',
     +'   UNCENSORED ',/1X,
     +  '                                                     RATIO ',
     +'  FAILURES ')
 9040    FORMAT(/1X,I3,3X,A8,1X,A12)
 9042    FORMAT(4X,I8,' * ',I8,' * ',I8,3X,F12.4,3X,F10.4,1X,I8)
 9043    FORMAT(4X,I8,' * ',I8,14X,F10.4,3X,F10.4,1X,I8)
 9044    FORMAT(4X,I8,25X,F10.4,3X,F10.4,1X,I8)
 9045    FORMAT(4X,I8,25X,F10.4,9X,'*',6X,I8)

      ELSE
C-----------------------------------------------------------------------
C NSTD = 1 ==> COMPUTE STANDARD ERRORS
C-----------------------------------------------------------------------
       ICHECK = 0
       CALL FCOX2(BETA,F,GRADF,STD,DLDET,NSTATUS,NOPTION,NDIM)
       IF (NCOVMOD.NE.0) WRITE(12,9048)
       DO 340 J=1,NCOVMOD
            II = IMOD(J)
            IF (ISAME(II).NE.0) GOTO 340
            IF (ICOVTYP(II).LE.0) THEN
             VARTYP = LABEL2(1)
            ELSE
             VARTYP = LABEL2(2)
            ENDIF
            WRITE(12,9040) J,LABEL(II),VARTYP
            DO 345 I=IFIRST(II),ILAST(II)
             KK = IOLDCODE(I,4)
             IF (KK.EQ.0) GOTO 345
             K = IFIRST(II) + KK - 1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c             IF (IGAM(II,1).EQ.0.AND.INOR(II,1).EQ.0.AND.NFAIL(K).EQ.0)
c     +        BETA(K)=-999.99D0
c added on october 21, 1996 (= group of unknown parents)
             IF (IOLDCODE(I,4).LT.0) K = ILAST(II) + IOLDCODE(I,4) +1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             BSOL = BETA(K)
             IF (ICOVTYP(II).LE.0) THEN
                BSOL = BSOL / XSQ(J)
                XINTER = XINTER + XAV(J) * BSOL
             ENDIF
             IF (BSOL.GT.-20.D0) THEN
               XRISK = DEXP(BSOL)
             ELSE
               XRISK = 0.D0
             ENDIF
             IF (STD(K).GT.1.D-8) THEN
               XSTD = STD(K)
               IF (ICOVTYP(II).LE.0) XSTD = XSTD / XSQ(J)
               XCHI2 = BSOL / XSTD
               XCHI2 = XCHI2 * XCHI2
               IFAIL=0
               CALL CHSCDF(XCHI2,1,XPROB)
               XPROB = 1.D0 - XPROB
               IF (NCOL(II).EQ.1) THEN
                   IF (ICOVTYP(II).LE.0) THEN
                   WRITE(12,9055) IOLDCODE(I,1),BSOL,
     +                         XSTD,XCHI2,XPROB,NFAIL(K)
                   ELSE
                   WRITE(12,9054) IOLDCODE(I,1),BSOL,
     +                         XSTD,XCHI2,XPROB,XRISK,NFAIL(K)
                   ENDIF
               ELSE IF (NCOL(II).EQ.2) THEN
                   WRITE(12,9052) IOLDCODE(I,1),IOLDCODE(I,2),
     +                  BSOL,XSTD,XCHI2,XPROB,XRISK,NFAIL(K)
               ELSE
                   WRITE(12,9050) IOLDCODE(I,1),IOLDCODE(I,2),
     +            IOLDCODE(I,3),BSOL,XSTD,XCHI2,XPROB,XRISK,NFAIL(K)
               ENDIF
             ELSE
               IF (NCOL(II).EQ.1) THEN
                    WRITE(12,9064) IOLDCODE(I,1),BSOL,
     +                   XRISK,NFAIL(K)
               ELSE IF (NCOL(II).EQ.2) THEN
                   WRITE(12,9062) IOLDCODE(I,1),IOLDCODE(I,2),
     +                  BSOL,XRISK,NFAIL(K)
               ELSE
                   WRITE(12,9060) IOLDCODE(I,1),IOLDCODE(I,2),
     +            IOLDCODE(I,3),BSOL,XRISK,NFAIL(K)
               ENDIF
             ENDIF
  345      CONTINUE
  340    CONTINUE
C
 9048    FORMAT(/7X,'******* SOLUTIONS ********',//1X,
     +  ' COVARIATE :                ESTIMATE STANDARD',
     +  '    CHI2    PROB   RISK UNCENSORED',/1X,
     +  '                                      ERROR ',
     +  '            >CHI2   RATIO FAILURES')
c
 9050    FORMAT(1X,I8,' *',I6,' *',I6,1X,F10.4,1X,F8.4,
     +          1X,F8.2,2X,F6.4,1X,F8.3,2X,I6)
 9052    FORMAT(1X,I8,' *',I6,9X,F10.4,1X,F8.4,
     +          1X,F8.2,2X,F6.4,1X,F8.3,2X,I6)
 9054    FORMAT(1X,I8,17X,F10.4,1X,F8.4,
     +          1X,F8.2,2X,F6.4,1X,F8.3,2X,I6)
 9055    FORMAT(1X,I8,16X,G12.4,1X,G10.4,1X,
     +          F8.2,1X,F6.4,6X,'*',2X,I6)
 9060    FORMAT(1X,I8,' *',I6,' *',I6,1X,F10.4,
     + '      *        *       *   ',F8.3,2X,I6)
 9062    FORMAT(1X,I8,' *',I6,9X,F10.4,
     + '      *        *       *   ',F8.3,2X,I6)
 9064    FORMAT(1X,I8,17X,F10.4,
     + '      *        *       *   ',F8.3,2X,I6)
      ENDIF
      IF (XINTER.NE.0.D0) WRITE(12,9070) XINTER
 9070 FORMAT(//1X,' "INTERCEPT" (DUE TO CENTERING THE CONTINUOUS ',
     +      'COVARIATES)=  ',G12.6)
c
      IF (NSURV.NE.0) THEN
        CALL BASELINE(NDIM,NBASE,NSURV,0 ,BETA)
      ELSE IF (NBASE.NE.0) THEN
        CALL BASELINE(NDIM,1,NSURV,0 ,BETA)
      ENDIF
      IF (NKAPLAN.EQ.1)
     +            CALL BASELINE(NDIM,0,NSURV,1 ,BETA)
C
C CPU TIME
C
      TIM1= SECOND2() - TIM00
      IF (TIM1.NE.0) WRITE(6,9190) TIM1
      IF (TIM1.NE.0) WRITE(12,9190) TIM1
 9190 FORMAT(/1X,' TOTAL TIME = ',F10.2,' SECONDS'//)
C
C STORE RESULTS
C
      IF (NOLDS.EQ.1.OR.NOLDS.EQ.3) THEN
        ICODE=1
        CALL RWBACKUP(ICODE,FILE(8))
      ENDIF
	  
      if (parmout.ne.'NONE'.and.parmout.ne.' ') then
        print*,'Computation details are in file: ', trim(parmout)
      else
        print*,'Computation details were printed to the screen.'
      endif	  
      WRITE(6,9200) file(3)
 9200 FORMAT(1X, 'Results are in file: ',A40,
     +      //1X, 'Computations finished.')	  
	 
C
C-----------------------------------------------------------------------
C DELETE TEMPORARY FILE(S)
C-----------------------------------------------------------------------
      IF (NSTOR.NE.1) THEN
        OPEN(4,FILE=FILE(9),FORM='UNFORMATTED')
        CLOSE(4,STATUS='DELETE')
        IF (NSURV.NE.0) THEN
          OPEN(4,FILE=FILE(10),FORM='UNFORMATTED')
          CLOSE(4,STATUS='DELETE')
        ENDIF
      ENDIF
      CLOSE(12)
c
C***********************************************************************
      END
	  
