      SUBROUTINE FCOX2(BETA1,F,GRADF,STD,DLDET,NSTATUS,NOPTION,NDIM1)
C***********************************************************************
C  FCOX2         *                                    *  04 / 05 /1996 *
C***********************************************************************
C  COMPUTE THE FINAL VALUE OF - COX' PARTIAL LIKELIHOOD, ITS VECTOR OF *
C       DERIVATIVES AND THE MATRIX OF SECOND DERIVATIVES TO COMPUTE    *
C       THE STANDARD ERRORS OF THE ESTIMATES                           *
C***********************************************************************
c
      use parinclu2
c
      implicit none
c     real*8,allocatable :: DC_RISK(:) !DC_RISK(NDIMAX)
c     real*8,allocatable :: HESS(:,:),D2C_RISK(:,:) !all XX(NDIMAX2,NDIMAX2)

      REAL*8 CONST
C
      INTEGER NDIM1,ICHECK
      INTEGER I,J,JJ,K,L,LL,N,ICODE,IPRETIM,JOB
      INTEGER IPRESTR,LTAB
      INTEGER IA,IP,IM,IGPM,NSTATUS,NOPTION
      INTEGER IA2,IP2,IM2,IGPM2,IDEL,I2,J2,K2
C
      REAL TIM0,TIM1,SECOND2
C
      REAL*8 CUM_RISK,F,U,UMINUS,W,WMINUS,XFAIL,XCOV,XCOV2,R,X,DM1(7)
      REAL*8 DLDET,GAMLOG
      REAL*8 XGAINV,BETA1(*),GRADF(*),std(*)
      REAL*8 X2,Y,Y2,D1,D2,D3,D4,D5
C
c     allocate(DC_RISK(NDIMAX))
c     allocate(HESS(NDIMAX,NDIMAX))
c     allocate(D2C_RISK(NDIMAX,NDIMAX))
C
!      EQUIVALENCE (INFO(1,1),KREC(1))
!      EQUIVALENCE (IDATA(1,1),XDATA(1,1))
      DATA (DM1(I),I=1,7)/1.D0,1.33333333333333D0,2.D0,
     +  1.D0,1.3333333333D0,1.06666666667D0,1.4545454545455D0/
C
C-----------------------------------------------------------------------
C  INITIALIZATION
C-----------------------------------------------------------------------
C
      F = 0.D0
      XFAIL = 0.D0
      IPRESTR=0
      CUM_RISK = 0.D0
      DO 10 I = 1,NDIM1
       GRADF(I) = 0.D0
       DC_RISK(I) = 0.D0
       DO 8 J=1,NDIM1
       D2C_RISK(J,I) = 0.D0
       HESS(J,I) = 0.D0
    8   CONTINUE
   10 CONTINUE
      IPRETIM = 0
      TIM0 = SECOND2()
C-----------------------------------------------------------------------
C  CONSTRAINT(S)
C-----------------------------------------------------------------------
      IF (ICHECK.NE.1) THEN
       DO 15 I = 1,ICONS(0)
       BETA1(ICONS(I)) = 0.D0
   15   CONTINUE
      ENDIF

C-----------------------------------------------------------------------
C   RANDOM EFFECTS
C-----------------------------------------------------------------------
c In case of CORRELATED random effects, compute corr form zeta
      if (corrflag) then
          X=exp(zeta)
          corr= (1.d0-2.d0*X)/(1.d0+2.d0*X)
      endif
c 
C computations for the RANDOM effect
      IF (NRAND.NE.0) THEN
       DO 300 I = 1,MAXRAND
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on April 3, 2000
       IF (ISAME(I).NE.0) GOTO 300
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       IF (IGAM(I,1).GE.1) THEN
             XGAINV=1.D0/XGAM(I)
             U = -XGAINV * DLOG(XGAM(I)) - GAMLOG(XGAINV)
c             U = XGAM(I) * DLOG(XGAM(I)) - GAMLOG(XGAM(I))
             DO 310 J = IGAM(I,2),IGAM(I,3)
               K = 0
               DO JJ = 1,ICONS(0)
                 IF (ICONS(JJ).EQ.J) K=1
               ENDDO
               IF (K.EQ.1) GOTO 310
             W = DEXP(BETA1(J))
             F = F - U - XGAINV * (BETA1(J) - W)
c             F = F - U - XGAM(I) * (BETA1(J) - W)
             GRADF(J) = GRADF(J) - XGAINV * (1.D0 - W)
c             GRADF(J) = GRADF(J) - XGAM(I) * (1.D0 - W)
             HESS(J,J) = HESS(J,J) + XGAINV * W
c             HESS(J,J) = HESS(J,J) + XGAM(I) * W
  310        CONTINUE
       ELSE IF (INOR(I,1).GE.1) THEN
!!!! uncorrelated random effects - this part remains as it was before
            if (icorr(i,2).eq.0) then
!!!!
             CONST = -0.5D0 * DLOG(XNOR(I))
c reference to NRELMAT2 added on Feb 6 2012
             IF (NRELMAT.EQ.0.OR.I.NE.NRELMAT2) THEN
             U = 1.D0 / XNOR(I)
             DO 312 J = INOR(I,2),INOR(I,3)
                  K = 0
                  DO JJ = 1,ICONS(0)
                   IF (ICONS(JJ).EQ.J) K=1
                  ENDDO
                  IF (K.EQ.1) GOTO 312
                  W = U * BETA1(J)
                  F = F - CONST + 0.5D0 * W * BETA1(J)
                  GRADF(J) = GRADF(J) + W
                  HESS(J,J) = HESS(J,J) + U
  312          CONTINUE
             ELSE
             U = 1.D0 / XNOR(NRELMAT2)
             IF (NRULE.EQ.1) THEN
             DO 320 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
                   IF (IPEDIG(2,K).LE.0) GOTO 320
                   F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
               IA = IPEDIG(1,K)
               IP = IPEDIG(3,K)
               IM = IPEDIG(4,K)
               X = BETA1(IA)
               IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
               IF (IM.GT.0) X = X - 0.5D0 * BETA1(IM)
               W = U * DM1(IPEDIG(2,K))
               X = W * X
               GRADF(IA) = GRADF(IA) + X
               HESS(IA,IA)= HESS(IA,IA) + W
               IF (IP.GT.0) THEN
                 GRADF(IP) = GRADF(IP) - 0.5D0 * X
                 HESS(IA,IP) = HESS(IA,IP) - 0.5D0 * W
                 HESS(IP,IA) = HESS(IP,IA) - 0.5D0 * W
                 HESS(IP,IP) = HESS(IP,IP) + 0.25D0 * W
               ENDIF
               IF (IM.GT.0) THEN
                 GRADF(IM) = GRADF(IM) - 0.5D0 * X
                 HESS(IA,IM) = HESS(IA,IM) - 0.5D0 * W
                 HESS(IM,IA) = HESS(IM,IA) - 0.5D0 * W
                 HESS(IM,IM) = HESS(IM,IM) + 0.25D0 * W
                 IF (IP.GT.0) THEN
                   HESS(IP,IM) = HESS(IP,IM) + 0.25D0 * W
                   HESS(IM,IP) = HESS(IM,IP) + 0.25D0 * W
                 ENDIF
               ENDIF
  320        CONTINUE
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Modified on September 26, 1997
              J=I
               DO 322 K=INOR(I,2),INOR(J,3)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                  F = F +0.5d0*BETA1(K)*GRADF(K)
  322          CONTINUE
             ELSE IF (NRULE.EQ.2) THEN
                 DO 330 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
                   IF (IPEDIG(2,K).LE.0) GOTO 330
                   F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                   IA = IPEDIG(1,K)
                   IP = IPEDIG(3,K)
                   IGPM = IPEDIG(4,K)
                   X = BETA1(IA)
                   IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
                   IF (IGPM.GT.0) X = X - 0.25D0 * BETA1(IGPM)
                   W = U * DM1(IPEDIG(2,K))
                   X = W * X
                   GRADF(IA) = GRADF(IA) + X
                   HESS(IA,IA)= HESS(IA,IA) + W
                   IF (IP.GT.0) THEN
                   GRADF(IP) = GRADF(IP) - 0.5D0 * X
                   HESS(IA,IP) = HESS(IA,IP) - 0.5D0 * W
                   HESS(IP,IA) = HESS(IP,IA) - 0.5D0 * W
                   HESS(IP,IP) = HESS(IP,IP) + 0.25D0 * W
                   ENDIF
                   IF (IGPM.GT.0) THEN
                   GRADF(IGPM)=GRADF(IGPM) -0.25D0 * X
                   HESS(IA,IGPM)=HESS(IA,IGPM) -0.25D0 * W
                   HESS(IGPM,IA)=HESS(IGPM,IA) -0.25D0 * W
                   HESS(IGPM,IGPM)=HESS(IGPM,IGPM)+0.0625D0*W
                   IF (IP.GT.0) THEN
                   HESS(IP,IGPM)=HESS(IP,IGPM) +0.125D0 * W
                   HESS(IGPM,IP)=HESS(IGPM,IP) +0.125D0 * W
                   ENDIF
                   ENDIF
  330            CONTINUE
                 DO 332 K=INOR(I,2),INOR(I,3)
                  F = F +0.5d0*BETA1(K)*GRADF(K)
  332            CONTINUE
               ENDIF
             ENDIF
!!!!!!!!!!!!!
!!!! correlated random effects - beginning
            else if (icorr(i,1).gt.0) then
!!!!
             I2=icorr(i,2)
             CONST = -0.5D0 * (DLOG(XNOR(I))+DLOG(XNOR(I2))+
     +                    DLOG(1.d0-corr*corr))
 ! difference between positions of the 2 random effects in the whole list	 
             IDEL=INOR(I2,2)-INOR(I,2)
! in case of no relationship matrix
! reference to NRELMAT2 added on Feb 6 2012
             IF (NRELMAT.EQ.0.OR.I.NE.NRELMAT2) THEN
              DO 412 J = INOR(I,2),INOR(I,3)
               J2=J+IDEL
               F = F -CONST+ 0.5D0 * (VM1(1,1)*BETA1(J)*BETA1(J)
     +                     + 2.D0 * VM1(1,2)*BETA1(J)*BETA1(J2)
     +                     + VM1(2,2) * BETA1(J2)*BETA1(J2) )
               GRADF(J) = GRADF(J) + VM1(1,1)*BETA1(J)
     +                             + VM1(1,2)*BETA1(J2)
               GRADF(J2) = GRADF(J2) + VM1(2,1)*BETA1(J)
     +                               + VM1(2,2)*BETA1(J2)
               HESS(J,J) = HESS(J,J) + VM1(1,1)
	       HESS(J,J2) = HESS(J,J2) + VM1(1,2)
	       HESS(J2,J) = HESS(J2,J) + VM1(2,1)
               HESS(J2,J2) = HESS(J2,J2) + VM1(2,2)
  412         CONTINUE
             ELSE
! with relationship matrix 
             IF (NRULE.EQ.1) THEN
              DO 420 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
               IF (IPEDIG(2,K).LE.0) GOTO 420
               F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
               IA = IPEDIG(1,K)
               IP = IPEDIG(3,K)
               IM = IPEDIG(4,K)
               IA2= IA+IDEL
               IP2= IP+IDEL
               IM2= IM+IDEL
               X = BETA1(IA)
               X2= BETA1(IA2)
               IF (IP.GT.0) THEN
                  X = X - 0.5D0 * BETA1(IP)
                  X2= X2 - 0.5D0 * BETA1(IP2)
               ENDIF
               IF (IM.GT.0) THEN
                  X = X - 0.5D0 * BETA1(IM)
                  X2 = X2 - 0.5D0 * BETA1(IM2)
               ENDIF
               D1= DM1(IPEDIG(2,K))
               D2 = 0.5d0* D1
               D3 = 0.25d0* D1
               Y = D1 * (VM1(1,1)*X + VM1(1,2)*X2)
               Y2 = D1 * (VM1(1,2)*X + VM1(2,2)*X2)
               GRADF(IA) = GRADF(IA) + Y
               GRADF(IA2) = GRADF(IA2) + Y2
               HESS(IA,IA)= HESS(IA,IA)+ D1 *VM1(1,1) 
               HESS(IA,IA2)= HESS(IA,IA2)+ D1 *VM1(1,2) 
               HESS(IA2,IA)= HESS(IA2,IA)+ D1 *VM1(2,1) 
               HESS(IA2,IA2)= HESS(IA2,IA2)+ D1 *VM1(2,2) 
               IF (IP.GT.0) THEN
                  GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                  GRADF(IP2) = GRADF(IP2) - 0.5D0 * Y2
                  HESS(IA,IP) = HESS(IA,IP) - D2 *VM1(1,1) 
                  HESS(IP,IA) = HESS(IP,IA) - D2 *VM1(1,1) 
                  HESS(IP,IP) = HESS(IP,IP) + D3 *VM1(1,1)
                  HESS(IA,IP2) = HESS(IA,IP2) - D2 *VM1(1,2) 
                  HESS(IP,IA2) = HESS(IP,IA2) - D2 *VM1(1,2) 
                  HESS(IP,IP2) = HESS(IP,IP2) + D3 *VM1(1,2)
                  HESS(IA2,IP) = HESS(IA2,IP) - D2 *VM1(2,1) 
                  HESS(IP2,IA) = HESS(IP2,IA) - D2 *VM1(2,1) 
                  HESS(IP2,IP) = HESS(IP2,IP) + D3 *VM1(2,1)
                  HESS(IA2,IP2) = HESS(IA2,IP2) - D2 *VM1(2,2) 
                  HESS(IP2,IA2) = HESS(IP2,IA2) - D2 *VM1(2,2) 
                  HESS(IP2,IP2) = HESS(IP2,IP2) + D3 *VM1(2,2)
               ENDIF
               IF (IM.GT.0) THEN
                  GRADF(IM) = GRADF(IM) - 0.5D0 * Y
                  GRADF(IM2) = GRADF(IM2) - 0.5D0 * Y2
                  HESS(IA,IM) = HESS(IA,IM) - D2 *VM1(1,1) 
                  HESS(IM,IA) = HESS(IM,IA) - D2 *VM1(1,1) 
                  HESS(IM,IM) = HESS(IM,IM) + D3 *VM1(1,1)
                  HESS(IA,IM2) = HESS(IA,IM2) - D2 *VM1(1,2) 
                  HESS(IM,IA2) = HESS(IM,IA2) - D2 *VM1(1,2) 
                  HESS(IM,IM2) = HESS(IM,IM2) + D3 *VM1(1,2)
                  HESS(IA2,IM) = HESS(IA2,IM) - D2 *VM1(2,1) 
                  HESS(IM2,IA) = HESS(IM2,IA) - D2 *VM1(2,1) 
                  HESS(IM2,IM) = HESS(IM2,IM) + D3 *VM1(2,1)
                  HESS(IA2,IM2) = HESS(IA2,IM2) - D2 *VM1(2,2) 
                  HESS(IM2,IA2) = HESS(IM2,IA2) - D2 *VM1(2,2) 
                  HESS(IM2,IM2) = HESS(IM2,IM2) + D3 *VM1(2,2)
                  IF (IP.GT.0) THEN
                    HESS(IP,IM) = HESS(IP,IM) + D3 *VM1(1,1)
                    HESS(IP,IM2) = HESS(IP,IM2) + D3 *VM1(1,2)
                    HESS(IP2,IM) = HESS(IP2,IM) + D3 *VM1(2,1)
                    HESS(IP2,IM2) = HESS(IP2,IM2) + D3 *VM1(2,2)
                  ENDIF
               ENDIF
  420         CONTINUE
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Modified on September 26, 1997
              J=I
              DO 422 K=INOR(I,2),INOR(J,3)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                K2=K+IDEL
                F = F +0.5 *(BETA1(K)*GRADF(K)+BETA1(K2)*GRADF(K2))
  422         CONTINUE
             ELSE IF (NRULE.EQ.2) THEN
              DO 430 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
               IF (IPEDIG(2,K).LE.0) GOTO 430
               F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
               IA = IPEDIG(1,K)
               IP = IPEDIG(3,K)
               IGPM = IPEDIG(4,K)
               IA2= IA+IDEL
               IP2= IP+IDEL
               IGPM2= IGPM+IDEL
               X = BETA1(IA)
               X2= BETA1(IA2)
               IF (IP.GT.0) THEN
                  X = X - 0.5D0 * BETA1(IP)
                  X2 = X2 - 0.5D0 * BETA1(IP2)
               ENDIF
               IF (IGPM.GT.0) THEN
                  X = X - 0.25D0 * BETA1(IGPM)
                  X2 = X2 - 0.25D0 * BETA1(IGPM2)
               ENDIF
               D1= DM1(IPEDIG(2,K))
               D2 = 0.5d0* D1
               D3 = 0.25d0* D1
	           D4 = 0.125d0 *D1
	           D5= 0.0625d0* D1
               Y = D1 * (VM1(1,1)*X + VM1(1,2)*X2)
               Y2 = D1 * (VM1(1,2)*X + VM1(2,2)*X2)
               GRADF(IA) = GRADF(IA) + Y
               GRADF(IA2) = GRADF(IA2) + Y2
               HESS(IA,IA)= HESS(IA,IA)+ D1 *VM1(1,1)
               HESS(IA,IA2)= HESS(IA,IA2)+ D1 *VM1(1,2)
               HESS(IA2,IA)= HESS(IA2,IA)+ D1 *VM1(2,1)
               HESS(IA2,IA2)= HESS(IA2,IA2)+ D1 *VM1(2,2)
               IF (IP.GT.0) THEN
                  GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                  GRADF(IP2) = GRADF(IP2) - 0.5D0 * Y2
                  HESS(IA,IP) = HESS(IA,IP) - D2 *VM1(1,1)
                  HESS(IP,IA) = HESS(IP,IA) - D2 *VM1(1,1)
                  HESS(IP,IP) = HESS(IP,IP) + D3 *VM1(1,1)
                  HESS(IA,IP2) = HESS(IA,IP2) - D2 *VM1(1,2)
                  HESS(IP,IA2) = HESS(IP,IA2) - D2 *VM1(1,2)
                  HESS(IP,IP2) = HESS(IP,IP2) + D3 *VM1(1,2)
                  HESS(IA2,IP) = HESS(IA2,IP) - D2 *VM1(2,1)
                  HESS(IP2,IA) = HESS(IP2,IA) - D2 *VM1(2,1)
                  HESS(IP2,IP) = HESS(IP2,IP) + D3 *VM1(2,1)
                  HESS(IA2,IP2) = HESS(IA2,IP2) - D2 *VM1(2,2)
                  HESS(IP2,IA2) = HESS(IP2,IA2) - D2 *VM1(2,2)
                  HESS(IP2,IP2) = HESS(IP2,IP2) + D3 *VM1(2,2)
               ENDIF
               IF (IGPM.GT.0) THEN
                  GRADF(IGPM)=GRADF(IGPM) -0.25D0 * Y
                  GRADF(IGPM2)=GRADF(IGPM2) -0.25D0 * Y2
                  HESS(IA,IGPM) = HESS(IA,IGPM) - D3 *VM1(1,1)
                  HESS(IGPM,IA) = HESS(IGPM,IA) - D3 *VM1(1,1)
                  HESS(IGPM,IGPM) = HESS(IGPM,IGPM) + D5 *VM1(1,1)
                  HESS(IA,IGPM2) = HESS(IA,IGPM2) - D3 *VM1(1,2)
                  HESS(IGPM,IA2) = HESS(IGPM,IA2) - D3 *VM1(1,2)
                  HESS(IGPM,IGPM2) = HESS(IGPM,IGPM2) + D5 *VM1(1,2)
                  HESS(IA2,IGPM) = HESS(IA2,IGPM) - D3 *VM1(2,1)
                  HESS(IGPM2,IA) = HESS(IGPM2,IA) - D3 *VM1(2,1)
                  HESS(IGPM2,IGPM) = HESS(IGPM2,IGPM) + D5 *VM1(2,1)
                  HESS(IA2,IGPM2) = HESS(IA2,IGPM2) - D3 *VM1(2,2)
                  HESS(IGPM2,IA2) = HESS(IGPM2,IA2) - D3 *VM1(2,2)
                  HESS(IGPM2,IGPM2) = HESS(IGPM2,IGPM2) + D5 *VM1(2,2)
                  IF (IP.GT.0) THEN
                    HESS(IP,IGPM) = HESS(IP,IGPM) + D4 *VM1(1,1)
                    HESS(IP,IGPM2) = HESS(IP,IGPM2) + D4 *VM1(1,2)
                    HESS(IP2,IGPM) = HESS(IP2,IGPM) + D4 *VM1(2,1)
                    HESS(IP2,IGPM2) = HESS(IP2,IGPM2) + D4 *VM1(2,2)
                  ENDIF
               ENDIF
  430         CONTINUE
              DO 432 K=INOR(I,2),INOR(I,3)
                K2=K+IDEL
                F = F + 0.5 *(BETA1(K)*GRADF(K)+ BETA1(K2)*GRADF(K2))
  432         CONTINUE
             ENDIF
             ENDIF
!!!! correlated random effects - end
            endif
!!!!
       ENDIF
  300   CONTINUE
      ENDIF
C
C-----------------------------------------------------------------------
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IF (nstor.ne.1)
     + OPEN(4,file=file(9),status='old',FORM='UNFORMATTED')

  100 IF (NSTOR.NE.1) THEN
       READ(4,END=199) NREC,LTAB,
     +  ((blockb%info(i,j),i=1,3),j=1,nrecmax),
     +  ((blockb%idata(i,j),i=1,mxef_used),j=1,nrecmax),
     +	((blockb%xdata(i,j),i=1,mxef_used),j=1,nrecmax)
      ENDIF
C
C-----------------------------------------------------------------------
C   FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
      DO 190 I=1,NREC
C
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD WAS THE LAST RECORD WITH TIME = IPRETIM
C   UPDATE F (COX PARTIAL LIKELIHOOD) AND GRADF (ITS GRADIENT)
C   XFAIL IS THE NUMBER FAILING AT TIME IPRETIM
C-----------------------------------------------------------------------
       IF ((blockb%info(1,I).NE.IPRETIM).AND.(IPRETIM.NE.0)) THEN
       IF ((CUM_RISK.GT.1.D-10).AND.(XFAIL.NE.0)) THEN
            F = F + XFAIL * DLOG(CUM_RISK)
            DO 20 J=1,NDIM1
             IF (DC_RISK(J).NE.0.D0) THEN
             GRADF(J) = GRADF(J) + XFAIL * DC_RISK(J) / CUM_RISK
             DO 18 K=1,NDIM1
                  IF (DC_RISK(K).NE.0.D0)
     +            HESS(K,J)= HESS(K,J) + (XFAIL / CUM_RISK) *
     +            (D2C_RISK(K,J) -(DC_RISK(J) * DC_RISK(K)) / CUM_RISK)
   18           CONTINUE
             ENDIF
   20       CONTINUE
            XFAIL = 0.D0
       ENDIF
       ENDIF
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD HAS A DIFFERENT STRATUM ID ==> NEW STRATUM
C   INITIALIZE CUM_RISK (CUMULATIVE RISK FOR ALL ANIMALS) AND VECTOR
C   DC_RISK (CUMULATED CONTRIBUTION FOR EACH LEVEL TO BE USED IN
C   COMPUTING GRADF) + D2C_RISK (TO BE USED IN COMPUTING HESSIAN)
C-----------------------------------------------------------------------
       IPRETIM =blockb%info(1,I)
       ICODE = blockb%info(2,I)
       IF (NSTRATA.GT.1) THEN
       IF (blockb%info(3,I).NE.IPRESTR) THEN
             IF (IPRESTR.NE.0) THEN
             CUM_RISK = 0.D0
             DO 25 J = 1,NDIM1
             DC_RISK(J) = 0.D0
             DO 24 K=1,NDIM1
                   D2C_RISK(K,J) = 0.D0
   24            CONTINUE
   25          CONTINUE
             ENDIF
             IPRESTR=blockb%info(3,I)
       ENDIF
       ENDIF
C-----------------------------------------------------------------------
C   U = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C   UMINUS = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT AFTER CHANGE
C-----------------------------------------------------------------------
       U = 0.D0
       UMINUS = 0.D0
C-----------------------------------------------------------------------
C        IPLUS1/2 = 0 FOR TIME-INDEPENDENT COVARIATES
C             ==> CONTRIBUTES TO U (AND TO UMINUS IF NOT LAST RECORD)
C        IPLUS1/2 = +1 FOR TIME-DEPENDENT (BEFORE CHANGE)
C             ==> CONTRIBUTES TO U EXCEPT IF LEFT TRUNCATED RECORD
C        IPLUS1/2 = -1 FOR TIME-DEPENDENT (AFTER CHANGE)
C             ==> CONTRIBUTES TO UMINUS IF NOT LAST RECORD
C     FIRST, IR1 CONTINUOUS COVARIATES, THEN IR2 DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => EXP(Z'* BETA1) WILL BE = 0
C-----------------------------------------------------------------------
       K = 0
       DO 35 J=1,IR1
            XCOV = blockb%xdata(J,I)
            IF (IPLUS1(J).GT.0) THEN
             K = K+1
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
             IF (ICODE.GE.-1) U = U + R
            ELSE IF (IPLUS1(J).EQ.0) THEN
             K = K+1
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement :
c            U = U + R
c was corrected on October 16, 1996 for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.NE.-2) U = U + R
             IF (ICODE.LT.0) UMINUS= UMINUS + R
            ELSE IF (ICODE.LT.0) THEN
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
             UMINUS = UMINUS + R
            ENDIF
   35     CONTINUE
       DO 36 J=1,IR2
            JJ = J + IR1
            K = blockb%idata(JJ,I)
            if (k.LE.0) goto 36
            IF (IPLUS2(J).GT.0) THEN
             IF (ICODE.GE.-1) U = U + BETA1(K)
            ELSE IF (IPLUS2(J).EQ.0) THEN
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement :
c            U = U + BETA1(K)
c was corrected on October 16, 1996 for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.NE.-2) U = U + BETA1(K)
             IF (ICODE.LT.0) UMINUS = UMINUS + BETA1(K)
            ELSE IF (ICODE.LT.0) THEN
             UMINUS = UMINUS + BETA1(K)
            ENDIF
   36     CONTINUE
C
C-----------------------------------------------------------------------
C   DIVERGENCE ==> STOP
C-----------------------------------------------------------------------
       IF (U.GT.100.D0) THEN
       K = MIN(50,NDIM1)
       WRITE(6,*) 'OVERFLOW '
       WRITE(6,*) 'BETA1 =   '
       WRITE(6,*) (BETA1(J),J=1,K)
       WRITE(6,*) 'U    =   ',U
       STOP
       ENDIF
C
C-----------------------------------------------------------------------
C   COMPUTE W = EXP(U) AND WMINUS = EXP(UMINUS) AND UPDATE CUM_RISK
C            DEPENDING ON CODE
C-----------------------------------------------------------------------
       W = 0.D0
       WMINUS = 0.D0
C
       IF (U.GT.-20.D0) W = DEXP(U)
       IF (ICODE.GE.0) THEN
             CUM_RISK = CUM_RISK + W
       ELSE IF (ICODE.EQ.-1) THEN
             IF (UMINUS.GT.-20.D0) WMINUS = DEXP(UMINUS)
             CUM_RISK = CUM_RISK + W - WMINUS
       ELSE IF (ICODE.LE.-2) THEN
             IF (UMINUS.GT.-20.D0) WMINUS = DEXP(UMINUS)
             CUM_RISK = CUM_RISK - WMINUS
       ENDIF
C
C-----------------------------------------------------------------------
C   UPDATE VECTOR DC_RISK AND MATRIX D2C_RISK DEPENDING ON CODE
C   FIRST, IR1 CONTINUOUS COVARIATES, THEN IR2 DISCRETE COVARIATES
C-----------------------------------------------------------------------
       K = 0
       DO 45 J=1,IR1
            XCOV = blockb%xdata(J,I)
            IF (IPLUS1(J).GT.0) THEN
             K = K+1
             IF (ICODE.GE.-1) THEN
             DC_RISK(K) = DC_RISK(K) + XCOV * W
             N = 0
             DO 145 L=1,IR1
                  XCOV2 = blockb%xdata(L,I)
                  IF (IPLUS1(L).GE.0) THEN
                   N = N+1
                   D2C_RISK(K,N) = D2C_RISK(K,N) + XCOV * XCOV2 * W
                  ENDIF
  145          CONTINUE
             DO 245 L=1,IR2
                  LL = L + IR1
                  IF (IPLUS2(L).GE.0) THEN
                   N = blockb%idata(LL,I)
                   if (N.LE.0) goto 245
                   D2C_RISK(K,N) = D2C_RISK(K,N) + XCOV * W
                  ENDIF
  245          CONTINUE
             ENDIF
            ELSE IF (IPLUS1(J).EQ.0) THEN
             K = K+1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement :
c was added on October 16, 1996 for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.EQ.-2) GOTO 498
             DC_RISK(K) = DC_RISK(K) + XCOV * W
             N = 0
             DO 345 L=1,IR1
             XCOV2 = blockb%xdata(L,I)
             IF (IPLUS1(L).GE.0) THEN
                  N = N+1
                  D2C_RISK(K,N) = D2C_RISK(K,N) + XCOV * XCOV2 * W
             ENDIF
  345         CONTINUE
             DO 445 L=1,IR2
             LL = L + IR1
             IF (IPLUS2(L).GE.0) THEN
                  N = blockb%idata(LL,I)
                  if (N.LE.0) goto 445
                  D2C_RISK(K,N) = D2C_RISK(K,N) + XCOV * W
             ENDIF
  445         CONTINUE
  498        IF (ICODE.LT.0) THEN
             DC_RISK(K) = DC_RISK(K) - XCOV * WMINUS
             N = 0
             DO 545 L=1,IR1
                  IF (IPLUS1(L).GE.0) N=N+1
                  IF (IPLUS1(L).LE.0) THEN
                   XCOV2 = blockb%xdata(L,I)
                   D2C_RISK(K,N) =D2C_RISK(K,N) -XCOV * XCOV2 * WMINUS
                  ENDIF
  545           CONTINUE
             DO 645 L=1,IR2
                  LL = L + IR1
                  IF (IPLUS2(L).LE.0) THEN
                  N = blockb%idata(LL,I)
                  if (N.LE.0) goto 645
                   D2C_RISK(K,N) = D2C_RISK(K,N) - XCOV * WMINUS
                  ENDIF
  645           CONTINUE
             ENDIF
            ELSE IF (ICODE.LT.0) THEN
             DC_RISK(K) = DC_RISK(K) - XCOV * WMINUS
             N = 0
             DO 745 L=1,IR1
             IF (IPLUS1(L).GE.0) N=N+1
             IF (IPLUS1(L).LE.0) THEN
                  XCOV2 = blockb%xdata(L,I)
                  D2C_RISK(K,N) = D2C_RISK(K,N) - XCOV * XCOV2 * WMINUS
             ENDIF
  745         CONTINUE
             DO 845 L=1,IR2
             LL = L + IR1
             IF (IPLUS2(L).LE.0) THEN
                  N = blockb%idata(LL,I)
                  if (N.LE.0) goto 845
                  D2C_RISK(K,N) = D2C_RISK(K,N) - XCOV * WMINUS
             ENDIF
  845         CONTINUE
            ENDIF
   45     CONTINUE
C
       DO 46 J=1,IR2
            JJ = J + IR1
            K = blockb%idata(JJ,I)
            if (k.LE.0) goto 46
            IF (IPLUS2(J).GT.0) THEN
             IF (ICODE.GE.-1) THEN
             DC_RISK(K) = DC_RISK(K) + W
             N = 0
             DO 146 L=1,IR1
                  IF (IPLUS1(L).GE.0) N=N+1
                  IF (IPLUS1(L).GE.0) THEN
                  if (N.LE.0) goto 146
                   XCOV2 = blockb%xdata(L,I)
                   D2C_RISK(K,N) = D2C_RISK(K,N) + XCOV2 * W
                  ENDIF
  146           CONTINUE
             DO 246 L=1,IR2
                  LL = L + IR1
                  IF (IPLUS2(L).GE.0) THEN
                   N = blockb%idata(LL,I)
                   if (N.LE.0) goto 246
                   D2C_RISK(K,N) = D2C_RISK(K,N) + W
                  ENDIF
  246          CONTINUE
             ENDIF
            ELSE IF (IPLUS2(J).EQ.0) THEN
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement was added on October 16, 1996
c  for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.EQ.-2) GOTO 499
             DC_RISK(K) = DC_RISK(K) + W
             N = 0
             DO 346 L=1,IR1
             XCOV2 = blockb%xdata(L,I)
             IF (IPLUS1(L).GE.0) THEN
                  N = N+1
                  D2C_RISK(K,N) = D2C_RISK(K,N) + XCOV2 * W
             ENDIF
  346         CONTINUE
             DO 446 L=1,IR2
             LL = L + IR1
             IF (IPLUS2(L).GE.0) THEN
                   N = blockb%idata(LL,I)
                   if (N.LE.0) goto 446
                   D2C_RISK(K,N) = D2C_RISK(K,N) + W
             ENDIF
  446        CONTINUE
  499        IF (ICODE.LT.0) THEN
             DC_RISK(K) = DC_RISK(K) - WMINUS
             N = 0
             DO 546 L=1,IR1
                  IF (IPLUS1(L).GE.0) N=N+1
                  IF (IPLUS1(L).LE.0) THEN
                   XCOV2 = blockb%xdata(L,I)
                   D2C_RISK(K,N) =D2C_RISK(K,N) - XCOV2 * WMINUS
                  ENDIF
  546           CONTINUE
             DO 646 L=1,IR2
                  LL = L + IR1
                  IF (IPLUS2(L).LE.0) THEN
                   N = blockb%idata(LL,I)
                   if (N.LE.0) goto 646
                   D2C_RISK(K,N) = D2C_RISK(K,N) - WMINUS
                  ENDIF
  646           CONTINUE
             ENDIF
            ELSE IF (ICODE.LT.0) THEN
             DC_RISK(K) = DC_RISK(K) - WMINUS
             N = 0
             DO 746 L=1,IR1
             IF (IPLUS1(L).GE.0) N=N+1
             IF (IPLUS1(L).LE.0) THEN
                  XCOV2 = blockb%xdata(L,I)
                  D2C_RISK(K,N) = D2C_RISK(K,N) - XCOV2 * WMINUS
             ENDIF
  746         CONTINUE
             DO 846 L=1,IR2
             LL = L + IR1
             IF (IPLUS2(L).LE.0) THEN
                  N = blockb%idata(LL,I)
                  if (N.LE.0) goto 846
                  D2C_RISK(K,N) = D2C_RISK(K,N) - WMINUS
             ENDIF
  846         CONTINUE
            ENDIF
   46     CONTINUE
C
C-----------------------------------------------------------------------
C   IF UNCENSORED RECORD, UPDATE F AND GRADF
C-----------------------------------------------------------------------
       K = 0
       IF (ICODE.GE.1) THEN
       XFAIL = XFAIL + 1.D0
       F = F - U
       DO 50 J=1,IR1
            IF (IPLUS1(J).GE.0) THEN
             K = K+1
             GRADF(K) = GRADF(K) - blockb%xdata(J,I)
            ENDIF
   50     CONTINUE
       DO 51 J=1,IR2
            JJ = J + IR1
            IF (IPLUS2(J).GE.0) THEN
             K = blockb%idata(JJ,I)
             if (K.LE.0) goto 51
             GRADF(K) = GRADF(K) - 1.D0
            ENDIF
   51     CONTINUE
       ENDIF
C
  190 CONTINUE
      IF (NSTOR.NE.1) GOTO 100

  199 IF (NSTOR.NE.1) CLOSE(4)
C
C-----------------------------------------------------------------------
C   LAST CONTRIBUTION TO F AND GRADF
C-----------------------------------------------------------------------
      IF ((CUM_RISK.GT.1.D-10).AND.(XFAIL.NE.0)) THEN
       F = F + XFAIL * DLOG(CUM_RISK)
       DO 200 J=1,NDIM1
       IF (DC_RISK(J).NE.0.D0) THEN
            GRADF(J) = GRADF(J) + XFAIL * DC_RISK(J) / CUM_RISK
            DO 205 K=1,NDIM1
             IF (DC_RISK(K).NE.0.D0)
     +         HESS(K,J)= HESS(K,J) + (XFAIL / CUM_RISK) *
     +          (D2C_RISK(K,J) -(DC_RISK(J) * DC_RISK(K)) / CUM_RISK)
  205       CONTINUE
       ENDIF
  200   CONTINUE
      ENDIF
C
C
C-----------------------------------------------------------------------
C   CONSTRAINTS ON GRADF AND HESSIAN
C-----------------------------------------------------------------------
       ICODE=0
       IF (NOPTION.GE.90) THEN
C----------------------------------------------------------------------
C  NUMERICAL FACTORIZATION TO LOOK FOR CONSTRAINTS
C----------------------------------------------------------------------
         ICODE=1
         CALL CHOLESKY(HESS,NDIMAX,NDIM1,J,ICODE)
         IF (NOPTION.EQ.90) RETURN
       ENDIF
C
      IF (ICHECK.NE.1) THEN
       DO 210 I = 1,ICONS(0)
       GRADF(ICONS(I)) = 0.D0
       DO 209 J=1,NDIM1
             HESS(J,ICONS(I))=0.D0
             HESS(ICONS(I),J)=0.D0
  209     CONTINUE
  210   CONTINUE
      ENDIF
C----------------------------------------------------------------------
C   END OF THE CONSTRUCTION OF THE HESSIAN
C----------------------------------------------------------------------
      TIM1=SECOND2()
      TIM0 = TIM1 - TIM0
      WRITE(6,9000) F,TIM0
 9000 FORMAT(1X,' VALUE OF F =',G20.12,/1X,
     +   ' TIME FOR THE COMPUTATION OF THE HESSIAN = ',F8.2,' SECONDS')
      TIM0 = TIM1
c
c print when debugging (delete the condition NDIM1.lt.-1)
c
       IF (NDIM1.lt.-1) THEN
c     IF (NDIM1.ne.-1) THEN
      DO 750 J=1,NDIM1
        DO 752 I=J,NDIM1
           HESS(I,J)=HESS(J,I)
           H(I,J)=HESS(J,I)
           H(J,I)=HESS(J,I)
  752   CONTINUE
  750 CONTINUE
c
       DLDET=0.D0
       ENDIF
C----------------------------------------------------------------------
C  NUMERICAL FACTORIZATION
C----------------------------------------------------------------------
       CALL CHOLESKY(HESS,NDIMAX,NDIM1,J,ICODE)
       TIM1=SECOND2()
       TIM0 = TIM1 - TIM0
       WRITE(6,9010) TIM0
 9010 FORMAT(1X,' TIME FOR NUMERICAL FACTORIZATION = ',F8.2,' SECONDS')
       TIM0 = TIM1
C
C----------------------------------------------------------------------
C  IF NOPTION = 1 ==> COMPUTATION OF THE LOG-DETERMINANT
C----------------------------------------------------------------------
      IF (NOPTION.EQ.1.OR.ICHECK.GT.0) THEN
	JOB=10
	CALL INVDET(HESS,NDIMAX,NDIM1,DLDET,JOB)
	TIM1=SECOND2()
	TIM0 = TIM1 - TIM0
        WRITE(6,9020) TIM0
 9020   FORMAT(1X,' TIME TO COMPUTE LOG-DETERMINANT = ',F8.2,' SECONDS')
        TIM0 = TIM1
      ENDIF
C-----------------------------------------------------------------------
C  IF NOPTION = 0 ==> COMPUTATION OF THE STANDARD DEVIATIONS
C-----------------------------------------------------------------------
      IF (NOPTION.EQ.0.OR.ICHECK.GT.0) THEN
        JOB=1
        CALL INVDET(HESS,NDIMAX,NDIM1,DLDET,JOB)
        DO 760 I=1,NDIM1
          STD(I) = HESS(I,I)
          IF (STD(I).GT.1.D-10) THEN
             STD(I) = DSQRT(STD(I))
          ELSE IF (STD(I).LT.-1.D-6) THEN
             WRITE(6,*) 'A NEGATIVE VALUE WAS FOUND ON THE DIAGONAL OF',
     +      ' THE HESSIAN'
          ELSE
            STD(I)=0.D0
          ENDIF
c        WRITE(6,*) 'I = ',I1,' STD(I) = ',STD(I)
  760   CONTINUE
      ENDIF
C
c     deallocate(D2C_RISK)
c     deallocate(HESS)
      RETURN
C***********************************************************************
      END
