      SUBROUTINE FCOX(BETA1,F,GRADF,NDIM1,NSTATE,IUSER)
C***********************************************************************
C  FCOX          *                                    *  04 / 05 /1993 *
C***********************************************************************
C  COMPUTE THE VALUE OF - COX' PARTIAL LIKELIHOOD AND ITS VECTOR OF    *
C       DERIVATIVES                                                    *
C***********************************************************************
c
      use parinclu2
c
      implicit none
c     real*8,allocatable :: DC_RISK(:) !all NDIMAX

      REAL*8 CONST
C
      INTEGER NDIM1,NSTATE,IUSER(3)
      INTEGER I,J,JJ,K,IDF,ICODE,IPRETIM
      INTEGER IA,IP,IM,IGPM
      INTEGER IPRESTR,LTAB,idel,I2,J2,K2
C
C
      REAL*8 CUM_RISK,F,U,UMINUS,W,WMINUS,XFAIL,XCOV,R,X,X2,DM1(7)
      REAL*8 GAMLOG,XGAINV,Y,Y2
      real*8 beta1(*),gradf(*)
C
c     allocate(DC_RISK(NDIMAX))
C
!      EQUIVALENCE (INFO(1,1),KREC(1))
!      EQUIVALENCE (IDATA(1,1),XDATA(1,1))
      DATA (DM1(I),I=1,7)/1.D0,1.33333333333333D0,2.D0,
     +  1.D0,1.3333333333D0,1.06666666667D0,1.4545454545455D0/

C
C-----------------------------------------------------------------------
C  INITIALIZATION
C-----------------------------------------------------------------------
C
      F = 0.D0
      XFAIL = 0.D0
      IPRESTR=0
      CUM_RISK = 0.D0
      DO 10 I = 1,NDIM1
       GRADF(I) = 0.D0
       DC_RISK(I) = 0.D0
   10 CONTINUE
      IDF=0
      IPRETIM = 0
C-----------------------------------------------------------------------
C  CONSTRAINT(S)
C-----------------------------------------------------------------------
      DO 15 I = 1,ICONS(0)
       BETA1(ICONS(I)) = 0.D0
   15 CONTINUE
C
C-----------------------------------------------------------------------
C   RANDOM EFFECTS
C-----------------------------------------------------------------------
C
c In case of CORRELATED random effects creates the inverse of the V matrix - VM1
c  computes the determinant and the off-diagonal elements using the correlation
c  from init_c.f
      if (corrflag) then
        do i=1,maxrand
C compute corr form zeta
          X=exp(zeta)
          corr= (1.d0-2.d0*X)/(1.d0+2.d0*X)    
          if ((inor(i,1).ge.1).and.(icorr(i,1).eq.i)) then  
            detv=(1-corr*corr)*xnor(i)*xnor(icorr(i,2))
            VM1(1,1)= xnor(icorr(i,2))/detv
            VM1(2,2)= xnor(i)/detv
            VM1(1,2)=(-corr*sqrt(xnor(i))*sqrt(xnor(icorr(i,2))))/detv
            VM1(2,1)=VM1(1,2)
          endif
        enddo
      endif	 
C computations for the RANDOM effect	  
      IF (NRAND.NE.0) THEN
       DO 300 I = 1,MAXRAND
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on September 26, 1997
       IF (ISAME(I).NE.0) GOTO 300
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       IF (IGAM(I,1).GE.1) THEN
             XGAINV=1.D0/XGAM(I)
c             U = XGAM(I) * DLOG(XGAM(I)) - GAMLOG(XGAM(I))
             U = -XGAINV * DLOG(XGAM(I)) - GAMLOG(XGAINV)
             DO 310 J = IGAM(I,2),IGAM(I,3)
               K = 0
               DO JJ = 1,ICONS(0)
                 IF (ICONS(JJ).EQ.J) K=1
               ENDDO
               IF (K.EQ.1) THEN
                 GOTO 310
               ENDIF
               W = DEXP(BETA1(J))
               F = F - U - XGAINV * (BETA1(J) - W)
c             F = F - U - XGAM(I) * (BETA1(J) - W)
               GRADF(J) = GRADF(J) - XGAINV * (1.D0 - W)
c             GRADF(J) = GRADF(J) - XGAM(I) * (1.D0 - W)
  310        CONTINUE
       ELSE IF (INOR(I,1).GE.1) THEN
!!!! uncorrelated random effects - this part remains as it was before 
            if (icorr(i,2).eq.0) then
!!!!
             CONST = -0.5D0 * DLOG(XNOR(I))
c reference to NRELMAT2 added on Feb 6 2012
             IF (NRELMAT.EQ.0.OR.I.NE.NRELMAT2) THEN
               U = 1.D0 / XNOR(I)
               DO 312 J = INOR(I,2),INOR(I,3)
                  K = 0
                  DO JJ = 1,ICONS(0)
                   IF (ICONS(JJ).EQ.J) K=1
                  ENDDO
               IF (K.EQ.1) THEN
                 GOTO 312
               ENDIF
c                  IF (K.EQ.1) GOTO 312
                  W = U * BETA1(J)
                  F = F -CONST+ 0.5D0 * W * BETA1(J)
                  GRADF(J) = GRADF(J) + W
  312          CONTINUE
             ELSE
             U = 1.D0 / XNOR(NRELMAT2)
             IF (NRULE.EQ.1) THEN
                 DO 320 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
                   IF (IPEDIG(2,K).LE.0) GOTO 320
                   F = F -CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                   IA = IPEDIG(1,K)
                   IP = IPEDIG(3,K)
                   IM = IPEDIG(4,K)
                   X = BETA1(IA)
                   IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
                   IF (IM.GT.0) X = X - 0.5D0 * BETA1(IM)
                   X = U * DM1(IPEDIG(2,K)) * X
                   GRADF(IA) = GRADF(IA) + X
                   IF (IP.GT.0) GRADF(IP) = GRADF(IP) - 0.5D0 * X
                   IF (IM.GT.0) GRADF(IM) = GRADF(IM) - 0.5D0 * X
 320             CONTINUE
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Modified on September 26, 1997
              J=I
               DO 322 K=INOR(I,2),INOR(J,3)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                  F = F +  0.5 * BETA1(K) * GRADF(K)
 322           CONTINUE
             ELSE IF (NRULE.EQ.2) THEN
                 DO 330 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
C corrected on April 3, 2000
                   IF (IPEDIG(2,K).LT.0) GOTO 330
                   F= F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                   IA = IPEDIG(1,K)
                   IP = IPEDIG(3,K)
                   IGPM = IPEDIG(4,K)
                   X = BETA1(IA)
                   IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
                   IF (IGPM.GT.0) X = X - 0.25D0 * BETA1(IGPM)
                   X = U * DM1(IPEDIG(2,K)) * X
                   GRADF(IA) = GRADF(IA) + X
                   IF (IP.GT.0) GRADF(IP) = GRADF(IP) - 0.5D0 * X
                   IF (IGPM.GT.0) GRADF(IGPM)=GRADF(IGPM) -0.25D0 * X
 330             CONTINUE
                 DO 332 K=INOR(I,2),INOR(I,3)
                   F = F + 0.5 * BETA1(K) * GRADF(K)
 332             CONTINUE
             ENDIF
             ENDIF
!!!! correlated random effects - beginning
            else if (icorr(i,1).gt.0) then
!!!!
             I2=icorr(i,2)
             CONST = -0.5D0 * (DLOG(XNOR(I))+DLOG(XNOR(I2))+
     +                    DLOG(1.d0-corr*corr))
! difference between positions of the 2 random effects in the whole list	 
             IDEL=INOR(I2,2)-INOR(I,2)
		 
! in case of no relationship matrix
! reference to NRELMAT2 added on Feb 6 2012
             IF (NRELMAT.EQ.0.OR.I.NE.NRELMAT2) THEN
                DO 412 J = INOR(I,2),INOR(I,3)
                  J2=J+IDEL
                  F = F -CONST+ 0.5D0 * ( VM1(1,1)*BETA1(J)*BETA1(J)
     +                        + 2.D0 * VM1(1,2)*BETA1(J)*BETA1(J2)
     +                        + VM1(2,2) * BETA1(J2)*BETA1(J2) )
                  GRADF(J) = GRADF(J) + VM1(1,1)*BETA1(J)
     +                                + VM1(1,2)*BETA1(J2)
                  GRADF(J2) = GRADF(J2) + VM1(2,1)*BETA1(J)
     +                                  + VM1(2,2)*BETA1(J2)
  412          CONTINUE
             ELSE
! with relationship matrix 
             IF (NRULE.EQ.1) THEN
                 DO 420 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
                   IF (IPEDIG(2,K).LE.0) GOTO 420
                   F = F -CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                   IA = IPEDIG(1,K)
                   IP = IPEDIG(3,K)
                   IM = IPEDIG(4,K)
                   X = BETA1(IA)
                   X2= BETA1(IA+IDEL)
                   IF (IP.GT.0) THEN
                      X = X - 0.5D0 * BETA1(IP)
                      X2= X2 - 0.5D0 * BETA1(IP+IDEL)
                   ENDIF
                   IF (IM.GT.0) THEN
                      X = X - 0.5D0 * BETA1(IM)
                      X2 = X2 - 0.5D0 * BETA1(IM+IDEL)
                   ENDIF
                   Y = DM1(IPEDIG(2,K)) * (VM1(1,1)*X + VM1(1,2)*X2)
                   Y2 = DM1(IPEDIG(2,K)) * (VM1(1,2)*X + VM1(2,2)*X2)
                   GRADF(IA) = GRADF(IA) + Y
                   GRADF(IA+IDEL) = GRADF(IA+IDEL) + Y2
                   IF (IP.GT.0) THEN
                      GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                      GRADF(IP+IDEL) = GRADF(IP+IDEL) - 0.5D0 * Y2
                   ENDIF
                   IF (IM.GT.0) THEN
                      GRADF(IM) = GRADF(IM) - 0.5D0 * Y
                      GRADF(IM+IDEL) = GRADF(IM+IDEL) - 0.5D0 * Y2
                   ENDIF
 420             CONTINUE
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Modified on September 26, 1997
              J=I
               DO 422 K=INOR(I,2),INOR(J,3)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                  K2=K+IDEL
                  F = F +0.5d0*(BETA1(K)*GRADF(K)+ BETA1(K2)*GRADF(K2))
 422           CONTINUE
             ELSE IF (NRULE.EQ.2) THEN
                 DO 430 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
C corrected on April 3, 2000
                   IF (IPEDIG(2,K).LT.0) GOTO 430
                   F= F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                   IA = IPEDIG(1,K)
                   IP = IPEDIG(3,K)
                   IGPM = IPEDIG(4,K)
                   X = BETA1(IA)
                   X2= BETA1(IA+IDEL)
                   IF (IP.GT.0) THEN
                      X = X - 0.5D0 * BETA1(IP)
                      X2 = X2 - 0.5D0 * BETA1(IP+IDEL)
                   ENDIF
                   IF (IGPM.GT.0) THEN
                      X = X - 0.25D0 * BETA1(IGPM)
                      X2 = X2 - 0.25D0 * BETA1(IGPM+IDEL)
                   ENDIF
                   Y = DM1(IPEDIG(2,K)) * (VM1(1,1)*X + VM1(1,2)*X2)
                   Y2 = DM1(IPEDIG(2,K)) * (VM1(1,2)*X + VM1(2,2)*X2)
                   GRADF(IA) = GRADF(IA) + Y
                   GRADF(IA+IDEL) = GRADF(IA+IDEL) + Y2
                   IF (IP.GT.0) THEN
                      GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                      GRADF(IP+IDEL) = GRADF(IP+IDEL) - 0.5D0 * Y2
                   ENDIF
                   IF (IGPM.GT.0) THEN
                      GRADF(IGPM)=GRADF(IGPM) -0.25D0 * Y
                      GRADF(IGPM+IDEL)=GRADF(IGPM+IDEL) -0.25D0 * Y2
                   ENDIF					  
 430             CONTINUE
                 DO 432 K=INOR(I,2),INOR(I,3)
                   K2=K+IDEL
                   F = F +0.5d0*(BETA1(K)*GRADF(K)+ BETA1(K2)*GRADF(K2))
 432             CONTINUE
             ENDIF
             ENDIF
!!!! correlated random effects - end
            endif
!!!!
       ENDIF
  300   CONTINUE
      ENDIF
C
C-----------------------------------------------------------------------
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IF (nstor.ne.1)
     + OPEN(4,file=file(9),status='old',FORM='UNFORMATTED')
  100 IF (NSTOR.NE.1) THEN
       READ(4,END=199) NREC,LTAB,
     +  ((blockb%info(i,j),i=1,3),j=1,nrecmax),
     +  ((blockb%idata(i,j),i=1,mxef_used),j=1,nrecmax),
     +	((blockb%xdata(i,j),i=1,mxef_used),j=1,nrecmax)
      ENDIF
C
C-----------------------------------------------------------------------
C   FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
      DO 190 I=1,NREC
C
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD WAS THE LAST RECORD WITH TIME = IPRETIM
C   UPDATE F (COX PARTIAL LIKELIHOOD) AND GRADF (ITS GRADIENT)
C   XFAIL IS THE NUMBER FAILING AT TIME IPRETIM
C-----------------------------------------------------------------------
       IF ((blockb%info(1,I).NE.IPRETIM).AND.(IPRETIM.NE.0)) THEN
       IF ((CUM_RISK.GT.1.D-10).AND.(XFAIL.NE.0)) THEN
            F = F + XFAIL * DLOG(CUM_RISK)
            DO 20 J=1,NDIM1
             IF (DC_RISK(J).NE.0.D0)
     +           GRADF(J) = GRADF(J) + XFAIL * DC_RISK(J) /  CUM_RISK
   20       CONTINUE
            XFAIL = 0.D0
       ENDIF
       ENDIF
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD HAS A DIFFERENT STRATUM ID ==> NEW STRATUM
C   INITIALIZE CUM_RISK (CUMULATIVE RISK FOR ALL ANIMALS) AND VECTOR
C   DC_RISK (CUMULATED CONTRIBUTION FOR EACH LEVEL TO BE USED IN
C   COMPUTING GRADF)
C-----------------------------------------------------------------------
       IPRETIM =blockb%info(1,I)
       ICODE = blockb%info(2,I)
       IF (NSTRATA.GT.1) THEN
       IF (blockb%info(3,I).NE.IPRESTR) THEN
             IF (IPRESTR.NE.0) THEN
             CUM_RISK = 0.D0
             DO 25 J = 1,NDIM1
             DC_RISK(J) = 0.D0
   25          CONTINUE
             ENDIF
             IPRESTR=blockb%info(3,I)
       ENDIF
       ENDIF
C-----------------------------------------------------------------------
C   U = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C   UMINUS = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT AFTER CHANGE
C-----------------------------------------------------------------------
       U = 0.D0
       UMINUS = 0.D0
C-----------------------------------------------------------------------
C        IPLUS1/2 = 0 FOR TIME-INDEPENDENT COVARIATES
C             ==> CONTRIBUTES TO U (AND TO UMINUS IF NOT LAST RECORD)
C             EXCEPT IF LEFT TRUNCATED RECORD  (ONLY UMINUS)
C        IPLUS1/2 = +1 FOR TIME-DEPENDENT (BEFORE CHANGE)
C             ==> CONTRIBUTES TO U EXCEPT IF LEFT TRUNCATED RECORD
C        IPLUS1/2 = -1 FOR TIME-DEPENDENT (AFTER CHANGE)
C             ==> CONTRIBUTES TO UMINUS IF NOT LAST RECORD
C     FIRST, IR1 CONTINUOUS COVARIATES, THEN IR2 DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => EXP(Z'* BETA1) WILL BE = 0
C-----------------------------------------------------------------------
       K = 0
       DO 35 J=1,IR1
       IF (IANAL1(J).NE.0) THEN
            XCOV = blockb%xdata(J,I)
            IF (IPLUS1(J).GT.0) THEN
             K = K+1
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
             IF (ICODE.GE.-1) U = U + R
            ELSE IF (IPLUS1(J).EQ.0) THEN
             K = K+1
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement :
c            U = U + R
c was corrected on October 16, 1996 for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.NE.-2) U = U + R
             IF (ICODE.LT.0) UMINUS= UMINUS + R
            ELSE IF (ICODE.LT.0) THEN
             R = BETA1(K) * XCOV
             IF (BETA1(K).LE.-999.D0) R = -999.9D0
             UMINUS = UMINUS + R
            ENDIF
       ENDIF
   35     CONTINUE
       DO 36 J=1,IR2
            JJ = J + IR1
       IF (IANAL2(J).NE.0) THEN
            K = blockb%idata(JJ,I)
            if (k.LE.0) goto 36
            IF (IPLUS2(J).GT.0) THEN
             IF (ICODE.GE.-1) U = U + BETA1(K)
            ELSE IF (IPLUS2(J).EQ.0) THEN
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement :
c            U = U + BETA1(K)
c was corrected on October 16, 1996 for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.NE.-2) U = U + BETA1(K)
             IF (ICODE.LT.0) UMINUS = UMINUS + BETA1(K)
            ELSE IF (ICODE.LT.0) THEN
             UMINUS = UMINUS + BETA1(K)
            ENDIF
       ENDIF
   36     CONTINUE
C
C-----------------------------------------------------------------------
C   DIVERGENCE ==> STOP
C-----------------------------------------------------------------------
       IF (U.GT.100.D0) THEN
       K = MIN(50,NDIM1)
       WRITE(6,*) 'OVERFLOW '
       WRITE(6,*) 'BETA1 =   '
       WRITE(6,*) (BETA1(J),J=1,K)
       WRITE(6,*) 'U    =   ',U
       STOP
       ENDIF
C
C-----------------------------------------------------------------------
C   COMPUTE W = EXP(U) AND WMINUS = EXP(UMINUS) AND UPDATE CUM_RISK
C            DEPENDING ON CODE
C-----------------------------------------------------------------------
       W = 0.D0
       WMINUS = 0.D0
       IF (U.GT.-20.D0) W = DEXP(U)
       IF (ICODE.GE.0) THEN
       CUM_RISK = CUM_RISK + W
       ELSE IF (ICODE.EQ.-1) THEN
       IF (UMINUS.GT.-20.D0) WMINUS = DEXP(UMINUS)
       CUM_RISK = CUM_RISK + W - WMINUS
       ELSE IF (ICODE.LE.-2) THEN
       IF (UMINUS.GT.-20.D0) WMINUS = DEXP(UMINUS)
       CUM_RISK = CUM_RISK - WMINUS
       ENDIF
C
C-----------------------------------------------------------------------
C   UPDATE VECTOR DC_RISK DEPENDING ON CODE
C   FIRST, IR1 CONTINUOUS COVARIATES, THEN IR2 DISCRETE COVARIATES
C-----------------------------------------------------------------------
       K = 0
       DO 45 J=1,IR1
       IF (IANAL1(J).NE.0) THEN
            XCOV = blockb%xdata(J,I)
            IF (IPLUS1(J).GT.0) THEN
             K = K+1
             IF (ICODE.GE.-1) DC_RISK(K) = DC_RISK(K) + XCOV * W
            ELSE IF (IPLUS1(J).EQ.0) THEN
             K = K+1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement :
c             DC_RISK(K) = DC_RISK(K) + XCOV *  W
c was corrected on October 16, 1996 for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.NE.-2) DC_RISK(K) = DC_RISK(K) + XCOV * W
             IF (ICODE.LT.0) DC_RISK(K) = DC_RISK(K) - XCOV * WMINUS
            ELSE IF (ICODE.LT.0) THEN
             DC_RISK(K) = DC_RISK(K) - XCOV * WMINUS
            ENDIF
       ENDIF
   45     CONTINUE
C
       DO 46 J=1,IR2
            JJ = J + IR1
       IF (IANAL2(J).NE.0) THEN
            K = blockb%idata(JJ,I)
            if (k.LE.0) goto 46
            IF (IPLUS2(J).GT.0) THEN
             IF (ICODE.GE.-1) DC_RISK(K) = DC_RISK(K) + W
            ELSE IF (IPLUS2(J).EQ.0) THEN
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement :
c             DC_RISK(K) = DC_RISK(K) + W
c was corrected on October 16, 1996 for left-truncated records
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (ICODE.NE.-2) DC_RISK(K) = DC_RISK(K) + W
             IF (ICODE.LT.0) DC_RISK(K) = DC_RISK(K) - WMINUS
            ELSE IF (ICODE.LT.0) THEN
             DC_RISK(K) = DC_RISK(K) - WMINUS
            ENDIF
       ENDIF
   46     CONTINUE
C
C-----------------------------------------------------------------------
C   IF UNCENSORED RECORD, UPDATE F AND GRADF
C-----------------------------------------------------------------------
       K = 0
       IF (ICODE.GE.1) THEN
       XFAIL = XFAIL + 1.D0
       F = F - U
       DO 50 J=1,IR1
       IF (IANAL1(J).NE.0) THEN
            IF (IPLUS1(J).GE.0) THEN
             K = K+1
             GRADF(K) = GRADF(K) - blockb%xdata(J,I)
            ENDIF
       ENDIF
   50     CONTINUE
       DO 51 J=1,IR2
            JJ = J + IR1
       IF (IANAL2(J).NE.0) THEN
            IF (IPLUS2(J).GE.0) THEN
             K = blockb%idata(JJ,I)
            if (k.LE.0) goto 51 
             GRADF(K) = GRADF(K) - 1.D0
            ENDIF
       ENDIF
   51     CONTINUE
       ENDIF
C
  190 CONTINUE
      IF (NSTOR.NE.1) GOTO 100

  199 IF (NSTOR.NE.1) CLOSE(4)
C
C-----------------------------------------------------------------------
C   LAST CONTRIBUTION TO F AND GRADF
C-----------------------------------------------------------------------
      IF ((CUM_RISK.GT.1.D-10).AND.(XFAIL.NE.0)) THEN
       F = F + XFAIL * DLOG(CUM_RISK)
       DO 200 J=1,NDIM1
       IF (DC_RISK(J).NE.0.D0)
     +    GRADF(J) = GRADF(J) + XFAIL * DC_RISK(J) /  CUM_RISK
  200   CONTINUE
      ENDIF
C
C-----------------------------------------------------------------------
C   CONSTRAINTS ON GRADF + COUNT NON ZERO PARAMETERS
C-----------------------------------------------------------------------
      DO 250 I = 1,ICONS(0)
       GRADF(ICONS(I)) = 0.D0
  250 CONTINUE
      IDF=0
      DO 260 J=1,NDIM1
       IF (GRADF(J).NE.0.D0) IDF = IDF + 1
  260 CONTINUE
      IUSER(1) = IDF
      IF (NSTATE.EQ.1) THEN
       IUSER(2) = 1
      ELSE
       IUSER(2) = IUSER(2) + 1
      ENDIF
C
c     deallocate(DC_RISK)
      RETURN
C***********************************************************************
      END
