        program prepare
C***********************************************************************
C  PREPARE       *                                    *  02 / 03 /1995 *
C                *                     Version 4   of June  30, 2003   *
C***********************************************************************
C  DATA PREPARATION PROGRAM                                            *
C***********************************************************************
c
        use prepinclu
c
        IMPLICIT NONE

        INTEGER I,II,J,KN
        integer ifile, istat
        CHARACTER TITLE(70)
        CHARACTER*8 w8
! Allocation of arrays
      allocate( tcmb(mxef), STAT=istat ) 
      allocate( rlev(mxef), STAT=istat )
      allocate( tco(mxef), STAT=istat )
      allocate( ir1p(mxef), STAT=istat )
      allocate( ir2p(mxef), STAT=istat )
      allocate( rtopl(0:mxef), STAT=istat )
      allocate( xlist(ndimax,8), STAT=istat )
  
c
C-----------------------------------------------------------------------
C CALL OF READPARM : READS MODEL SPECIFICATION + OPTIONS
C-----------------------------------------------------------------------
c 
        CALL READPARM(NWORD,TITLE,WORD,NFIG,LFIG,IFIG)
	IF (NKEYFE.NE.22) THEN
           WRITE(6,9005) 
 9005    FORMAT(/1X,'THIS VERSION OF PREPARE.F WAS COMPILED WITH AN',
     +   ' INCORRECT PREPINCLU FILE',/1X,'PREPINCLU SHOULD HAVE',
     +   ' NKEYFE=21',/)
           STOP
        ENDIF
c       WRITE(6,9000) (TITLE(K),K=1,70)
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        wn = 0
      FUTURF=0
      idped(1)=0
      idped(2)=0
      join(1)=0
      join(2)=0
        fout=1
      nrecmaxch=0
      mxefch=0
      ndimaxch=0
      ncolpedch=0
      transfcount=0
      do i=1,mxef
        ir1p(i)=0
        ir2p(i)=0
      enddo
C
C-----------------------------------------------------------------------
C INTERPRET THE (NWORD) WORDS FROM THE WORD LIST OBTAINED AFTER READING
C PARAMETER FILE (UNIT 1) WITH SUBROUTINE READPARM
C-----------------------------------------------------------------------
      do
        wn=wn+1
        if (wn >= NWORD) exit
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)

      select case (W8)
      case ('FILES   ')
        kn = 1
        call FILES
      case ('NRECMAX ')
        kn = 2
        call parchange(nrecmax)
      case ('NCOLPED ')
        kn = 22
        call parchange(ncolped)
      case ('NEFMAX  ')
        kn = 3
        call parchange(mxef)
        if (mxefch .eq. 1) then
           deallocate(tcmb,rlev,tco,ir1p,ir2p,rtopl)
           allocate(tcmb(mxef),rlev(mxef),tco(mxef),ir1p(mxef),
     +              ir2p(mxef),rtopl(mxef))
           do i=1,mxef
               ir1p(i)=0
               ir2p(i)=0
           enddo
        endif
      case ('NDIMAX  ')
        kn = 4
        call parchange(ndimax)
        if (ndimaxch .eq. 1) then
           deallocate(xlist)
           allocate(xlist(ndimax,8))
        endif
      case ('INPUT   ')
        kn = 5
        call INPUT
      case ('TIME    ')
        kn = 6
        call TTIME
      case ('CENSCODE')
        kn = 7
        call CENSCODE
      case ('IDREC   ')
        kn = 8
        call IDREC
      case ('TRUNCATE')
        kn = 9
        call TRUNCATE
      case ('TIMECOV ')
        kn = 10
        call TIMECOV
      case ('CONVDT  ')
        kn = 11
        call CONVDT
      case ('CLASS   ')
        kn = 12
        call CLASS
      case ('TIMEDEP ')
        kn = 13
        call TIMEDEP
      case ('COMBINE ')
        kn = 14
        call COMBINE
      case ('OUTPUT  ')
        kn = 15
        call OUTPUT
      case ('FUTURE  ')
        kn = 16
        call FUTURE
      case ('PEDIGREE')
        kn = 17
        call PEDIGREE
      case ('JOINCODE')
        kn = 18
        call JOINCODE
      case ('FORMOUT ')
        kn = 19
        call FORMOUT
      case ('DISCRETE')
        kn = 20
        call DISCRETE
      case ('CORRELAT')
c flag variable for the correlation statement
        corr=.TRUE.
        kn = 21
c CORRELATION and JOINCODE are using the same subroutine
        call JOINCODE
      case default
          write(*,9000) w8
9000    format(1x,'Error: ',A8,' is not a valid statement name.' /
     +  1x,'Must be one of the following:')
          write(*,'(5(1x,A8))') (keyword(kk),kk=1,nkeyfe)
          stop
      end select
      end do
 
        call transf
        write(6,40) file(2)
40    format(/1x,'REMINDER: File ',a15,' has to be sorted',
     + ' for the use of COX.'/
     + 1x,'Sorting order:'/
     + 1x,'Strata variable, ascending (only if strata are used)'/
     + 1x,'Time variable, descending'/
     + 1x,'Censoring variable, ascending')

! Deallocation of allocated arrays
      deallocate( tcmb, STAT=istat )
      deallocate( rlev, STAT=istat )
      deallocate( tco, STAT=istat )
      deallocate( ir1p, STAT=istat )
      deallocate( ir2p, STAT=istat )
      deallocate( rtopl, STAT=istat )	  
      deallocate( xlist, STAT=istat )
        STOP	
	
       contains

        subroutine transf
C***********************************************************************
C  transformation of data set into the form needed by program COX      *
C***********************************************************************
C input data file has to be in free format                             *
c output data file is unformatted                                      *
C***********************************************************************
c
c
        integer,allocatable:: idata(:)
        integer,allocatable:: jdata(:)
        real*8,allocatable:: xdata(:)
        real*8,allocatable:: ydata(:)
        integer,allocatable:: krec0(:), iv0(:)		

        INTEGER I,II,J,K,L,M,n
        integer idmurl
        integer numvar(maxword),timd(maxword),info(3)
        integer db(3),de(3),nb,ne,nday,nn,nch,n1,n2
        integer minus1,minus2,iprevious
        integer trunt,nt,fc,fin
        integer iunit,ifile,ierr
        real*8 rec(maxword),val(maxword),a
        CHARACTER*24 CREATEFM
c
        integer nrecmaxr,nchlim
        parameter(nrecmaxr=5000,nchlim=10*nrecmaxr)
c       INTEGER F77UNCOMPRESS
        integer nrect,ncht
c
        integer krec1(18*nrecmaxr),iv1((nchlim+200)*3)
        integer nrecr0
c
      allocate( itabl(nrecmax,mxef) )
      allocate( xtabl(nrecmax,mxef) )
      allocate( krr(mxef*nrecmax) )
      allocate( idata(mxef) )
      allocate( jdata(mxef) )	  
      allocate( xdata(mxef) )	  
      allocate( ydata(mxef) )
      allocate( krec(0:17,nrecmaxr) )	! REMINDER: maybe 0:17 should be replaced with MXEF  
      allocate( iv(nchlim+200,3) )	    !           KREC only used in f77cwrite
      allocate( krec0(18*nrecmaxr) )    !           also true for KREC0
      allocate( iv0((nchlim+200)*3) )	  
C
      if (nrecmaxch .eq. 1 .or. mxefch .eq. 1) then
        deallocate(itabl,xtabl,krr)
        allocate(itabl(nrecmax,mxef),xtabl(nrecmax,mxef),
     +           krr(mxef*nrecmax))
      endif
	  
      if (mxefch .eq. 1) then
         deallocate(idata,jdata,xdata,ydata)
         allocate(idata(mxef),jdata(mxef),xdata(mxef),ydata(mxef))
      endif
C-----------------------------------------------------------------------
C open input data file, output data file, codelist file
C-----------------------------------------------------------------------
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      fin=1
      if (fin.eq.1) then
        open(7,file=file(1),status='old',form='formatted')
c     else
cc compressed
c       call f77openr(IDFILE2,file(1)//char(0))
c       nrecr0=0
      endif
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c modified on January 15 1997
      ifile=8
      call openfile(ifile,file(2))
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      FM2=CREATEFM(IR2+2,IR1,FMI,FMR)
      FM3=CREATEFM(IR2+3,IR1,FMI,FMR)
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        m=0
        nrecr=0
        nrecw=0
        minus1=-1
      minus2=-2
      do 5 i=1,ir2
        rtopl(i)=0
        rlev(i)=0
5     continue
      lastil=0
      indl=1
      ipla=5 
      trunt=0 
      nt=0
      fc=0
      nrr=0
      ltab=nrecmax*mxef
C-----------------------------------------------------------------------
C read data record...
C-----------------------------------------------------------------------
10    continue
      nch=0
c<<<<<<<<<<<<<<<<<<<<<<<<
c Moved on December 10, 1996
      iprevious=0
c<<<<<<<<<<<<<<<<<<<<<<<<
        if (fin.eq.1) then
C-----------------------------------------------------------------------
C ... when no time dependent variables were defined on INPUT statement
C-----------------------------------------------------------------------
          if (ntimdepr.eq.0) then
            read(7,*,end=100) (rec(i),i=1,nvread)
C-----------------------------------------------------------------------
C ... when time dependent variables were defined on INPUT statement
C-----------------------------------------------------------------------
          else
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
            read(7,*,end=100) (rec(i),i=1,nvread),
     +         m,(numvar(i),timd(i),val(i),i=1,m)
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c         if (nrecr.LT.10) print*,'data', nrecr, (rec(i),i=1,nvread),
c    +         m,(numvar(i),timd(i),val(i),i=1,m)
         endif
       else

C
C THIS VERSION DOES NOT ALLOW THE USE OF THE C SUBROUTINES TO 
C READ WRITE AND COMPRESS THE FILES
C ==> STOP
 
         WRITE(6,888)
888     FORMAT(//1X,' THIS VERSION DOES NOT ALLOW THE USE OF THE ',
     +   'C SUBROUTINES TO',/,
     +   1X,'READ AND WRITE AND COMPRESS FILES ==> STOP')
         STOP 
c
!             if (nrect.eq.0.or.nrect.eq.nrecr0) then 
c
c  compress and read      
c            CALL F77READ(IDFILE2,NRECT,INTFOR,IERR) 
c            write(6,*) nrect
!             IF (IERR.NE.0) THEN
c              CALL F77READ(IDFILE2,NCHT,INTFOR,IERR)    
c              write(6,*) ncht
C
C uncompresses KREC1 (of size LTAB1) into KREC0 (of size ltab0 on exit)
C
c              CALL F77READ(IDFILE2,LTAB1,INTFOR,IERR)
c              CALL F77READ(IDFILE2,KREC1,LTAB1,IERR)
!               LTAB0=NRECT*4*18
!               LTAB12=LTAB1
!               LTAB02=LTAB0
c              I=F77UNCOMPRESS(KREC,LTAB02,KREC1,LTAB12)
c              write(6,*) (krec0(i),i=1,10)
C
C uncompresses iv1 (of size LTAB1) into iv0 (of size ltab0 on exit)
C
c             CALL F77READ(IDFILE2,LTAB1,INTFOR,IERR)
c             CALL F77READ(IDFILE2,iv1,LTAB1,IERR)
!              LTAB0=(NCHLIM+200)*12
!              LTAB12=LTAB1
!              LTAB02=LTAB0
c             I=F77UNCOMPRESS(iv0,LTAB02,iv1,LTAB12)
c             write(6,*) 'nouv ltab1',ltab1
c             write(6,*) (iv0(i),i=1,10)
c             write(6,*) (iv1(i),i=1,10)
!              nrecr0=0
!              ncht=0
!            else
!              goto 100
!            endif 
!          endif
!           nrecr0=nrecr0+1
!             do 777 i=1,nvread
!               rec(i)=krec(i,nrecr0) 
!  777        continue
!             nch=krec(0,nrecr0)
!             m=nch
!             do 778 i=1,nch
!                ncht=ncht+1
!                numvar(i)=iv(ncht,1)
!                timd(i)=iv(ncht,2)
!                val(i)=iv(ncht,3)
!  778        continue
c
        endif
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        nrecr=nrecr+1
        if (mod(nrecr,100000).eq.1) write(6,*) ' lus: ',nrecr
c        if (nrecr.GT.50000) goto   100
C-----------------------------------------------------------------------
C process time variable
C-----------------------------------------------------------------------
        if (timev(1).le.nvread) then
          info(1)=nint(rec(timev(1)))
        if (timev(2).gt.0) then
            call ddat(db,nint(rec(timev(2))),vartyp(timev(2)))
            nb=nday(db(1),db(2),db(3))
        endif
          if (timev(3).gt.0) then
            call ddat(de,nint(rec(timev(3))),vartyp(timev(3)))
            ne=nday(de(1),de(2),de(3))
        endif
        else
          call ddat(db,nint(rec(timev(2))),vartyp(timev(2)))
          call ddat(de,nint(rec(timev(3))),vartyp(timev(3)))
          nb=nday(db(1),db(2),db(3))
          ne=nday(de(1),de(2),de(3))
          info(1)=ne-nb
          if (info(1).le.0) then
          write(*,9001) nrecr,nint(rec(timev(2))),nint(rec(timev(3))),
     +    info(1)
9001      format(1x,'Error when reading data on line ',I8/
     +    1x,'Beginning of observation =     ',i9/
     +    1x,'End of observation       =     ',i9/
     +    1x,'Difference               =     ',i9/
     +    1x,'Must be positive'/
     +    1x,'Check data or parameter file')
            stop
          endif
        endif
C-----------------------------------------------------------------------
C process censoring variable (only right censoring at the moment)
C-----------------------------------------------------------------------
        if (nint(rec(censv(1))).eq.censv(2)) then
          info(2)=0
        else
          info(2)=1
        endif
C-----------------------------------------------------------------------
C process idrec variable
C-----------------------------------------------------------------------
        if (idrev.gt.0) then 
        if (idrev.le.nvread) then
            info(3)=nint(rec(idrev)) 
        else 
          info(3)=nrecr  
        endif
        endif
C-----------------------------------------------------------------------
C process truncation variable
C-----------------------------------------------------------------------
        if (trunv.gt.0) then
        if(vartyp(trunv).eq.'I4') then
          trunt=nint(rec(trunv))
        else
          if(nint(rec(trunv)).gt.0) then
              call ddat(de,nint(rec(trunv)),vartyp(trunv))
              nt=nday(de(1),de(2),de(3))
              trunt=nt-nb
            if (trunt.le.0) then
            write(*,9004) nrecr,nint(rec(timev(2))),nint(rec(trunv)),
     +        trunt  
9004          format(1x,'Error when reading data on line ',I8/
     +        1x,'Beginning of observation =     ',i9/
     +        1x,'Truncation date          =     ',i9/
     +        1x,'Difference               =     ',i9/
     +        1x,'Must be positive'/
     +        1x,'Check data or parameter file')
                stop
              endif
          else
            trunt=0
          endif
        endif
        if (trunt.gt.info(1)) then
            write(*,9005) nrecr,trunt,info(1)
9005      format(1x,'Error when reading data on line ',I8/
     +    1x,'Truncation of observation after',i9,' units of time'/
     +    1x,'Total duration of observation =',i9,' units of time'/
     +    1x,'Truncation must occur before the end of observation'/
     +    1x,'Check data or parameter file')
            stop
        endif
        endif
C-----------------------------------------------------------------------
C process continuous covariates
C-----------------------------------------------------------------------
        do 20 i=1,ir1
          l=ir1p(i)
          if (l.eq.0) goto 20
          if (varcom(l,1).ne.-1) then
            xdata(i)=rec(l)
          else
C-----------------------------------------------------------------------
C calculate time from two dates for covariates defined in CONVDT statem.
C-----------------------------------------------------------------------
            call ddat(de,nint(rec(varcom(l,2))),vartyp(varcom(l,2)))
            call ddat(db,nint(rec(varcom(l,3))),vartyp(varcom(l,3)))
            n2=nday(de(1),de(2),de(3))
            n1=nday(db(1),db(2),db(3))
            xdata(i)=float(n2-n1)
          endif
20    continue
C-----------------------------------------------------------------------
C include covariate from TIMECOV statement
C-----------------------------------------------------------------------
      nch=m
        if (timcov(1).ne.0) then
C-----------------------------------------------------------------------
C ... when changes of hazard were given as times
C-----------------------------------------------------------------------
          if (timcov(2).eq.1) then
          k=0
            do 50 j =1,timcov(3)
C-----------------------------------------------------------------------
C ### bug corrected on Feb 20, 1996: The if statement below was initially
c     AFTER the two "goto". The initial value was undefined if failure
c     was before the first change in timc()  
C ### new bug corrected on Oct 25, 1996 
C-----------------------------------------------------------------------
                if (nch.eq.m) then
                    rec(timcov(1))=j
                    k = 1
                endif 
                if(info(1).le.timc(j)) goto 60
                if(trunt.gt.0.and.timc(j).le.trunt) goto 50
                nch=nch+1
                numvar(nch)=timcov(1)
                val(nch)=float(j+1)
                timd(nch)=timc(j)
50        continue
60        continue
          else
C-----------------------------------------------------------------------
C ... when changes of hazard were given as dates
C-----------------------------------------------------------------------
            k=0
            do 70 j=1,timcov(3)
C-----------------------------------------------------------------------
C ### bug corrected on Feb 20, 1996: The if statement below was initially
c     AFTER the two "goto". The initial value was undefined if failure
c     was before the first change in timc()  
C ### new bug corrected on Oct 25, 1996 
C-----------------------------------------------------------------------
                if (nch.eq.m) then
                    rec(timcov(1))=j
                    k = 1
                endif 
                if (timc(j).le.nb) goto 70
                if (trunt.gt.0.and.timc(j).le.nt) goto 70
                if (timc(j).ge.ne) goto 80
                nch=nch+1
                numvar(nch)=timcov(1)
                val(nch)=float(j+1)
                timd(nch)=timc(j)-nb
70          continue
80        continue
            if (k.eq.0) then
            rec(timcov(1))=timcov(3)+1
                k=1
            endif
          endif
        endif
           transfcount=transfcount+1	
		   
C-----------------------------------------------------------------------
C process discontinuous (class) covariates
C-----------------------------------------------------------------------
        do 30 i=1,ir2
          l=ir2p(i)
          if (l.eq.0) goto 30
        if(varcom(l,1).le.1) then
          nlev=1
          levcod(1)=nint(rec(l))
        else
          nlev=varcom(l,1)
          do 25 k=1,nlev
            levcod(k)=nint(rec(varcom(l,k+1)))
25        continue
        endif
          if(join(2).ne.0.and.(l.eq.join(1).or.l.eq.join(2))) then
            n=pir(join(1))
            if(levcod(1).eq.0) then
                idata(i)=0
                goto 30
            endif
        else
          n=i
        endif
        j=idmurl(levcod,nlev,rtopl(n),indl,xlist,ipla,
     *    ndimax,8,lastil,new)
        if (new.eq.1) then
          if(fc.eq.1) then
            write(*,9007) nrecr
9007        format(1x,'Error when reading FUTURE data file on line ',I8/
     +      1x,'New codes (or combinations of codes for combined ',
     +         'variables) are not allowed'/
     +      1x,'Check data or parameter file')
            write(*,'('' Variable '',A8)') varnam(l)
            do 350 k=1,nlev
              write(*,'(1x,i9)') levcod(k)
350         continue
                stop
          endif
          rlev(n)=rlev(n)+1
          xlist(j,7)=rlev(n)
          xlist(j,8)=n
        endif
        idata(i)=xlist(j,7)
30    continue
C-----------------------------------------------------------------------
C time dependent covariates
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C process changes in covariate values given on record 
C-----------------------------------------------------------------------
        if (m.gt.0) then
          do 40 i=1,m
C-----------------------------------------------------------------------
C ...check if var. number given on record corresponds to timedep. var.
C-----------------------------------------------------------------------
            if(vartim(numvar(i),1).ne.1) then
                write(*,9002) nrecr,numvar(i)
9002        format(1x,'Error when reading data on line ',I8/
     +      1x,'Variable ',i8,' is not a time dependent covariate'/
     +      1x,'Check data or parameter file')
                stop
            endif
C-----------------------------------------------------------------------
C ...if time of change of hazard is given as date: transform into time
C-----------------------------------------------------------------------
            if(vartim(numvar(i),2).eq.2) then
                call ddat(de,timd(i),vartyp(timev(2)))
                nn=nday(de(1),de(2),de(3))
C-----------------------------------------------------------------------
C ...time must be a positive number
C-----------------------------------------------------------------------
                if (nn-nb.le.0) then
                  write(*,9003) nrecr,nint(rec(timev(2))),numvar(i),nn-nb
9003          format(1x,'Error when reading data on line ',I8/
     +        1x,'Beginning of observation =     ',i9/
     +        1x,'Variable',i3,' changed on =     ',i9/
     +        1x,'Difference               =     ',i9/
     +        1x,'Must be positive'/
     +        1x,'Check data or parameter file')
                  stop
                endif
                numvar(i)=numvar(i)
                timd(i)=nn-nb
                val(i)=val(i)
            endif
c
            if(timd(i).gt.info(1)) then
              write(*,9103) nrecr,i,info(1),numvar(i),timd(i)
9103          format(1x,'Error when reading data on line ',I8/
     +        1x,'Processing the',i4,' th change of a time dep. cov.'/
     +        1x,'Total ''length of life'' (time units) =     ',i9/
     +        1x,'Variable',i3,' changed after time units = ',i9/
     +        1x,'Check data file')
                endif
             
40      continue
        endif
C-----------------------------------------------------------------------
C sort nch changes in hazard by time
C-----------------------------------------------------------------------
        if (nch.gt.1) then
          DO 90 K=1,NCH-1
          DO 90 L=K+1,NCH
            IF (TIMD(K).GT.TIMD(L)) THEN
                I=TIMD(L)
                TIMD(L)=TIMD(K)
                TIMD(K)=I
                I=NUMVAR(L)
                NUMVAR(L)=NUMVAR(K)
                NUMVAR(K)=I
                A=VAL(L)
                VAL(L)=VAL(K)
                VAL(K)=A
            ENDIF
90      CONTINUE
        endif
C-----------------------------------------------------------------------
C ### bug corrected on March 10, 200 (due to Ron Crump):
c  if (timd(i) = info(i)) ignore it 
C-----------------------------------------------------------------------
        do 91 K=1,nch
          if(timd(k).ge.info(1)) nch = nch-1
91      continue
C-----------------------------------------------------------------------
C  write out transformed records
C-----------------------------------------------------------------------
      if (trunt.gt.0) then
C-----------------------------------------------------------------------
C  ...write extra record for truncated observations
C-----------------------------------------------------------------------
        do 230 k=1,ir2
          if(ir2p(k).eq.0) goto 230
          if (vartim(ir2p(k),1).eq.1) then
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c  added / modified  on February 19, 1997 for left-truncated records
c            jdata(k)=0
            jdata(k)=idata(k)
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            jdata(k+1)=idata(k)
           else
            jdata(k)=idata(k)
          endif
230     continue
        do 240 k=1,ir1
          if(ir1p(k).eq.0) goto 240
          if (vartim(ir1p(k),1).eq.1) then
            ydata(k)=0
            ydata(k+1)=xdata(k)
          else
            ydata(k)=xdata(k)
          endif
240     continue
        nrr=nrr+1
        itabl(nrr,1)=trunt
        itabl(nrr,2)=minus2
        ninf=2
        if(infp(3).ne.0) then
          itabl(nrr,3)=info(3)
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c case added on February 19, 1997 for left-truncated records
          if (itabl(nrr,2).eq.-2.and.infp(3).lt.0)
     +            itabl(nrr,3)=0 
          iprevious=trunt
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          ninf=3
        endif
        do k=1,ir2
          itabl(nrr,ninf+k)=jdata(k)
        enddo
        do k=1,ir1
          xtabl(nrr,ninf+ir2+k)=ydata(k)
        enddo
		
        if (nrr.eq.nrecmax) then
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c         print*,'? nrecw,nrr,ir2,ir1',nrecw,nrr,ir2,ir1,
c    +      ninf,nrecmax,nrecmaxr
c         do i=1,20
c         print*,'=>',(itabl(i,k),k=1,43)
c         enddo
c££££££££££££££
c substitution of equivalence statements with reshape
          krec0=reshape((krec),(/18*nrecmaxr/))
          iv0=reshape((iv),(/(nchlim+200)*3/))
          krr=reshape((itabl),(/nrecmax*mxef/))
c         krr=reshape((xtabl),(/nrecmax*mxef/))
c         print*,'krr',(krr(k),k=1,100)
          call writof(ifile)
        endif
          nrecw=nrecw+1
      endif
C-----------------------------------------------------------------------
C  ...including no time dependent covariates
C-----------------------------------------------------------------------
        if (nch.eq.0) then
C-----------------------------------------------------------------------
C  .......write regular record 
C-----------------------------------------------------------------------
        nrr=nrr+1
        itabl(nrr,1)=info(1)
        itabl(nrr,2)=info(2)
        ninf=2
        if(infp(3).ne.0) then
C-------------------------------------------------------------------
C if infp(3) .lt.0 ==> store previous time into info(3)
C-------------------------------------------------------------------
          if (infp(3).lt.0) then
             info(3) =iprevious
             iprevious=timd(i-1)
          endif
          itabl(nrr,3)=info(3)
          ninf=3
        endif
        do k=1,ir2
          itabl(nrr,ninf+k)=idata(k)
        enddo
        do k=1,ir1
          xtabl(nrr,ninf+ir2+k)=xdata(k)
        enddo
        if (nrr.eq.nrecmax) then
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c         print*,'! nrecw,nrr,ir2,ir1',nrecw,nrr,ir2,ir1,
c    +      ninf,nrecmax,nrecmaxr
c         do i=1,20
c         print*,'=>',(itabl(i,k),k=1,43)
c         enddo
c££££££££££££££
c substitution of equivalence statements with reshape
          krec0=reshape((krec),(/18*nrecmaxr/))
          iv0=reshape((iv),(/(nchlim+200)*3/))
          krr=reshape((itabl),(/nrecmax*mxef/))
c         krr=reshape((xtabl),(/nrecmax*mxef/))
          call writof(ifile)
        endif
          nrecw=nrecw+1
        else
C-----------------------------------------------------------------------
C  ...including time dependent covariates
C-----------------------------------------------------------------------
          do 120 i=1,ntimdep
            if (tco(i).eq.0) goto 120
            if (varcc(tco(i)).eq.1) then
                idata(pir(tco(i))+1)=idata(pir(tco(i)))
            else
                xdata(pir(tco(i))+1)=xdata(pir(tco(i)))
            endif
120     continue
C-----------------------------------------------------------------------
C  .......process and write regular records 
C-----------------------------------------------------------------------
          do 130 i=1,nch
            if (i.gt.1) then
            if (timd(i).ne.timd(i-1)) then
c---- update combined variables
            if (ntcmb.gt.0) then
              do 160 k=1,ntcmb
                if(vartim(tcmb(k),1).eq.0) goto 160
                ii=pir(tcmb(k))
                if (ii.eq.0) goto 160 
                nlev=varcom(tcmb(k),1)
                do 170 l=1,nlev
                  levcod(l)=nint(rec(varcom(tcmb(k),l+1)))
170             continue
                j=idmurl(levcod,nlev,rtopl(ii),indl,xlist,ipla,
     *          ndimax,8,lastil,new)
                if (new.eq.1) then
                if(fc.eq.1) then
                  write(*,9007) nrecr
                  write(*,'('' Variable '',A8)') varnam(tcmb(k))
                  do 360 l=1,nlev
                    write(*,'(1x,i9)') levcod(l)
360               continue
                      stop
                endif
                  rlev(ii)=rlev(ii)+1
                  xlist(j,7)=rlev(ii)
                  xlist(j,8)=ii
                endif
                idata(ii+1)=xlist(j,7)
160           continue
            endif
c----- write out new record
            nrr=nrr+1
            itabl(nrr,1)=timd(i-1)
            itabl(nrr,2)=minus1
            ninf=2
            if(infp(3).ne.0) then
C-------------------------------------------------------------------
C if infp(3) .lt.0 ==> store previous time into info(3)
C-------------------------------------------------------------------
              if (infp(3).lt.0) then
                info(3) =iprevious
                iprevious=timd(i-1)
              endif
              itabl(nrr,3)=info(3)
              ninf=3
            endif
            do k=1,ir2
              itabl(nrr,ninf+k)=idata(k)
            enddo
            do k=1,ir1
              xtabl(nrr,ninf+ir2+k)=xdata(k)
            enddo
            if (nrr.eq.nrecmax) then
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c         print*,'% nrecw,nrr,ir2,ir1',nrecw,nrr,ir2,ir1,
c    +      ninf,nrecmax,nrecmaxr
c         do ii=1,20
c          print*,'=>',(itabl(ii,k),k=1,43)
c         enddo
c££££££££££££££
c substitution of equivalence statements with reshape
          krec0=reshape((krec),(/18*nrecmaxr/))
          iv0=reshape((iv),(/(nchlim+200)*3/))
          krr=reshape((itabl),(/nrecmax*mxef/))
c         krr=reshape((xtabl),(/nrecmax*mxef/))
              call writof(ifile)
            endif
                nrecw=nrecw+1
                do 140 j=1,ntimdep
                  if (tco(j).eq.0) goto 140
                  if (varcc(tco(j)).eq.1) then
                    idata(pir(tco(j)))=idata(pir(tco(j))+1)
                  else
                    xdata(pir(tco(j)))=xdata(pir(tco(j))+1)
                  endif
140         continue
            endif
            endif
c----- update effects
            ii=pir(numvar(i))
            if (ii.eq.0) goto 130
            if (varcc(numvar(i)).eq.1) then
              nlev=1
              levcod(1)=nint(val(i))
              rec(numvar(i))=nint(val(i))
              j=idmurl(levcod,nlev,rtopl(ii),indl,xlist,ipla,
     *        ndimax,8,lastil,new)
              if (new.eq.1) then
                if(fc.eq.1) then
                  write(*,9007) nrecr
                  write(*,'('' Variable '',A8)') varnam(numvar(i))
                  write(*,'(1x,i9)') levcod(1)
                  stop
                endif
                rlev(ii)=rlev(ii)+1
                xlist(j,7)=rlev(ii)
                xlist(j,8)=ii
              endif
              idata(ii+1)=xlist(j,7)
            else
              xdata(pir(numvar(i))+1)=val(i)
            endif
130     continue
C-----------------------------------------------------------------------
C  process last change
C-----------------------------------------------------------------------
c---- update combined variables
            if (ntcmb.gt.0) then
              do 180 k=1,ntcmb
                if(vartim(tcmb(k),1).eq.0) goto 180
                ii=pir(tcmb(k))
                if (ii.eq.0) goto 180
                nlev=varcom(tcmb(k),1)
                do 190 l=1,nlev
                  levcod(l)=nint(rec(varcom(tcmb(k),l+1)))
190             continue
                j=idmurl(levcod,nlev,rtopl(ii),indl,xlist,ipla,
     *          ndimax,8,lastil,new)
                if (new.eq.1) then
                  if(fc.eq.1) then
                    write(*,9007) nrecr
                    write(*,'('' Variable '',A8)') varnam(tcmb(k))
                    do 370 l=1,nlev
                      write(*,'(1x,i9)') levcod(l)
370                 continue
                        stop
                  endif
                  rlev(ii)=rlev(ii)+1
                  xlist(j,7)=rlev(ii)
                  xlist(j,8)=ii
                endif
                idata(ii+1)=xlist(j,7)
180           continue
            endif
c----- write out record
            nrr=nrr+1
            itabl(nrr,1)=timd(i-1)
            itabl(nrr,2)=minus1
            ninf=2
            if(infp(3).ne.0) then
C-------------------------------------------------------------------
C if infp(3) .lt.0 ==> store previous time into info(3)
C-------------------------------------------------------------------
              if (infp(3).lt.0) then
                info(3) =iprevious
                iprevious=timd(i-1)
              endif
              itabl(nrr,3)=info(3)
              ninf=3
            endif
            do k=1,ir2
              itabl(nrr,ninf+k)=idata(k)
            enddo
            do k=1,ir1
              xtabl(nrr,ninf+ir2+k)=xdata(k)
            enddo
            if (nrr.eq.nrecmax) then
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c         print*,'@ nrecw,nrr,ir2,ir1',nrecw,nrr,ir2,ir1,
c    +      ninf,nrecmax,nrecmaxr
c         do i=1,20
c         print*,'=>',(itabl(i,k),k=1,43)
c         enddo
c££££££££££££££
c substitution of equivalence statements with reshape
          krec0=reshape((krec),(/18*nrecmaxr/))
          iv0=reshape((iv),(/(nchlim+200)*3/))
          krr=reshape((itabl),(/nrecmax*mxef/))
c         krr=reshape((xtabl),(/nrecmax*mxef/))
              call writof(ifile)
            endif
          nrecw=nrecw+1
C-----------------------------------------------------------------------
C write completed record
C-----------------------------------------------------------------------
          do 150 i=1,ntimdep
            if (tco(i).eq.0.or.pir(tco(i)).eq.0) goto 150
            if (varcc(tco(i)).eq.1) then
                idata(pir(tco(i)))=idata(pir(tco(i))+1)
                idata(pir(tco(i))+1)=0
            else
                xdata(pir(tco(i)))=xdata(pir(tco(i))+1)
                xdata(pir(tco(i))+1)=0.
            endif
150     continue
            nrr=nrr+1
            itabl(nrr,1)=info(1)
            itabl(nrr,2)=info(2)
            ninf=2
            if(infp(3).ne.0) then
C-------------------------------------------------------------------
C if infp(3) .lt.0 ==> store previous time into info(3)
C-------------------------------------------------------------------
              if (infp(3).lt.0) then
                info(3) =iprevious
                iprevious=timd(i-1)
              endif
              itabl(nrr,3)=info(3)
              ninf=3
            endif
            do k=1,ir2
              itabl(nrr,ninf+k)=idata(k)
            enddo
            do k=1,ir1
              xtabl(nrr,ninf+ir2+k)=xdata(k)
            enddo
            if (nrr.eq.nrecmax) then
              call writof(ifile)
            endif
          nrecw=nrecw+1
        endif
c      do 110 k=1,nch
c       write(6,*) numvar(k),val(k),timd(k)
c110    continue
c        print  *, nrecr,nrecw
        goto 10
100   continue
      if (nrr.gt.0) then
        call writof(ifile)
      endif
      if (fc.eq.0) then
      write(6,'('' Records read from input data file'',i9)')nrecr
      write(6,'('' Elementary records written       '',i9)')nrecw
          do 271 l=1,ir2
            if (ir2p(l).eq.0) goto 271
            if(ir2p(l).eq.join(2)) then
              write(6,272) varnam(ir2p(l)),rlev(pir(join(1)))
            else
              write(6,272) varnam(ir2p(l)),rlev(l)
            endif  
271      continue
272     format(' Class variable ',a8,' with ',i6,' classes')
        endif
      close(7)
      if (fout.ne.5) then
        close(ifile)
c     else
c       call f77close(idfile)
      endif
C-----------------------------------------------------------------------
C if a pedigree statement is specified, process pedigree file
C-----------------------------------------------------------------------
      if (idped(1).gt.0.and.fc.ne.1) then
        call pedicode
      endif
C-----------------------------------------------------------------------
C if a future records file is specified, process the records
C-----------------------------------------------------------------------
      if(futurf.eq.1) then
        if(fc.eq.0) then
          open(7,file=file(5),status='old',form='formatted')
            call openfile(8,file(6))
c          open(8,file=file(6),status='unknown',form='formatted')
c          open(8,file=file(6),status='unknown',form='unformatted')
          fc=1
          nrecr=0
          nrecw=0
          goto 10
        else
          write(6,'('' Records read from FUTURE data file'',i7)')nrecr
          write(6,'('' Elementary records written        '',i7)')nrecw
          close(7)
          if (fout.ne.5) then
            close(ifile)
c         else
c           call f77close(idfile)
          endif
        endif
      endif
C-----------------------------------------------------------------------
C write out list of old and new codes for each class variable
c Order: variable name; number of classes; number of variables combined;
c        3 'old' codes; number of occurences; 1 'new' code.
C-----------------------------------------------------------------------
      if (idped(1).eq.0) then
          open(9,file=file(3),status='unknown',form='formatted')
        k=0
22      continue
        k=k+1
          if(k.gt.ir2) goto 23
          l=ir2p(k)
          if (varcom(l,1).eq.0) varcom(l,1)=1
        do 24 i=1,lastil
          if(xlist(i,8).eq.k .and. varnam(l).ne.corrName(2)) then
              write(9,9006) varnam(l),rlev(k),varcom(l,1),
     *      xlist(i,1),xlist(i,2),xlist(i,3),xlist(i,4),xlist(i,7)
          endif
24      continue
c if the CORREALTION keyword is used the list of (random) variables
c  should be written out to codelist.txt two times - once for both
c  random variable
        if (corr) then
          if (varnam(l).eq.corrName(1)) then
            do i=1,lastil
             if(xlist(i,8).eq.k) then
              write(9,9006) corrName(2),rlev(k),varcom(l,1),
     *        xlist(i,1),xlist(i,2),xlist(i,3),xlist(i,4),xlist(i,7)
             endif
            enddo
          endif
        endif
9006    format(1x,a8,i5,i2,3i10,2i8)		
          if (vartim(l,1).eq.1.or.l.eq.timcov(1)) k=k+1
        goto 22
23      continue
        close (9)
      endif
C-----------------------------------------------------------------------
C ...write out information about output variables on output par. file
C-----------------------------------------------------------------------
      open(10,file=file(4),form='formatted',status='unknown')
      write(10,'(''TIME    1;'')')
      write(10,'(''CODE    2;'')')
      if (infp(3).gt.0) write(10,'(''ID      3;'')')
      if (infp(3).lt.0) write(10,'(''PREVIOUS_TIME      3;'')')
      write(10,'(''COVARIATE'')')
        if( ir2.gt.0) then
          write(10,9009)
9009    format('/* class variables */')
          m=3
          if (infp(3).eq.0) m=2
          do 270 l=1,ir2
            if (ir2p(l).eq.0) goto 270
            j=m+l
            if (vartim(ir2p(l),1).eq.1.or.ir2p(l).eq.timcov(1)) then
              k=j+1
            else
              k=j
            endif
            if(ir2p(l).eq.join(2)) then 
         write(10,'(a8,i6,2i4)') varnam(ir2p(l)),rlev(pir(join(1))),j,k       
            else
              write(10,'(a8,i6,2i4)') varnam(ir2p(l)),rlev(l),j,k
            endif
270      continue
        endif
        if (ir1.gt.0) then
          write(10,9010)
9010    format('/* continuous variables */')
          m=3+ir2
          if (infp(3).eq.0) m=2+ir2
          do 280 l=1,ir1
            if (ir1p(l).eq.0) goto 280
          j=m+l
            if (vartim(ir1p(l),1).eq.1) then
              k=j+1
            else
              k=j
            endif
            write(10,'(a8,''     0'',2i4)') varnam(ir1p(l)),j,k
280      continue
        endif
        write(10,'('';'')')
c not writing out the JOINCODE if the CORRELATION keyword was used
        if (join(1).ne.0.and..not.corr) then
          write(10,281) 
     *    varnam(join(1)),varnam(join(2))
281     format('JOINCODE',2(1x,a8),';')
        endif
	if (varnam(nvar).eq.'tim_unit') write(10,*) 'DISCRETE_SCALE;'
        if (fout.eq.1) then
          write(10,*) 'FREE_FORMAT;'
        elseif (fout.eq.2) then
          write(10,*) 'FIXED_FORMAT;'
        elseif (fout.eq.3) then
          write(10,*) 'UNFORMATTED;'
        elseif (fout.eq.4) then
          write(10,*) 'BLOCKED_UNFORMATTED;'
        elseif (fout.eq.5) then
          write(10,*) 'COMPRESSED;'
        endif
        close(10)
        deallocate( itabl )	
        deallocate( xtabl )
        deallocate( krr )
        deallocate( idata )
        deallocate( jdata )		
        deallocate( xdata )		
        deallocate( ydata )		
        deallocate( krec )	
        deallocate( iv )	
        deallocate( krec0 )	
        deallocate( iv0 )	
		
        return
        end subroutine transf

        subroutine pedicode
C***********************************************************************
C  recodes pedigree file                                               *
C***********************************************************************
C input data file has to be in free format, ncolped+1 columns,         *
c                 ias described in subroutine PEDIGREE                 *
c output data file is unformatted                                      *
C***********************************************************************
c
      integer, allocatable:: id(:)
      integer, allocatable:: idc(:,:)
      logical, allocatable:: notick(:)

        INTEGER I,J,K,L,ll
        integer idmurl,nunknown,ione,izero,nrec
        integer i2,ic,imess
		
      allocate( id(ncolped) )
      allocate( idc(ncolped,2) )
      allocate( notick(ndimax) )	  
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
      nlev=1
      nrec=0
      nunknown=0
      do i=1,ndimax
        notick(i)=.true.
      enddo
C-----------------------------------------------------------------------
C open input pedigree file and recoded pedigree file
C-----------------------------------------------------------------------
      open(11,file=file(7),status='old',form='formatted')
      open(12,file=file(8),status='unknown',form='formatted')
c      open(12,file=file(8),status='unknown',form='unformatted')
C-----------------------------------------------------------------------
C define position(s) of identification variable(s) in input data file
C-----------------------------------------------------------------------
      i=pir(idped(1))
      if(idped(2).gt.0) i2=pir(idped(2))  
      if (idped(1).le.nvread) then
C-----------------------------------------------------------------------
C start the recoding process
C-----------------------------------------------------------------------
10      continue
        read(11,*,end=100) id(1),ic,(id(ll),ll=2,ncolped)
        nrec=nrec+1
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement was modified on October 21, 1996 
c        if (idped(2).eq.0) then
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        if (idped(2).eq.0.or.ic.eq.-1) then
C-----------------------------------------------------------------------
C ... for sire or animal models
C-----------------------------------------------------------------------
          do 20 k=1,ncolped
            if (id(k).eq.0) goto 20
            j=idmurl(id(k),nlev,rtopl(i),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement was added on October 21, 1996 
c (groups of unknown parents are coded from -1 to -nunknown)
                if (ic.eq.-1) then
                  nunknown=nunknown+1
                  xlist(j,7)=-nunknown
                  xlist(j,8)=i
                  id(2)=0
                  id(3)=0
                else if (id(k).lt.0) then 
                  nunknown=nunknown+1
                  xlist(j,7)=-nunknown
                  xlist(j,8)=i
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                else
                  rlev(i)=rlev(i)+1
                  xlist(j,7)=rlev(i)
                  xlist(j,8)=i
                endif
            endif
            id(k)=xlist(j,7)
20        continue
          write(12,*) id(1),ic,(id(ll),ll=2,ncolped)
c          write(12) id(1),ic,id(2),id(3)
          if (id(1).gt.0) notick(id(1))=.false.
        else
C-----------------------------------------------------------------------
C ... for sire/dam models
C-----------------------------------------------------------------------
          if(ic.eq.1) then  
C-----------------------------------------------------------------------
C ...... male individual
C-----------------------------------------------------------------------
            j=idmurl(id(1),nlev,rtopl(i),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
              rlev(i)=rlev(i)+1
              xlist(j,7)=rlev(i)
              xlist(j,8)=i
            endif
            id(1)=xlist(j,7)
          elseif (ic.eq.2) then
C-----------------------------------------------------------------------
C ...... female individual
C-----------------------------------------------------------------------
            j=idmurl(id(1),nlev,rtopl(i2),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
              rlev(i2)=rlev(i2)+1
              xlist(j,7)=rlev(i2)
              xlist(j,8)=i2
            endif
            id(1)=xlist(j,7)
          else
            write(*,9002) nrec
9002        format(1x,'Error in PEDIGREE file, record no. ',i8/
     +      1x,'code in second column must be 1 (for male) ',
     +         'or 2 (for female)'/
     +      1x,'Check file')
              stop
          endif
C-----------------------------------------------------------------------
C ...... sire
C-----------------------------------------------------------------------
          if(id(2).gt.0) then
            j=idmurl(id(2),nlev,rtopl(i),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement was added on October 21, 1996 
c (groups of unknown parents are coded from -1 to -nunknown)
                if (id(2).lt.0) then 
                  nunknown=nunknown+1
                  xlist(j,7)=-nunknown
                  xlist(j,8)=i
                else
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                  rlev(i)=rlev(i)+1
                  xlist(j,7)=rlev(i)
                  xlist(j,8)=i
                endif
            endif
            id(2)=xlist(j,7)
          endif
C-----------------------------------------------------------------------
C ...... dam
C-----------------------------------------------------------------------
          if(id(3).gt.0) then
            j=idmurl(id(3),nlev,rtopl(i2),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c The following statement was added on October 21, 1996 
c (groups of unknown parents are coded from -1 to -nunknown)
                if (id(3).lt.0) then 
                  nunknown=nunknown+1
                  xlist(j,7)=-nunknown
                  xlist(j,8)=i
                else
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                  rlev(i2)=rlev(i2)+1
                  xlist(j,7)=rlev(i2)
                  xlist(j,8)=i2
                endif
            endif
            id(3)=xlist(j,7)
          endif
          write(12,*) id(1),ic,id(2),id(3)
c        write(12) id(1),ic,id(2),id(3)
        endif
        goto 10
100     continue 
c---- add animals that were listed as sires or dams but not as animals
c---- to list of animals in recoded file
        ione=1
        izero=0
c---- message only if not sire-dam model
        if (idped(2).eq.0) then 
          imess=0
        else
          imess=1
        endif
        do j=1,rlev(i)
          if (notick(j)) then 
          write(12,*) j,ione,izero,izero
          if (imess.eq.0) then
            write(*,9201)
            write(*,*) j,ione,izero,izero
9201    format(' WARNING: Your pedigree file seems to be incomplete'/
     *         ' All individuals which are sires or dams (MGS) should'/
     *         ' also appear as animals (first column)'/
     *         ' This is not the case. The program has assumed that '/
     *         ' such individuals are base animals and has added them'/
     *         ' to the pedigree data set accordingly. '/
     *         ' Still, we strongly recommend more careful examination'/
     *         ' of the pedigree data.')
            imess=1
          endif
          endif
        enddo
        close(11)
        CLOSE(12)
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on October 21, 1996:
      if (nunknown.ne.0) then 
        write(6,*) nunknown,' groups of unknown parents were defined'
        rlev(i)=rlev(i)+nunknown
      endif
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C-----------------------------------------------------------------------
C write out list of old and new codes for each class variable
c Order: variable name; number of classes; number of variables combined;
c        3 'old' codes; number of occurences; 1 'new' code.
C-----------------------------------------------------------------------
        open(9,file=file(3),status='unknown',form='formatted')
        k=0
22      continue
        k=k+1
          if(k.gt.ir2) goto 23
        l =ir2p(k)
        if (varcom(l,1).eq.0) varcom(l,1)=1
        do 24 i=1,lastil
          if(xlist(i,8).eq.k) then
              write(9,9006) varnam(l),rlev(k),varcom(l,1),
     *      xlist(i,1),xlist(i,2),xlist(i,3),xlist(i,4),xlist(i,7)
          endif
24      continue
c if the CORREALTION keyword is used the list of (random) variables
c  should be written out to codelist.txt two times - once for both
c  random variable
        if (corr) then
          if (varnam(l).eq.corrName(1)) then
            do i=1,lastil
             if(xlist(i,8).eq.k) then
              write(9,9006) corrName(2),rlev(k),varcom(l,1),
     *        xlist(i,1),xlist(i,2),xlist(i,3),xlist(i,4),xlist(i,7)
             endif
            enddo
          endif
        endif
9006    format(1x,a8,i5,i2,3i10,2i8)
        if (vartim(l,1).eq.1.or.l.eq.timcov(1)) k=k+1
        goto 22
23      continue
        close (9) 
      else  
        nlev=2
C-----------------------------------------------------------------------
C start the recoding process when id s are combined variables
C-----------------------------------------------------------------------
110    continue
        read(11,*,end=1100) (idc(ll,1),idc(ll,2),ll=1,ncolped)
       write(6,*) idc(1,1),idc(1,2),ic,(idc(ll,1),idc(ll,2),
     +      ll=2,ncolped) 
        nrec=nrec+1
        if (idped(2).eq.0) then
C-----------------------------------------------------------------------
C ... for sire or animal models
C-----------------------------------------------------------------------
          do 120 k=1,3
            if (idc(k,1).eq.0.and.idc(k,2).eq.0) then   
               id(k) = 0
               goto 120 
            endif
            levcod(1)=idc(k,1)
            levcod(2)=idc(k,2)
            j=idmurl(levcod,nlev,rtopl(i),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
              rlev(i)=rlev(i)+1
              xlist(j,7)=rlev(i)
              xlist(j,8)=i
            endif
            id(k)=xlist(j,7)
120       continue
          write(12,*) id(1),ic,id(2),id(3)
c          write(12) id(1),ic,id(2),id(3)
          if (id(1).gt.0) notick(id(1))=.false.
        else
C-----------------------------------------------------------------------
C ... for sire/dam models
C-----------------------------------------------------------------------  
          levcod(1)=idc(1,1)
          levcod(2)=idc(1,2) 
          if(ic.eq.1) then  
C-----------------------------------------------------------------------
C ...... male individual
C----------------------------------------------------------------------- 
            j=idmurl(levcod,nlev,rtopl(i),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
              rlev(i)=rlev(i)+1
              xlist(j,7)=rlev(i)
              xlist(j,8)=i
            endif
            id(1)=xlist(j,7)
          elseif (ic.eq.2) then
C-----------------------------------------------------------------------
C ...... female individual
C-----------------------------------------------------------------------
            j=idmurl(levcod,nlev,rtopl(i2),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
              rlev(i2)=rlev(i2)+1
              xlist(j,7)=rlev(i2)
              xlist(j,8)=i2
            endif
            id(1)=xlist(j,7)
          else
            write(*,9102) nrec
9102        format(1x,'Error in PEDIGREE file, record no. ',i8/
     +      1x,'code in third column must be 1 (for male) ',
     +         'or 2 (for female)'/
     +      1x,'Check file')
              stop
          endif
C-----------------------------------------------------------------------
C ...... sire
C----------------------------------------------------------------------- 
          if(idc(2,1).eq.0.and.idc(2,2).eq.0) then  
            id(2) = 0
          else
            levcod(1)=idc(2,1)
            levcod(2)=idc(2,2) 
            j=idmurl(levcod,nlev,rtopl(i),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
              rlev(i)=rlev(i)+1
              xlist(j,7)=rlev(i)
              xlist(j,8)=i
            endif
            id(2)=xlist(j,7)
          endif
C-----------------------------------------------------------------------
C ...... dam
C-----------------------------------------------------------------------  
          if(idc(3,1).eq.0.and.idc(3,2).eq.0) then
            id(3)=0
          else
            levcod(1)=idc(3,1)
            levcod(2)=idc(3,2) 
            j=idmurl(levcod,nlev,rtopl(i2),indl,xlist,ipla,
     *      ndimax,8,lastil,new)
            if (new.eq.1) then
              rlev(i2)=rlev(i2)+1
              xlist(j,7)=rlev(i2)
              xlist(j,8)=i2
            endif
            id(3)=xlist(j,7)
          endif
          write(12,*) id(1),ic,id(2),id(3)
c        write(12) id(1),ic,id(2),id(3)
          if (id(1).gt.0) notick(id(1))=.false.
        endif
        goto 110
1100    continue 
c---- add animals that were listed as sires or dams but not as animals
c---- to list of animals in recoded file
        ione=1
        izero=0
        imess=0
        do j=1,rlev(i)
          if(notick(j))then 
          if (imess.eq.0) then
            write(*,9201)
            imess=1
         endif
         write(12,*) j,ione,izero,izero
         endif
        enddo
        close(11)
        CLOSE(12)
C-----------------------------------------------------------------------
C write out list of old and new codes for each class variable
c Order: variable name; number of classes; number of variables combined;
c        3 'old' codes; number of occurences; 1 'new' code.
C-----------------------------------------------------------------------
        open(9,file=file(3),status='unknown',form='formatted')
        k=0
122      continue
        k=k+1
          if(k.gt.ir2) goto 123
        l =ir2p(k)
        if (varcom(l,1).eq.0) varcom(l,1)=1
        do 124 i=1,lastil
          if(xlist(i,8).eq.k) then
              write(9,9006) varnam(l),rlev(k),varcom(l,1),
     *      xlist(i,1),xlist(i,2),xlist(i,3),xlist(i,4),xlist(i,7)
          endif
124      continue
        if (vartim(l,1).eq.1.or.l.eq.timcov(1)) k=k+1
        goto 122
123      continue
        close (9)   
      endif
	  
      deallocate( id )
      deallocate( idc )
      deallocate( notick )	  
	  
      return
      end subroutine pedicode
 
        subroutine files
C***********************************************************************
C processes files statement                                            *
C***********************************************************************
c in the files statement, the filenames of four files are defined      *
c it has the following form:                                           *
c                                                                      *
c files filename1 filename2 filename3 filename4;                       *
c                                                                      *
c where                                                                *
c filename1 is the name of the original data file (must exist in your  *
c           directory)                                                 *
c filename2 is the name of the recoded file produced by the program    *
c filename3 is the name of a file containing the original and new      *
c           codes for each class effect.                               *
c filename4 is the name of a file containeing information about the    *
c           variables in the data sets (is one of two parameter files  *
c           for the survival analysis                                  *
c                                                                      *
c Note: the maximum length of a filename is 15 characters              *
C***********************************************************************
c
        INTEGER I,J,L
        CHARACTER*8 w8
c
C
c flag variable "parmark" changes to indicate wether variables NRECMAX,
c MXEF or NDIMAX or NCOLPED  are changed before FILES as required
      parmark=.TRUE.
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        do 20 l=1,8
          file(l)='               '
20    continue
C-----------------------------------------------------------------------
C process the 4 file names
C-----------------------------------------------------------------------
        do 10 l=1,4
          wn=wn+1
C-----------------------------------------------------------------------
C read name of variable
C-----------------------------------------------------------------------
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
          call chkkeyw(w8)
C-----------------------------------------------------------------------
C if word is ';' ==> write error statement
C-----------------------------------------------------------------------
          if (word(1,wn).eq.';') then
            write(*,9001) l-1
9001      format(1x,'Error in FILES statement'/
     +    1x,'4 file names have to specified in this statement '/
     +    1x,'Only ',i2,' found'/
     +    1x,'Check parameter file')
            stop
          endif
          file(l)=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +         //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
     +         //WORD(9,wn)//WORD(10,wn)//WORD(11,wn)//WORD(12,wn)
     +         //WORD(13,wn)//WORD(14,wn)//WORD(15,wn)
10    continue
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9002)
9002    format(1x,'Error in FILES statement'/
     +  1x,'Only 4 arguments to statement admissible'/
     +  1x,'Check parameter file')
          stop
        endif 
        return
        end subroutine files

        subroutine input
C***********************************************************************
C processes input statement                                            *
C***********************************************************************
C in the input statement variable names their respective variable      *
c types are defined. it has the following form:                        *
c                                                                      *
c input name type name type name type .....;                           *
c                                                                      *
C the follwing variable types are allowed:                             *
c I4 - integer*4                                                       *
c r4 - real*4                                                          *
c d6 - date with 6 digits  ddmmyy                                      *
c d8 - date with 8 digits  ddmmyyyy                                    *
C***********************************************************************
c
        INTEGER I,J,K,iend
        CHARACTER*8 w8
C
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        nvar=0
        nvread=0
        iend=nword-wn
C-----------------------------------------------------------------------
C go through list of words
C-----------------------------------------------------------------------
        do 10 k=1,iend
          wn=wn+1
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
          call chkkeyw(w8)
C-----------------------------------------------------------------------
C if word is ';' ==>return
C-----------------------------------------------------------------------
          if (word(1,wn).eq.';') then
            if (mod(k,2).eq.0) then
                write(*,9000) k-1
9000        format(1x,'Error in input statement'/
     +      1x,i3,' arguments to input statement - this should',
     +      ' be an even number'/1x,'Check parameter file')
                stop
            endif
            nvread=nvar
c          do 20 l=1,nvar
c            write(6,*) varnam(l),vartyp(l)
c20        continue
            return
          endif
C-----------------------------------------------------------------------
C create list of variables and corresponding types
C-----------------------------------------------------------------------
          if (mod(k,2).eq.1) then
C-----------------------------------------------------------------------
C name of variable
C-----------------------------------------------------------------------
            nvar=nvar+1
            varnam(nvar)=w8
          else
C-----------------------------------------------------------------------
C type of variable
C-----------------------------------------------------------------------
            vartyp(nvar)=word(1,wn)//word(2,wn)
C-----------------------------------------------------------------------
C check if type is o.k.
C-----------------------------------------------------------------------
            if (vartyp(nvar).eq.'I4') goto 10
            if (vartyp(nvar).eq.'R4') goto 10
            if (vartyp(nvar).eq.'D6') goto 10
            if (vartyp(nvar).eq.'D8') goto 10
C-----------------------------------------------------------------------
C type of variable is unknown; write error message
C-----------------------------------------------------------------------
            write(*,9001) varnam(nvar),w8
9001      format(1x,'Error in Input statement'/
     +    1x,'type of variable ',A8,'was given as ',A8/
     +    1x,'expected to be one of the following: I4 R4 D6 D8'/
     +    1x,'check parameter file')
            stop
          endif
10    continue
        end subroutine input

        subroutine ttime
C***********************************************************************
C processes time statement                                             *
C***********************************************************************
c in the time statement, the dependent variable is defined.            *
c this is usually time, but may be other things like lifetime          *
c production, etc.                                                     *
c the time statement may have three different forms:                   *
c                                                                      *
c 1) time name;                                                        *
c 2) time name name;                                                   *
C 3) time name name name;                                              *
c                                                                      *
c ad 1): the name must be identical with one of the names specified    *
c        in the input statement and must contain the time till death   *
c        or censoring of an individual (must be of type I4).           *
c ad 2): the first name must fulfil the same criteria as in 1), the    *
c        second name is the date (D6 or D8) indicating the beginning   *
c        of the observation                                            *
c        (must also be contained in list of input variables).          *
c        this is necessary when changes in risk are given by dates and *
c        not by times in the TIMECOV or TIMEDEP statements.            *
c ad 3): the first name is the name of the time variable. it may or    *
c        may not be contained in the list of variables in the INPUT    *
c        statement. the second and third variables are dates indicating*
c        the beginning and end of the observation. they must be in the *
c        INPUT statement. if the first name is not in the input state- *
c        ment, its value will be calculated as difference between end  *
c        and beginning of the observation.                             *
C***********************************************************************
c
        INTEGER I,J,K,L,nvarold
        CHARACTER*8 w8
C
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        timev(1)=0
        timev(2)=0
        timev(3)=0
        nvarold=nvar
C-----------------------------------------------------------------------
C go through list of words
C-----------------------------------------------------------------------
        do 10 k=1,3
          wn=wn+1
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
          call chkkeyw(w8)
C-----------------------------------------------------------------------
C if word is ';' ==>return
C-----------------------------------------------------------------------
          if (word(1,wn).eq.';') goto 50
C-----------------------------------------------------------------------
C check if word appears in list of input variables
C-----------------------------------------------------------------------
          do 40 l=1,nvread
            if (w8.eq. varnam(l)) goto 30
40      continue
C-----------------------------------------------------------------------
C new variable name
C-----------------------------------------------------------------------
          if (k.eq.1) then
            nvar=nvar+1
            varnam(nvar)=w8
            vartyp(nvar)='I4'
            timev(1)=nvar
            goto 10
          else
            write(*,9001) w8
9001      format(1x,'Error in TIME statement'/
     +    1x,A8,' did not appear in the list of input variables'/
     +    1x,'Check parameter file')
            stop
          endif
C-----------------------------------------------------------------------
C write variable number to vector timev
C-----------------------------------------------------------------------
30      continue
          timev(k)=l
C-----------------------------------------------------------------------
C 1st variable has to be I4, 2nd and 3rd variables have to be D6 or D8
C-----------------------------------------------------------------------
          if (k.eq.1) then
            if (vartyp(l).ne.'I4') then
                write(*,9002) w8
9002        format(1x,'Error in TIME statement'/
     +      1x,'Variable type of ',A8,' has to be I4'/
     +      1x,'Check parameter file')
                stop
            endif
          else
            if (vartyp(l).ne.'D6'.and.vartyp(l).ne.'D8') then
                write(*,9003) w8
9003        format(1x,'Error in TIME statement'/
     +      1x,'Variable type of ',A8,' has to be D6 or D8'/
     +      1x,'Check parameter file')
                stop
            endif
          endif
10    continue
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9004)
9004    format(1x,'Error in TIME statement'/
     +  1x,'Only 3 arguments to statement admissible'/
     +  1x,'Check parameter file')
          stop
        endif
50    continue
C-----------------------------------------------------------------------
C new variable name for 1st variable is only admissible when 2nd and 3rd
C variables are defined
C-----------------------------------------------------------------------
        if (nvar.gt.nvarold.and.k.le.3) then
          write(*,9005)
9005    format(1x,'Error in TIME statement'/
     +  1x,'if 1st variable is not in list of input variables,'/
     +  1x,'2nd and 3rd variables have to be given'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C 2nd and 3rd variables have to be of the same type
C-----------------------------------------------------------------------
        if (k.gt.3) then
          if (vartyp(timev(2)).ne.vartyp(timev(3))) then
            write(*,9006) varnam(timev(2)),vartyp(timev(2)),
     +    varnam(timev(3)),vartyp(timev(3))
9006      format(1x,'Error in TIME statement'/
     +    1x,'2nd variable ',A8,' has type ',A2/
     +    1x,'3rd variable ',A8,' has type ',A2/
     +    1x,'Types have to be identical'/
     +    1x,'Check parameter file')
            stop
          endif
        endif
c      do 20 l=1,3
c        if (timev(l).gt.0) then
c          write(*,9007) timev(l),varnam(timev(l)),vartyp(timev(l))
c9007      format(i4,2x,a8,2x,a8)
c        endif
c20    continue
        return
        end subroutine ttime

        subroutine censcode
C***********************************************************************
C processes censcode statement                                         *
C***********************************************************************
c in the censcode statement, the censoring variable is defined.        *
c it has the following form                                            *
c                                                                      *
c censcode name value;                                                 *
c                                                                      *
c  the name must be identical with one of the names specified          *
c  in the input statement and must contain the censoring code          *
c  (must be of type I4). value indicates which number denotes          * 
c  right censored records. all other values of the variable            *
c  indicate death (failure).                                           *
C***********************************************************************
c
        INTEGER I,J,L
        CHARACTER*8 w8
C
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        censv(1)=0
        censv(2)=0
C-----------------------------------------------------------------------
C read name of censoring variable
C-----------------------------------------------------------------------
        wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
        call chkkeyw(w8)
C----------------------------------------------------------------------
C check if word appears in list of input variables
C-----------------------------------------------------------------------
        do 40 l=1,nvread
          if (w8.eq. varnam(l)) goto 30
40    continue
C-----------------------------------------------------------------------
C variable name not in list of input variables ==>error
C-----------------------------------------------------------------------
        write(*,9000) w8
9000  format(1x,'Error in CENSCODE statement'/
     +1x,A8,' did not appear in the list of input variables'/
     +1x,'Check parameter file')
        stop
C-----------------------------------------------------------------------
C write variable number to first position of vector censv
C-----------------------------------------------------------------------
30    continue
        censv(1)=l
C-----------------------------------------------------------------------
C read censoring code(s)
C-----------------------------------------------------------------------
        if (nfig(wn).eq.1) then
          censv(2)=ifig(lfig(wn))
        else
          write(*,9001) nfig(wn)
9001    format(1x,'Error in CENSCODE statement'/
     +  1x,i4,' numeric values are given after the variable name'/
     +  1x,'1 value was expected'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9002)
9002    format(1x,'Error in CENSCODE statement'/
     +  1x,'Only 1 character and 1 numeric argument ',
     +     'to statement admissible'/
     +  1x,'Check parameter file')
          stop
        endif
c      write(6,*) varnam(censv(1))
c      write(6,*) censv(2)
20    continue
        return
        end subroutine censcode

        subroutine idrec
C***********************************************************************
C processes idrec statement                                           *
C***********************************************************************
c in the idrec statement, a variabe is defined that is unique to each  *
c record. This variable is needed for sorting the elementary records   *
c when using a Weibull model.                                          *
c it has the following alternative forms:                              *
c                                                                      *
c idrec name;                                                          *
c idrec store_pr(evious time);
c                                                                      *
c the name must be of a variable defined previously, of type I4.       *
c note: the same variable may also appear in the class statement (e.g. *
c animal identification for the animal model. in this case, the        *
c variable will appear twice in the recoded file that is the result    *
c of this program. first, unrecoded as the 3rd variable on the record, *
c and second, recoded as one of the class variables.                   *
c store_pr(evious_time) indicates that each elementary record will     *
c include both the beginning and the end of the interval when the time *
c dependent variables remain constant. This is needed when later on in *
c the weibull program, a (log-gamma) random time-dependent covariate is*
c integrated out (and only then). When store_pr(evious_time) is        *
c included, the beginning of each interval is stored in column 3,      *
C***********************************************************************
c
        INTEGER I,J,L
        CHARACTER*8 w8
c
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        idrev=0
C-----------------------------------------------------------------------
C read name of variable
C-----------------------------------------------------------------------
        wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
C check if word appears in list of variables
C-----------------------------------------------------------------------
        do 20 l=1,nvread
          if (w8.eq. varnam(l)) then
          idrev=l
          goto 10 
        endif
20    continue        
        do 21 l=nvread+1,nvar
          if (w8.eq. varnam(l)) then 
          idrev=l    
          write(6,*) 'IDREC values are consecutive numbers'
          goto 10 
        endif
21    continue
C-----------------------------------------------------------------------
C check if argument to statement is STORE_PR
C-----------------------------------------------------------------------
      if (w8.eq.'STORE_PR') then
        infp(3)=-1
        goto 11
      endif
C-----------------------------------------------------------------------
C variable name not in list of input variables and not STORE_PR ==>error
C-----------------------------------------------------------------------
        write(*,9001) w8
9001  format(1x,'Error in IDREC statement'/
     +1x,A8,' did not appear in the list of variables'/ 
     +1x,' or IDREC statement appeared before a combine statement',/
     +1x,' nor is it STORE_PR',/
     +1x,'Check parameter file')
        stop
C-----------------------------------------------------------------------
C set idrec indicator idrev to number of variable
C-----------------------------------------------------------------------
10    continue
C----------------------------------------------------------------------
C type has to be I4
C-----------------------------------------------------------------------
        if (vartyp(l).ne.'I4') then
          write(*,9002) varnam(l),vartyp(l)
9002    format(1x,'Error in IDREC statement'/
     +  1x,'Type of ',A8,' is ',A2/
     +  1x,'Must be I4'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
11    continue
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9003)
9003    format(1x,'Error in IDREC statement'/
     +  1x,'Only one argument admissible'/
     +  1x,'Check parameter file')
          stop
        endif
c      write(6,*) idrev,varnam(l)
        end subroutine idrec
        subroutine truncate
C***********************************************************************
C processes truncate statement                                         *
C***********************************************************************
c in the truncate statement, information is provided for handling      *
c left truncated records. It has the following form                    *
c                                                                      *
c truncate name;                                                       *
c                                                                      *
c name  specifies the variable holding the time of the truncation      *
c  point. Variable must have been specified in the input statement and *
c  must be of type I4, D6 or D8. If it is I4, it specifies the time    *
c  between the beginning of the observation and the point in time when *
c  the individual actually entered the study (truncation point). If it *
c  is D6 or D8, it holds the truncation date and time will be          *
c  calculated as difference between this date and the date sspecified  *
c  in the first argument of the time statement (types must be          *
c  identical). If the variable is coded 0 in the data set, the record  *
c  is treated as untruncated (independently from data type)            *
c***********************************************************************
c
        INTEGER I,J,L
        CHARACTER*8 w8
c
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        trunv=0
C-----------------------------------------------------------------------
C read name of variable
C-----------------------------------------------------------------------
        wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
C check if word appears in list of variables
C-----------------------------------------------------------------------
        do 20 l=1,nvar
          if (w8.eq. varnam(l)) goto 10
20    continue
C-----------------------------------------------------------------------
C variable name not in list of input variables ==>error
C-----------------------------------------------------------------------
        write(*,9001) w8
9001  format(1x,'Error in TRUNCATE statement'/
     +1x,A8,' did not appear in the list of variables'/
     +1x,'Check parameter file')
        stop
C-----------------------------------------------------------------------
C set truncation variable indicator trunv to number of variable
C-----------------------------------------------------------------------
10    continue
        trunv=l
C----------------------------------------------------------------------
C type has to be I4
C-----------------------------------------------------------------------
        if (vartyp(l).ne.'I4'.and.vartyp(l).ne.'D6'.and.
     +    vartyp(l).ne.'D8') then
          write(*,9002) varnam(l),vartyp(l)
9002    format(1x,'Error in TRUNCATE statement'/
     +  1x,'Type of ',A8,' is ',A2/
     +  1x,'Must be I4, D6 or D8'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9003)
9003    format(1x,'Error in TRUNCATE statement'/
     +  1x,'Only one argument admissible'/
     +  1x,'Check parameter file')
          stop
        endif
c      write(6,*) trunv,varnam(trunv)
        end subroutine truncate

        subroutine timecov
C***********************************************************************
C processes timecov statement                                          *
C***********************************************************************
c the timecov statement is needed when the hazard changes with time    *
c (this may be calendar time or time as measured form the beginning    *
c of each observation) independently from special (stochastic) events. *
c the timecov statement has the following form:                        *
c                                                                      *
c timecov name type value value ....;                                  *
c                                                                      *
c name stands for the name of the timecov variable. this must be a     *
c new name not specified previously (in the input or time statements). *
c type may be either integer (I4) or a date (D6 or D8). If it is       *
c integer, the values indicate changes in the hazard rate relative     *
c to the beginning of each observation. if type is a date, it          *
c determines points in the calendar time, when the risk changes for    *
c all individuals. the change on the time axis of the individual       *
c is then calculated internally as difference between the respective   *
c date given and the date indicating the starting point of the         *
c observation in the TIME statement. Therefore, when using a TIMECOV   *
c statement, the TIME statement must have the date of the beginning of *
c the observation as second argument and the date of the end of the    *
c observation as third argument. The variable types of those arguments *
C***********************************************************************
c
        INTEGER I,J,K,L,datev(3)
        integer nday
        CHARACTER*8 w8
        character*2 w2
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        timcov(1)=0
        timcov(2)=0
        timcov(3)=0
C-----------------------------------------------------------------------
C read name of timecov variable
C-----------------------------------------------------------------------
        wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
C check if name in list of variables, if yes ==>error
C-----------------------------------------------------------------------
        do 10 l=1,nvar
          if (w8.eq. varnam(l)) then
            write(*,9000) w8
9000      format(1x,'Error in TIMECOV statement'/
     +    1x,A8,' already defined. Must be a new variable name'/
     +    1x,'Check parameter file')
            stop
          endif
10    continue
        nvar=nvar+1
        varnam(nvar)=w8
        vartyp(nvar)='I4'
        varcc(nvar)=1
        timcov(1)=nvar
      vartim(nvar,1)=1
C-----------------------------------------------------------------------
C read type of arguments to timecov variable
C-----------------------------------------------------------------------
        wn=wn+1
        W2=WORD(1,wn)//WORD(2,wn)
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
C type has to be I4, D6 or D8
C-----------------------------------------------------------------------
        if (w2.ne.'I4'.and.w2.ne.'D6'.and.w2.ne.'D8') then
          write(*,9001) varnam(nvar),w8
9001    format(1x,'Error in TIMECOV statement'/
     +  1x,'Type of ',A8,' given as ',A8/
     +  1x,' Must be one of the following: I4 D6 D8'/
     +  1x,'Check parameter file')
          stop
        endif
        if (w2.eq.'D6'.or.w2.eq.'D8') then
C-----------------------------------------------------------------------
C if type is D6 or D8, variables 2 and 3 in TIME statement must be
C defined
C-----------------------------------------------------------------------
          if (timev(2).eq.0.or.timev(3).eq.0) then
            write(*,9002) varnam(nvar),w2
9002      format(1x,'Error in TIMECOV statement'/
     +    1x,'If type of TIMECOV variable ',A8,' is ',A2,
     +       ', the TIME statement must include'/
     +    1x,'variables indicating the beginning',
     +       ' and end of an observation'/
     +    1x,'Check parameter file')
            stop
          endif
C-----------------------------------------------------------------------
C if type is D6 or D8, it must be identical to type of variables
C 2 and 3 in TIME statement
C-----------------------------------------------------------------------
          if (vartyp(timev(2)).ne.w2) then
            write(*,9003) varnam(nvar),vartyp(nvar),
     +    varnam(timev(2)),vartyp(timev(2))
9003      format(1x,'Error in TIMECOV statement'/
     +    1x,'TIMECOV variable ',A8,' has type ',A2/
     +    1x,'2nd variable in TIME statement ',A8,' has type ',A2/
     +    1x,'Types have to be identical'/
     +    1x,'Check parameter file')
          stop
          endif
        endif
C-----------------------------------------------------------------------
C read values of TIMECOV variable
C-----------------------------------------------------------------------
        timcov(3)=nfig(wn)
        if (nfig(wn).eq.0) then
          write(*,9004)
9004    format(1x,'Error in TIMECOV statement'/
     +  1x,'No values for TIMECOV variable given'/
     +  1x,'Check parameter file')
          stop
        endif
        do 20 k=1,nfig(wn)
          l=lfig(wn)+k-1
C-----------------------------------------------------------------------
C ... for type I4
C-----------------------------------------------------------------------
          if (w2.eq.'I4') then
            timc(k)=ifig(l)
            if (k.gt.1) then 
            if(timc(k).le.timc(k-1)) then
                write(*,9005) k-1,timc(k-1),k,timc(k)
9005        format(1x,'Error in TIMECOV statement'/
     +      1x,'Value ',i4,' = ',i9/
     +      1x,'Value ',i4,' = ',i9/
     +      1x,'Values have to be in ascending order.'/
     +      1x,'Check parameter file')
                stop
            endif
            endif
          else
C-----------------------------------------------------------------------
C ... for type D6
C-----------------------------------------------------------------------
            if (w2.eq.'D6') then
                if (ifig(l).lt.010100.or.ifig(l).gt.311299) then
                  write(*,9006) ifig(l)
9006          format(1x,'Error in TIMECOV statement'/
     +        1x,'Value ',i9,' is not compatible with format D6'/
     +        1x,'Check parameter file')
                  stop
                endif
                datev(1)=ifig(l)/10000
                datev(2)=(ifig(l)-datev(1)*10000)/100
                datev(3)=ifig(l)-datev(1)*10000-datev(2)*100
                if (datev(3).lt.nbug_2000) datev(3)=datev(3)+100
C-----------------------------------------------------------------------
C ... for type D8
C-----------------------------------------------------------------------
            elseif (w2.eq.'D8') then
                if (ifig(l).lt.01010000.or.ifig(l).gt.31129999) then
                  write(*,9007) ifig(l)
9007          format(1x,'Error in TIMECOV statement'/
     +        1x,'Value ',i9,' is not compatible with format D8'/
     +        1x,'Check parameter file')
                  stop
                endif
                datev(1)=ifig(l)/1000000
                datev(2)=(ifig(l)-datev(1)*1000000)/10000
                datev(3)=ifig(l)-datev(1)*1000000-datev(2)*10000
            endif
            if (datev(1).gt.31) then
                write(*,9008) ifig(l)
9008        format(1x,'Error in TIMECOV statement'/
     +      1x,'Value ',i9,' is not o.k.'/
     +      1x,'Code for days must be <= 31'/
     +      1x,'Check data or parameter file')
                stop
            endif
            if (datev(2).gt.12) then
                write(*,9009) ifig(l)
9009        format(1x,'Error in TIMECOV statement'/
     +      1x,'Value ',i9,' is not o.k.'/
     +      1x,'Code for months must be <= 12'/
     +      1x,'Check data or parameter file')
                stop
            endif
            timc(k)=nday(datev(1),datev(2),datev(3))
            if (k.gt.1) then
            if (timc(k).le.timc(k-1)) then
                write(*,9010) k-1,ifig(l-1),k,ifig(l)
9010        format(1x,'Error in TIMECOV statement'/
     +      1x,'Value ',i4,' = ',i8/
     +      1x,'Value ',i4,' = ',i8/
     +      1x,'Values have to be in ascending order.'/
     +      1x,'Check parameter file')
                stop
            endif
            endif
          endif
20    continue
C-----------------------------------------------------------------------
C store codes for variable and argument type on variable timcov(2)
C-----------------------------------------------------------------------
        if(w2.eq.'I4') then
          timcov(2)=1
        else
          timcov(2)=2
        endif
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9011)
9011    format(1x,'Error in TIMECOV statement'/
     +  1x,'Only 1 character arguments (+values) admissible'/
     +  1x,'Check parameter file')
          stop
        endif
c      write(6,*) varnam(nvar),vartyp(nvar)
c      do 30 k=1,nfig(wn-1)
c       write(6,*) timc(k)
c30    continue
        return
        end subroutine timecov
	
        subroutine discrete 
C***********************************************************************
C processes DISCRETE  statement                                        *
C***********************************************************************
c the discrete statement is needed when the time scale is discrete     *
c (small values of the TIME variable, many ties, eg: values expressed  *
c in years). The discrete statement is COMPLETELY equivalent to:       *
c timecov tim_unit I4 1 2 3 ... ...;                                   *
c                                                                      *
c the discrete statement stands alone as:                              *
c discrete ;                                                           *
c                                                                      *
C***********************************************************************
c
        INTEGER MAXDISC
        PARAMETER (MAXDISC=100)
        INTEGER I,J,K,L,datev(3)
        integer nday
        CHARACTER*8 w8
        character*2 w2
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        timcov(1)=0
        timcov(2)=0
        timcov(3)=0
C-----------------------------------------------------------------------
C read name of timecov variable
C-----------------------------------------------------------------------
        W8='tim_unit'
C----------------------------------------------------------------------
C check if name in list of variables, if yes ==>error
C-----------------------------------------------------------------------
        nvar=nvar+1
        varnam(nvar)=w8
        vartyp(nvar)='I4'
        varcc(nvar)=1
        timcov(1)=nvar
        timcov(2)=1
        vartim(nvar,1)=1
C----------------------------------------------------------------------
C if the option "DISCRETE" is used, type for TIME has to be I4 
C-----------------------------------------------------------------------
        if (timev(2).ne.0) then
            write(*,9900) 
9900      format(1x,'Error in TIME statement'/
     +    1x,'If DISCRETE is used later, the TIME type must be I4', 
     +    1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C read values of TIMECOV variable (1...min(MAXDISC,MAXFIG))
C-----------------------------------------------------------------------
        timcov(3)=min(MAXDISC,MAXFIG)
c        write(*,9004) timcov(3)
9004    format(1x,'the largest DISCRETE time value considered as ',
     +    'valid will be: ',I6)
        do 20 k=1,timcov(3)
          timc(k)=k
20    continue
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9011)
9011    format(1x,'Error in DISCRETE statement'/
     +  1x,'No arguments admitted'/
     +  1x,'Check parameter file')
          stop
        endif
c      write(6,*) varnam(nvar),vartyp(nvar)
c      do 30 k=1,nfig(wn-1)
c       write(6,*) timc(k)
c30    continue
        return
        end subroutine discrete

        subroutine convdt
C***********************************************************************
C processes convdt statement                                           *
C***********************************************************************
c with the convdt statement the difference between two date variables  *
c is calculated and written onto a new time  variable                  *
c the convdt statement has the following form:                         *
c                                                                      *
c convdt name=name-name name=name-name .....;                          *
c                                                                      *
c the name to the left of the = sign must be a new name, the names     *
c to both sides of the - sign must be dates of the same type (D6 or D8)*
c this will be used for covariates but not for the dependent variable, *
c which is processed in the TIME statement.                            *
C***********************************************************************
c
        INTEGER I,J,L
        CHARACTER*8 w8
c
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
c
C-----------------------------------------------------------------------
C read name of converted variable
C-----------------------------------------------------------------------
        wn=wn+1
10    continue
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
C check if name in list of variables, if yes ==>error
C-----------------------------------------------------------------------
        do 20 l=1,nvar
          if (w8.eq. varnam(l)) then
            write(*,9000) w8
9000      format(1x,'Error in CONVDT statement'/
     +    1x,A8,' already defined. Must be a new variable name'/
     +    1x,'Check parameter file')
            stop
          endif
20    continue
        nvar=nvar+1
        varnam(nvar)=w8
        vartyp(nvar)='I4'
        varcom(nvar,1)=-1
C-----------------------------------------------------------------------
C next word has to be '='
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.'=') then
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
          write(*,9001) w8
9001    format(1x,'Error in CONVDT statement'/
     +  1x,a8,' found when  =  expected'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C read name of 1st date
C-----------------------------------------------------------------------
        wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
C check if word appears in list of input variables
C-----------------------------------------------------------------------
        do 40 l=1,nvread
          if (w8.eq. varnam(l)) goto 30
40    continue
C-----------------------------------------------------------------------
C variable name not in list of input variables ==>error
C-----------------------------------------------------------------------
        write(*,9002) w8
9002  format(1x,'Error in CONVDT statement'/
     +1x,A8,' did not appear in the list of input variables'/
     +1x,'Check parameter file')
        stop
C-----------------------------------------------------------------------
C write variable number onto varcom(nvar,2)
C-----------------------------------------------------------------------
30    continue
        varcom(nvar,2)=l
C----------------------------------------------------------------------
C type has to be D6 or D8
C-----------------------------------------------------------------------
        if (vartyp(l).ne.'D6'.and.vartyp(l).ne.'D8') then
          write(*,9003) varnam(l),vartyp(l)
9003    format(1x,'Error in CONVDT statement'/
     +  1x,'Type of ',A8,' is ',A2/
     +  1x,' Must be one of the following: D6 D8'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C next word has to be '-'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.'-') then
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
          write(*,9004) w8
9004    format(1x,'Error in CONVDT statement'/
     +  1x,a8,' found when  - (minus sign) expected'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C read name of 2nd date
C-----------------------------------------------------------------------
        wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
C check if word appears in list of input variables
C-----------------------------------------------------------------------
        do 60 l=1,nvread
          if (w8.eq. varnam(l)) goto 50
60    continue
C-----------------------------------------------------------------------
C variable name not in list of input variables ==>error
C-----------------------------------------------------------------------
        write(*,9005) w8
9005  format(1x,'Error in CONVDT statement'/
     +1x,A8,' did not appear in the list of input variables'/
     +1x,'Check parameter file')
        stop
C-----------------------------------------------------------------------
C write variable number onto varcom(nvar,3)
C-----------------------------------------------------------------------
50    continue
        varcom(nvar,3)=l
C----------------------------------------------------------------------
C type has to be identical to type of 1st date
C-----------------------------------------------------------------------
        if (vartyp(l).ne.vartyp(varcom(nvar,2))) then
          write(*,9006) varnam(varcom(nvar,2)),vartyp(varcom(nvar,2)),
     +  varnam(l),vartyp(l)
9006    format(1x,'Error in CONVDT statement'/
     +  1x,'Variable ',A8,' has type ',A2/
     +  1x,'Variable ',A8,' has type ',A2/
     +  1x,'Types have to be identical'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C if next word is ';' ==> return
C otherwise process another conversion
C-----------------------------------------------------------------------
c      write(6,*) varnam(nvar),varnam(varcom(nvar,2)),
c     +           varnam(varcom(nvar,3))
        wn=wn+1
        if(word(1,wn).eq.';') then
          return
        else
          goto 10
        endif
        end subroutine convdt

        subroutine class
C***********************************************************************
C processes class statement                                            *
C***********************************************************************
c in the class statement, class variables are defined                  *
c it has the following form:                                           *
c                                                                      *
c class name name name .....;                                          *
c                                                                      *
c the names must be names of variables defined previously, of type I4. *
C***********************************************************************
c
        INTEGER I,J,L
        CHARACTER*8 w8
c
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
c
C-----------------------------------------------------------------------
C read name of variable
C-----------------------------------------------------------------------
10    continue
        wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
        call chkkeyw(w8)
C-----------------------------------------------------------------------
C if word is ';' ==>return
C-----------------------------------------------------------------------
        if (word(1,wn).eq.';') then
          return
        endif
C----------------------------------------------------------------------
C check if word appears in list of variables
C-----------------------------------------------------------------------
        do 40 l=1,nvar
          if (w8.eq. varnam(l)) goto 30
40    continue
C-----------------------------------------------------------------------
C variable name not in list of input variables ==>error
C-----------------------------------------------------------------------
        write(*,9001) w8
9001  format(1x,'Error in CLASS statement'/
     +1x,A8,' did not appear in the list of variables'/
     +1x,'Check parameter file')
        stop
C-----------------------------------------------------------------------
C set class indicator varcc(l) to 1
C-----------------------------------------------------------------------
30    continue
        varcc(l)=1
C-----------------------------------------------------------------------
C type has to be I4
C-----------------------------------------------------------------------
        if (vartyp(l).ne.'I4') then
          write(*,9002) varnam(l),vartyp(l)
9002    format(1x,'Error in CLASS statement'/
     +  1x,'Type of ',A8,' is ',A2/
     +  1x,'Must be I4'/
     +  1x,'Check parameter file')
          stop
        endif
c      write(6,*) l,varnam(l),vartyp(l),varcc(l)
        goto 10
        end subroutine class

        subroutine timedep
C***********************************************************************
C processes timedep statement                                          *
C***********************************************************************
c time dependent covariates are defined with this statement            *
c it has the following form:                                           *
c                                                                      *
c timedep name typediff name typediff .....;                           *
c                                                                      *
c the names must be names of variables defined in the input list.      *
c changes in those variables with time are given at the end of each    *
c record.                                                              *
C these are stated in the following way:                               *
c a) (consecutive) number of the time dependent covariate              *
c b) date or time of change in covariate value                         *
c c) new covariate value                                               *
c the typediff relates to the way the difference between beginning of  *
c the observation and the actual change of the covariate is given.     *
c if it is I4, it is given as time, if it is D6 or D8, it is calculated*
c internally as the difference between the date given in b) and the    *
c date describing the beginning of the observation in the              *
c TIME statement. if this case, both dates must be of the same type.   *
C***********************************************************************
c
        INTEGER I,J,L
        CHARACTER*8 w8
        character*2 w2
c
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
c
C-----------------------------------------------------------------------
C read name of converted variable
C-----------------------------------------------------------------------
        wn=wn+1
10    continue
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
        call chkkeyw(w8)
C-----------------------------------------------------------------------
C if word is ';' ==>return
C-----------------------------------------------------------------------
        if (word(1,wn).eq.';') then
          return
        endif
C-----------------------------------------------------------------------
C check if word appears in list of input variables
C-----------------------------------------------------------------------
        do 40 l=1,nvread
          if (w8.eq. varnam(l)) goto 30
40    continue
C-----------------------------------------------------------------------
C variable name not in list of input variables ==>error
C-----------------------------------------------------------------------
        write(*,9001) w8
9001  format(1x,'Error in CLASS statement'/
     +1x,A8,' did not appear in the list of variables'/
     +1x,'Check parameter file')
        stop
C-----------------------------------------------------------------------
C set  timedep indicator vartim(l,1) to 1
C-----------------------------------------------------------------------
30    continue
        vartim(l,1)=1
C----------------------------------------------------------------------
C type has to be I4 or R4
C-----------------------------------------------------------------------
        if (vartyp(l).ne.'I4'.and.vartyp(l).ne.'R4') then
          write(*,9002) varnam(l),vartyp(l)
9002    format(1x,'Error in TIMEDEP statement'/
     +  1x,'Type of ',A8,' is ',A2/
     +  1x,'This must be I4 or R4'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C read type of variable defining the difference betwen the beginning of
c the observation and the point in time when the covariate canges
C-----------------------------------------------------------------------
        wn=wn+1
        W2=WORD(1,wn)//WORD(2,wn)
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
C type has to be I4, D6 or D8
C-----------------------------------------------------------------------
        if (w2.ne.'I4'.and.w2.ne.'D6'.and.w2.ne.'D8') then
          write(*,9003) varnam(l),w8
9003    format(1x,'Error in TIMEDEP statement'/
     +  1x,'Type of difference for variable ',A8,' given as ',A8/
     +  1x,' Must be one of the following: I4 D6 D8'/
     +  1x,'Check parameter file')
          stop
        endif
        if (w2.eq.'I4') then
          vartim(l,2)=1
        elseif (w2.eq.'D6'.or.w2.eq.'D8') then
C-----------------------------------------------------------------------
C if type is D6 or D8, variable 2 in TIME statement must be defined
C-----------------------------------------------------------------------
          if (timev(2).eq.0) then
            write(*,9004) varnam(l),w2
9004      format(1x,'Error in TIMEDEP statement'/
     +    1x,'If type of difference for TIMEDEP ',
     +       'variable ',A8,' is ',A2,','/
     +    1x,'the TIME statement must include'/
     +    1x,'a variable indicating the beginning',
     +       ' of an observation'/
     +    1x,'Check parameter file')
            stop
          endif
C-----------------------------------------------------------------------
C if type is D6 or D8, it must be identical to type of variable 2
C in TIME statement
C-----------------------------------------------------------------------
          if (vartyp(timev(2)).ne.w2) then
            write(*,9005) varnam(l),vartyp(l),
     +    varnam(timev(2)),vartyp(timev(2))
9005      format(1x,'Error in TIMEDEP statement'/
     +    1x,'Difference for TIMEDEP variable ',A8,' has type ',A2/
     +    1x,'2nd variable in TIME statement ',A8,' has type ',A2/
     +    1x,'Types have to be identical'/
     +    1x,'Check parameter file')
          stop
          endif
          vartim(l,2)=2
        endif
C-----------------------------------------------------------------------
C if next word is ';' ==> return
C otherwise process another TIMEDEP variable
C-----------------------------------------------------------------------
c      write(6,*) varnam(l),vartim(l,1),vartim(l,2)
        wn=wn+1
        if(word(1,wn).eq.';') then
          return
        else
          goto 10
        endif
        end subroutine timedep

        subroutine combine
C***********************************************************************
C processes combine statement                                          *
C***********************************************************************
c with the convdt statement, two or tree class variables may be        *
c to produce an 'interaction effect'.                                  *
c the combine statement has the following form:                        *
c                                                                      *
c convdt name=name+name name=name+name+name .....;                     *
c                                                                      *
c the name to the left of the = sign must be a new name, the names     *
c to both sides of the + sign must be class variables already defined  *
C***********************************************************************
c
        INTEGER I,J,K,L,n
        CHARACTER*8 w8
c
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
c
C-----------------------------------------------------------------------
C read name of combined variable
C-----------------------------------------------------------------------
        wn=wn+1
10    continue
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
        call chkkeyw(w8)
C----------------------------------------------------------------------
C check if name in list of variables, if yes ==>error
C-----------------------------------------------------------------------
        do 20 l=1,nvar
          if (w8.eq. varnam(l)) then
            write(*,9000) w8
9000      format(1x,'Error in COMBINE statement'/
     +    1x,A8,' already defined. Must be a new variable name'/
     +    1x,'Check parameter file')
            stop
          endif
20    continue
        nvar=nvar+1
        varnam(nvar)=w8
        vartyp(nvar)='I4'
      varcc(nvar)=1
        varcom(nvar,1)=0
      n=0
C-----------------------------------------------------------------------
C next word has to be '='
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.'=') then
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
          write(*,9001) w8
9001    format(1x,'Error in CONVDT statement'/
     +  1x,a8,' found when  =  expected'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C read names of variables to be combined
C-----------------------------------------------------------------------
70    wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if word appears in list of variables
C-----------------------------------------------------------------------
        do 40 l=1,nvar-1
          if (w8.eq. varnam(l)) goto 30
40    continue
C-----------------------------------------------------------------------
C variable name not in list of variables ==>error
C-----------------------------------------------------------------------
        write(*,9002) w8
9002  format(1x,'Error in COMBINE statement'/
     +1x,A8,' did not appear in the list of input variables'/
     +1x,'Check parameter file')
        stop
C-----------------------------------------------------------------------
C write variable number onto varcom(nvar,2)
C-----------------------------------------------------------------------
30    continue
      n=n+1
      varcom(nvar,1)=n
        varcom(nvar,n+1)=l
C----------------------------------------------------------------------
C variables to be combined have to be class variables
C-----------------------------------------------------------------------
        if (varcc(l).ne.1) then
          write(*,9003) varnam(l)
9003    format(1x,'Error in COMBINE statement'/
     +  1x,'Variable ',A8,' is not a class variable'/
     +  1x,'Only variables defined in the CLASS or TIMECOV statements',
     +     ' are allowed'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C next word has to be '+' or ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).eq.'+') then
        if(varcom(nvar,1).ge.3) then
          write(*,9004) varnam(nvar)
9004      format(1x,'Error in COMBINE statement, variable ',A8/
     +    1x,'No more than three variables may be combined'/
     +    1x,'Check parameter file')
            stop
        endif
        goto 70
      elseif(word(1,wn).eq.';') then
        if(varcom(nvar,1).le.1) then
          write(*,9005) varnam(nvar)
9005      format(1x,'Error in COMBINE statement, variable ',A8/
     +    1x,'At least two variables have to be combined'/
     +    1x,'Check parameter file')
            stop
        endif
        do 90 k=2,varcom(nvar,1)+1
          if (vartim(varcom(nvar,k),1).eq.1.or.
     *        timcov(1).eq.varcom(nvar,k)) then
            vartim(nvar,1)=1
            vartim(nvar,2)=3
          endif
90      continue
        return
      else
C-----------------------------------------------------------------------
C before processing a new combined variable, check if really two
C or three variables are included and determine if the combined variable
C is time dependent
C-----------------------------------------------------------------------
        if(varcom(nvar,1).le.1) then
          write(*,9005) varnam(nvar)
        endif
        do 80 k=2,varcom(nvar,1)+1
          if (vartim(varcom(nvar,k),1).eq.1.or.
     *        timcov(1).eq.varcom(nvar,k)) then
            vartim(nvar,1)=1
            vartim(nvar,2)=3
          endif
80      continue
        goto 10
        endif
        end subroutine combine

        subroutine output
C***********************************************************************
C processes output statement                                           *
C***********************************************************************
c in the class statement, those variables are defined which will be    *
c written onto the output file (this file will then be used for the    *
c analysis with the COX program                                        *
c it has the following form:                                           *
c                                                                      *
c output name name name .....;                                         *
c                                                                      *
c the names must be names of variables defined previously, of type I4  *
c or R4. No date variables may be included into the output file!       *
C***********************************************************************
c
        INTEGER I,J,K,L,M
        integer j1,j2,imess,ind_disc
        integer ifile
        CHARACTER*8 w8
c
c
C-----------------------------------------------------------------------
C open file giving information about the output variables
C-----------------------------------------------------------------------
c open(10,file=file(4),form='formatted',status='unknown')
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
        ir1=0
        ir2=0
        infp(1)=0
        infp(2)=0
        if (infp(3).ne.-1) infp(3)=0 
        ntimdepr=0
        ntimdep=0
        ntcmb=0
        j=0
        do i=1,nvar
           if (varnam(i).eq.'tim_unit') then
              j=i
              exit
           endif
        enddo
        if (j>0.and.j.ne.nvar) then
        print*,' DISCRETE_SCALE should appear as the last statement ',
     +      'before the UTPUT statement'
           stop
        endif
        if (varnam(nvar).eq.'tim_unit') then
          ind_disc=1
        else
          ind_disc=0
        endif  
C-----------------------------------------------------------------------
C read name of variable
C-----------------------------------------------------------------------
10    continue
        if (ind_disc.eq.0) then
          wn=wn+1
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +    //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
        else
          W8='tim_unit'
          ind_disc=0
        endif
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
        call chkkeyw(w8)
C-----------------------------------------------------------------------
C if word is ';' ==> goto 100
C-----------------------------------------------------------------------
        if (word(1,wn).eq.';') goto 100
C----------------------------------------------------------------------
C check if word appears in list of variables
C-----------------------------------------------------------------------
        do 40 l=1,nvar
          if (w8.eq. varnam(l)) goto 30
40    continue
C-----------------------------------------------------------------------
C variable name not in list of variables ==>error
C-----------------------------------------------------------------------
        write(*,9007) w8
9007  format(1x,'Error in OUTPUT statement'/
     +1x,A8,' did not appear in the list of variables'/
     +1x,'Check parameter file')
        stop
30    continue
C-----------------------------------------------------------------------
C type has to be I4 or R4
C-----------------------------------------------------------------------
        if (vartyp(l).ne.'I4'.and.vartyp(l).ne.'R4') then
          write(*,9008) varnam(l),vartyp(l)
9008    format(1x,'Error in OUTPUT statement'/
     +  1x,'Type of ',A8,' is ',A2/
     +  1x,'Must be I4 or R4'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C if this is the time variable, store in infp(1)
C-----------------------------------------------------------------------
        if (l.eq.timev(1)) then
          infp(1)=l
C-----------------------------------------------------------------------
C if this is the censoring variable, store in infp(2)
C-----------------------------------------------------------------------
        elseif (l.eq.censv(1)) then
          infp(2)=l
C-----------------------------------------------------------------------
C if this is the idrec variable, store in infp(3)
C-----------------------------------------------------------------------
        elseif (l.eq.idrev) then
          infp(3)=l
C----- if it is also a class variable, store in ir2p(ir2)
          if (varcc(l).eq.1) then
            ir2=ir2+1
            ir2p(ir2)=l
            pir(l)=ir2
          endif
C-----------------------------------------------------------------------
C if this is a class variable, store in ir2p(ir2)
C-----------------------------------------------------------------------
        elseif (varcc(l).eq.1) then
          ir2=ir2+1
          ir2p(ir2)=l
          pir(l)=ir2
C-----------------------------------------------------------------------
C ...if this is a combined variable, store position in vector tcmb
C-----------------------------------------------------------------------
        if (varcom(l,1).gt.1) then
          ntcmb=ntcmb+1
          tcmb(ntcmb)=l
        endif
C-----------------------------------------------------------------------
C ...if this is a time dependent variable, spare an extra position
C-----------------------------------------------------------------------
          if (vartim(l,1).eq.1.or.l.eq.timcov(1)) then
            ir2=ir2+1
            ntimdep=ntimdep+1
            tco(ntimdep)=l
            if (l.le.nvread) ntimdepr=ntimdepr+1
          endif
C-----------------------------------------------------------------------
C if this is a continuous variable, store in ir1p(ir1)
C-----------------------------------------------------------------------
        elseif (varcc(l).ne.1) then
          ir1=ir1+1
          ir1p(ir1)=l
          pir(l)=ir1
C-----------------------------------------------------------------------
C ...if this is a time dependent variable, spare an extra position
C-----------------------------------------------------------------------
          if (vartim(l,1).ne.0) then
            ir1=ir1+1
            ntimdep=ntimdep+1
            tco(ntimdep)=l
            if(l.le.nvread) ntimdepr=ntimdepr+1
          endif
        endif
c      write(6,*) l,varnam(l),vartyp(l)
        goto 10
100   continue
C-----------------------------------------------------------------------
C perform checks, write output paramater file, return
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C ...time and censoring variables must have been defined
C-----------------------------------------------------------------------
        if(infp(1).eq.0) then
          write(*,9001) varnam(timev(1))
9001    format(1x,'Error in OUTPUT statement'/
     +  1x,'Time variable ',A8,' must be in list of output variables'/
     +  1x,'Check parameter file')
          stop
        endif
        if(infp(2).eq.0) then
          write(*,9002) varnam(censv(1))
9002    format(1x,'Error in OUTPUT statement'/
     +  1x,'Censoring variable ',A8,
     +     ' must be in list of output variables'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C ... for combind time-dependent variables the original variables have
C     also to be included in the output file  (technical problem)
C-----------------------------------------------------------------------
        if (ntcmb.gt.0) then
          imess=0
          do j1=1,ntcmb
            l=tcmb(j1)
            if(vartim(l,1).ne.0) then
              do j2=2,varcom(l,1)+1
                do k=1,ir2
                  if(ir2p(k).eq.varcom(l,j2)) goto 50
                enddo
                write(*,9003) varnam(l),varnam(varcom(l,j2))
9003  format(1x,'Error in OUTPUT statement'/
     +       1x,'Time-dependent combined variable ',a8,/
     +       1x,'Original variable ',a8,' has also to be included'/
     +       1x,'in the OUTPUT statement (for technical reasons)')
                imess=1
50              continue
              enddo
            endif
          enddo
          if(imess.eq.1) stop
        endif
C-----------------------------------------------------------------------
C ... total no. of variables must not exceed mxef
C-----------------------------------------------------------------------
        if (ir2+ir1+3.gt.mxef) then
          write(*,9004) mxef,ir2+ir1+3
9004      format(1x,'Error in NEFMAX statement'/
     +    1x,'Parameter NEFMAX:',i4,' too small'/
     +    1x,'Increase to     :',i4/
     +    1x,'Check parameter file')
          stop
        endif
        return

        end subroutine output

        subroutine formout
C***********************************************************************
C processes formout statement                                          *
C***********************************************************************
c in theoutform statement, the format of the recoded output file is    *
c defined (this is filename2 of the files and future statements        *
c it has one of the following forms:                                   *
c                                                                      *
c formout free;                                                        *
c formout fixed In Fn.d;                                               *
c formout unformatted;                                                 *
c formout blocked_unformatted;                                         *
c formout compressed;                                                  *
c                                                                      *
c free format is the default. fixed format is defined together with    *
c the size of integer and real variables in the usual fortran form     *
c unformatted is saving time and (some)  space when writing.           *
c blocked_unformatted saves more time but may not be used when data    *
c have to be sorted after prepare. compressed is saving much space     *
c because it produces a zipped file. may also not be used when sorting *
c is required.                                                         *
C***********************************************************************
c
        INTEGER I,J
        CHARACTER*8 w8,formtyp(10)
        integer ifile
c
c
        data formtyp/'free_for','FREE_FOR','fixed_fo','FIXED_FO',
     *'unformat','UNFORMAT','blocked_','BLOCKED_','compress','COMPRESS'/
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
c
C-----------------------------------------------------------------------
C read format
C-----------------------------------------------------------------------
10    continue
        wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
        call chkkeyw(w8)
C-----------------------------------------------------------------------
C if word is ';' ==>return
C-----------------------------------------------------------------------
        if (word(1,wn).eq.';') then
          return
        endif
C----------------------------------------------------------------------
C if format is free, set fout to 1
C-----------------------------------------------------------------------
        if (w8.eq.formtyp(1).or.w8.eq.formtyp(2)) then
          fout=1
C----------------------------------------------------------------------
C if format is fixed, set fout to 2 and check for format
C-----------------------------------------------------------------------
        elseif (w8.eq.formtyp(3).or.w8.eq.formtyp(4)) then
          fout=2
c---- read two formats types (integer and real)
          wn=wn+1
          fmi=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)
C check if new keyword appears before end of statement
          call chkkeyw(w8)
C if word is ';' ==> write error statement
          if (word(1,wn).eq.';') then
            write(*,9002)
9002      format(1x,'Error in FORMOUT statement'/
     +    1x,'after FIXED_FORMAT, two format types are expexted'/
     +    1x,'Check parameter file')
            stop
          endif
          wn=wn+1
          fmr=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)
C check if new keyword appears before end of statement
          call chkkeyw(w8)
C if word is ';' ==> write error statement
          if (word(1,wn).eq.';') then
            write(*,9002)
            stop
          endif
C----------------------------------------------------------------------
C if format is unformatted, set fout to 3
C-----------------------------------------------------------------------
        elseif (w8.eq.formtyp(5).or.w8.eq.formtyp(6)) then
c**********************************************************************
c for compatibility reasons with current version of Weibull (02.March.2009)
c         write(*,*)'This version does not allow the use of keywords'
c         write(*,*)'UNFORMATTED, BLOCKED_UNFORMATTED and COMPRESSED'
c         write(*,*)'in the FORMOUT statement.'
c         write(*,*)'Please use FREE_FORMAT or FIXED_FORMAT instead.'
c         stop
c**********************************************************************
          fout=3
C----------------------------------------------------------------------
C if format is blocked_unformatted, set fout to 4
C-----------------------------------------------------------------------
        elseif (w8.eq.formtyp(7).or.w8.eq.formtyp(8)) then
c**********************************************************************
c for compatibility reasons with current version of Weibull (02.March.2009)
c         write(*,*)'This version does not allow the use of keywords'
c         write(*,*)'UNFORMATTED, BLOCKED_UNFORMATTED and COMPRESSED'
c         write(*,*)'in the FORMOUT statement.'
c         write(*,*)'Please use FREE_FORMAT or FIXED_FORMAT instead.'
c         stop
c**********************************************************************
          fout=4
C----------------------------------------------------------------------
C if format is compressed, set fout to 5
C-----------------------------------------------------------------------
        elseif (w8.eq.formtyp(9).or.w8.eq.formtyp(10)) then
c**********************************************************************
c for compatibility reasons with current version of Weibull (02.March.2009)
c         write(*,*)'This version does not allow the use of keywords'
c         write(*,*)'UNFORMATTED, BLOCKED_UNFORMATTED and COMPRESSED'
c         write(*,*)'in the FORMOUT statement.'
c         write(*,*)'Please use FREE_FORMAT or FIXED_FORMAT instead.'
c         stop
c**********************************************************************
          fout=5
C-----------------------------------------------------------------------
C if fromat is not of the preceding --> error
C-----------------------------------------------------------------------
        else
          write(*,9001) w8
9001    format(1x,'Error in FORMOUT statement'/
     +  1x,A8,' is not a valid argument to the statement'/
     +  1x,'Must be one of the following:'/
     +  1x,'FREE_FORMAT'/
     +  1x,'FIXED_FORMAT'/
!     +  1x,'UNFORMATTED'/
!     +  1x,'BLOCKED_UNFORMATTED'/
!     +  1x,'COMPRESSED'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9011)
9011    format(1x,'Error in FORMOUT statement'/
     +  1x,'Only 1 character argument (+values) admissible'/
     +  1x,'Check parameter file')
          stop
        endif
        return
        end subroutine formout

        subroutine joincode
C***********************************************************************
C processes joincode statement                                         *
C***********************************************************************
c the statement has the following form:                                *
c                                                                      *
c joincode name name;                                                  *
c                                                                      *
c the names must be names of variables defined previously in the class *
c statement.                                                           *
c the effect of the statement is that when recoding the data, one list *
c of codes is used for both variables. this is necessary for           *
c sire - maternal grandsire models where sire and maternal grandsire   *
c are given as different variables in the input statement but identity *
c of codes must be recognised by the analysis program.                 *
C***********************************************************************
c the CORRELATION statement is using the same subroutine with          *
c corr=.TRUE. and has the following form:                                              *
c                                                                      *
c correlation name name;                                               *
c                                                                      *
c the structure of this subroutine largely copies the structure of     *
c JOINCODE. This subroutine prepares the data for the situation when   *
c two correlated random effects with relationship matrices are         *
c included into the model. The CORRELATION subroutine does exactly     *
c the same as JOINCODE, but not writing anything into varlist.txt and  *
c repeating the data block in codelist.txt for both correlated random  *
c effects.                                                             *
C***********************************************************************
c
        INTEGER I,J,k,L
        CHARACTER*8 w8
c
c
c tests if keywords JOINCODE and CORRELATION are used in the same run
      if (joinCor) then
         write(*,9101)
9101    format(1x,'JOINCODE and CORRELATION keywords should not be '/
     +  1x,'used in the same run'/
     +  1x,'Check parameter file')
         stop
      endif
c turns on the error flag just after the check
      joinCor=.TRUE.
c
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
c
C-----------------------------------------------------------------------
C read 2 names of variable
C-----------------------------------------------------------------------
      do k=1,2
        wn=wn+1
        W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +//WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
        call chkkeyw(w8)
C-----------------------------------------------------------------------
C check if ';' appears to early
C-----------------------------------------------------------------------
        if (word(1,wn).eq.';') then
          write(*,9003)
          stop
        endif
C----------------------------------------------------------------------
C check if word appears in list of variables
C-----------------------------------------------------------------------
        do 40 l=1,nvar
          if (w8.eq. varnam(l)) goto 30
40    continue
C-----------------------------------------------------------------------
C variable name not in list of input variables ==>error
C-----------------------------------------------------------------------
        write(*,9001) w8
9001  format(1x,'Error in JOINCODE or CORRELATION statement'/
     +1x,A8,' did not appear in the list of variables'/
     +1x,'Check parameter file')
        stop
C-----------------------------------------------------------------------
C check if word appeared in class statement
C-----------------------------------------------------------------------
30    continue
      if (varcc(l).ne.1) then
          write(*,9002) varnam(l)
9002    format(1x,'Error in JOINCODE or CORRELATION statement'/
     +  1x,'Variable ',A8,' must be included in class statement'/
     +  1x,'Check parameter file')
          stop
        endif
c      write(6,*) l,varnam(l),vartyp(l),varcc(l)
C-----------------------------------------------------------------------
C write position of variable to vector join
c (join is a vector of length two giving the variables whose codes are
c to be joined)
C-----------------------------------------------------------------------
      join(k)=l
c if the CORRELATION was used the variable names are stored
      if (corr) corrName(k)=W8	  
        enddo
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9003)
9003    format(1x,'Error in JOINCODE or CORRELATION statement'/
     +  1x,'exactly two arguments (=variable names) are allowed'/
     +  1x,'or the semicolon is missing'/
     +  1x,'Check parameter file')
          stop
        endif
      return
        end subroutine joincode
		
        subroutine future
C***********************************************************************
C processes future statement                                           *
C***********************************************************************
c in the future statement, you provide information about a set of      *
c records, for which you want a printout on values of the survivor     *
c curve (like quantile values or functional values of the survival     *
c function at given times.                                             *
c it has the following form:                                           *
c                                                                      *
c future filename1 filename2;                                          *
c                                                                      *
c where                                                                *
c filename1 is the name of the original file holding the               *
c           future records(must exist in your directory)              *
c filename2 is the name of the recoded file produced by the program    *
c           (will be used by COX to produce values related to the      *
c           corresponding survival functions)                          *
c Note: the maximum length of a filename is 15 characters              *
c Note: if you have a future statement, you also need to have a idrec  *
c       statement, as elementary records have to be sorted by identity *
c       of original records                                            *
C***********************************************************************
c
        INTEGER I,J,L
        CHARACTER*8 w8
c
c
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
         futurf=1
C-----------------------------------------------------------------------
C check if idrec statement is included in the parameter file
C-----------------------------------------------------------------------
        if(idrev.eq.0) then
          write(*,9006)
9006    format(1x,'Error in FUTURE statement'/
     +  1x,'If this statement is used, the IDREC statement must also'/
     +  1x,'be included in the parameter file'/
     +  1x,'Check parameter file')
          stop
        endif
C-----------------------------------------------------------------------
C process the 2 file names
C-----------------------------------------------------------------------
        do 10 l=5,6
          wn=wn+1
C-----------------------------------------------------------------------
C read name of variable
C-----------------------------------------------------------------------
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
          call chkkeyw(w8)
C-----------------------------------------------------------------------
C if word is ';' ==> write error statement
C-----------------------------------------------------------------------
          if (word(1,wn).eq.';') then
            write(*,9001)
9001      format(1x,'Error in FUTURE statement'/
     +    1x,'2 file names expected'/
     +    1x,'Check parameter file')
            stop
          endif
          file(l)=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +         //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
     +         //WORD(9,wn)//WORD(10,wn)//WORD(11,wn)//WORD(12,wn)
     +         //WORD(13,wn)//WORD(14,wn)//WORD(15,wn)
10    continue
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9004)
9004    format(1x,'Error in FUTURE statement'/
     +  1x,'Only 2 arguments to statement admissible'/
     +  1x,'Check parameter file')
          stop
        endif
        return
        end subroutine future

        subroutine pedigree
C***********************************************************************
C processes pedigree statement                                         *
C***********************************************************************
c In the pedigree statement, you give information about a pedigree     *
c file for including relationships between individuals into the model  *
c it has the following form:                                           *
c                                                                      *
c PEDIGREE Filename1 Filename2 IDname;   (for sire or animal models)   *
c or                                                                   *
c PEDIGREE Filename1 Filename2 IDname1 IDname2;  (for sire/dam models) *  
c                                                                      *
c where                                                                *
c filename1 is the name of the original pedigree file (must exist)     *
c filename2 is the name of the recoded pedigree file produced by the   *
c           program                                                    *
c     Note: the maximum length of a filename is 15 characters          *
c IDname    is the variable name indicating the random variable        *
c           (animal or sire) in the data file (must be stated in INPUT *
c           and OUTPUT)                                                *
c IDname1, IDname2 (for sire/dam models) indicate the names of the     *
c           sire and dam variables in the data file (must be stated in *
c           INPUT and OUTPUT)                                          *
c                                                                      *
c FORM OF THE PEDIGREE FILE:                                           *
c The pedigree file has ALWAYS to consist of four or five columns:     *
c  1 - identity of animal                                              *
c  2 - sex code in sire/dam models (1 = male, 2 = female)              *
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*
c The following feature was added on October 21, 1996                  * 
c      if = -1 (whatever the model):                                   *
c           specifies a group of unknown parents                       *
c      columns 3 or 4 are irrelevant in this case                      *
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*
c      may be used for other purposes in other models                  *
c  3 - identity of sire                                                *
c  4 - identity of dam (or maternal grandsire)                         *
c if ncolped=4 then                                                    * 
c  5 - group of unknown grand dam                                      * 
C***********************************************************************
c
        INTEGER I,J,L
        CHARACTER*8 w8
c
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C process the 2 file names
C-----------------------------------------------------------------------
        do 10 l=7,8
          wn=wn+1
C-----------------------------------------------------------------------
C read name of variable
C-----------------------------------------------------------------------
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C check if new keyword appears before end of statement
C-----------------------------------------------------------------------
          call chkkeyw(w8)
C-----------------------------------------------------------------------
C if word is ';' ==> write error statement
C-----------------------------------------------------------------------
          if (word(1,wn).eq.';') then
            write(*,9001)
9001      format(1x,'Error in PEDIGREE statement'/
     +    1x,'2 file names + 1 or 2 variable names (IDnames) expected'/
     +    1x,'Check parameter file')
            stop
          endif
          file(l)=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +         //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
     +         //WORD(9,wn)//WORD(10,wn)//WORD(11,wn)//WORD(12,wn)
     +         //WORD(13,wn)//WORD(14,wn)//WORD(15,wn)
10    continue
C-----------------------------------------------------------------------
C check for IDname
C-----------------------------------------------------------------------
      do 20 j=1,2
          wn=wn+1
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C-----------------------------------------------------------------------
C ...check if new keyword appears before end of statement
C-----------------------------------------------------------------------
          call chkkeyw(w8)
C-----------------------------------------------------------------------
C ...if word is ';' ==> write error statement or return
C-----------------------------------------------------------------------
        if (word(1,wn).eq.';') then
          if(j.eq.1) then
              write(*,9001)
              stop
          else
            return
          endif
          endif
C-----------------------------------------------------------------------
C ...check if word appears in list of variables read
C-----------------------------------------------------------------------
          do 40 l=1,nvread
            if (w8.eq. varnam(l)) goto 30
40        continue 
          do 41 l=nvread+1,nvar
            if (w8.eq. varnam(l)) goto 31
41        continue
C-----------------------------------------------------------------------
C if WITH_MGD (i.e. with maternal grand dam) is specified, NCOLPED =4
C in all other cases prints an error message
C-----------------------------------------------------------------------
        select case (W8)
        case ('WITH_MGD')
          ncolped = 4
          goto 20
        case default
C-----------------------------------------------------------------------
C variable name not in list of input variables ==>error
C-----------------------------------------------------------------------
          write(*,9003) w8
9003    format(1x,'Error in PEDIGREE statement'/1x,A8,
     +  ' did not appear in the list of input or combine variables'/
     +  1x,'Check parameter file')
          stop
        end select
		  
c-----------------------------------------------------------------------
c store position of variable on idped
c-----------------------------------------------------------------------
31      write(*,9013)  
9013    format(1x,' In pedigree file, the animal and parents IDs will',
     +   ' be read in two parts')       
30      continue
        idped(j)=l
C-----------------------------------------------------------------------
C type has to be I4
C-----------------------------------------------------------------------
          if (vartyp(l).ne.'I4') then
            write(*,9005) varnam(l),vartyp(l)
9005      format(1x,'Error in PEDIGREE statement'/
     +    1x,'Type of ID variable ',A8,' is ',A2/
     +    1x,'Must be I4'/
     +    1x,'Check parameter file')
            stop
          endif
20    continue
C-----------------------------------------------------------------------
C next word has to be ';'
C-----------------------------------------------------------------------
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9004)
9004    format(1x,'Error in PEDIGREE statement'/
     +  1x,'Only 5 arguments to statement admissible'/
     +  1x,'Check parameter file')
          stop
        endif
        return
        end subroutine pedigree

        subroutine prevtim 
C***********************************************************************
C processes store_pr(evious_time) statement                            *
C***********************************************************************
c store_pr(evious_time) indicates that each elementary record will     * 
c include both the beginning and the end of the interval when the time *
c dependent variables remain constant. This is needed when later on in *
c the weibull program, a (log-gamma) random time-dependent covariate is*
c integrated out (and only then). When store_pr(evious_time) is        *
c included, the beginning of each interval is stored in column 3, which*
c implies that store_previous_time and idrec are mutually exclusive    * 
c                                                                      *
c it has the following form:                                           *
c store_pr(evious_time);                                               *
C***********************************************************************
c
      integer, allocatable:: tco(:)

        integer ntimdep,I,J

      allocate( tco(mxef) )
c
C-----------------------------------------------------------------------
C statement found after idrec ==>error
C-----------------------------------------------------------------------
        if (infp(3).ne.0) then
        write(*,9001) 
9001  format(1x,'Error in IDREC/ STORE_PR(EVIOUS_TIME) statements'/
     +1x,' both statements are mutually exclusive',/
     +1x,'Check parameter file')
        stop
        endif
        infp(3)=-1
        wn=wn+1
		
        deallocate( tco )
		
        return
        end subroutine prevtim

        subroutine chkkeyw(w8)
C***********************************************************************
C checks if a word is identical with one of the keywords specified in  *
C a list                                                               *
C***********************************************************************
c
        INTEGER I,J
        CHARACTER*8 w8
C
c
        do 50 kk=1,nkeyfe
          if (w8.eq.keyword(kk)) then
            write(*,9000) keyword(kn),w8
9000      format(1x,'Error in ',A8,' statement'/
     +    1x,'New keyword ',A8,' found before end of statement'/
     +    1x,'Check parameter file')
            stop
          endif
50    continue
        return
        end subroutine chkkeyw 

        subroutine ddat(datev,date,type)
C***********************************************************************
C decomposes single integer DDMMYY (type D6) or DDMMYYYY (type D8)     *
c into a vector datev, with datev(1)=DD, datev(2)=MM, datev(3)= YY(YY) *
C***********************************************************************
c
        integer datev(3),date
c
        character*2 type
c
c
C-----------------------------------------------------------------------
C for type D6
C-----------------------------------------------------------------------
        if (type.eq.'D6') then
          if (date.lt.010100.or.date.gt.311299) then
            write(*,9001) nrecr,date
9001      format(1x,'Error when reading data on line ',I8/
     +    1x,'Value ',i9,' is not compatible with format D6'/
     +    1x,'Check data or parameter file')
            stop
          endif
          datev(1)=date/10000
          datev(2)=(date-datev(1)*10000)/100
          datev(3)=date-datev(1)*10000-datev(2)*100
          if (datev(3).lt.nbug_2000) datev(3)=datev(3)+100
C-----------------------------------------------------------------------
C for type D8
C-----------------------------------------------------------------------
        else
          if (date.lt.01010000.or.date.gt.31129999) then
            write(*,9002) nrecr,date
9002      format(1x,'Error when reading data on line ',I8/
     +    1x,'Value ',i9,' is not compatible with format D8'/
     +    1x,'Check data or parameter file')
            stop
          endif
          datev(1)=date/1000000
          datev(2)=(date-datev(1)*1000000)/10000
          datev(3)=date-datev(1)*1000000-datev(2)*10000
        endif
          if (datev(1).gt.31) then
            write(*,9003) nrecr,date
9003      format(1x,'Error when reading data on line ',I8/
     +    1x,'Value ',i9,' is not o.k.'/
     +    1x,'Code for days must be <= 31'/
     +    1x,'Check data or parameter file')
            stop
          endif
          if (datev(2).gt.12) then
            write(*,9004) nrecr,date
9004      format(1x,'Error when reading data on line ',I8/
     +    1x,'Value ',i9,' is not o.k.'/
     +    1x,'Code for months must be <= 12'/
     +    1x,'Check data or parameter file')
            stop
          endif
        return
        end subroutine ddat

      SUBROUTINE READPARM(NWORD1,TITLE1,WORD1,NFIG1,LFIG1,IFIG1)
C***********************************************************************
C  READPARM      *                                    *  04 / 05 /1993 *
C***********************************************************************
C  READS A PARAMETER FILE IN UNIT 15                                   *
C  STORE A TITLE (LINE STARTING WITH KEYWORD TITLE)                    * 
C  DOES NOT STORE COMMENTS (STARTING WITH /* AND FINISHING WITH */)    *
C  STORES THE (NWORD) WORDS IN VECTOR 'WORD'                           *
C  NFIG(I) IS THE NUMBER OF FIGURES FOLLOWING THE ITH WORD             *
C  THESE FIGURES ARE STORED IN VECTOR IFIG(K) STARTING AT LFIG(I)      *
C***********************************************************************
c
        INTEGER NSPEC
        PARAMETER(NSPEC=6)
C                                                                       
      INTEGER NWORD1,IUNIT,I,N,L,J,K,NF,NTOT,ILENG
      INTEGER NFIG1(0:MAXWORD),LFIG1(0:MAXWORD),IFIG1(MAXFIG)
      REAL*4 XFIG(MAXFIG),U,XPOW              
      CHARACTER W(LRECL),Z(LRECL),WORD1(MAXLENG,0:MAXWORD)               
      CHARACTER TITLE1(70),SPECHAR(NSPEC),WSP,UPC(26),DOT                    
      CHARACTER*5 X    
      CHARACTER*8 CHEKKW                                                 
      LOGICAL NUMB,COMMENT,SPC,NEGSIGN,DECIMAL,TRUEKW 

C                                                                       
      DATA (SPECHAR(I),I=1,NSPEC)/';','+','-','=','(',')'/              
      DATA (UPC(I),I=1,26)/'A','B','C','D','E','F','G','H','I','J',     
     + 'K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/ 
C                      
C
      IF (SUPPLY_INPUT0) THEN
        print *,'name of parameter file ?' 
        read(*,'(A100)') parm1
      ELSE 
        print *,'parameter file  ',trim(PARM1),
     +      ' ( = default)'
      ENDIF 
      IUNIT=15                                                 
      OPEN(15,FILE=PARM1,FORM='FORMATTED',status='old')
      NWORD1=0                                                           
      NF=0                                                              
      NTOT=0 
      DOT='.'                                                           
      COMMENT = .FALSE.                                                 
      SPC = .FALSE.                                                     
      NEGSIGN = .FALSE.
      DECIMAL = .FALSE. 
C                                                                       
C-----------------------------------------------------------------------
C   READS A LINE                                                        
C-----------------------------------------------------------------------
  10  READ(IUNIT,'(500a1)',end=100) (W(K),K=1,LRECL)                     
      ILENG=0                                                           
      NUMB=.TRUE.                                                       
      DO 20 J=1,LRECL                                                   
C-----------------------------------------------------------------------
C   BEGINNING OF A COMMENT                                              
C-----------------------------------------------------------------------
       IF (J.LT.LRECL) THEN                                             
       IF ((W(J).EQ.'/').AND.(W(J+1).EQ.'*')) COMMENT=.TRUE.            
       ENDIF                                                            
C-----------------------------------------------------------------------
C   END OF A COMMENT                                                    
C-----------------------------------------------------------------------
       IF (J.GT.1) THEN                                                 
       IF ((W(J-1).EQ.'*').AND.(W(J).EQ.'/')) THEN                      
             COMMENT = .FALSE.                                          
             GOTO 20                                                    
       ENDIF                                                            
       ENDIF                                                            
C-----------------------------------------------------------------------
C   WHEN THIS IS NOT A COMMENT                                          
C-----------------------------------------------------------------------
       IF (.NOT.COMMENT) THEN                                           
C-----------------------------------------------------------------------
C   CHECK FOR SPECIAL CHARACTERS                                        
C-----------------------------------------------------------------------
       DO 21 K=1,NSPEC                                                  
       IF (W(J).EQ.SPECHAR(K)) THEN                                     
             WSP=W(J)                                                   
             W(J)=' '                                                   
             SPC=.TRUE.                                                 
       ENDIF                                                            
  21    CONTINUE                                                        
       IF (W(J).NE.' ') THEN                                            
       ILENG=ILENG+1                                                    
C-----------------------------------------------------------------------
C   TOO LONG A WORD ==> STOP                                            
C-----------------------------------------------------------------------
       IF (ILENG.GT.MAXLENG) THEN                                       
            WRITE(6,9900) IUNIT,MAXLENG,(W(K),K=1,MAXLENG)              
            STOP                                                        
       ENDIF                                                            
       Z(ILENG)=W(J)                                                    
C-----------------------------------------------------------------------
C   IF UPPER_CASE =  .TRUE. TRANSFORM LOWER CASE TO UPPER CASE                 
C-----------------------------------------------------------------------
       IF (UPPER_CASE) THEN
         K = INDEX('abcdefghijklmnopqrstuvwxyz',Z(ILENG))                 
         IF (K.GE.1.AND.K.LE.26) Z(ILENG) = UPC(K)                        
       ENDIF
C-----------------------------------------------------------------------
C   THIS IS NOT A NUMBER                                                
C-----------------------------------------------------------------------
       IF (INDEX('0123456789.',W(J)).EQ.0) NUMB=.FALSE.                  
       ELSE IF (ILENG.GT.0) THEN                                        
C-----------------------------------------------------------------------
C   TOO MANY NUMBERS ==> STOP                                           
C        ELSE TRANSFORM BACK FROM CHARACTERS TO NUMBER AND STORE        
C-----------------------------------------------------------------------
       IF (NUMB) THEN                                                   
          NF=NF+1                                                    
          NTOT=NTOT+1                                                
          IF (NTOT.GT.MAXFIG) THEN                                   
            WRITE(6,9910) IUNIT,MAXFIG                                 
            STOP                                                       
          ENDIF 
          U=0.                                                       
          XPOW=1.                                                     
          DO 25 K=ILENG,1,-1   
             IF (Z(K).EQ.DOT) THEN
               IF (DECIMAL) THEN
                 WRITE(6,9915)
                 STOP
               ELSE
                 DECIMAL=.TRUE. 
                 U = U / XPOW
                 XPOW = 1.
               ENDIF  
             ELSE  
               U = U + XPOW * (INDEX('0123456789',Z(K))-1)                
               XPOW = 10. * XPOW 
             ENDIF                                          
   25     CONTINUE    
          IF (DECIMAL) THEN 
             IF (NEGSIGN) THEN
               XFIG(NTOT) = -1. * U
               NEGSIGN=.FALSE.
             ELSE
               XFIG(NTOT) = U
             ENDIF
             DECIMAL = .FALSE.
          ELSE
             N = NINT(U)                                              
             IF (NEGSIGN) THEN                                          
               IFIG1(NTOT) = -1*N                                          
               NEGSIGN=.FALSE.                                            
             ELSE                                                       
               IFIG1(NTOT)=N                                               
             ENDIF
          ENDIF                                                      
          NFIG1(NWORD1)=NF                                             
          IF (NF.EQ.1) LFIG1(NWORD1)=NTOT   
       ELSE                                                             
C-----------------------------------------------------------------------
C   CHECK FOR KEYWORD = 'TITLE' , IF IT IS THE TITLE, STORE             
C-----------------------------------------------------------------------
          X = Z(1)//Z(2)//Z(3)//Z(4)//Z(5)                           
          IF (X.EQ.'TITLE'.OR.X.EQ.'title') THEN                                
           DO 28 K=1,69                                               
             L = K + J                                                  
             IF (W(L).EQ.';') W(L)=' '                                  
             IF (L.LT.LRECL) TITLE1(K) = W(L)                            
   28      CONTINUE                                                 
           ILENG = 0                                                  
           GOTO 10                                                    
          ENDIF                                                      
          IF (WORD1(1,NWORD1).NE.' ') NWORD1 = NWORD1 + 1                
C-----------------------------------------------------------------------
C   TOO MANY WORDS ==> STOP                                             
C-----------------------------------------------------------------------
          IF (NWORD1.GT.MAXWORD) THEN                                 
             WRITE(6,9920) IUNIT,MAXWORD                                
             STOP                                                       
          ENDIF                                                      
          NF = 0                                                     
C-----------------------------------------------------------------------
C   STORE                                                               
C-----------------------------------------------------------------------
          DO 30 K=1,ILENG                                            
            WORD1(K,NWORD1) = Z(K)                                       
   30     CONTINUE                                                   
          DO 31 K=ILENG+1,MAXLENG                                    
            WORD1(K,NWORD1) = ' '                                        
   31     CONTINUE                                                   
          NFIG1(NWORD1)=NF                                             
       ENDIF                                                            
       ILENG=0                                                          
       NUMB=.TRUE.                                                      
       IF (SPC) THEN                                                    
            IF (WORD1(1,NWORD1).NE.' ') NWORD1 = NWORD1 + 1                 
            WORD1(1,NWORD1) = WSP                                         
            DO 32 K=2,MAXLENG                                           
             WORD1(K,NWORD1)= ' '                                         
   32       CONTINUE                                                    
            SPC=.FALSE.                                                 
       ENDIF                                                            
C-----------------------------------------------------------------------
C   IF SPECIAL CHARACTER UNLESS IT IS A NEGATIVE SIGN OF A NUMBER       
C-----------------------------------------------------------------------
       ELSE IF (SPC) THEN                                               
            IF (WSP.EQ.'-'.AND.INDEX('0123456789',W(J+1)).NE.0) THEN    
             NEGSIGN=.TRUE.                                             
             SPC=.FALSE.                                                
             GOTO 20                                                    
            ELSE                                                        
             IF (WORD1(1,NWORD1).NE.' ') NWORD1 = NWORD1 + 1                
             WORD1(1,NWORD1) = WSP                                        
             DO 33 K=2,MAXLENG                                          
             WORD1(K,NWORD1)= ' '                                         
   33         CONTINUE                                                  
             SPC=.FALSE.                                                
       ENDIF                                                            
       ENDIF                                                            
       ENDIF                                                            
   20  CONTINUE                                                         
      GOTO 10                                                           
C     
  100 CLOSE(IUNIT)                                                                  
C                                                                       
      IF (UPPER_CASE) RETURN 
C-----------------------------------------------------------------------
C   IF UPPER_CASE=FALSE : CHECK FOR KEYWORDS      I
C   FOR EACH KEYWORD, TRANSFORM WORD(*,I) TO UPPER_CASE 
C-----------------------------------------------------------------------
      DO 200 I=1,NWORD1
        TRUEKW=.FALSE.
        DO 210 J=1,8
C-----------------------------------------------------------------------
C   TRANSFORM LOWER CASE TO UPPER CASE                                  
C-----------------------------------------------------------------------
           W(J) = WORD1(J,I)                        
           K = INDEX('abcdefghijklmnopqrstuvwxyz',W(J))                 
           IF (K.GE.1.AND.K.LE.26) W(J) = UPC(K)                        
  210   CONTINUE
        CHEKKW =W(1)//W(2)//W(3)//W(4)//W(5)//W(6)//W(7)//W(8)
        DO 220 J=1,NKEYFE
           IF (CHEKKW.EQ.KEYWORD(J)) TRUEKW=.TRUE.
  220   CONTINUE
        IF (TRUEKW) THEN
          DO 230 J=1,8
             WORD1(J,I)=W(J)
  230     CONTINUE
        ENDIF
  200 CONTINUE
      RETURN                                                            
C                                                                       
C-----------------------------------------------------------------------
C   FORMATS                                                             
C-----------------------------------------------------------------------
 9900 FORMAT(/1X,'THE FOLLOWING WORD IN FILE ',I2,                      
     +         ' IS LONGER THAN THE MAXIMUM ALLOWED: ',I4/,10X,15A,/,   
     +          5X,' CHECK THIS WORD OR INCREASE PARAMETER MAXLENG')    
 9910 FORMAT(/1X,'THERE WERE MORE FIGURES READ IN FILE ',I2,            
     +           ' THAN THE MAXIMUM ALLOWED: ',I4,/                     
     +          5X,'CHECK DATA OR INCREASE PARAMETER MAXFIG')    
 9915 FORMAT(/1X,'THERE ARE ERRORS IN THE WAY REAL NUMBERS ARE',
     +             '  EXPRESSED')          
 9920 FORMAT(/1X,'THERE WERE MORE WORDS READ IN FILE ',I2,              
     +           ' THAN THE MAXIMUM ALLOWED: ',I4,/                     
     +          5X,'CHECK DATA OR INCREASE PARAMETER MAXWORD')          
C***********************************************************************
      END subroutine readparm                                                               

      subroutine openfile(iunit,filen)
C***********************************************************************
C opens file for writing according to format specified in FORMOUT      *
C statement                                                            *
C***********************************************************************
c
        CHARACTER*15 filen
        integer iunit
        integer ifile
c
C-----------------------------------------------------------------------
c free (=default) or fixed format
C-----------------------------------------------------------------------
      if (fout.eq.1.or.fout.eq.2) then
        open(iunit,file=filen,status='unknown',form='formatted')
C-----------------------------------------------------------------------
C unformatted or blocked_unformatted
C-----------------------------------------------------------------------
      elseif (fout.eq.3.or.fout.eq.4) then
        open(iunit,file=filen,status='unknown',form='unformatted')
C-----------------------------------------------------------------------
C compressed
C-----------------------------------------------------------------------

      else
C
C THIS VERSION DOES NOT ALLOW THE USE OF THE C SUBROUTINES TO 
C READ WRITE AND COMPRESS THE FILES
C ==> STOP
C
      WRITE(6,888)
 888   FORMAT(//1X,' THIS VERSION DOES NOT ALLOW THE USE OF THE ',
     +   'C SUBROUTINES TO',/,
     +   1X,'READ AND WRITE AND COMPRESS FILES ==> STOP')
       STOP 
       
c       call f77openw(idfile,filen//char(0))
      endif
      return
      end subroutine openfile

      subroutine writof(ifile)
C***********************************************************************
C writes elementary records in the format specified in the FORMOUT     *
C statement                                                            *
C***********************************************************************
c
        integer iunit
        integer i,l,ieof
        integer ifile,len

        CHARACTER*24 CREATEFM
c
      iunit=8
      ltab0=ltab*4
      ltab1=ltab*4+ltab/2
c
C-----------------------------------------------------------------------
c free format
C-----------------------------------------------------------------------
      if (fout.eq.1) then
        do i=1,nrr
          write(iunit,*) (itabl(i,l),l=1,ninf+ir2),
     *    (xtabl(i,l),l=ninf+ir2+1,ninf+ir2+ir1)
        enddo
C-----------------------------------------------------------------------
C fixed format
C-----------------------------------------------------------------------
      elseif (fout.eq.2) then
        if (ninf.eq.2) then
          do i=1,nrr
            write(iunit,fm2) (itabl(i,l),l=1,ninf+ir2),
     *      (xtabl(i,l),l=ninf+ir2+1,ninf+ir2+ir1)
          enddo
        elseif(ninf.eq.3) then
          do i=1,nrr
            write(iunit,fm3) (itabl(i,l),l=1,ninf+ir2),
     *      (xtabl(i,l),l=ninf+ir2+1,ninf+ir2+ir1)
          enddo
        endif
C-----------------------------------------------------------------------
c unformatted
C-----------------------------------------------------------------------
      elseif (fout.eq.3) then
        do i=1,nrr
          write(iunit) (itabl(i,l),l=1,ninf+ir2),
     *    (xtabl(i,l),l=ninf+ir2+1,ninf+ir2+ir1)
        enddo
C-----------------------------------------------------------------------
c blocked_unformatted
C-----------------------------------------------------------------------
      elseif (fout.eq.4) then
c££££££££££££££££££££££££££££££££££££££££££££££££
        print*,'ici',nrr,nrecw,ltab,(krr(i),i=1,100)
        write(iunit) nrr,ltab,(krr(i),i=1,ltab)
        stop
C-----------------------------------------------------------------------
C compressed
C-----------------------------------------------------------------------
c     else
c       call f77cwrite(idfile,nrr,ltab,krr)
      endif
      nrr=0

       return
	end subroutine writof
  
	SUBROUTINE F77CWRITE(IDFILE,NREC,LTAB,KREC2)
C***********************************************************************
C  F77CWRITE    *                                     *  20 / 01 /1997 *
C***********************************************************************
C  WRITES AND COMPRESSES A FILE (uses C subroutines)
C***********************************************************************
c
c variable KREC renamed to KREC2, KREC1 to KREC12
	integer:: krec2(*)
	integer,allocatable:: krec12(:)
  
	INTEGER I,NREC,IERR,F77COMPRESS,LTAB,IDFILE
!      INTEGER KREC2(MXEF*nrecmax),KREC12(MXEF*nrecmax)
	allocate( krec12(MXEF*nrecmax) )	  
  
C
C THIS VERSION DOES NOT ALLOW THE USE OF THE C SUBROUTINES TO 
C READ WRITE AND COMPRESS THE FILES
C ==> STOP
C
	WRITE(6,10)
10    FORMAT(//1X,' THIS VERSION DOES NOT ALLOW THE USE OF THE ',
     +   'C SUBROUTINES TO',/,
     +   1X,'READ AND WRITE AND COMPRESS FILES ==> STOP')
	STOP 

c     CALL F77WRITE(IDFILE,NREC,INTFOR,IERR)
c     CALL F77WRITE(IDFILE,LTAB,INTFOR,IERR)
	LTAB0=LTAB*INTFOR
	LTAB12=LTAB0+100
	LTAB02=LTAB0
C
C compresses KREC2 (of size LTAB0) into KREC12 (of size ltab1 on exit)
C
c     I=F77COMPRESS(KREC12,LTAB12,KREC2,LTAB02)
	LTAB1=LTAB12
c     CALL F77WRITE(IDFILE,LTAB1,INTFOR,IERR)
c     CALL F77WRITE(IDFILE,KREC12,LTAB1,IERR)

	deallocate(krec12)	
	RETURN
C***********************************************************************
	END subroutine f77cwrite
  
	subroutine parchange (tochange)
c To change variables for prepare in the parameter file without recompilation
	integer tochange,changed	  
  
c tests whether keywords appear before FILES statement
	if (parmark) then
 	write(*,9001) keyword(kn)
9001    format(1x,'Error in ',A8,' statement'/
     +  1x,'Keyword should appear before FILES statement'/
     +  1x,'Check parameter file')
 	stop
	endif

c reads in new values specified by user  
	if (nfig(wn) .gt. 0) then
   	 changed = lfig(wn)
    	if (ifig(changed) .ge. 0) then
     	  tochange = ifig(changed)
     	  if (kn .eq. 2) then 
            print*,'NRECMAX changed to ',tochange
                    nrecmaxch = 1
               endif
               if (kn .eq. 22) then 
                  print*,'NCOLPED changed to',tochange
                  ncolpedch = 1
               endif
               if (kn .eq. 3) then 
                   print*,'NEFMAX changed to ',tochange
                   mxefch = 1
               endif
               if (kn .eq. 4) then 
                  print*,'NDIMAX changed to ',tochange
                  ndimaxch = 1
               endif
            endif
        endif

c next word has to be ';'
        wn=wn+1
        if (word(1,wn).ne.';') then
          write(*,9002)  keyword(kn)
9002    format(1x,'Error in ',A8,' statement'/
     +  1x,'Semicolon missing'/
     +  1x,'Check parameter file')
          stop
        endif 		

      end subroutine parchange	  
	  
       end program prepare

! 3 functions + 1 subroutine moved outside of <program-end program> block

	     FUNCTION NDAY(ID,IM,IY)
C***********************************************************************
C     PERPETUAL DAY FUNCTION WITH LEAP YEARS  (by S.P. SMITH)          *
C***********************************************************************
        implicit none
c
        integer nday,id,im,iy,ly,MON(12)
        DATA MON/0,31,59,90,120,151,181,212,243,273,304,334/
c
        IF((IY.EQ.0).OR.(IM.EQ.0).OR.(ID.EQ.0))THEN
        NDAY=0
        RETURN
      END IF
      LY=(IY+3)/4
      NDAY=365*IY+LY+ID+MON(IM)
      IF((IM.GT.2).AND.(4*LY.EQ.IY))NDAY=NDAY+1
      RETURN
      END function nday
	   
      SUBROUTINE BITSTR2(LEVCOD,NLEV,IBITS,NBDIG)
C***********************************************************************
C     SUBROUTINE TO RETURN THE BINARY STRUCTURE OF AN INTEGER          *
C***********************************************************************
C     DECLARE PARAMETERS
      INTEGER LEVCOD(3),IBITS(96),NBDIG,NLEV
C     DECLARE LOCAL VARIABLES
      INTEGER II,K,L
      DO I=1,NLEV
        IBEG=1+32*(I-1)
        IEND=32*I
        IEND2=32*(I-1)
        II=Abs(LEVCOD(I))
        DO 1 K=IBEG,IEND
    1   IBITS(K)=0

        NBDIG=0
        DO 2 K=31,1,-1
         L=2**(K-1)
         IF (L .LE. II) THEN
            IF (NBDIG .NE. 0) NBDIG=K+IEND2
            IBITS(K+IEND2)=1
            II=II-L
            ENDIF
    2  CONTINUE

       IF (II .NE. 0) THEN
         PRINT *,'BITSTR ERROR',LEVCOD(I),II,IBITS,NBDIG
         STOP
       ENDIF
      ENDDO
      RETURN
      END subroutine bitstr2
  
      FUNCTION CREATEFM(I1,I2,FMI,FMR)     
C*****************************************************************************
C  CREATE A FORMAT WITH I1 INTEGERS (FORMAT FMI) AND I2 REAL (FORMAT FMR)
C*****************************************************************************
      CHARACTER*24 CREATEFM
      CHARACTER*22 FT
      CHARACTER*11 FT1,FT2
      CHARACTER*5 FMI,FMR
      INTEGER A(20),IM(5)
      CHARACTER FIG(0:10)
      data (fig(j),j=0,10) /'0','1','2','3','4','5','6','7','8','9',
     + ' '/    
C
C Integer part
C
      J=I1 
      I=1
      L=1
    5 K=MOD(J/I,10*I)
      IM(L)=K   
      I=I*10
      L=L+1
      IF (I.LE.J) GOTO 5
      DO 10 I=L,5 
         IM(I)= 10
   10 CONTINUE
      FT1=FIG(IM(5))//FIG(IM(4))//FIG(IM(3))//FIG(IM(2))
     +    //FIG(IM(1))//FMI
C
C Real part
C      
      IF (I2.NE.0) THEN   
       J=I2
       I=1
       L=1
   15  K=MOD(J/I,10*I)
       IM(L)=K   
       I=I*10
       L=L+1
       IF (I.LE.J) GOTO 15
       DO 20 I=L,5 
         IM(I)= 10
   20  CONTINUE
       FT2=','//FIG(IM(5))//FIG(IM(4))//FIG(IM(3))//FIG(IM(2))
     +    //FIG(IM(1))//FMR 
       FT=FT1//FT2  
      ELSE
       FT=FT1
      ENDIF    
        CREATEFM = '('//FT//')'
      RETURN
      END function createfm
	  
      INTEGER FUNCTION IDMURL(LEVCOD,NLEV,RTOPL,INDL,XLIST,IPLA,
     *        ID1,ID2,LASTIL,NEW)
c+++
c
c     Function IDMURL.
c     Author: Just Jensen
c     Last revision: 12.06.93.
c     Modified by Hans Soelkner: 05.10.93.
c
c+++
c
C     FUNCTION TO UPDATE A LIST OF CODES IN A RADIX TREE.
c     The function can update and search a list with up to 2**31
c     elements. The Maximum number of IF-statements executed in
c     order ot find an element is 31, and is in most cases much
c     lower.

c     The routine first find the binary representation of the input
c     level code. I.e. a vector of zeros and ones. These are then
c     used to decide whether to go left(0) or right(1) in the
c     search tree.

c     Description of parameters.

c     LEVCOD(3) Vector of (maximum) 3 Integers to either include
c               in the list or to update
c               (check for existence) in the list.
c
c     NLEV      Number of elements of LEVCOD used in this search
c
c     RTOPL     Integer pointing to the first element in the current
c               list. The top pointer is necessary because several
c               lists can be stored in the same array.
c
c     INDL      Counter. This integer variable is always added to
c               col 3 of the list array in the row corresponding to
c               the levcod. Is used as one when reading data or order
c               to count number of observations in each level. After
c               the data are read once INDL is set to zero in the
c               calling program.
c
c     XLIST     an integer array of dimension ID1*ID2.
c               IDNURL uses the coloums of XLIST as described in the
c               following. Other coloums might be used for other
c               purposes by other routines.
c
c               Coloumn  Description
c               -------  ---------------------------------------------
c                1       element identification of LEVCOD(1).
c                2       Element identification of LEVCOD(2).
c                3       Element identification of LEVCOD(3).
c                4       Counter where INDL is added everytime this
c                        element was "visited". Can be used to count
c                        number of observations per class level.
c                IPLA    These two coloums are used for pointers in
c                IPLA+1  the binary search tree. The actual coloums
c                        used are decided by the user.
c
c     IPLA      Integer input variable that indicates the first col
c               in XLIST that is used to store the pointers in the
c               binary tree.
c
c     ID1       First dimension of integer array XLIST. Must be
c               equal to or larger then  the maximum number of
c               elements in the list(s).
c
c     ID2       Second dimension (No of coloums) of integer array
c               XLIST. Must be 6 or greater.
c
c     LASTIL    Input/output variable that keeps track of the
c               last used element/row in XLIST.
c
c     NEW       Output variable thet indicates if a new element have
c               been added to the list. NEW = 1 if a new element
c               was added, otherwise NEW = 0.

c---------------------------------------------------------------------
C     DECLARE PARAMETERS.
      INTEGER LEVCOD(3),ID1,ID2,RTOPL,INDL,XLIST(ID1,ID2),IPLA,LASTIL
      INTEGER NEW,NLEV

C     DECLARE LOCAL VARIABLES.
      INTEGER IBITS(96),NBDIG,I,J
      INTEGER PTR,FPTR

C     FIND BINARY STRUCTURE OF "LEVCOD"
      CALL BITSTR2(LEVCOD,NLEV,IBITS,NBDIG)
c      write(*,222) levcod,ibits,lastil
c222   format(3(1x,i8),2x,64i1)
      PTR=RTOPL
      FPTR=0
      LEVEL=0
      NEW=0

    1 IF (PTR.EQ.0) THEN
C       ELEMENT TO BE ADDED. BOTTOM OF TREE FOUND.
        LASTIL=LASTIL+1
        IF (LASTIL .GT. ID1) THEN
          PRINT *,'DIMENSION PROBLEM IN IDMURL'
          PRINT *,'PARAMETER NDIMAX = ',ID1,' MUST BE ENLARGED'
          PRINT *,'CHECK NDIMAX STATEMENT IN YOUR PARAMETER FILE'
          PRINT *,'COMPUTATIONS ABORTED'
          STOP 16
        ENDIF
        DO 2 I=1,ID2
          XLIST(LASTIL,I)=0
    2   CONTINUE
        IF (FPTR.EQ.0) THEN
          RTOPL=LASTIL
        ELSE
          XLIST(FPTR,IB)=LASTIL
        ENDIF
        PTR=LASTIL
        DO I=1,NLEV
          XLIST(PTR,I)=LEVCOD(I)
        ENDDO

        NEW=1
      ELSE
        J=0
        DO I=1,NLEV
          IF (XLIST(PTR,I).NE.LEVCOD(I)) J=J+1
        ENDDO
        IF (J.GT.0) THEN
c         Element not found yet. Goto next element in tree.
          LEVEL=LEVEL+1
          IB=IBITS(LEVEL)+IPLA
          FPTR=PTR
          PTR=XLIST(PTR,IB)
          GOTO 1
        ENDIF
      ENDIF

C
C     "LEVCOD" ALREADY IN TREE
C
c     Update counter.
      XLIST(PTR,4)=XLIST(PTR,4)+INDL
      IDMURL=PTR

c      write(*,*) lastil,ptr,fptr
      RETURN
      END function idmurl

