      SUBROUTINE FWEIB2(BETA1,F,GRADF,STD,DLDET,IDF,NOPTION,NDIM1)
C***********************************************************************
C  FWEIB2        *                                    *  18 / 09 /1995 *
C***********************************************************************
C  COMPUTE THE FINAL VALUE OF - WEIB' PARTIAL LIKELIHOOD, ITS VECTOR OF*
C       DERIVATIVES, THE MATRIX OF SECOND DERIVATIVES TO COMPUTE STD   *
C       VECTOR OF STANDARD ERRORS OF THE ESTIMATES                     *
C***********************************************************************
      use sparsem
      use sparseop 
      use parinclu
      
      implicit none
c 
      integer,allocatable:: kfirst(:),klast(:),listys(:)  !all NDIMAX
      integer,allocatable:: point(:),itopl(:)             !all NDIMAX
      integer,allocatable:: pointom(:)                    !POINTOM(NZE_HESS)
      real*8,allocatable:: domeg(:)                       !all NDIMAX
      real*8,allocatable:: d2omeg(:)                      !D2OMEG(NZE_HESS)
	  
      real*8 gradf(NDIM1),std(NDIM1)
c
      INTEGER NDIM1,LAST,LASTOM,LAST1,LAST2
      INTEGER NDCOV0,NDCOV1,NDCOVP1
      INTEGER I,J,K,K1,KK,JJ,J1,J2,K2,ICODE,IPRETIM,ITIM,IQ,IVALQ
      INTEGER IPRESTR,LTAB
      INTEGER LEVCOD(2),GARDE,IDMURM,iflag
      INTEGER IA,IP,IM,IGPM,IGMM,INDJ,LASTIL,NEW,ISTR
      INTEGER NDIMBPS,M1,M2
      INTEGER IA2,IP2,IM2,IGPM2,IGMM2,IDEL,I2
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on December 10, 1996
      INTEGER IDHERD,NH,N1,I1,MAXYS,NLISTYS,NCOND
      INTEGER IERR
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on October 20,2003

      CHARACTER*15 FILENAMC
      INTEGER IDF,NOPTION
C
      REAL TIM0,TIM1,SECOND
C
C     REAL*8 LCHOl(NMAX,NMAX)
      REAL*8 GAM0,CONST,XNQGAM,OMQGAM,R1GAM,R2GAM,R3GAM,OMEG
      REAL*8 F,U,W,W1,W2,W3,W4,W5,W6,W7,XNS,XNQ,XCOV,XCOV2,X,DM1(7)
      REAL*8 BETA1(*),RHO,TRHO,TPRERHO,LRHO,DLTIM,DLPRETIM
      REAL*8 GAMLOG,XGAINV,DIGAMA,TRIGAM,GAMVAR,XNSFIX
      REAL*8 DLDET,WADD,WADD0,WADD1,WADD2
      REAL*8 X2,Y,Y2,D1,D2,D3,D4,D5
C
C FSPAK variables
C 
C      INTEGER IAV(NDIMAX+2),JAV(NZE_HESS),IS(NZE_HESS),IWO(NZE_HESS)
      REAL*8 XS
      type (sparse_hashm)::hess
      type (sparse_ija):: hess_ija
      type (sparse_ija_strict):: hess_str
      integer:: maxround,p_ic,idim,msglev,maxmem
      real*8 ::conv,relax
      logical::zerosol,cal_icho

      INTEGER IOUT,IOOR,NEEDED,LEV,IR,JRANK
      CHARACTER*100 FILENAM
C
C
      EQUIVALENCE(FILENAM,FILENAMC)
c      EQUIVALENCE (IS(1),XS)

      DATA (DM1(I),I=1,7)/1.D0,1.33333333333333D0,2.D0,
     + 	 1.D0,1.3333333333D0,1.06666666667D0,1.4545454545455D0/
C
      allocate( kfirst(NDIMAX),klast(NDIMAX),listys(NDIMAX) )
      allocate( point(NDIMAX),itopl(NDIMAX) )
      allocate( domeg(NDIMAX),POINTOM(NZE_HESS),D2OMEG(NZE_HESS)  )

C
C-----------------------------------------------------------------------
c IF NDENS = 1, IN FACT THE HESSIAN WILL BE COMPUTED IN "DENSE MODE"
C-----------------------------------------------------------------------
      IF (NDENS.EQ.1.OR.NOPTION.GE.90) THEN
        CALL FWEIB2D(BETA1,F,GRADF,STD,DLDET,IDF,NOPTION,NDIM1)
        RETURN
      ENDIF
C-----------------------------------------------------------------------
c IF NOPTION=99 ==> STATISTICS ON FSPAK
C-----------------------------------------------------------------------
      IF (NOPTION.EQ.99) THEN
        call fspak90('stat',hess_ija)
c        CALL FSPAK(80,NDIM1,iav,jav,hess,std,IFLAG,IOUT,ioor,NZE_HESS,
c     +         NEEDED,IS, i,i,1,1,1.D0,1,JRANK)
        IOUT=12
        call fspak90('stat',hess_ija)
c        CALL FSPAK(80,NDIM1,iav,jav,hess,std,IFLAG,IOUT,ioor,NZE_HESS,
c     +         NEEDED,IS, i,i,1,1,1.D0,1,JRANK)
        RETURN
      ENDIF
C
C-----------------------------------------------------------------------
C  INITIALIZATION
C-----------------------------------------------------------------------
C
      IOUT=6
      N1=0    
      LEV=0
      NDCOV0 = NCCOV + 1
      NDCOV1 = NCCOV + NDCOV
      NDCOVP1 = NDCOV1 + 1
      F = 0.D0
      XNS = 0.D0
      XNQ = 0.D0
      XNSFIX = 0.D0
      NDIMBPS = NDIMB + NSTRATA
      MAXYS=1000
      IPRESTR=0
      IF (INTEGAM.NE.0) THEN
        IF (NJOINT.EQ.0) THEN
          GAMVAR = XGAM(INTEGAM)
        ELSE
          GAMVAR=DEXP(BETA1(NDIM1))
        ENDIF
      ENDIF
      
c
      if (nze2.eq.0) nze2=NZE_HESS
      call init(hess)
      call zerom(hess,ndim1,nze2) 
      DO 8 J=1,NDIM1
        DO 9 I=1,4
          YLIST(I,J) = 0
    9   CONTINUE
        POINTOM(J)=0
    8 CONTINUE
	  TIM0=SECOND()
C-----------------------------------------------------------------------
C INITIALIZING TAB(), FOR IDMURM
C-----------------------------------------------------------------------
      LASTIL = -NDIM1
      LASTIL=IDMURM(LEVCOD,ITOPL,LASTIL,NEW)
      LASTIL=0
      DO 7 I=1,NZE_HESS
        POINTOM(I)=0
    7 CONTINUE
      DO 10 I = 1,NDIM1
        ITOPL(I) = 0
        GRADF(I) = 0.D0
        DOMEG(I) = 0.D0
        POINT(I) = 0
   10 CONTINUE
C
      IPRETIM = 0
C----------------------------------------------------------------------
c<<<<<<<< modified on April 17, 1997 for ICRHO=0 >>>>>>>>>>>>>>>>>>>>>>>
C  READ THE VALUE(S) OF RHO IF ICRHO=1
C----------------------------------------------------------------------
      IF (ICRHO.EQ.1) THEN
        K = NSTRATA
        IF (NO_LOG.EQ.1) THEN
          DO 11 I=1,NSTRATA
            VALRHO(I) = BETA1(NDIMBPS+I)
            DLOGRHO(I) = DLOG(VALRHO(I))
  11      CONTINUE
        ELSE
          DO 12 I=1,NSTRATA
            DLOGRHO(I) = BETA1(NDIMBPS+I)
            VALRHO(I) = DEXP(DLOGRHO(I))
  12      CONTINUE
        ENDIF
      ELSE IF (ICRHO.EQ.99) THEN
        DO 1016 I=1,NSTRATA
          DLOGRHO(I) = 0.D0
          VALRHO(I) =  1.D0
1016    CONTINUE
      ENDIF
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DO 13 I=1,NSTRATA
        VECEXP(1,I) =  1.D0
        DO 14 J=2,MAXTIM(1)
	   IF (VECLOG(J).NE.0.D0) THEN
             VECEXP(J,I) =  DEXP(VALRHO(I)*VECLOG(J))
	   ENDIF
  14    CONTINUE
  13  CONTINUE
C-----------------------------------------------------------------------
C  CONSTRAINT(S)
C-----------------------------------------------------------------------
      IF (ICHECK.EQ.0) THEN
        DO 19 I = 1,ICONS(0)
          BETA1(ICONS(I)) = 0.D0
   19   CONTINUE
      ENDIF
C-----------------------------------------------------------------------
C   RANDOM EFFECTS
C-----------------------------------------------------------------------
c In case of CORRELATED random effects, compute corr form zeta
      if (corrflag) then
        X=exp(zeta)
        corr= (1.d0-2.d0*X)/(1.d0+2.d0*X)
	do i=1,maxrand
          if ((inor(i,1).ge.1).and.(icorr(i,1).eq.i)) then
            detv=(1-corr*corr)*xnor(i)*xnor(icorr(i,2))
            VM1(1,1)= xnor(icorr(i,2))/detv
            VM1(2,2)= xnor(i)/detv
            VM1(1,2)=(-corr*sqrt(xnor(i))*sqrt(xnor(icorr(i,2))))/detv
            VM1(2,1)=VM1(1,2)
            exit
          endif
        enddo	  
      endif
c 
C computations for the RANDOM effect
      IF (NRAND.NE.0) THEN
       DO 300 I = 1,MAXRAND
       IF (ISAME(I).NE.0) GOTO 300
       IF (IGAM(I,1).GE.1.AND.IGAM(I,2).NE.0.AND.I.NE.INTEGAM) THEN
c modfied on Decembre 16 2013
         XGAINV=1.D0/XGAM(I)
c         U = XGAM(I) * DLOG(XGAM(I)) - GAMLOG(XGAM(I))
         U = -XGAINV * DLOG(XGAM(I)) - GAMLOG(XGAINV)
         F = F - (IGAM(I,3) - IGAM(I,2) +1 ) * U
         DO 310 J = IGAM(I,2),IGAM(I,3)
             IF (BETA1(J).LT.-80.D0) THEN
               W=0.D0
             ELSE
               W = DEXP(BETA1(J))
             ENDIF
c modified on Decembre 16 2013
c             F = F  - XGAM(I) * (BETA1(J) - W)
c             GRADF(J) = GRADF(J) - XGAM(I) * (1.D0 - W)
             F = F - XGAINV * (BETA1(J) - W)
             GRADF(J) = GRADF(J) - XGAINV * (1.D0 - W)
	     WADD = XGAINV * W
             call addm(wadd,j,j,hess)
  310    CONTINUE
       ELSE IF (INOR(I,1).GE.1) THEN
!!!! correlated random effects - this part remains as it was before
         if (icorr(i,2).eq.0) then
!!!!
           CONST = - 0.5D0 * DLOG(XNOR(I))
           IF (NRELMAT.EQ.0.OR.I.NE.NRELMAT2) THEN
             U = 1.D0 / XNOR(I)
             DO 312 J = INOR(I,2),INOR(I,3)
               W = U * BETA1(J)
               F = F -CONST + 0.5D0 * W * BETA1(J)
               GRADF(J) = GRADF(J) + W
               call addm(u,j,j,hess)
  312        CONTINUE
           ELSE
             U = 1.D0 / XNOR(NRELMAT2)
             IF (NRULE.EQ.1) THEN
             DO 320 K=1,NANI
               IF (IPEDIG(2,K).LT.0) THEN
	              WADD = 0.D0
                  IA=IPEDIG(1,K)
                  DO 324 K2= INOR(I,2),IA
                    call addm(wadd,k2,ia,hess)
  324             CONTINUE
                  GOTO 320
               ENDIF
               F = F - CONST
               IA = IPEDIG(1,K)
               IP = IPEDIG(3,K)
               IM = IPEDIG(4,K)
               X = BETA1(IA)
               IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
               IF (IM.GT.0) X = X - 0.5D0 * BETA1(IM)
               W = U * DM1(IPEDIG(2,K))
               X = W * X
               GRADF(IA) = GRADF(IA) + X
               call addm(w,ia,ia,hess)
c
               IF (IP.GT.0) THEN
                  GRADF(IP) = GRADF(IP) - 0.5D0 * X
                  J1 = MIN(IA,IP)
                  J2 = MAX(IA,IP)
	              WADD = -0.5D0 * W
                  call addm(wadd,j1,j2,hess)
	              WADD = 0.25D0 * W
                  call addm(wadd,ip,ip,hess)
                ENDIF
                IF (IM.GT.0) THEN
	              GRADF(IM) = GRADF(IM) - 0.5D0 * X
         	      J1 = MIN(IA,IM)
                  J2 = MAX(IA,IM)
	              WADD = -0.5D0 * W
                  call addm(wadd,j1,j2,hess)
	              WADD = 0.25D0 * W
                  call addm(wadd,im,im,hess)
c
                  IF (IP.GT.0) THEN
                    J1 = MIN(IP,IM)
                    J2 = MAX(IP,IM)
		            WADD = 0.25D0 * W
C (corresponds to same group of unknown parents for sire and dam
                    IF (IP.EQ.IM) WADD = 2.D0 * WADD
                    call addm(wadd,j1,j2,hess)
                  ENDIF
                ENDIF
  320        CONTINUE
               J=I
               DO 322 K=INOR(I,2),INOR(J,3)
                 F = F + 0.5 * BETA1(K) * GRADF(K)
  322          CONTINUE
c
             ELSE IF (NRULE.EQ.2) THEN
               DO 330 K=1,NANI
c              IF (IPEDIG(2,K).LE.0) GOTO 330
                 F = F - CONST
                 IA = IPEDIG(1,K)
                 IF (IPEDIG(2,K).LE.0) THEN 
                   IP=0
                   IGPM=0
                   IGMM=0
                 ELSE
                   IP = IPEDIG(3,K)
                   IGPM = IPEDIG(4,K)
                   IF (NCOLPED.EQ.4) THEN
                     IGMM = IPEDIG(NCOLPED+1,K)
                   ELSE
                     IGMM = 0
                   ENDIF
                 ENDIF
                 X = BETA1(IA)
                 IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
                 IF (IGPM.GT.0) X = X - 0.25D0 * BETA1(IGPM)
                 IF (IGMM.GT.0) X = X - 0.25D0 * BETA1(IGMM)
                   IF (IPEDIG(2,K).LE.0) THEN
                     W = U
                   ELSE
                     W = U * DM1(IPEDIG(2,K))
                   ENDIF
                 X = W * X
                 GRADF(IA) = GRADF(IA) + X
c
                 call addm(w,ia,ia,hess)
                 IF (IP.GT.0) THEN
                   GRADF(IP) = GRADF(IP) - 0.5D0 * X		
                   J1 = MIN(IA,IP)
                   J2 = MAX(IA,IP)
	               WADD = -0.5D0 * W
                   call addm(wadd,j1,j2,hess)
	               WADD = 0.25D0 * W
                   call addm(wadd,ip,ip,hess)
                 ENDIF
c
                 IF (IGPM.GT.0) THEN 				
                   GRADF(IGPM) = GRADF(IGPM) - 0.25D0 * X
                   J1 = MIN(IA,IGPM)
                   J2 = MAX(IA,IGPM)
	               WADD = -0.25D0 * W
                   call addm(wadd,j1,j2,hess)
	               WADD = 0.0625D0 * W
                   call addm(wadd,igpm,igpm,hess)
c
                   IF (IP.GT.0) THEN
                     J1 = MIN(IP,IGPM)
                     J2 = MAX(IP,IGPM)
		             WADD = 0.125D0 * W
C (corresponds to same group of unknown parents for sire and maternal grand sire 
                     IF (IP.EQ.IGPM) WADD = 2.D0 * WADD
                     call addm(wadd,j1,j2,hess)
                   ENDIF
                 ENDIF
c
                 IF (IGMM.GT.0) THEN 				
                   GRADF(IGMM) = GRADF(IGMM) - 0.25D0 * X
                   J1 = MIN(IA,IGMM)
                   J2 = MAX(IA,IGMM)
	               WADD = -0.25D0 * W
                   call addm(wadd,j1,j2,hess)
	               WADD = 0.0625D0 * W
                   call addm(wadd,igmm,igmm,hess)
c
                   IF (IP.GT.0) THEN
                     J1 = MIN(IP,IGMM)
                     J2 = MAX(IP,IGMM)
		             WADD = 0.125D0 * W
C (corresponds to same group of unknown parents for sire and meaternal grand dam
                     IF (IP.EQ.IGMM) WADD = 2.D0 * WADD
                     call addm(wadd,j1,j2,hess)
                   ENDIF
c
                   IF (IGPM.GT.0) THEN
                     J1 = MIN(IGPM,IGMM)
                     J2 = MAX(IGPM,IGMM)
		             WADD = 0.0625D0 * W
C (corresponds to same group of unknown parents for maternal grand sire and grand dam
                     IF (IGPM.EQ.IGMM) WADD = 2.D0 * WADD
                     call addm(wadd,j1,j2,hess)
                   ENDIF
                 ENDIF
  330          CONTINUE 
               DO 332 K=INOR(I,2),INOR(I,3)
                 F = F + 0.5 * BETA1(K) * GRADF(K)
  332          CONTINUE
             ENDIF
           ENDIF

!!!! correlated random effects - beginning
         else if (icorr(i,1).gt.0) then
             I2=icorr(i,2)
             CONST = -0.5D0 * (DLOG(XNOR(I))+DLOG(XNOR(I2))+
     +                    DLOG(1.d0-corr*corr))

! difference between positions of the 2 random effects in the whole list	 
             IDEL=INOR(I2,2)-INOR(I,2)
! in case of no relationship matrix
           IF (NRELMAT.EQ.0.OR.I.NE.NRELMAT2) THEN
             DO 412 J = INOR(I,2),INOR(I,3)
               J2=J+IDEL
               F = F -CONST+ 0.5D0 * (VM1(1,1)*BETA1(J)*BETA1(J)
     +                     + 2.D0 * VM1(1,2)*BETA1(J)*BETA1(J2)
     +                     + VM1(2,2) * BETA1(J2)*BETA1(J2) )
               GRADF(J) = GRADF(J) + VM1(1,1)*BETA1(J)
     +                             + VM1(1,2)*BETA1(J2)
               GRADF(J2) = GRADF(J2) + VM1(2,1)*BETA1(J)
     +                               + VM1(2,2)*BETA1(J2)
c
               call addm(VM1(1,1),j,j,hess)
               call addm(VM1(1,2),j,j2,hess)
               call addm(VM1(2,1),j2,j,hess)
               call addm(VM1(2,2),j2,j2,hess)
  412        CONTINUE
           ELSE
             U = 1.D0 / XNOR(NRELMAT2)
             IF (NRULE.EQ.1) THEN
             DO 420 K=1,NANI
               IF (IPEDIG(2,K).LT.0) THEN
	              WADD = 0.D0
                  IA=IPEDIG(1,K)
                  IA2=IA+IDEL
                  DO 424 K2= INOR(I,2),IA
                    call addm(wadd,k2,ia,hess)
                    call addm(wadd,k2,ia2,hess)
                    call addm(wadd,k2+idel,ia2,hess)
  424             CONTINUE
                  GOTO 420
               ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
               F = F - CONST
               IA = IPEDIG(1,K)
               IP = IPEDIG(3,K)
               IM = IPEDIG(4,K)
               IA2= IA+IDEL
               IP2= IP+IDEL
               IM2= IM+IDEL
               X = BETA1(IA)
               X2= BETA1(IA2)
               IF (IP.GT.0) THEN
                  X = X - 0.5D0 * BETA1(IP)
                  X2= X2 - 0.5D0 * BETA1(IP2)
               ENDIF
               IF (IM.GT.0) THEN
                  X = X - 0.5D0 * BETA1(IM)
                  X2 = X2 - 0.5D0 * BETA1(IM2)
               ENDIF
               D1= DM1(IPEDIG(2,K))
               D2 = 0.5d0* D1
               D3 = 0.25d0* D1
               Y = D1 * (VM1(1,1)*X + VM1(1,2)*X2)
               Y2 = D1 * (VM1(1,2)*X + VM1(2,2)*X2)
               GRADF(IA) = GRADF(IA) + Y
               GRADF(IA2) = GRADF(IA2) + Y2
c
               call addm(D1*VM1(1,1),ia,ia,hess)
               call addm(D1*VM1(1,2),ia,ia2,hess)
               call addm(D1*VM1(2,1),ia2,ia,hess)
               call addm(D1*VM1(2,2),ia2,ia2,hess)
c
               IF (IP.GT.0) THEN
                  GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                  GRADF(IP2) = GRADF(IP2) - 0.5D0 * Y2
	              WADD =  -D2 *VM1(1,1) 
                  call addm(wadd,MIN(IA,IP),MAX(IA,IP),hess)
c
	              WADD =  D3 *VM1(1,1)
                  call addm(wadd,ip,ip,hess)
c
	              WADD =  -D2 *VM1(1,2) 
                  call addm(wadd,MIN(IA,IP2),MAX(IA,IP2),hess)
                  call addm(wadd,MIN(IA2,IP),MAX(IA2,IP),hess)
c				  
	              WADD =  D3 *VM1(1,2) 
                  call addm(wadd,MIN(IP,IP2),MAX(IP,IP2),hess)
c				  
	              WADD =  -D2 *VM1(2,2) 
                  call addm(wadd,MIN(IA2,IP2),MAX(IA2,IP2),hess)
c				  
	              WADD =  D3 *VM1(2,2)
                  call addm(wadd,ip2,ip2,hess)
                ENDIF
                IF (IM.GT.0) THEN
                  GRADF(IM) = GRADF(IM) - 0.5D0 * Y
                  GRADF(IM2) = GRADF(IM2) - 0.5D0 * Y2
	              WADD =  -D2 *VM1(1,1) 
                  call addm(wadd,MIN(IA,IM),MAX(IA,IM),hess) 
c
	              WADD =  D3 *VM1(1,1)
                  call addm(wadd,IM,IM,hess)
c
	              WADD =  -D2 *VM1(1,2) 
                  call addm(wadd,MIN(IA,IM2),MAX(IA,IM2),hess)
                  call addm(wadd,MIN(IA2,IM),MAX(IA2,IM),hess) 
c				  
	              WADD =  D3 *VM1(1,2) 
                  call addm(wadd,MIN(IM,IM2),MAX(IM,IM2),hess)
c				  
	              WADD =  -D2 *VM1(2,2) 
                  call addm(wadd,MIN(IA2,IM2),MAX(IA2,IM2),hess)
c				  
	              WADD =  D3 *VM1(2,2)
                  call addm(wadd,IM2,IM2,hess)
c
                  IF (IP.GT.0) THEN
	                 WADD =  D3 *VM1(1,1)
C                  corresponds to same group of unknown parents for sire and dam
                     IF (IP.EQ.IM) WADD = 2.D0 * WADD
                     call addm(wadd,MIN(IP,IM),MAX(IP,IM),hess)
c
	                 WADD =  D3 *VM1(1,2)
C                  corresponds to same group of unknown parents for sire and dam
c                  VM1(1,2) = VM1(2,1)
                     IF (IP.EQ.IM2) WADD = 2.D0 * WADD
			call addm(wadd,MIN(IP,IM2),MAX(IP,IM2),hess)		
			call addm(wadd,MIN(IP2,IM),MAX(IP2,IM),hess)
c
	                 WADD =  D3 *VM1(2,2)
                     IF (IP2.EQ.IM2) WADD = 2.D0 * WADD
                     call addm(wadd,MIN(IP2,IM2),MAX(IP2,IM2),hess)
                  ENDIF
                ENDIF
  420        CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Modified on June 27, 1997
               J=I
               DO 422 K=INOR(I,2),INOR(J,3)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                 K2=K+IDEL
                 F = F+0.5* (BETA1(K)*GRADF(K)+BETA1(K2)*GRADF(K2))
  422          CONTINUE
c
             ELSE IF (NRULE.EQ.2) THEN
               DO 430 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
c              IF (IPEDIG(2,K).LE.0) GOTO 430
                 F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                 IA = IPEDIG(1,K)
                 IA2= IA+IDEL
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                 IF (IPEDIG(2,K).LE.0) THEN 
                   IP=0
                   IGPM=0
                   IGMM=0
                   IP2=0
                   IGPM2=0
                   IGMM2=0
                 ELSE
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   IP = IPEDIG(3,K)
                   IGPM = IPEDIG(4,K)
                   IP2=IP+IDEL
                   IGPM2=IGPM+IDEL
                   IF (NCOLPED.EQ.4) THEN
                     IGMM = IPEDIG(NCOLPED+1,K)
                     IGMM2 = IGPM+IDEL
                   ELSE
                     IGMM = 0
                     IGMM2 = 0
                   ENDIF
                 ENDIF
                 X = BETA1(IA)
                 X2= BETA1(IA2)
                 IF (IP.GT.0) THEN
                   X = X - 0.5D0 * BETA1(IP)
                   X2 = X2 - 0.5D0 * BETA1(IP2)
                 ENDIF
                 IF (IGPM.GT.0) THEN
                   X = X - 0.25D0 * BETA1(IGPM)
                   X2 = X2 - 0.25D0 * BETA1(IGPM2)
                 ENDIF
                 IF (IGMM.GT.0) THEN
                   X = X - 0.25D0 * BETA1(IGMM)
                   X2 = X2 - 0.25D0 * BETA1(IGMM2)
                 ENDIF
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                 IF (IPEDIG(2,K).LE.0) THEN
                   D1 = 1d0
                   D2 = 0.5d0
                   D3 = 0.25d0
	           D4 = 0.125d0
	           D5 = 0.0625d0
                 ELSE
                   D1 = DM1(IPEDIG(2,K))
                   D2 = 0.5d0* D1
                   D3 = 0.25d0* D1
	           D4 = 0.125d0 *D1
	           D5 = 0.0625d0* D1
                 ENDIF
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                 Y = D1 * (VM1(1,1)*X + VM1(1,2)*X2)
                 Y2 = D1 * (VM1(1,2)*X + VM1(2,2)*X2)
                 GRADF(IA) = GRADF(IA) + Y
                 GRADF(IA2) = GRADF(IA2) + Y2
c
                 call addm(D1*VM1(1,1),ia,ia,hess)
                 call addm(D1*VM1(1,2),ia,ia2,hess)
                 call addm(D1*VM1(2,1),ia2,ia,hess)
                 call addm(D1*VM1(2,2),ia2,ia2,hess)
c				 
                 IF (IP.GT.0) THEN
                   GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                   GRADF(IP2) = GRADF(IP2) - 0.5D0 * Y2
	               WADD =  -D2 *VM1(1,1) 
                   call addm(wadd,MIN(IA,IP),MAX(IA,IP),hess) 
c 
	               WADD =  D3 *VM1(1,1)
                   call addm(wadd,ip,ip,hess)
c 
	               WADD =  -D2 *VM1(1,2) 
                   call addm(wadd,MIN(IA,IP2),MAX(IA,IP2),hess)
                   call addm(wadd,MIN(IA2,IP),MAX(IA2,IP),hess)
c		 		  
	               WADD =  D3 *VM1(1,2) 
                   call addm(wadd,MIN(IP,IP2),MAX(IP,IP2),hess)
c	  
	               WADD =  -D2 *VM1(2,2) 
                   call addm(wadd,MIN(IA2,IP2),MAX(IA2,IP2),hess)
c				  
	               WADD =  D3 *VM1(2,2)
                   call addm(wadd,ip2,ip2,hess)
                 ENDIF
c
                 IF (IGPM.GT.0) THEN 				
                  GRADF(IGPM)=GRADF(IGPM) -0.25D0 * Y
                  GRADF(IGPM2)=GRADF(IGPM2) -0.25D0 * Y2

	               WADD = -D3 *VM1(1,1)
                   call addm(wadd,MIN(IA,IGPM),MAX(IA,IGPM),hess)
c
	               WADD = D5 *VM1(1,1)
                   call addm(wadd,IGPM,IGPM,hess)
c
	               WADD = -D3 *VM1(1,2)
                   call addm(wadd,MIN(IA,IGPM2),MAX(IA,IGPM2),hess)
                   call addm(wadd,MIN(IA2,IGPM),MAX(IA2,IGPM),hess)
c
	              WADD = D5 *VM1(1,2)
                  call addm(wadd,MIN(IGPM,IGPM2),MAX(IGPM,IGPM2),hess)
c
	               WADD = -D3 *VM1(2,2)
                   call addm(wadd,MIN(IA2,IGPM2),MAX(IA2,IGPM2),hess)
c
	               WADD = D5 *VM1(2,2)
                   call addm(wadd,IGPM2,IGPM2,hess)
c
                   IF (IP.GT.0) THEN
		      WADD = D4 *VM1(1,1)
C                corresponds to same group of unknown parents for sire and maternal grand sire 
                     IF (IP.EQ.IGPM) WADD = 2.D0 * WADD
                     call addm(wadd,MIN(IP,IGPM),MAX(IP,IGPM),hess)
c
		      WADD = D4 *VM1(1,2)
                     IF (IP.EQ.IGPM2) WADD = 2.D0 * WADD
c                VM1(1,2) = VM1(2,1)
                     call addm(wadd,MIN(IP,IGPM2),MAX(IP,IGPM2),hess)
                     call addm(wadd,MIN(IP2,IGPM),MAX(IP2,IGPM),hess)
c
		            WADD = D4 *VM1(2,2)
                    IF (IP2.EQ.IGPM2) WADD = 2.D0 * WADD
                    call addm(wadd,MIN(IP2,IGPM2),MIN(IP2,IGPM2),hess)
                   ENDIF
                 ENDIF
c
               IF (IGMM.GT.0) THEN 				
                  GRADF(IGMM) = GRADF(IGMM) - 0.25D0 * Y
                  GRADF(IGMM2) = GRADF(IGMM2) - 0.25D0 * Y2
		          WADD = -D3 *VM1(1,1)
                  call addm(wadd,MIN(IA,IGMM),MAX(IA,IGMM),hess)
c
		          WADD = D5 *VM1(1,1)
                  call addm(wadd,IGMM,IGMM,hess)
c
		          WADD = -D3 *VM1(1,2)
                  call addm(wadd,MIN(IA,IGMM2),MAX(IA,IGMM2),hess)
                  call addm(wadd,MIN(IA2,IGMM),MAX(IA2,IGMM),hess)
c
		          WADD = D5 *VM1(1,2)
                  call addm(wadd,MIN(IGMM,IGMM2),MAX(IGMM,IGMM2),hess)
c
		          WADD = -D3 *VM1(2,2)
                  call addm(wadd,MIN(IA2,IGMM2),MAX(IA2,IGMM2),hess)
c
		          WADD = D5 *VM1(2,2)
                  call addm(wadd,IGMM2,IGMM2,hess)
c
                   IF (IP.GT.0) THEN
		             WADD = D4 *VM1(1,1)
C                  corresponds to same group of unknown parents for sire and meaternal grand dam
                    IF (IP.EQ.IGMM) WADD = 2.D0 * WADD
                    call addm(wadd,MIN(IP,IGMM),MAX(IP,IGMM),hess)
c
		            WADD = D4 *VM1(1,2)
c                  VM1(1,2) = VM1(2,1)
                    IF (IP.EQ.IGMM2) WADD = 2.D0 * WADD
                    call addm(wadd,MIN(IP,IGMM2),MAX(IP,IGMM2),hess)
                    call addm(wadd,MIN(IP2,IGMM),MAX(IP2,IGMM),hess)
c
		            WADD = D4 *VM1(2,2)
                    IF (IP2.EQ.IGMM2) WADD = 2.D0 * WADD
                    call addm(wadd,MIN(IP2,IGMM2),MIN(IP2,IGMM2),hess)
                   ENDIF
c
                  IF (IGPM.GT.0) THEN
		           WADD = D5 *VM1(1,1)
C corresponds to same group of unknown parents for maternal grand sire and grand dam
                   IF (IGPM.EQ.IGMM) WADD = 2.D0 * WADD
                   call addm(wadd,MIN(IGPM,IGMM),MAX(IGPM,IGMM),hess)
c
		           WADD = D5 *VM1(1,2)
c                VM1(1,2) = VM1(2,1)
                   IF (IGPM.EQ.IGMM2) WADD = 2.D0 * WADD
                   call addm(wadd,MIN(IGPM,IGMM2),MAX(IGPM,IGMM2),hess)
                   call addm(wadd,MIN(IGPM2,IGMM),MAX(IGPM2,IGMM),hess)
c
		           WADD = D5 *VM1(2,2)
                   IF (IGPM2.EQ.IGMM2) WADD = 2.D0 * WADD
                call addm(wadd,MIN(IGPM2,IGMM2),MIN(IGPM2,IGMM2),hess)
                  ENDIF
                 ENDIF
  430          CONTINUE 
               DO 432 K=INOR(I,2),INOR(I,3)
                 K2=K+IDEL
                 F = F + 0.5 * (BETA1(K)*GRADF(K)+BETA1(K2)*GRADF(K2))
  432          CONTINUE
             ENDIF
           ENDIF

!!!! correlated random effects - end
         endif
!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       ENDIF
  300   CONTINUE
      ENDIF
C-----------------------------------------------------------------------
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IF (nstor.ne.1) THEN
        IF (IOMODE.NE.4) THEN
           OPEN(4,file=FILE(9),FORM='UNFORMATTED')
c       ELSE
c          FILENAM=FILE(9)
c          CALL f77openr(IDFILE,FILENAMC)
c          IERR=1
        ENDIF
      ENDIF
C
C-----------------------------------------------------------------------
C   FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
      IQ = 0
      LAST = -1
      LASTOM = -1
      IPRETIM = 0
      DLPRETIM = 0.D0
      OMEG=0.D0
      TPRERHO = 0.D0
  100 IF (NSTOR.NE.1) THEN
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on December 12, 1996
cc##################################################
        IF (IOMODE.NE.4) THEN
           DO 766 I=1,NRECMAX
             DO 766 J=1,INTE_ST1
                blockb%info(I,J)=0
  766      CONTINUE
           do i=1,nrecmax
              do j=1,mxef_used
               blockb%idata(i,j)=0
               blockb%xdata(i,j)=0.d0
              end do
           end do
       READ(4,END=199) NREC,LTAB,
     + ((blockb%info(i,j),i=1,nrecmax),j=1,inte_st1),
     + ((blockb%idata(i,j),i=1,nrecmax),j=1,mxef_used),
     + ((blockb%xdata(i,j),i=1,nrecmax),j=1,mxef_used)
c       ELSE
c IOMODE = 4 <==> compressed
c         DO 767 I=1,NRECMAX
c            DO 767 J=1,INTE_ST1
c               blockb%info(I,J)=0
c 767     CONTINUE
c         CALL f77cread(idfile,nrec,ltab,krec,ierr)
c         IF (IERR.EQ.0) GOTO 199
        ENDIF
      ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added or modified on December 10, 1996
C  IF KEYWORD 'WITHIN' WAS USED WITH 'INTEGRATE_OUT', THIS PART
C  LOOKS AT THE TABLE OF RECORDS AND DETERMINES THE ORDER SUITABLE
C  FOR THE INTEGRATION: eg: year-season WITHIN herd. THIS ORDER IS
C  STORED IN blockb%info(*,KCOLINT) AND blockb%info(*,KCOLWITH) IS UPDATED
C  SO blockb%info(*,KCOLWITH) CORRESPONDING
C  TO DIFFERENT 'herds' ARE DIFFERENT. IT IS ASSUMED THAT THERE ARE
C  LESS THAN MAXYS 'year-seasons' per 'herd'.
      NCOND = NINTTDEP + NWITHIN + ITDEPSTR
      IF (NWITHIN.NE.0) THEN
        IF (blockb%info(1,KCOLINT).GT.MAXYS) GOTO 909
        NH = MAXYS
        IDHERD = blockb%info(1,KCOLWITH)
        JJ = blockb%info(1,KCOLINT)
        KFIRST(JJ) = 1
        KLAST(JJ) = 1
        NLISTYS= 1
        LISTYS(1)= JJ
        blockb%info(1,KCOLINT)= NH +  JJ
        DO 900 I=2, NREC
           IF (blockb%info(I,KCOLWITH).NE.IDHERD) THEN
              DO 910 I1 = 1,NLISTYS-1
                 JJ = LISTYS(I1)
                 KK = LISTYS(I1+1)
                 blockb%info(KLAST(JJ),KCOLWITH) = KFIRST(KK)
                 KFIRST(KK) = 0
                 KLAST(JJ) = 0
  910         CONTINUE
              NH = NH + MAXYS
              IDHERD = blockb%info(I,KCOLWITH)
              KK = LISTYS(NLISTYS)
              blockb%info(KLAST(KK),KCOLWITH)= I
              KLAST(KK) = 0
              NLISTYS= 0
           ENDIF
           JJ = blockb%info(I,KCOLINT)
           blockb%info(I,KCOLINT)= NH + JJ
           K = KLAST(JJ)
           IF (K.NE.0) THEN
              blockb%info(K,KCOLWITH) = I
           ELSE
              NLISTYS= NLISTYS + 1
              LISTYS(NLISTYS)= JJ
              KFIRST(JJ)= I
           ENDIF
           KLAST(JJ)= I
 900    CONTINUE
        DO 930 I1 = 1,NLISTYS-1
          JJ = LISTYS(I1)
          KK = LISTYS(I1+1)
          blockb%info(KLAST(JJ),KCOLWITH) = KFIRST(KK)
          KLAST(JJ) = 0
  930   CONTINUE
        KK = LISTYS(NLISTYS)
        blockb%info(KLAST(KK),KCOLWITH) = 0 
        KLAST(KK) = 0
      ENDIF
C
C
 909  I=1
      DO 190 I1=1,NREC
        N1=N1+1
        IF (NWITHIN.EQ.0) THEN
          I=I1
        ELSE IF (I1.NE.1) THEN
c         I = blockb%info(I,INTE_ST-1)
          I = blockb%info(I,KCOLWITH)
        ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        IVALQ = blockb%info(I,KCOLINT)
C <<<<<<<<<<<<<<<<<<<<<<
C added October 16, 1996, modified (NCOND) December 10, 1996
        ICODE = blockb%info(I,2)
        IF (NCOND.NE.0.AND.ICODE.EQ.-2) THEN
           GOTO 190
        ENDIF
C <<<<<<<<<<<<<<<<<<<<<<
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD WAS THE LAST RECORD WITH IVALQ = IQ
C   UPDATE F (WEIBULL LIKELIHOOD) AND GRADF (ITS GRADIENT)
C   NQ IS THE NUMBER OF OBSERVED FAILURES WITH IVALQ = IQ
c
c IF INTEGAM=0 ==> THERE IS NO INTEGRATION OF ANY RANDOM (LOGGAMMA) EFFECT
c             ==> = REGULAR WEIBULL MODEL and LIKELIHOOD
c IF INTEGAM >0 ==> the fixed effect indicated by IVALQ is integrated out
c          assuming a gamma distribution
C-----------------------------------------------------------------------
         IF (IQ.NE.0.AND.IVALQ.NE.IQ.AND.INTEGAM.NE.0) THEN
         IF (IQ.GT.0) THEN
           GAM0= GAMVAR
           XNS=XNS+1.D0
         ELSE
           GAM0=XINCLU
           XNSFIX=XNSFIX+1.D0
         ENDIF
         XNQGAM = XNQ + GAM0
         OMQGAM = OMEG + GAM0
         R1GAM = XNQGAM / OMQGAM
         R2GAM = R1GAM / OMQGAM
         F = F - GAMLOG(XNQGAM) + XNQGAM * DLOG(OMQGAM)
         IF (NJOINT.EQ.1.AND.IQ.GT.0) THEN
            R3GAM = (XNQ - OMEG) / (OMQGAM*OMQGAM)
            GRADF(NDIM1) = GRADF(NDIM1)
     +            - DIGAMA(XNQGAM) + DLOG(OMQGAM)+ R1GAM
            WADD=  - TRIGAM(XNQGAM)
     +           + (GAM0 + 2.D0*OMEG - XNQ)/(OMQGAM*OMQGAM)
            WADD = GAMVAR * GAMVAR * WADD
            call addm(wadd,NDIM1,NDIM1,hess)
         ENDIF

c
         LAST1=LAST
   16    LAST2=LAST1
         IF (NJOINT.EQ.1.AND.IQ.GT.0) THEN
           WADD = -R3GAM * GAMVAR * DOMEG(LAST1)
           call addm(wadd,last1,NDIM1,hess)
         ENDIF
   15    J1 = MIN(LAST1,LAST2)
         J2 = MAX(LAST1,LAST2)
	 WADD = - R2GAM * DOMEG(LAST1) * DOMEG(LAST2)
         call addm(wadd,j1,j2,hess)
c
         LAST2 = POINT(LAST2)
         IP = IP+1
         IF (LAST2.GT.0) THEN
            GOTO 15
         ELSE
           LAST1 = POINT(LAST1)
           IF (LAST1.GT.0) GOTO 16
         ENDIF
c
   18    J1 = MIN(YLIST(1,LASTOM),YLIST(2,LASTOM))
         J2 = MAX(YLIST(1,LASTOM),YLIST(2,LASTOM))
         WADD = R1GAM * D2OMEG(LASTOM)
         call addm(wadd,j1,j2,hess)

         D2OMEG(LASTOM) = 0.D0
         LAST1 = POINTOM(LASTOM)
         POINTOM(LASTOM) = 0
         LASTOM = LAST1
         IF (LASTOM.GT.0) GOTO 18
c
   20    GRADF(LAST) = GRADF(LAST) + R1GAM * DOMEG(LAST)
         DOMEG(LAST) = 0.D0
         LAST1 = POINT(LAST)
         POINT(LAST) = 0
         LAST = LAST1
         IF (LAST.GT.0) GOTO 20
c
         XNQ = 0.D0
         OMEG = 0.D0
         LAST = -1
         LASTOM = -1
       ENDIF
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD HAS A DIFFERENT STRATUM ID ==> NEW STRATUM
C   INITIALIZE CUM_RISK (CUMULATIVE RISK FOR ALL INDIVIDUALS) AND VECTOR
C   DC_RISK (CUMULATED CONTRIBUTION FOR EACH LEVEL TO BE USED IN
C   COMPUTING GRADF) + D2C_RISK (TO BE USED IN COMPUTING HESSIAN)
C
C  IF NINTTDEP=1  , blockb%info(I,KCOLPRE) CONTAINS PREVIOUS TIME
C-----------------------------------------------------------------------
       ITIM =blockb%info(I,1)
       ICODE = blockb%info(I,2)
       IF (NSTRATA.GT.1) THEN
          ISTR = blockb%info(I,KCOLSTR)
       ELSE
          ISTR=1
       ENDIF
       RHO = VALRHO(ISTR)
       LRHO = DLOGRHO(ISTR)
       IQ = IVALQ
C-----------------------------------------------------------------------
C     W1 = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C     FIRST, NCCOV CONTINUOUS COVARIATES, THEN NDCOV DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => W2 = EXP(W1) WILL BE = 0
C----------------------------------------------------------------------
       K = 0
       W1 = 0.D0
       DO 25 J=1,NCCOV
           XCOV = blockb%xdata(I,J)
           W1 = W1 + BETA1(J) * XCOV
           IF (BETA1(J).LE.-999.D0) W1 = -999.9D0
   25  CONTINUE
       DO 30 J=NDCOV0,NDCOV1
           K = blockb%idata(I,J)
           IF (K.NE.0) THEN
             WADD0=BETA1(K)
             IF (ICOEF(J).EQ.1) WADD0= WADD0 * XCOEF(J)
	     W1 = W1 + WADD0
           ENDIF
   30  CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
c{
c{         JJ= NCOEF(J)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on July 18, 1997
c{         IF (IANAL(JJ).NE.0) THEN
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c{           K = blockb%idata(I,JJ)
c{           IF (K.NE.0) W1=W1 + (XCOEF(JJ) - 1.D0) * BETA1(K)
c{         ENDIF
c{   31  CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       W1 = W1 + BETA1(NDIMB+ISTR)
C
C-----------------------------------------------------------------------
C   DIVERGENCE ==> STOP
C-----------------------------------------------------------------------
       IF (W1.GT.100.D0) THEN
         K = MIN(50,NDIM1)
         IA = NDIM1+1
         IF (K.LT.NDIM1) IA=NDIM1-3
         WRITE(6,*) 'OVERFLOW '
         WRITE(6,*) 'BETA1 =   '
         WRITE(6,32) (J,BETA1(J),J=1,K),(J,BETA1(J),J=IA,NDIM1)
  32     FORMAT(1x,4(I5,G12.5),/1x)
         WRITE(6,*) 'W1    =   ',W1
         STOP
       ENDIF
C
C-----------------------------------------------------------------------
C   COMPUTE W2 = EXP(W1) AND W3 = W2 * (ITIM**RHO - IPRETIM**RHO)
C  IF ICRHO=1  COMPUTE:
C      IF NO_LOG=1    (MAXIMIZATION IS ON RHO):
c    W4 = W2 * (ITIM**RHO * (LOG ITIM) - IPRETIM**RHO * (LOG IPRETIM))
c    W5=[W2*(ITIM**RHO * (LOG ITIM)**2 - IPRETIM**RHO * (LOG IPRETIM)**2)]
C      IF NO_LOG^=1    (MAXIMIZATION IS ON LOG(RHO)):
c    W4 = RHO * W4 ABOVE
C    W5 = W4 + RHO * RHO * W5 ABOVE
C-----------------------------------------------------------------------
       W2 = 0.D0
C
       IF (W1.GT.-80.D0) W2 = DEXP(W1)
       DLTIM = VECLOG(ITIM)
c       DLTIM = DLOG(DBLE(ITIM))
       TRHO = VECEXP(ITIM,ISTR)
c       TRHO = DEXP(RHO*DLTIM)
C <<<<<<<<<<<<<<<<<<<<<<
C added October 16, 1996, modified (NCOND) December 10, 1996
      IF (ICODE.EQ.-2) THEN
         IPRETIM= ITIM
         DLPRETIM = DLTIM
         TPRERHO = TRHO
         GOTO 190
      ENDIF
      IF (NCOND.NE.0) THEN
C <<<<<<<<<<<<<<<<<<<<<<
       IF (NINTTDEP.NE.0.OR.ITDEPSTR.NE.0) THEN
C
C BECAUSE THE ORDERING OF THE RECORDS DOES NOT PERMIT TO KEEP OLD
C VALUES OF DLTIM AND TRHO , THEY HAVE TO BE RECALCULATED
C
         IPRETIM= blockb%info(I,KCOLPRE)
         IF (IPRETIM.EQ.0) THEN
            DLPRETIM=0
            TPRERHO=0
         ELSE
	    DLPRETIM=VECLOG(IPRETIM)
c             DLPRETIM=DLOG(DBLE(IPRETIM))
            TPRERHO=VECEXP(IPRETIM,ISTR)
c             TPRERHO=DEXP(RHO*DLPRETIM)
         ENDIF
C <==> NWITHIN <> 0
C <<<<<<<<<<<<<<<<<<<<<<
C added February 27 1997
        ELSE IF (NWITHIN.NE.0) THEN
C <<<<<<<<<<<<<<<<<<<<<<
C added December 10, 1996
          IF (I.EQ.1) THEN
C <<<<<<<<<<<<<<<<<<<<<<
C added February 27 1997
            IPRETIM=0
            DLPRETIM=0.D0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).GE.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO ANOTHER ANIMAL
            IPRETIM=0
            DLPRETIM=0.D0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).LT.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO THE SAME ANIMAL
            IPRETIM= blockb%info(I-1,1)
            DLPRETIM=VECLOG(IPRETIM)
            TPRERHO=VECEXP(IPRETIM,ISTR)
          ENDIF
C <<<<<<<<<<<<<<<<<<<<<<
         ENDIF
       ENDIF
C
       W3 = W2 * (TRHO - TPRERHO)
c
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       IF (ICRHO.EQ.99.AND.ICODE.GT.0) GOTO 7878
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       OMEG = OMEG + W3
c
       DO 55 J=1,NCCOV
         XCOV = blockb%xdata(I,J)
         IF (POINT(J).EQ.0) THEN
           POINT(J) = LAST
           LAST = J
         ENDIF
         DOMEG(J) = DOMEG(J) +  W3 * XCOV
         DO 58 J2=J,NCCOV
           XCOV2 = blockb%xdata(I,J2)
           LEVCOD(1)=J
           LEVCOD(2) = J2
           INDJ=IDMURM(LEVCOD,ITOPL(J),LASTIL,NEW)
           IF (NEW.EQ.1) THEN
             D2OMEG(INDJ)= XCOV * XCOV2 * W3
           ELSE
             D2OMEG(INDJ) = D2OMEG(INDJ) +  XCOV * XCOV2 * W3
           ENDIF
           IF (POINTOM(INDJ).EQ.0) THEN
             POINTOM(INDJ) = LASTOM
             LASTOM = INDJ
             if (LASTOM.gt.(NZE_HESS-5)) then
       print*,'The maximal number of nonzero elements'
       print*,' in the Hessian matrix too small!'
       print*,'Increase NZE_HESS in the parameter file!'
       stop
             endif
           ENDIF
   58    CONTINUE
         DO 60 J2=NDCOV0,NDCOVP1
           IF (J2.LE.NDCOV1) THEN
             K2 = blockb%idata(I,J2)
             IF (K2.EQ.0) GOTO 60
           ELSE
             K2 = NDIMB+ISTR
           ENDIF
           LEVCOD(2) = K2
           INDJ=IDMURM(LEVCOD,ITOPL(J),LASTIL,NEW)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
           WADD1= XCOV * W3
           IF (ICOEF(J2).EQ.1) WADD1= WADD1 * XCOEF(J2)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
           IF (NEW.EQ.1) THEN
             D2OMEG(INDJ)= WADD1
           ELSE
             D2OMEG(INDJ) = D2OMEG(INDJ) + WADD1
           ENDIF
           IF (POINTOM(INDJ).EQ.0) THEN
             POINTOM(INDJ) = LASTOM
             LASTOM = INDJ
             if (LASTOM.gt.(NZE_HESS-5)) then
       print*,'The maximal number of nonzero elements'
       print*,' in the Hessian matrix too small!'
       print*,'Increase NZE_HESS in the parameter file!'
       stop
             endif
           ENDIF
   60    CONTINUE
   55  CONTINUE
       DO 70 J=NDCOV0,NDCOVP1
         IF (J.LE.NDCOV1) THEN
           K = blockb%idata(I,J)
           IF (K.EQ.0) GOTO 70
         ELSE
           K = NDIMB+ISTR
         ENDIF
         IF (POINT(K).EQ.0) THEN
           POINT(K) = LAST
           LAST = K
         ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
         WADD1= W3
         IF (ICOEF(J).EQ.1) WADD1= WADD1 * XCOEF(J)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         DOMEG(K) = DOMEG(K) +  WADD1
         DO 65 J2=J,NDCOVP1
           IF (J2.LE.NDCOV1) THEN
             K2 = blockb%idata(I,J2)
             IF (K2.EQ.0) GOTO 65
           ELSE
             K2 = NDIMB+ISTR
           ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
           WADD2= WADD1
           IF (ICOEF(J2).EQ.1) WADD2= WADD2 * XCOEF(J2)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
           LEVCOD(1) = MIN(K,K2)
           LEVCOD(2) = MAX(K,K2)
           INDJ=IDMURM(LEVCOD,ITOPL(MIN(K,K2)),LASTIL,NEW)
           IF (NEW.EQ.1) THEN
             D2OMEG(INDJ)= WADD2
           ELSE
             D2OMEG(INDJ) = D2OMEG(INDJ) + WADD2
           ENDIF
           IF (POINTOM(INDJ).EQ.0) THEN
             POINTOM(INDJ) = LASTOM
             LASTOM = INDJ
             if (LASTOM.gt.(NZE_HESS-5)) then
       print*,'The maximal number of nonzero elements'
       print*,' in the Hessian matrix too small!'
       print*,'Increase NZE_HESS in the parameter file!'
       stop
             endif
           ENDIF
   65    CONTINUE
   70  CONTINUE
c
C-----------------------------------------------------------------------
c elements in first and 2nd derivatives with respect to rho's
C-----------------------------------------------------------------------
c
       IF (ICRHO.EQ.1) THEN
          W4 = W2 * (TRHO * DLTIM - TPRERHO * DLPRETIM)
          IF (NO_LOG.NE.1) W4 = RHO * W4
          K = NDIMBPS + ISTR
          IF (POINT(K).EQ.0) THEN
            POINT(K) = LAST
            LAST = K
          ENDIF
          DOMEG(K) = DOMEG(K) + W4
          W5 =  W2 * (TRHO *DLTIM *DLTIM -
     +                             TPRERHO *DLPRETIM *DLPRETIM)
          IF (NO_LOG.NE.1) W5 = W4 + RHO * RHO * W5
c
          LEVCOD(1) = K
          LEVCOD(2) = K
          INDJ=IDMURM(LEVCOD,ITOPL(K),LASTIL,NEW)
          IF (NEW.EQ.1) THEN
            D2OMEG(INDJ)= W5
          ELSE
            D2OMEG(INDJ) = D2OMEG(INDJ) + W5
          ENDIF
          IF (POINTOM(INDJ).EQ.0) THEN
            POINTOM(INDJ) = LASTOM
            LASTOM = INDJ
             if (LASTOM.gt.(NZE_HESS-5)) then
       print*,'The maximal number of nonzero elements'
       print*,' in the Hessian matrix too small!'
       print*,'Increase NZE_HESS in the parameter file!'
       stop
             endif
          ENDIF
          DO 85 J2=1,NCCOV
           XCOV2 = blockb%xdata(I,J2)
           LEVCOD(1) = J2
           INDJ=IDMURM(LEVCOD,ITOPL(J2),LASTIL,NEW)
           IF (NEW.EQ.1) THEN
             D2OMEG(INDJ)= XCOV2 * W4
           ELSE
             D2OMEG(INDJ) = D2OMEG(INDJ) + XCOV2 *   W4
           ENDIF
           IF (POINTOM(INDJ).EQ.0) THEN
             POINTOM(INDJ) = LASTOM
             LASTOM = INDJ
             if (LASTOM.gt.(NZE_HESS-5)) then
       print*,'The maximal number of nonzero elements'
       print*,' in the Hessian matrix too small!'
       print*,'Increase NZE_HESS in the parameter file!'
       stop
             endif
           ENDIF
   85    CONTINUE
         DO 90 J2=NDCOV0,NDCOVP1
           IF (J2.LE.NDCOV1) THEN
             K2 = blockb%idata(I,J2)
             IF (K2.EQ.0) GOTO 90
           ELSE
             K2 = NDIMB+ISTR
           ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
           WADD2= W4
           IF (ICOEF(J2).EQ.1) WADD2= WADD2 * XCOEF(J2)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
           LEVCOD(1) = K2
           INDJ=IDMURM(LEVCOD,ITOPL(K2),LASTIL,NEW)
           IF (NEW.EQ.1) THEN
             D2OMEG(INDJ)=  WADD2
           ELSE
             D2OMEG(INDJ) = D2OMEG(INDJ) +  WADD2
           ENDIF
           IF (POINTOM(INDJ).EQ.0) THEN
             POINTOM(INDJ) = LASTOM
             LASTOM = INDJ
             if (LASTOM.gt.(NZE_HESS-5)) then
       print*,'The maximal number of nonzero elements'
       print*,' in the Hessian matrix too small!'
       print*,'Increase NZE_HESS in the parameter file!'
       stop
             endif
           ENDIF
   90    CONTINUE
       ENDIF
C
C-----------------------------------------------------------------------
C   IF UNCENSORED RECORD, UPDATE F AND GRADF
C-----------------------------------------------------------------------
 7878  K = 0
       IF (ICODE.GE.1) THEN
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         XNQ = XNQ + 1.D0
	 IF (ICRHO.EQ.99) THEN
           W6= DEXP(- W2)
           W7= 1.D0 - W6
	   F = F - DLOG(W7)
           W7= DEXP(W1-W2)/W7
	 ELSE
           F = F - LRHO - (RHO - 1.D0) * DLTIM - W1
         ENDIF
         DO 75 J=1,NCCOV
             IF (ICRHO.EQ.99) THEN
                GRADF(J) = GRADF(J) - blockb%xdata(I,J) * W7
                DO 76 J1=J,NCCOV
                  WADD = (1.D0 - W2 - W7) * blockb%xdata(I,J1)
	          WADD = - blockb%xdata(I,J) * W7 * WADD
                  call addm(wadd,j,j1,hess)
   76           CONTINUE
                DO 77 J1= NDCOV0,NDCOVP1
                  IF (J1.LE.NDCOV1) THEN
                      K = blockb%idata(I,J1)
                      IF (K.EQ.0) GOTO 77
                   ELSE
                      K = NDIMB+ISTR
                   ENDIF
	           IF (K.GT.0) THEN
                      WADD = 1.D0 - W2 - W7
	              WADD = - blockb%xdata(I,J) * W7 * WADD
                      IF (ICOEF(J1).EQ.1) WADD = WADD * XCOEF(J1)
                      call addm(wadd,j,k,hess)
                   ENDIF
   77           CONTINUE
             ELSE
                GRADF(J) = GRADF(J) - blockb%xdata(I,J)
             ENDIF
   75    CONTINUE
c
         DO 80 J= NDCOV0,NDCOVP1
           IF (J.LE.NDCOV1) THEN
             K = blockb%idata(I,J)
             IF (K.EQ.0) GOTO 80
           ELSE
             K = NDIMB+ISTR
           ENDIF
	   IF (K.GT.0) THEN
             IF (ICRHO.EQ.99) THEN
               WADD0 = W7
               WADD = 1.D0 - W2 - W7
	       WADD = - W7 * WADD
               IF (ICOEF(J).EQ.1) THEN
                 WADD0 = WADD0 * XCOEF(J)
                 WADD = WADD * XCOEF(J)
               ENDIF
               GRADF(K) = GRADF(K) - WADD0
C
               DO 81 J1= J,NDCOVP1
                  IF (J1.LE.NDCOV1) THEN
                     K1 = blockb%idata(I,J1)
                     IF (K1.EQ.0) GOTO 81
                  ELSE
                     K1 = NDIMB+ISTR
                  ENDIF
	           IF (K1.GT.0) THEN
                     WADD1=WADD
                     IF (ICOEF(J1).EQ.1) WADD1 = WADD1 * XCOEF(J1)
                     M1=MIN(K,K1)
                     M2=MAX(K,K1)
                     call addm(wadd1,m1,m2,hess)
                   ENDIF
  81            CONTINUE
             ELSE
               WADD0 = 1.D0
               IF (ICOEF(J).EQ.1) WADD0 = WADD0 * XCOEF(J)
               GRADF(K) = GRADF(K) - WADD0
             ENDIF
           ENDIF
   80    CONTINUE
         IF (ICRHO.EQ.1) THEN
           K = NDIMBPS + ISTR
           IF (NO_LOG.EQ.1) THEN
             GRADF(K) = GRADF(K) - (1.D0/RHO)  - DLTIM
             WADD = 1.D0/(RHO*RHO)
           ELSE
             GRADF(K) = GRADF(K) - 1.D0 - RHO * DLTIM
	     WADD = - RHO * DLTIM
           ENDIF
c
           call addm(wadd,k,k,hess)
         ENDIF
       ENDIF
  189  IF (NCOND.EQ.0) THEN
         IF (ICODE.GE.0) THEN
           IPRETIM = 0
           TPRERHO = 0.D0
           DLPRETIM = 0.D0
         ELSE
           IPRETIM = ITIM
           TPRERHO = TRHO
           DLPRETIM = DLTIM
         ENDIF
       ENDIF
C
  190 CONTINUE
      IF (NSTOR.NE.1) GOTO 100
  199 IF (NSTOR.NE.1) THEN
         IF (IOMODE.NE.4) THEN
           CLOSE(4)
c        ELSE
c          call f77close(idfile)
         ENDIF
      ENDIF
C
C-----------------------------------------------------------------------
C   LAST CONTRIBUTION TO F AND GRADF
C-----------------------------------------------------------------------
      IF (INTEGAM.EQ.0) THEN
C-----------------------------------------------------------------------
C   REGULAR WEIBULL MODEL
C-----------------------------------------------------------------------
         F = F + OMEG
         R1GAM = 1.D0
      ELSE
C-----------------------------------------------------------------------
C   WEIBULL MODEL WITH INTEGRATION OF A FRAILTY TERM
C-----------------------------------------------------------------------
        IF (IQ.GT.0) THEN
          GAM0= GAMVAR
          XNS=XNS+1.D0
        ELSE
          GAM0=XINCLU
          XNSFIX=XNSFIX+1.D0
        ENDIF
        XNQGAM = XNQ + GAM0
        OMQGAM = OMEG + GAM0
        R1GAM = XNQGAM / OMQGAM
        R2GAM = R1GAM / OMQGAM
C derivative with respect to GAMVAR
        F = F - XNS * (GAMVAR * DLOG(GAMVAR) - GAMLOG(GAMVAR))
        F = F -GAMLOG(XNQGAM) + XNQGAM * DLOG(OMQGAM)
        IF (NJOINT.EQ.1.AND.IQ.GT.0)  THEN
          R3GAM = (XNQ - OMEG) / (OMQGAM*OMQGAM)
          GRADF(NDIM1) = GRADF(NDIM1)
     +         - DIGAMA(XNQGAM) + DLOG(OMQGAM)+ R1GAM
          WADD= - TRIGAM(XNQGAM)
     +         + (GAMVAR + 2.D0*OMEG - XNQ)/(OMQGAM*OMQGAM)
          WADD = GAMVAR * GAMVAR * WADD
          call addm(wadd,NDIM1,NDIM1,hess)
        ENDIF
        IF (NJOINT.EQ.1)  THEN
          GRADF(NDIM1) = GRADF(NDIM1)
     +         - XNS * (1.D0 + DLOG(GAMVAR) - DIGAMA(GAMVAR))
          WADD= - XNS * (1.D0/GAMVAR - TRIGAM(GAMVAR))
          WADD = GAMVAR * (GAMVAR *  WADD + GRADF(NDIM1))
c          CALL SBSIJ(NDIM1,NZE_HESS,IAV,JAV,HESS,IWO,NDIM1,NDIM1,WADD,
c     +		      	        MODE,LEV,IOUT,IR)
          call addm(wadd,NDIM1,NDIM1,hess)
          GRADF(NDIM1) = GAMVAR * GRADF(NDIM1)
        ENDIF
c
        LAST1=LAST
  214   LAST2=LAST1
        IF (NJOINT.EQ.1.AND.IQ.GT.0) THEN
           WADD = -R3GAM * GAMVAR * DOMEG(LAST1)
          call addm(wadd,last1,NDIM1,hess)
        ENDIF
c
  215   J1 = MIN(LAST1,LAST2)
        J2 = MAX(LAST1,LAST2)
	    WADD = - R2GAM * DOMEG(LAST1) * DOMEG(LAST2)
        call addm(wadd,j1,j2,hess)
c
        LAST2 = POINT(LAST2)
        IF (LAST2.GT.0) THEN
          GOTO 215
        ELSE
          LAST1 = POINT(LAST1)
          IF (LAST1.GT.0) GOTO 214
        ENDIF
      ENDIF
c
  218 IF (INTEGAM.EQ.0) THEN
        WADD = D2OMEG(LASTOM)
      ELSE
        WADD = R1GAM * D2OMEG(LASTOM)
      ENDIF
      J1 = MIN(YLIST(1,LASTOM),YLIST(2,LASTOM))
      J2 = MAX(YLIST(1,LASTOM),YLIST(2,LASTOM))
      call addm(wadd,j1,j2,hess)
      D2OMEG(LASTOM) = 0.D0
      LAST1 = POINTOM(LASTOM)
      POINTOM(LASTOM) = 0
      LASTOM = LAST1
      if (LASTOM.gt.(NZE_HESS-5)) then
         print*,'The maximal number of nonzero elements'
         print*,' in the Hessian matrix too small!'
         print*,'Increase NZE_HESS in the parameter file!'
         stop
      endif
      IF (LASTOM.GT.0) GOTO 218
c
  220 X = DOMEG(LAST)
      GRADF(LAST) = GRADF(LAST) + R1GAM * X
      DOMEG(LAST) = 0.D0
      LAST1 = POINT(LAST)
      POINT(LAST) = 0
      LAST = LAST1
      IF (LAST.GT.0) GOTO 220
c
      XNQ = 0.D0
      OMEG = 0.D0
      LAST = -1
      LASTOM = -1

C
C----------------------------------------------------------------------
C   CONSTRAINTS ON GRADF AND HESSIAN
C----------------------------------------------------------------------
c             call printm(hess)
c           print*,'****'
       IF (ICHECK.NE.1) THEN
        WADD = 0.D0
        DO 210 I = 1,ICONS(0)
          GRADF(ICONS(I)) = 0.D0
          DO 209 J=1,NDIM1
            J1 = MIN(J,ICONS(I))
            J2 = MAX(J,ICONS(I))
            call setm(wadd,j1,j2,hess)
  209     CONTINUE
  210   CONTINUE
      IDF=0
      DO 260 J=1,NDIM1
        IF (GRADF(J).NE.0.D0) IDF = IDF + 1
  260 CONTINUE

      ENDIF
C----------------------------------------------------------------------
C   END OF THE CONSTRUCTION OF THE HESSIAN
C----------------------------------------------------------------------

	  TIM1=SECOND()
	  TIM0 = TIM1 - TIM0
c  WRITE(6,*) 'TIME TO COMPUTE FWEIB2 = ',TIM0
	  TIM0 = TIM1
c           do i=1,NDIM1
c          do j=i,NDIM1
c            X=getm(i,j,hess)
c          if (x.ne.0.d0) print*,'hess0s',i,j,x     
c            enddo
c            enddo

c	  CALL SBEND(NDIM1,NZE_HESS,IAV,JAV,HESS,IWO)
c
C----------------------------------------------------------------------
C  solve if noption=10 
C----------------------------------------------------------------------
          if (NZE_HESS.lt.(NDIM+hess%filled+5)) then
             print*,'Maximal number of nonzero elements too low.'
             print*,'Increase NZE_HESS in the parameter file.'
             stop
          endif			 
          if (noption.eq.10) then
c             print *,'NDIM1,NZE_HESS,hess%filled='
c     +                                      ,ndim1,NZE_HESS,hess%filled
             call init(hess_str)
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>            
             hess_str=hess
c             call printm(hess_str)
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>            
             p_ic=2
             call reset(hess)
c
             cal_icho=.true.
             zerosol=.false.
             call default_iter(decomp=cal_icho,zerosol=zerosol,
     +              p_ic=p_ic)
             call solve_iterm(hess_str,gradf,delta)
             call reset(hess_str)
	     TIM1=SECOND()
	     TIM0 = TIM1 - TIM0
c             if (nze2.eq.NZE_HESS)
c    +         WRITE(6,*) 'TIME TO solve hess_ija*delta=gradf = ',TIM0
  	     TIM0 = TIM1
             return
          endif
c print when debugging (delete the condition NDIM1.lt.-1)
c
      IF (NDIM1.lt.-1) THEN
c      IF (NDIM1.eq.-1) THEN
        print *, 'H='
         hess_ija=hess
      DO 750 J=1,NDIM1
        DO 752 I=hess_ija%IA(J),hess_ija%IA(J+1)-1
           J2=hess_ija%JA(I)
           H(J,J2)=hess_ija%a(I)
           H(J2,J)=H(J,J2)
           print*,'j,j2,h(j,j2) ',j,j2,h(j,j2)
  752   CONTINUE
  750 CONTINUE
       DLDET=0.D0
       IF (I.NE.999) RETURN
      ENDIF
C-----------------------------------------------------------------------
C  NUMERICAL FACTORIZATION USING FSPAK
C-----------------------------------------------------------------------
       call init(hess_ija)
       hess_ija=hess
       call reset(hess)
       IF (NOPTION.LT.0) THEN
C        factorisation already done and stored in fspakf90.ord
          idim=-hess_ija%n
          print*,' reading of fspak90.ord',idim
          call fspak90('factor',hess_ija,rank=idim)
          noption=-noption
       else 
         call fspak90('factor',hess_ija)
c      CALL FSPAK(40,NDIM1,IAV,JAV,HESS,domeg,IFLAG,IOUT,ioor,NZE_HESS,
c    +         NEEDED,IS, j,j,j,j,x,j,JRANK)
	  TIM1=SECOND()
c  TIM0 = TIM1 - TIM0
c  print '('' TIME FOR FACTORIZATION = '',F10.2)',TIM0
	  TIM0 = TIM1
       endif
C
C-----------------------------------------------------------------------
C  IF NOPTION = 1 ==> COMPUTATION OF THE LOG-DETERMINANT
C-----------------------------------------------------------------------
      IF (NOPTION.EQ.1.OR.ICHECK.GT.0) THEN
          call fspak90('ldet',hess_ija,det=dldet)
c         CALL FSPAK(55,NDIM1,iav,jav,hess,STD,IFLAG,IOUT,ioor,NZE_HESS,
c     +         NEEDED,IS, j,j,j,j,x,j,JRANK)
c	  DLDET = STD(1)
	  TIM1=SECOND()
c  TIM0 = TIM1 - TIM0
c print'('' TIME TO COMPUTE LOG-DETERMINANT = '',F10.2)',TIM0
          noption=0
	  TIM0 = TIM1
      ENDIF
C----------------------------------------------------------------------
C  IF NOPTION = 0 ==> COMPUTATION OF THE STANDARD DEVIATIONS
C----------------------------------------------------------------------
      IF (NOPTION.EQ.2.OR.ICHECK.GT.0) THEN
          call fspak90('ldet',hess_ija,det=dldet)
         call fspak90('invert',hess_ija,rank=JRANK)
c        CALL FSPAK(51,NDIM1,iav,jav,hess,std,IFLAG,IOUT,ioor,NZE_HESS,
c     +         NEEDED,IS, i,i,1,1,x,1,JRANK)
c
        DO 550 I=1,NDIM1
c        CALL FSPAK(52,NDIM1,iav,jav,hess,STD(I),IFLAG,IOUT,ioor,NZE_HESS,
c     +         NEEDED,IS, i,i,1,1,1.D0,1,JRANK)
          DO 555 J=hess_ija%ia(I),hess_ija%ia(i+1)-1
            if (i.eq.hess_ija%ja(j)) then
               std(i)=hess_ija%a(j)
               IF (STD(I).GT.1.d-8) THEN
	         STD(I)= DSQRT(STD(I))
               ELSE
	         STD(I)=0.D0
               ENDIF
            ENDIF
  555     CONTINUE
  550   CONTINUE
      ENDIF

      deallocate(kfirst,klast,listys,point,itopl,domeg)
      deallocate(POINTOM,D2OMEG)
	  
C***********************************************************************
      RETURN
      END
!	  
!	  
      SUBROUTINE FWEIB2D(BETA1,F,GRADF,STD,DLDET,IDF,NOPTION,NDIM1)
C***********************************************************************
C  FWEIB2D       *                                    *  23 / 04 /1996 *
C***********************************************************************
C  COMPUTE THE FINAL VALUE OF - WEIB' PARTIAL LIKELIHOOD, ITS VECTOR OF*
C       DERIVATIVES, THE MATRIX OF SECOND DERIVATIVES TO COMPUTE STD=  *
C       VECTOR OF STANDARD ERRORS OF THE ESTIMATES                     *
C  "DENSE VERSION"
C***********************************************************************
      use sparsem
      use sparseop
      use parinclu
	  
      integer,allocatable:: kfirst(:),klast(:),listys(:),point(:)  !all NDIMAX
      real*8,allocatable:: domeg(:),diag2om(:)                     !all NDIMAX

      real*8 gradf(NDIM1),std(NDIM1)  
	  
      INTEGER NDIM1,LAST,LAST1,LAST2
      INTEGER NDCOV0,NDCOV1,NDCOVP1
      INTEGER I,J,K,KK,JJ,J1,K1,J2,K2,M1,M2,ICODE,IPRETIM,ITIM,IQ,IVALQ
      INTEGER IPRESTR,LTAB
      INTEGER IA,IP,IM,IGPM,IGMM,ISTR,JOB
      INTEGER NDIMBPS
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on December 10, 1996
      INTEGER IDHERD,NH,N1,I1,MAXYS,NLISTYS,NCOND
      INTEGER IERR
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on October 20,2003
      CHARACTER*15 FILENAMC
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      INTEGER IDF,NOPTION
C
      REAL TIM0,TIM1,SECOND
C
      REAL*8 GAM0,CONST,XNQGAM,OMQGAM,R1GAM,R2GAM,R3GAM,OMEG
      REAL*8 F,U,W,W1,W2,W3,W4,W5,W6,W7,XNS,XNQ,XCOV,XCOV2,X,DM1(7)
      REAL*8 BETA1(*)
      REAL*8 RHO,TRHO,TPRERHO,LRHO,DLTIM,DLPRETIM
      REAL*8 GAMLOG,XGAINV,DIGAMA,TRIGAM,GAMVAR,XNSFIX
      REAL*8 DLDET,WADD0,WADD,WADD1,WADD2
      CHARACTER*100 FILENAM
      
      integer ncalhes
      type (densem)::hess,d2omeg
      type (sparse_ija):: hess_ija
      type (sparse_ija_strict):: hess_str
      integer:: maxround,p_ic,idim,msglev,maxmem,JRANK
      real*8 ::conv,relax,zer
      
      logical::zerosol,cal_icho,try_again
C
C
      EQUIVALENCE(FILENAM,FILENAMC)

      DATA (DM1(I),I=1,7)/1.D0,1.33333333333333D0,2.D0,
     +  1.D0,1.3333333333D0,1.06666666667D0,1.4545454545455D0/
C
      allocate( kfirst(NDIMAX),klast(NDIMAX),listys(NDIMAX), 
     +   point(NDIMAX),domeg(NDIMAX),diag2om(NDIMAX)) 

C-----------------------------------------------------------------------
C  INITIALIZATION
C-----------------------------------------------------------------------
C
      NCALHES=0
      NDCOV0 = NCCOV + 1
      NDCOV1 = NCCOV + NDCOV
      NDCOVP1 = NDCOV1 + 1
      zer=0.D0
      F = 0.D0
      XNS = 0.D0
      XNQ = 0.D0
      XNSFIX = 0.D0
      NDIMBPS = NDIMB + NSTRATA
      MAXYS=1000
      IPRESTR=0
      IF (INTEGAM.NE.0) THEN
        IF (NJOINT.EQ.0) THEN
          GAMVAR = XGAM(INTEGAM)
        ELSE
          GAMVAR=DEXP(BETA1(NDIM1))
        ENDIF
      ENDIF
c
C-----------------------------------------------------------------------
C INITIALIZING
C-----------------------------------------------------------------------
      if (nze2.eq.0) nze2=NZE_HESS
      call zerom(hess,NDIM1) 
      DO 10 I = 1,NDIM1
        GRADF(I) = 0.D0
        DOMEG(I) = 0.D0
        DIAG2OM(I) = 0.D0
        POINT(I) = 0
   10 CONTINUE
      IF (NOPTION.EQ.-999) RETURN
C
      TIM0=SECOND()
      IPRETIM = 0
C----------------------------------------------------------------------
c<<<<<<<< modified on April 17, 1997 for ICRHO=0 >>>>>>>>>>>>>>>>>>>>>>>
C  READ THE VALUE(S) OF RHO IF ICRHO=1
C----------------------------------------------------------------------
      IF (ICRHO.EQ.1) THEN
        K = NSTRATA
        IF (NO_LOG.EQ.1) THEN
          DO 11 I=1,NSTRATA
            VALRHO(I) = BETA1(NDIMBPS+I)
            DLOGRHO(I) = DLOG(VALRHO(I))
  11      CONTINUE
        ELSE
          DO 12 I=1,NSTRATA
            DLOGRHO(I) = BETA1(NDIMBPS+I)
            VALRHO(I) = DEXP(DLOGRHO(I))
  12      CONTINUE
        ENDIF
      ELSE IF (ICRHO.EQ.99) THEN
	DO 1016 I=1,NSTRATA
          DLOGRHO(I) = 0.D0
          VALRHO(I) =  1.D0
1016    CONTINUE
      ENDIF
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DO 13 I=1,NSTRATA
        VECEXP(1,I) =  1.D0
        DO 14 J=2,MAXTIM(1)
           VECLOG(J) =  DLOG(DBLE(J))
           VECEXP(J,I) =  DEXP(VALRHO(I)*VECLOG(J))
  14    CONTINUE
  13  CONTINUE
C-----------------------------------------------------------------------
C  CONSTRAINT(S)
C-----------------------------------------------------------------------
      IF (ICHECK.EQ.0) THEN
        DO 19 I = 1,ICONS(0)
          BETA1(ICONS(I)) = 0.D0
   19   CONTINUE
      ENDIF
C-----------------------------------------------------------------------
C   RANDOM EFFECTS
C-----------------------------------------------------------------------
c In case of CORRELATED random effects, compute corr form zeta
      if (corrflag) then
        X=exp(zeta)
        corr= (1.d0-2.d0*X)/(1.d0+2.d0*X)
	do i=1,maxrand
          if ((inor(i,1).ge.1).and.(icorr(i,1).eq.i)) then
            detv=(1-corr*corr)*xnor(i)*xnor(icorr(i,2))
            VM1(1,1)= xnor(icorr(i,2))/detv
            VM1(2,2)= xnor(i)/detv
            VM1(1,2)=(-corr*sqrt(xnor(i))*sqrt(xnor(icorr(i,2))))/detv
            VM1(2,1)=VM1(1,2)
            exit
          endif
        enddo	  
      endif
c 
C computations for the RANDOM effect    
      IF (NRAND.NE.0) THEN
       DO 300 I = 1,MAXRAND
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on November 26, 1996
       IF (ISAME(I).NE.0) GOTO 300
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       IF (IGAM(I,1).GE.1.AND.IGAM(I,2).NE.0.AND.I.NE.INTEGAM) THEN
c modfied on Decembre 16 2013
         XGAINV=1.D0/XGAM(I)
c         U = XGAM(I) * DLOG(XGAM(I)) - GAMLOG(XGAM(I))
         U = -XGAINV * DLOG(XGAM(I)) - GAMLOG(XGAINV)
         F = F - (IGAM(I,3) - IGAM(I,2) +1 ) * U
         DO 310 J = IGAM(I,2),IGAM(I,3)
             IF (BETA1(J).LT.-80.D0) THEN
               W=0.D0
             ELSE
               W = DEXP(BETA1(J))
             ENDIF
             F = F  - XGAINV * (BETA1(J) - W)
             GRADF(J) = GRADF(J) - XGAINV * (1.D0 - W)
	     WADD = XGAINV * W
             call addm(wadd,j,j,hess)
  310    CONTINUE
       ELSE IF (INOR(I,1).GE.1) THEN

!!!! uncorrelated random effects - this part remains as it was before
         if (icorr(i,2).eq.0) then
!!!!
           CONST = - 0.5D0 * DLOG(XNOR(I))
           IF (NRELMAT.EQ.0.OR.I.NE.NRELMAT2) THEN
             U = 1.D0 / XNOR(I)
             DO 312 J = INOR(I,2),INOR(I,3)
               W = U * BETA1(J)
               F = F - CONST + 0.5D0 * W * BETA1(J)
               GRADF(J) = GRADF(J) + W
               call addm(U,j,j,hess)
  312        CONTINUE
           ELSE
             U = 1.D0 / XNOR(NRELMAT2)
             IF (NRULE.EQ.1) THEN
             DO 320 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
               IF (IPEDIG(2,K).LT.0) THEN
	          WADD = 0.D0
                  IA=IPEDIG(1,K)
                  DO 324 K2= INOR(I,2),IA
                    call addm(wadd,k2,ia,hess)
  324             CONTINUE
                  GOTO 320
               ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
               F = F - CONST
               IA = IPEDIG(1,K)
               IP = IPEDIG(3,K)
               IM = IPEDIG(4,K)
               X = BETA1(IA)
               IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
               IF (IM.GT.0) X = X - 0.5D0 * BETA1(IM)
               W = U * DM1(IPEDIG(2,K))
               X = W * X
               GRADF(IA) = GRADF(IA) + X
               call addm(W,ia,ia,hess)
c
               IF (IP.GT.0) THEN
                  GRADF(IP) = GRADF(IP) - 0.5D0 * X
c
                  J1 = MIN(IA,IP)
                  J2 = MAX(IA,IP)
	          WADD = -0.5D0 * W
                  call addm(WADD,j1,j2,hess)
     	          WADD = 0.25D0 * W
                  call addm(WADD,ip,ip,hess)
                ENDIF
                IF (IM.GT.0) THEN
	          GRADF(IM) = GRADF(IM) - 0.5D0 * X
            	  J1 = MIN(IA,IM)
                  J2 = MAX(IA,IM)
    	          WADD = -0.5D0 * W
                  call addm(WADD,j1,j2,hess)
                  WADD = 0.25D0 * W
                  call addm(WADD,im,im,hess)
c
                  IF (IP.GT.0) THEN
                    J1 = MIN(IP,IM)
                    J2 = MAX(IP,IM)
		    WADD = 0.25D0 * W

C (corresponds to same group of unknown parents for sire and dam
                  IF (IP.EQ.IM) WADD = 2.D0 * WADD
                    call addm(WADD,j1,j2,hess)
                   ENDIF
                 ENDIF
  320          CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Modified on June 27, 1997
               J=I
               DO 322 K=INOR(I,2),INOR(J,3)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                 F = F + 0.5 * BETA1(K) * GRADF(K)
  322          CONTINUE
c
             ELSE IF (NRULE.EQ.2) THEN
               DO 330 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
c                IF (IPEDIG(2,K).LE.0) GOTO 330
                 F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                 IA = IPEDIG(1,K)
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                 IF (IPEDIG(2,K).LE.0) THEN 
                   IP=0
                   IGPM=0
                   IGMM=0
                 ELSE
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   IP = IPEDIG(3,K)
                   IGPM = IPEDIG(4,K)
                   IF (NCOLPED.EQ.4) THEN
                     IGMM = IPEDIG(NCOLPED+1,K)
                   ELSE
                     IGMM = 0
                   ENDIF
                 ENDIF
                 X = BETA1(IA)
                 IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
                 IF (IGPM.GT.0) X = X - 0.25D0 * BETA1(IGPM)
                 IF (IGMM.GT.0) X = X - 0.25D0 * BETA1(IGMM)
c                 W = U * DM1(IPEDIG(2,K))
                   IF (IPEDIG(2,K).LE.0) THEN
                     W = U
                   ELSE
                     W = U * DM1(IPEDIG(2,K))
                   ENDIF

                 X = W * X
                 GRADF(IA) = GRADF(IA) + X
                 call addm(W,ia,ia,hess)
c
                 IF (IP.GT.0) THEN
                   GRADF(IP) = GRADF(IP) - 0.5D0 * X
c				
	           J1 = MIN(IA,IP)
                   J2 = MAX(IA,IP)
                   WADD = -0.5D0 * W
                   call addm(WADD,j1,j2,hess)
                   WADD = 0.25D0 * W
                   call addm(WADD,ip,ip,hess)
                 ENDIF
                 IF (IGPM.GT.0) THEN 				
                   GRADF(IGPM) = GRADF(IGPM) - 0.25D0 * X
c
     	           J1 = MIN(IA,IGPM)
                   J2 = MAX(IA,IGPM)
	           WADD = -0.25D0 * W
                   call addm(WADD,j1,j2,hess)
     	           WADD = 0.0625D0 * W
                   call addm(WADD,igpm,igpm,hess)
c
                   IF (IP.GT.0) THEN
                     J1 = MIN(IP,IGPM)
                     J2 = MAX(IP,IGPM)
		     WADD = 0.125D0 * W
C (corresponds to same group of unknown parents for sire and maternal grand sire 
                    IF (IP.EQ.IGPM) WADD = 2.D0 * WADD
                     call addm(WADD,j1,j2,hess)
                   ENDIF
c
                 ENDIF
                 IF (IGMM.GT.0) THEN 				
                   GRADF(IGMM) = GRADF(IGMM) - 0.25D0 * X
c
     	           J1 = MIN(IA,IGMM)
                   J2 = MAX(IA,IGMM)
	           WADD = -0.25D0 * W
                   call addm(WADD,j1,j2,hess)
     	           WADD = 0.0625D0 * W
                   call addm(WADD,igmm,igmm,hess)
c
                   IF (IP.GT.0) THEN
                     J1 = MIN(IP,IGMM)
                     J2 = MAX(IP,IGMM)
		     WADD = 0.125D0 * W

C (corresponds to same group of unknown parents for sire and maternal grand dam
                    IF (IP.EQ.IGMM) WADD = 2.D0 * WADD
                     call addm(WADD,j1,j2,hess)
                   ENDIF
c
                   IF (IGPM.GT.0) THEN
                     J1 = MIN(IGPM,IGMM)
                     J2 = MAX(IGPM,IGMM)
		     WADD = 0.0625D0 * W

C (corresponds to same group of unknown parents for maternal grand sire and grand dam
                    IF (IGPM.EQ.IGMM) WADD = 2.D0 * WADD
                     call addm(WADD,j1,j2,hess)
                   ENDIF
c
                 ENDIF
  330          CONTINUE
               DO 332 K=INOR(I,2),INOR(I,3)
                 F = F + 0.5 * BETA1(K) * GRADF(K)
  332          CONTINUE
             ENDIF
           ENDIF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!
!!!! correlated random effects - beginning
         else if (icorr(i,1).gt.0) then
!!!!
             I2=icorr(i,2)
             CONST = -0.5D0 * (DLOG(XNOR(I))+DLOG(XNOR(I2))+
     +                    DLOG(1.d0-corr*corr))
 ! difference between positions of the 2 random effects in the whole list
             IDEL=INOR(I2,2)-INOR(I,2)
! in case of no relationship matrix
           IF (NRELMAT.EQ.0.OR.I.NE.NRELMAT2) THEN
             DO 412 J = INOR(I,2),INOR(I,3)
               J2=J+IDEL
               F = F -CONST+ 0.5D0 * (VM1(1,1)*BETA1(J)*BETA1(J)
     +                     + 2.D0 * VM1(1,2)*BETA1(J)*BETA1(J2)
     +                     + VM1(2,2) * BETA1(J2)*BETA1(J2) )
               GRADF(J) = GRADF(J) + VM1(1,1)*BETA1(J)
     +                             + VM1(1,2)*BETA1(J2)
               GRADF(J2) = GRADF(J2) + VM1(2,1)*BETA1(J)
     +                               + VM1(2,2)*BETA1(J2)
c
               call addm(VM1(1,1),j,j,hess)
               call addm(VM1(1,2),j,j2,hess)
               call addm(VM1(2,2),j2,j2,hess)
 412        CONTINUE


           ELSE
             U = 1.D0 / XNOR(NRELMAT2)
             IF (NRULE.EQ.1) THEN
             DO 420 K=1,NANI
               IF (IPEDIG(2,K).LT.0) THEN
                      WADD = 0.D0
                  IA=IPEDIG(1,K)
                  IA2=IA+IDEL
                  DO 424 K2= INOR(I,2),IA
                    call addm(wadd,k2,ia,hess)
                    call addm(wadd,k2,ia2,hess)
                    call addm(wadd,k2+idel,ia2,hess)
  424             CONTINUE
                  GOTO 420
               ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
               F = F - CONST
               IA = IPEDIG(1,K)
               IP = IPEDIG(3,K)
               IM = IPEDIG(4,K)
               IA2= IA+IDEL
               IP2= IP+IDEL
               IM2= IM+IDEL
               X = BETA1(IA)
               X2= BETA1(IA2)
               IF (IP.GT.0) THEN
                  X = X - 0.5D0 * BETA1(IP)
                  X2= X2 - 0.5D0 * BETA1(IP2)
               ENDIF
               IF (IM.GT.0) THEN
                  X = X - 0.5D0 * BETA1(IM)
                  X2 = X2 - 0.5D0 * BETA1(IM2)
               ENDIF
               D1= DM1(IPEDIG(2,K))
               D2 = 0.5d0* D1
               D3 = 0.25d0* D1
               Y = D1 * (VM1(1,1)*X + VM1(1,2)*X2)
               Y2 = D1 * (VM1(1,2)*X + VM1(2,2)*X2)
               GRADF(IA) = GRADF(IA) + Y
               GRADF(IA2) = GRADF(IA2) + Y2
c
               call addm(D1*VM1(1,1),ia,ia,hess)
               call addm(D1*VM1(1,2),ia,ia2,hess)
               call addm(D1*VM1(2,1),ia2,ia,hess)
               call addm(D1*VM1(2,2),ia2,ia2,hess)
c
               IF (IP.GT.0) THEN
                  GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                  GRADF(IP2) = GRADF(IP2) - 0.5D0 * Y2
                      WADD =  -D2 *VM1(1,1)
                  call addm(wadd,MIN(IA,IP),MAX(IA,IP),hess)

c
                      WADD =  D3 *VM1(1,1)
                  call addm(wadd,ip,ip,hess)
c
                      WADD =  -D2 *VM1(1,2)
                  call addm(wadd,MIN(IA,IP2),MAX(IA,IP2),hess)
                  call addm(wadd,MIN(IA2,IP),MAX(IA2,IP),hess)
c
                      WADD =  D3 *VM1(1,2)
                  call addm(wadd,MIN(IP,IP2),MAX(IP,IP2),hess)
c
                      WADD =  -D2 *VM1(2,2)
                  call addm(wadd,MIN(IA2,IP2),MAX(IA2,IP2),hess)
c
                      WADD =  D3 *VM1(2,2)
                  call addm(wadd,ip2,ip2,hess)
                ENDIF
                IF (IM.GT.0) THEN
                  GRADF(IM) = GRADF(IM) - 0.5D0 * Y
                  GRADF(IM2) = GRADF(IM2) - 0.5D0 * Y2

                      WADD =  -D2 *VM1(1,1)
                  call addm(wadd,MIN(IA,IM),MAX(IA,IM),hess)
c
                      WADD =  D3 *VM1(1,1)
                  call addm(wadd,IM,IM,hess)

c
                      WADD =  -D2 *VM1(1,2)
                  call addm(wadd,MIN(IA,IM2),MAX(IA,IM2),hess)
                  call addm(wadd,MIN(IA2,IM),MAX(IA2,IM),hess)
c
                      WADD =  D3 *VM1(1,2)
                  call addm(wadd,MIN(IM,IM2),MAX(IM,IM2),hess)
c
                      WADD =  -D2 *VM1(2,2)
                  call addm(wadd,MIN(IA2,IM2),MAX(IA2,IM2),hess)
c
                      WADD =  D3 *VM1(2,2)
                  call addm(wadd,IM2,IM2,hess)
c
                  IF (IP.GT.0) THEN

                         WADD =  D3 *VM1(1,1)
C          corresponds to same group of unknown parents for sire and dam
                     IF (IP.EQ.IM) WADD = 2.D0 * WADD
                     call addm(wadd,MIN(IP,IM),MAX(IP,IM),hess)
c
                         WADD =  D3 *VM1(1,2)
C          corresponds to same group of unknown parents for sire and dam
c                  VM1(1,2) = VM1(2,1)
                     IF (IP.EQ.IM2) WADD = 2.D0 * WADD
                      call addm(wadd,MIN(IP,IM2),MAX(IP,IM2),hess)

                         call addm(wadd,MIN(IP2,IM),MAX(IP2,IM),hess)
c
                         WADD =  D3 *VM1(2,2)
                     IF (IP2.EQ.IM2) WADD = 2.D0 * WADD
                     call addm(wadd,MIN(IP2,IM2),MAX(IP2,IM2),hess)
                  ENDIF
                ENDIF
  420        CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Modified on June 27, 1997
               J=I
               DO 422 K=INOR(I,2),INOR(J,3)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                 K2=K+IDEL
                 F = F+0.5* (BETA1(K)*GRADF(K)+BETA1(K2)*GRADF(K2))
  422          CONTINUE
c
             ELSE IF (NRULE.EQ.2) THEN
               DO 430 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
c              IF (IPEDIG(2,K).LE.0) GOTO 430
                 F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                 IA = IPEDIG(1,K)
                 IA2= IA+IDEL
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                 IF (IPEDIG(2,K).LE.0) THEN
                   IP=0
                   IGPM=0
                   IGMM=0
                   IP2=0
                   IGPM2=0
                   IGMM2=0
                 ELSE
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   IP = IPEDIG(3,K)
                   IGPM = IPEDIG(4,K)
                   IP2=IP+IDEL
                   IGPM2=IGPM+IDEL
                   IF (NCOLPED.EQ.4) THEN
                     IGMM = IPEDIG(NCOLPED+1,K)
                     IGMM2 = IGPM+IDEL
                   ELSE
                     IGMM = 0
                     IGMM2 = 0
                   ENDIF
                 ENDIF
                 X = BETA1(IA)
                 X2= BETA1(IA2)
                 IF (IP.GT.0) THEN
                   X = X - 0.5D0 * BETA1(IP)
                   X2 = X2 - 0.5D0 * BETA1(IP2)
                 ENDIF
                 IF (IGPM.GT.0) THEN
                   X = X - 0.25D0 * BETA1(IGPM)
                   X2 = X2 - 0.25D0 * BETA1(IGPM2)
                 ENDIF
                 IF (IGMM.GT.0) THEN
                   X = X - 0.25D0 * BETA1(IGMM)
                   X2 = X2 - 0.25D0 * BETA1(IGMM2)
                 ENDIF
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                 IF (IPEDIG(2,K).LE.0) THEN
                   D1 = 1d0
                   D2 = 0.5d0
                   D3 = 0.25d0
                       D4 = 0.125d0
                       D5 = 0.0625d0
                 ELSE
                   D1 = DM1(IPEDIG(2,K))
                   D2 = 0.5d0* D1
                   D3 = 0.25d0* D1
                       D4 = 0.125d0 *D1
                       D5 = 0.0625d0* D1
                 ENDIF
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                 Y = D1 * (VM1(1,1)*X + VM1(1,2)*X2)
                 Y2 = D1 * (VM1(1,2)*X + VM1(2,2)*X2)
                 GRADF(IA) = GRADF(IA) + Y
                 GRADF(IA2) = GRADF(IA2) + Y2
c
                 call addm(D1*VM1(1,1),ia,ia,hess)
                 call addm(D1*VM1(1,2),ia,ia2,hess)
                 call addm(D1*VM1(2,1),ia2,ia,hess)
                 call addm(D1*VM1(2,2),ia2,ia2,hess)
c
                 IF (IP.GT.0) THEN
                   GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                   GRADF(IP2) = GRADF(IP2) - 0.5D0 * Y2

                       WADD =  -D2 *VM1(1,1)
                   call addm(wadd,MIN(IA,IP),MAX(IA,IP),hess)
c
                       WADD =  D3 *VM1(1,1)
                   call addm(wadd,ip,ip,hess)
c
                       WADD =  -D2 *VM1(1,2)
                   call addm(wadd,MIN(IA,IP2),MAX(IA,IP2),hess)
                   call addm(wadd,MIN(IA2,IP),MAX(IA2,IP),hess)

c
                       WADD =  D3 *VM1(1,2)
                   call addm(wadd,MIN(IP,IP2),MAX(IP,IP2),hess)

c
                       WADD =  -D2 *VM1(2,2)
                   call addm(wadd,MIN(IA2,IP2),MAX(IA2,IP2),hess)
c
                       WADD =  D3 *VM1(2,2)
                   call addm(wadd,ip2,ip2,hess)
                 ENDIF
c
                 IF (IGPM.GT.0) THEN
                  GRADF(IGPM)=GRADF(IGPM) -0.25D0 * Y
                  GRADF(IGPM2)=GRADF(IGPM2) -0.25D0 * Y2

                       WADD = -D3 *VM1(1,1)
                   call addm(wadd,MIN(IA,IGPM),MAX(IA,IGPM),hess)
c
                       WADD = D5 *VM1(1,1)
                   call addm(wadd,IGPM,IGPM,hess)
c
                       WADD = -D3 *VM1(1,2)
                   call addm(wadd,MIN(IA,IGPM2),MAX(IA,IGPM2),hess)
                   call addm(wadd,MIN(IA2,IGPM),MAX(IA2,IGPM),hess)
c
                      WADD = D5 *VM1(1,2)
                  call addm(wadd,MIN(IGPM,IGPM2),MAX(IGPM,IGPM2),hess)
c
                       WADD = -D3 *VM1(2,2)
                   call addm(wadd,MIN(IA2,IGPM2),MAX(IA2,IGPM2),hess)
c
                       WADD = D5 *VM1(2,2)
                   call addm(wadd,IGPM2,IGPM2,hess)
c
                   IF (IP.GT.0) THEN
                             WADD = D4 *VM1(1,1)
C  corresponds to same group of unknown parents for sire and maternal grand sire
                     IF (IP.EQ.IGPM) WADD = 2.D0 * WADD
                     call addm(wadd,MIN(IP,IGPM),MAX(IP,IGPM),hess)
c
                             WADD = D4 *VM1(1,2)
                     IF (IP.EQ.IGPM2) WADD = 2.D0 * WADD
                     call addm(wadd,MIN(IP,IGPM2),MAX(IP,IGPM2),hess)
                     call addm(wadd,MIN(IP2,IGPM),MAX(IP2,IGPM),hess)
c
                            WADD = D4 *VM1(2,2)
                    IF (IP2.EQ.IGPM2) WADD = 2.D0 * WADD
                    call addm(wadd,MIN(IP2,IGPM2),MIN(IP2,IGPM2),hess)
                   ENDIF
                 ENDIF
c
               IF (IGMM.GT.0) THEN
                  GRADF(IGMM) = GRADF(IGMM) - 0.25D0 * Y
                  GRADF(IGMM2) = GRADF(IGMM2) - 0.25D0 * Y2

                          WADD = -D3 *VM1(1,1)
                  call addm(wadd,MIN(IA,IGMM),MAX(IA,IGMM),hess)

                          WADD = D5 *VM1(1,1)
                  call addm(wadd,IGMM,IGMM,hess)
c
                          WADD = -D3 *VM1(1,2)
                  call addm(wadd,MIN(IA,IGMM2),MAX(IA,IGMM2),hess)
                  call addm(wadd,MIN(IA2,IGMM),MAX(IA2,IGMM),hess)

c
                          WADD = D5 *VM1(1,2)
                  call addm(wadd,MIN(IGMM,IGMM2),MAX(IGMM,IGMM2),hess)
c
                          WADD = -D3 *VM1(2,2)
                  call addm(wadd,MIN(IA2,IGMM2),MAX(IA2,IGMM2),hess)
c
                          WADD = D5 *VM1(2,2)
                  call addm(wadd,IGMM2,IGMM2,hess)
c
                   IF (IP.GT.0) THEN
c                     J1x = MIN(IP,IGMM)
c                     J2x = MAX(IP,IGMM)
                             WADD = D4 *VM1(1,1)
C  corresponds to same group of unknown parents for sire and meaternal grand dam
                    IF (IP.EQ.IGMM) WADD = 2.D0 * WADD
                    call addm(wadd,MIN(IP,IGMM),MAX(IP,IGMM),hess)
c
                            WADD = D4 *VM1(1,2)
c                  VM1(1,2) = VM1(2,1)
                    IF (IP.EQ.IGMM2) WADD = 2.D0 * WADD
                    call addm(wadd,MIN(IP,IGMM2),MAX(IP,IGMM2),hess)
                    call addm(wadd,MIN(IP2,IGMM),MAX(IP2,IGMM),hess)
c
                            WADD = D4 *VM1(2,2)
                    IF (IP2.EQ.IGMM2) WADD = 2.D0 * WADD
                    call addm(wadd,MIN(IP2,IGMM2),MIN(IP2,IGMM2),hess)
                   ENDIF
c
                  IF (IGPM.GT.0) THEN
c                     J1x = MIN(IGPM,IGMM)
c                     J2x = MAX(IGPM,IGMM)
                           WADD = D5 *VM1(1,1)
C  corresponds to same group of unknown parents for maternal grand sire and grand dam
                   IF (IGPM.EQ.IGMM) WADD = 2.D0 * WADD
                   call addm(wadd,MIN(IGPM,IGMM),MAX(IGPM,IGMM),hess)
c
                           WADD = D5 *VM1(1,2)
c                VM1(1,2) = VM1(2,1)
                   IF (IGPM.EQ.IGMM2) WADD = 2.D0 * WADD
                   call addm(wadd,MIN(IGPM,IGMM2),MAX(IGPM,IGMM2),hess)
                   call addm(wadd,MIN(IGPM2,IGMM),MAX(IGPM2,IGMM),hess)
c
                           WADD = D5 *VM1(2,2)
                   IF (IGPM2.EQ.IGMM2) WADD = 2.D0 * WADD
                call addm(wadd,MIN(IGPM2,IGMM2),MIN(IGPM2,IGMM2),hess)
                  ENDIF
                 ENDIF
  430          CONTINUE
               DO 432 K=INOR(I,2),INOR(I,3)
                 K2=K+IDEL
                 F = F + 0.5 * (BETA1(K)*GRADF(K)+BETA1(K2)*GRADF(K2))
  432          CONTINUE
             ENDIF
           ENDIF

!!!! correlated random effects - end
         endif
!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!		   	   
       ENDIF
  300   CONTINUE
      ENDIF
C
C-----------------------------------------------------------------------
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IF (nstor.ne.1) THEN
        IF (IOMODE.NE.4) THEN
           OPEN(4,file=FILE(9),FORM='UNFORMATTED')
c       ELSE
c          FILENAM=FILE(9)
c          CALL f77openr(IDFILE,FILENAMC)
c          IERR=1
        ENDIF
      ENDIF
      KFIRST=0
      KLAST=0
C
C-----------------------------------------------------------------------
C   FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
      IQ = 0
      LAST = -1
      IPRETIM = 0
      DLPRETIM = 0.D0
      OMEG=0.D0
      TPRERHO = 0.D0
  100 IF (NSTOR.NE.1) THEN
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on December 12, 1996
cc##################################################
        IF (IOMODE.NE.4) THEN
           DO 766 I=1,NRECMAX
             DO 766 J=1,INTE_ST1
                blockb%info(I,J)=0
  766      CONTINUE
           do i=1,nrecmax
              do j=1,mxef_used
               blockb%idata(i,j)=0
               blockb%xdata(i,j)=0.d0
              end do
           end do
        READ(4,END=199) NREC,LTAB,
     +  ((blockb%info(i,j),i=1,nrecmax),j=1,inte_st1),
     +  ((blockb%idata(i,j),i=1,nrecmax),j=1,mxef_used),
     +	((blockb%xdata(i,j),i=1,nrecmax),j=1,mxef_used)
c       ELSE
c IOMODE = 4 <==> compressed
c          DO 767 I=1,NRECMAX
c            DO 767 J=1,INTE_ST1
c               blockb%info(I,J)=0
c 767      CONTINUE
c         CALL f77cread(idfile,nrec,ltab,krec,ierr)
c         if (ierr.eq.0) goto 199
        ENDIF
      ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added or modified on December 10, 1996
C  IF KEYWORD 'WITHIN' WAS USED WITH 'INTEGRATE_OUT', THIS PART
C  LOOKS AT THE TABLE OF RECORDS AND DETERMINES THE ORDER SUITABLE
C  FOR THE INTEGRATION: eg: year-season WITHIN herd. THIS ORDER IS
C  STORED IN blockb%info(*,KCOLINT) AND blockb%info(*,KCOLWITH) IS UPDATED
C  SO blockb%info(*,KCOLWITH) CORRESPONDING
C  TO DIFFERENT 'herds' ARE DIFFERENT. IT IS ASSUMED THAT THERE ARE
C  LESS THAN MAXYS 'year-seasons' per 'herd'.
      NCOND = NINTTDEP + NWITHIN + ITDEPSTR
      IF (NWITHIN.NE.0) THEN
        IF (blockb%info(1,KCOLINT).GT.MAXYS) GOTO 909
        NH = MAXYS
        IDHERD = blockb%info(1,KCOLWITH)
        JJ = blockb%info(1,KCOLINT)
        KFIRST(JJ) = 1
        KLAST(JJ) = 1
        NLISTYS= 1
        LISTYS(1)= JJ
        blockb%info(1,KCOLINT)= NH +  JJ
        DO 900 I=2, NREC
           IF (blockb%info(I,KCOLWITH).NE.IDHERD) THEN
             if (nlistys.GT.1) then
              DO 910 I1 = 1,NLISTYS-1
                 JJ = LISTYS(I1)
                 KK = LISTYS(I1+1)
                 blockb%info(KLAST(JJ),KCOLWITH) = KFIRST(KK)
                 KFIRST(KK) = 0
                 KLAST(JJ) = 0
  910         CONTINUE
             endif
              NH = NH + MAXYS
              IDHERD = blockb%info(I,KCOLWITH)
c             IF (NLISTYS.NE.0) THEN
              KK = LISTYS(NLISTYS)
              blockb%info(KLAST(KK),KCOLWITH)= I
              KLAST(KK) = 0
c             ENDIF
              NLISTYS= 0
           ENDIF
           JJ = blockb%info(I,KCOLINT)
           blockb%info(I,KCOLINT)= NH + JJ
           K = KLAST(JJ)
c           if (K.GT.NRECMAX) then
c              print*,' K,JJ,I,NH,klast(1:3)',K,JJ,I,NH,nlisty,
c     +              klast(1),klast(2),klast(3),klast(4)
c           ENDIF
           IF (K.NE.0) THEN
              blockb%info(K,KCOLWITH) = I
           ELSE
              NLISTYS= NLISTYS + 1
              LISTYS(NLISTYS)= JJ
              KFIRST(JJ)= I
           ENDIF
           KLAST(JJ)= I
 900    CONTINUE
        DO 930 I1 = 1,NLISTYS-1
          JJ = LISTYS(I1)
          KK = LISTYS(I1+1)
          blockb%info(KLAST(JJ),KCOLWITH) = KFIRST(KK)
          KLAST(JJ) = 0
  930   CONTINUE
c        IF (NLISTYS.NE.0) THEN
          KK = LISTYS(NLISTYS)
          blockb%info(KLAST(KK),KCOLWITH)= 0
          KLAST(KK) = 0
c       ENDIF
      ENDIF
C
 909  I=1
      DO 190 I1=1,NREC
        IF (NWITHIN.EQ.0) THEN
          I=I1
        ELSE IF (I1.NE.1) THEN
          IF (I.EQ.0) GOTO 190
          I = blockb%info(I,KCOLWITH)
          IF (I.EQ.0) GOTO 190
        ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          IVALQ = blockb%info(I,KCOLINT)
C <<<<<<<<<<<<<<<<<<<<<<
C added October 16, 1996, modified (NCOND) December 10, 1996
        ICODE = blockb%info(I,2)
        IF (NCOND.NE.0.AND.ICODE.EQ.-2)  GOTO 190
C <<<<<<<<<<<<<<<<<<<<<<
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD WAS THE LAST RECORD WITH IVALQ = IQ
C   UPDATE F (WEIBULL LIKELIHOOD) AND GRADF (ITS GRADIENT)
C   NQ IS THE NUMBER OF OBSERVED FAILURES WITH IVALQ = IQ
c
c IF INTEGAM=0 ==> THERE IS NO INTEGRATION OF ANY RANDOM (LOGGAMMA) EFFECT
c             ==> = REGULAR WEIBULL MODEL and LIKELIHOOD
c IF INTEGAM >0 ==> the fixed effect indicated by IVALQ is integrated out
c          assuming a gamma distribution
C-----------------------------------------------------------------------
         IF (IQ.NE.0.AND.IVALQ.NE.IQ.AND.INTEGAM.NE.0) THEN
         IF (IQ.GT.0) THEN
           GAM0= GAMVAR
           XNS=XNS+1.D0
         ELSE
           GAM0=XINCLU
           XNSFIX=XNSFIX+1.D0
         ENDIF
         XNQGAM = XNQ + GAM0
         OMQGAM = OMEG + GAM0
         R1GAM = XNQGAM / OMQGAM
         R2GAM = R1GAM / OMQGAM
         F = F - GAMLOG(XNQGAM) + XNQGAM * DLOG(OMQGAM)
         IF (NJOINT.EQ.1.AND.IQ.GT.0) THEN
            R3GAM = (XNQ - OMEG) / (OMQGAM*OMQGAM)
            GRADF(NDIM1) = GRADF(NDIM1)
     +            - DIGAMA(XNQGAM) + DLOG(OMQGAM)+ R1GAM
            WADD=  - TRIGAM(XNQGAM)
     +           + (GAM0 + 2.D0*OMEG - XNQ)/(OMQGAM*OMQGAM)
            WADD = GAMVAR * GAMVAR * WADD
            call addm(WADD,NDIM1,NDIM1,hess)
         ENDIF

c
         LAST1=LAST
   16    LAST2=LAST1
         IF (NJOINT.EQ.1.AND.IQ.GT.0) THEN
           WADD = -R3GAM * GAMVAR * DOMEG(LAST1)
           call addm(WADD,last1,NDIM1,hess)
         ENDIF
   15    J1 = MIN(LAST1,LAST2)
         J2 = MAX(LAST1,LAST2)
	 WADD = - R2GAM * DOMEG(LAST1) * DOMEG(LAST2)
         call addm(WADD,j1,j2,hess)
         IF (J1.EQ.J2) THEN
             WADD = R1GAM * DIAG2OM(J1)
c            x=DIAG2OM(J1)
             DIAG2OM(J1)=0.D0
         ELSE
           WADD =  R1GAM * hess%x(j2,j1)
           call setm(zer,j2,j1,hess)
c	   D2OMEG(J2,J1)=0.D0
         ENDIF
         call addm(WADD,j1,j2,hess)
c
         LAST2 = POINT(LAST2)
         IP = IP+1
         IF (LAST2.GT.0) THEN
            GOTO 15
         ELSE
           LAST1 = POINT(LAST1)
           IF (LAST1.GT.0) GOTO 16
         ENDIF
c
   20    GRADF(LAST) = GRADF(LAST) + R1GAM * DOMEG(LAST)
         DOMEG(LAST) = 0.D0
         LAST1 = POINT(LAST)
         POINT(LAST) = 0
         LAST = LAST1
         IF (LAST.GT.0) GOTO 20
c
         XNQ = 0.D0
         OMEG = 0.D0
         LAST = -1
c        LASTOM = -1
       ENDIF
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD HAS A DIFFERENT STRATUM ID ==> NEW STRATUM
C   INITIALIZE CUM_RISK (CUMULATIVE RISK FOR ALL INDIVIDUALS) AND VECTOR
C   DC_RISK (CUMULATED CONTRIBUTION FOR EACH LEVEL TO BE USED IN
C   COMPUTING GRADF) + D2C_RISK (TO BE USED IN COMPUTING HESSIAN)
C
C  IF NINTTDEP=1  , blockb%info(I,KCOLPRE) CONTAINS PREVIOUS TIME
C-----------------------------------------------------------------------
       ITIM =blockb%info(I,1)
       ICODE = blockb%info(I,2)
       IF (NSTRATA.GT.1) THEN
          ISTR = blockb%info(I,KCOLSTR)
       ELSE
          ISTR=1
       ENDIF
       RHO = VALRHO(ISTR)
       LRHO = DLOGRHO(ISTR)
       IQ = IVALQ
C-----------------------------------------------------------------------
C     W1 = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C     FIRST, NCCOV CONTINUOUS COVARIATES, THEN NDCOV DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => W2 = EXP(W1) WILL BE = 0
C-----------------------------------------------------------------------
       K = 0
       W1 = 0.D0
       DO 25 J=1,NCCOV
         XCOV = blockb%xdata(I,J)
         W1 = W1 + BETA1(J) * XCOV
         IF (BETA1(J).LE.-999.D0) W1 = -999.9D0
   25  CONTINUE
       DO 30 J=NDCOV0,NDCOV1
         K = blockb%idata(I,J)
         IF (K.NE.0) THEN
	   WADD0=BETA1(K)
	   IF (ICOEF(J).EQ.1) WADD0 = WADD0 *XCOEF(J)
	   W1 = W1 + WADD0
	 ENDIF
   30  CONTINUE
C
       W1 = W1 + BETA1(NDIMB+ISTR)
C
C-----------------------------------------------------------------------
C   DIVERGENCE ==> STOP
C-----------------------------------------------------------------------
       IF (W1.GT.100.D0) THEN
         K = MIN(50,NDIM1)
         IA = NDIM1+1
         IF (K.LT.NDIM1) IA=NDIM1-3
         WRITE(6,*) 'OVERFLOW '
         WRITE(6,*) 'BETA1 =   '
         WRITE(6,32) (J,BETA1(J),J=1,K),(J,BETA1(J),J=IA,NDIM1)
  32     FORMAT(1x,4(I5,G12.5),/1x)
         WRITE(6,*) 'W1    =   ',W1
         STOP
       ENDIF
C
C-----------------------------------------------------------------------
C   COMPUTE W2 = EXP(W1) AND W3 = W2 * (ITIM**RHO - IPRETIM**RHO)
C  IF ICRHO=1  COMPUTE:
C      IF NO_LOG=1    (MAXIMIZATION IS ON RHO):
c    W4 = W2 * (ITIM**RHO * (LOG ITIM) - IPRETIM**RHO * (LOG IPRETIM))
c    W5=[W2*(ITIM**RHO * (LOG ITIM)**2 - IPRETIM**RHO * (LOG IPRETIM)**2)]
C      IF NO_LOG^=1    (MAXIMIZATION IS ON LOG(RHO)):
c    W4 = RHO * W4 ABOVE
C    W5 = W4 + RHO * RHO * W5 ABOVE
C-----------------------------------------------------------------------
       W2 = 0.D0
C
       IF (W1.GT.-80.D0) W2 = DEXP(W1)
       DLTIM = VECLOG(ITIM)
c       DLTIM = DLOG(DBLE(ITIM))
       TRHO = VECEXP(ITIM,ISTR)
c       TRHO = DEXP(RHO*DLTIM)
C <<<<<<<<<<<<<<<<<<<<<<
C added October 16, 1996, modified (NCOND) December 10, 1996
      IF (ICODE.EQ.-2) THEN
         IPRETIM= ITIM
         DLPRETIM = DLTIM
         TPRERHO = TRHO
         GOTO 190
      ENDIF
      IF (NCOND.NE.0) THEN
C <<<<<<<<<<<<<<<<<<<<<<
       IF (NINTTDEP.NE.0.OR.ITDEPSTR.NE.0) THEN
C
C BECAUSE THE ORDERING OF THE RECORDS DOES NOT PERMIT TO KEEP OLD
C VALUES OF DLTIM AND TRHO , THEY HAVE TO BE RECALCULATED
C
         IPRETIM= blockb%info(I,KCOLPRE)
         IF (IPRETIM.EQ.0) THEN
            DLPRETIM=0
            TPRERHO=0
         ELSE
	    DLPRETIM=VECLOG(IPRETIM)
            TPRERHO=VECEXP(IPRETIM,ISTR)
         ENDIF
C <==> NWITHIN <> 0
C <<<<<<<<<<<<<<<<<<<<<<
C added February 27 1997
        ELSE IF (NWITHIN.NE.0) THEN
C <<<<<<<<<<<<<<<<<<<<<<
C added December 10, 1996
          IF (I.EQ.1)  THEN
C THE PREVIOUS RECORD CORRESPONDS TO ANOTHER ANIMAL
C <<<<<<<<<<<<<<<<<<<<<<
C added February 27 1997
            IPRETIM=0
            DLPRETIM=0.D0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).GE.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO ANOTHER ANIMAL
            IPRETIM=0
            DLPRETIM=0.D0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).LT.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO THE SAME ANIMAL
            IPRETIM= blockb%info(I-1,1)
            DLPRETIM=VECLOG(IPRETIM)
            TPRERHO=VECEXP(IPRETIM,ISTR)
          ENDIF
        ENDIF
C <<<<<<<<<<<<<<<<<<<<<<
       ENDIF
C
       W3 = W2 * (TRHO - TPRERHO)
c
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       IF (ICRHO.EQ.99.AND.ICODE.GT.0) GOTO 7878
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF (w3.lt.0.) THEN
         print*,'w3,',xnq,w3,TRHO,TPRERHO,ITIM,IPRETIM,
     +   I,I1,ISTR,RHO,(blockb%info(I,J),J=1,7),F
      ENDIF

       OMEG = OMEG + W3
c
       DO 55 J=1,NCCOV
         XCOV = blockb%xdata(I,J)
         IF (POINT(J).EQ.0) THEN
           POINT(J) = LAST
           LAST = J
         ENDIF
         DOMEG(J) = DOMEG(J) +  W3 * XCOV
c         ITOPL = J
         DO 58 J2=J,NCCOV
           XCOV2 = blockb%xdata(I,J2)
    	   IF (J.EQ.J2) THEN
             DIAG2OM(J) = DIAG2OM(J) + XCOV * XCOV2 * W3
           ELSE
c            D2OMEG(J2,J) = D2OMEG(J2,J) + XCOV * XCOV2* W3
             WADD= XCOV * XCOV2* W3
             call addm(WADD,j2,j,hess)
           ENDIF
   58    CONTINUE
         DO 60 J2=NDCOV0,NDCOVP1
           IF (J2.LE.NDCOV1) THEN
             K2 = blockb%idata(I,J2)
             IF (K2.EQ.0) GOTO 60
           ELSE
             K2 = NDIMB+ISTR
           ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
           WADD1= XCOV * W3
           IF (ICOEF(J2).EQ.1) WADD1= WADD1 * XCOEF(J2)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c	   D2OMEG(K2,J) = D2OMEG(K2,J) + WADD1
           call addm(WADD1,k2,j,hess)
   60    CONTINUE
   55  CONTINUE
       DO 70 J=NDCOV0,NDCOVP1
         IF (J.LE.NDCOV1) THEN
           K = blockb%idata(I,J)
           IF (K.EQ.0) GOTO 70
         ELSE
           K = NDIMB+ISTR
         ENDIF
         IF (POINT(K).EQ.0) THEN
           POINT(K) = LAST
           LAST = K
         ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
         WADD1= W3
         IF (ICOEF(J).EQ.1) WADD1= WADD1 * XCOEF(J)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         DOMEG(K) = DOMEG(K) +  WADD1
         DO 65 J2=J,NDCOVP1
           IF (J2.LE.NDCOV1) THEN
             K2 = blockb%idata(I,J2)
             IF (K2.EQ.0) GOTO 65
           ELSE
             K2 = NDIMB+ISTR
           ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
           WADD2= WADD1
           IF (ICOEF(J2).EQ.1) WADD2= WADD2 * XCOEF(J2)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
           M1 = MIN(K,K2)
           M2 = MAX(K,K2)
    	   IF (M1.EQ.M2) THEN
	     DIAG2OM(M1) = DIAG2OM(M1) +  WADD2
           ELSE
c	     D2OMEG(M2,M1) = D2OMEG(M2,M1) +  WADD2
             call addm(WADD2,m2,m1,hess)
           ENDIF
   65    CONTINUE
   70  CONTINUE
c
C-----------------------------------------------------------------------
c elements in first and 2nd derivatives with respect to rho's
C-----------------------------------------------------------------------
c
       IF (ICRHO.EQ.1) THEN
          W4 = W2 * (TRHO * DLTIM - TPRERHO * DLPRETIM)
          IF (NO_LOG.NE.1) W4 = RHO * W4
          K = NDIMBPS + ISTR
          IF (POINT(K).EQ.0) THEN
            POINT(K) = LAST
            LAST = K
          ENDIF
          DOMEG(K) = DOMEG(K) + W4
          W5 =  W2 * (TRHO *DLTIM *DLTIM -
     +                             TPRERHO *DLPRETIM *DLPRETIM)
          IF (NO_LOG.NE.1) W5 = W4 + RHO * RHO * W5
c
          DIAG2OM(K) = DIAG2OM(K) + W5
          DO 85 J2=1,NCCOV
           XCOV2 = blockb%xdata(I,J2)
c	    D2OMEG(K,J2) = D2OMEG(K,J2) + XCOV2 *  W4
            WADD= XCOV2 * W4
            call addm(WADD,k,j2,hess)
   85    CONTINUE
         DO 90 J2=NDCOV0,NDCOVP1
           IF (J2.LE.NDCOV1) THEN
             K2 = blockb%idata(I,J2)
             IF (K2.EQ.0) GOTO 90
           ELSE
             K2 = NDIMB+ISTR
           ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
           WADD2= W4
           IF (ICOEF(J2).EQ.1) WADD2= WADD2 * XCOEF(J2)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c	   D2OMEG(K,K2) = D2OMEG(K,K2) +   WADD2
            call addm(WADD2,k,k2,hess)
   90    CONTINUE
       ENDIF
C
C-----------------------------------------------------------------------
C   IF UNCENSORED RECORD, UPDATE F AND GRADF
C-----------------------------------------------------------------------
 7878  K = 0
       IF (ICODE.GE.1) THEN
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         XNQ = XNQ + 1.D0
         IF (ICRHO.EQ.99) THEN
           W6= DEXP(- W2)
           W7= 1.D0 - W6
	   F = F - DLOG(W7)
           W7= DEXP(W1-W2)/W7
	 ELSE
           F = F - LRHO - (RHO - 1.D0) * DLTIM - W1
         ENDIF
         DO 75 J=1,NCCOV
             IF (ICRHO.EQ.99) THEN
                GRADF(J) = GRADF(J) - blockb%xdata(I,J) * W7
C
		DO 76 J1=J,NCCOV
                  WADD = (1.D0 - W2 - W7) * blockb%xdata(I,J1)
                  WADD = - blockb%xdata(I,J) * W7 * WADD
                  call addm(WADD,j,j1,hess)
   76           CONTINUE
c
		DO 77 J1= NDCOV0,NDCOVP1
                   IF (J1.LE.NDCOV1) THEN
                      K = blockb%idata(I,J1)
                      IF (K.EQ.0) GOTO 77
                   ELSE
                      K = NDIMB+ISTR
                   ENDIF
                   IF (K.GT.0) THEN
                      WADD = 1.D0 - W2 - W7
                      WADD = - blockb%xdata(I,J) * W7 * WADD
                      IF (ICOEF(J1).EQ.1) WADD = WADD * XCOEF(J1)
                      call addm(WADD,j,k,hess)
                   ENDIF
   77           CONTINUE
             ELSE
                GRADF(J) = GRADF(J) - blockb%xdata(I,J)
             ENDIF
   75    CONTINUE
C
         DO 80 J= NDCOV0,NDCOVP1
           IF (J.LE.NDCOV1) THEN
             K = blockb%idata(I,J)
             IF (K.EQ.0) GOTO 80
           ELSE
             K = NDIMB+ISTR
           ENDIF
	   IF (K.GT.0) THEN
             IF (ICRHO.EQ.99) THEN
	       WADD0 = W7
               WADD = 1.D0 - W2 - W7
               WADD = - W7 * WADD
               IF (ICOEF(J).EQ.1) THEN
                 WADD0 = WADD0 * XCOEF(J)
                 WADD = WADD * XCOEF(J)
               ENDIF
               GRADF(K) = GRADF(K) - WADD0
C	
             DO 81 J1= J,NDCOVP1
                  IF (J1.LE.NDCOV1) THEN
                     K1 = blockb%idata(I,J1)
                     IF (K1.EQ.0) GOTO 81
                  ELSE
                      K1 = NDIMB+ISTR
                  ENDIF
                   IF (K1.GT.0) THEN
                     WADD1=WADD
                     IF (ICOEF(J1).EQ.1) WADD1 = WADD1 * XCOEF(J1)
                     M1=MIN(K,K1)
                     M2=MAX(K,K1)
                     call addm(WADD1,m1,m2,hess)
                   ENDIF
  81            CONTINUE
             ELSE
               WADD0 = 1.D0
               IF (ICOEF(J).EQ.1) WADD0 = WADD0 * XCOEF(J)
               GRADF(K) = GRADF(K) - WADD0
             ENDIF
           ENDIF
   80    CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         IF (ICRHO.EQ.1) THEN
           K = NDIMBPS + ISTR
           IF (NO_LOG.EQ.1) THEN
             GRADF(K) = GRADF(K) - (1.D0/RHO) - DLTIM
             WADD = 1.D0/(RHO*RHO)
           ELSE
             GRADF(K) = GRADF(K) - 1.D0 - RHO * DLTIM
    	     WADD = - RHO * DLTIM
           ENDIF
c
            call addm(WADD,k,k,hess)
         ENDIF
       ENDIF
  189  IF (NCOND.EQ.0) THEN
         IF (ICODE.GE.0) THEN
           IPRETIM = 0
           TPRERHO = 0.D0
           DLPRETIM = 0.D0
         ELSE
           IPRETIM = ITIM
           TPRERHO = TRHO
           DLPRETIM = DLTIM
         ENDIF
       ENDIF
C
  190 CONTINUE
      IF (NSTOR.NE.1) GOTO 100
  199 IF (NSTOR.NE.1) THEN
         IF (IOMODE.NE.4) THEN
           CLOSE(4)
c        ELSE
c          call f77close(idfile)
         ENDIF
      ENDIF
C
C-----------------------------------------------------------------------
C   LAST CONTRIBUTION TO F AND GRADF
C-----------------------------------------------------------------------
      IF (INTEGAM.EQ.0) THEN
C-----------------------------------------------------------------------
C   REGULAR WEIBULL MODEL
C-----------------------------------------------------------------------
         F = F + OMEG
         R1GAM = 1.D0
      ELSE
C-----------------------------------------------------------------------
C   WEIBULL MODEL WITH INTEGRATION OF A FRAILTY TERM
C-----------------------------------------------------------------------
        IF (IQ.GT.0) THEN
          GAM0= GAMVAR
          XNS=XNS+1.D0
        ELSE
          GAM0=XINCLU
          XNSFIX=XNSFIX+1.D0
        ENDIF
        XNQGAM = XNQ + GAM0
        OMQGAM = OMEG + GAM0
        R1GAM = XNQGAM / OMQGAM
        R2GAM = R1GAM / OMQGAM
C derivative with respect to GAMVAR
        F = F - XNS * (GAMVAR * DLOG(GAMVAR) - GAMLOG(GAMVAR))
        F = F -GAMLOG(XNQGAM) + XNQGAM * DLOG(OMQGAM)
        IF (NJOINT.EQ.1.AND.IQ.GT.0)  THEN
          R3GAM = (XNQ - OMEG) / (OMQGAM*OMQGAM)
          GRADF(NDIM1) = GRADF(NDIM1)
     +         - DIGAMA(XNQGAM) + DLOG(OMQGAM)+ R1GAM
          WADD= - TRIGAM(XNQGAM)
     +         + (GAMVAR + 2.D0*OMEG - XNQ)/(OMQGAM*OMQGAM)
          WADD = GAMVAR * GAMVAR * WADD
          call addm(WADD,NDIM1,NDIM1,hess)
        ENDIF
        IF (NJOINT.EQ.1)  THEN
          GRADF(NDIM1) = GRADF(NDIM1)
     +         - XNS * (1.D0 + DLOG(GAMVAR) - DIGAMA(GAMVAR))
          WADD= - XNS * (1.D0/GAMVAR - TRIGAM(GAMVAR))
          WADD = GAMVAR * (GAMVAR * WADD + GRADF(NDIM1))
          call addm(WADD,NDIM1,NDIM1,hess)
          GRADF(NDIM1) = GAMVAR * GRADF(NDIM1)
        ENDIF
      ENDIF
c
        LAST1=LAST
  214   LAST2=LAST1
        IF (INTEGAM.NE.0) THEN
          IF (NJOINT.EQ.1.AND.IQ.GT.0) THEN
             WADD = -R3GAM * GAMVAR * DOMEG(LAST1)
             call addm(WADD,last1,NDIM1,hess)
          ENDIF
        ENDIF
c
  215   J1 = MIN(LAST1,LAST2)
        J2 = MAX(LAST1,LAST2)
        IF (INTEGAM.EQ.0) THEN
          X = 1.D0
          R2GAM=1.D0
          WADD=0.D0
        ELSE
          X = R1GAM
	  WADD = - R2GAM * DOMEG(LAST1) * DOMEG(LAST2)
        ENDIF
	IF (J1.EQ.J2) THEN
	   WADD = WADD + X * DIAG2OM(J1)
	   DIAG2OM(J1)=0.D0
        ELSE
c           WADD = WADD + X * D2OMEG(J2,J1)
            WADD = WADD + X * hess%x(J2,J1)
c  	    D2OMEG(J2,J1)=0.D0
            call setm(zer,j2,j1,hess)
        ENDIF
        call addm(WADD,j1,j2,hess)
c
        LAST2 = POINT(LAST2)
        IF (LAST2.GT.0) THEN
          GOTO 215
        ELSE
          LAST1 = POINT(LAST1)
          IF (LAST1.GT.0) GOTO 214
        ENDIF
c
  220 X = DOMEG(LAST)
      GRADF(LAST) = GRADF(LAST) + R1GAM * X
      DOMEG(LAST) = 0.D0
      LAST1 = POINT(LAST)
      POINT(LAST) = 0
      LAST = LAST1
      IF (LAST.GT.0) GOTO 220
c
      XNQ = 0.D0
      OMEG = 0.D0
      LAST = -1
C
C----------------------------------------------------------------------
C   CONSTRAINTS ON GRADF AND HESSIAN
C---------------------------------------------------------------------- 
c     print*,'F FINAL',F
      if (noption.eq.0) return
       ICODE=0
       IF (NOPTION.GE.90) THEN
C----------------------------------------------------------------------
C  NUMERICAL FACTORIZATION TO LOOK FOR CONSTRAINTS
C----------------------------------------------------------------------
         IF (NDCOV.NE.0) THEN
           ICONS(0)=1
           J= ICONS(0)
           ICONS(J)=NCCOV+1
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on February 13, 1997
  204      IF (BETA1(ICONS(J)).lt.-998.D0.AND.ICONS(J).LT.NDIMB) THEN
             ICONS(0) = ICONS(0)+1
             J = J + 1
             ICONS(J) = ICONS(J-1)+1
             GOTO 204
           ENDIF
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         ELSE
           RETURN
         ENDIF
         ICODE=1
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c        CALL CHOLESKY(HESS,NDIMAX2,NDIMB,J,ICODE)
         CALL CHOLESKY(HESS%x,NDIM1,NDIMB,J,ICODE)
C Delete useless constraints (due to no observed failures)
         J=0
         DO 207 I=2,ICONS(0)
           IF (BETA1(ICONS(I)).GT.-998.D0) THEN
             J=J+1
             ICONS(J)=ICONS(I)
           ENDIF
  207    CONTINUE
         DO 208 I=J+1,ICONS(0)
           ICONS(I)=0
  208    CONTINUE
         ICONS(0)=J
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         IF (NOPTION.EQ.90) RETURN
       ENDIF

       IF (ICHECK.NE.1) THEN
        DO 210 I = 1,ICONS(0)
          GRADF(ICONS(I)) = 0.D0
          DO 209 J=1,NDIM1
            J1 = MIN(J,ICONS(I))
            J2 = MAX(J,ICONS(I))
            call setm(zer,j1,j2,hess)
  209     CONTINUE
  210   CONTINUE
      ENDIF

C----------------------------------------------------------------------
C   END OF THE CONSTRUCTION OF THE HESSIAN
C----------------------------------------------------------------------
      IDF=0
      DO 261 J=1,NDIM1
        IF (GRADF(J).NE.0.D0) IDF = IDF + 1
  261 CONTINUE
      TIM1=SECOND()
      TIM0 = TIM1 - TIM0
c     WRITE(6,9000) TIM0
c9000 FORMAT(1X,
c    +   ' TIME FOR THE COMPUTATION OF THE HESSIAN = ',F8.2,' SECONDS')
      TIM0 = TIM1
c
       DLDET=0.D0
c
C----------------------------------------------------------------------
C  solve if noption=10
C----------------------------------------------------------------------
          if (noption.eq.10.or.noption.eq.-10) then
             IF (FORCE_POS.EQ.1) THEN
             call init(hess_ija)
             hess_ija=hess
c Check whether the hessian is positive definite. If not, calculate
c    mu_add to be added to force positive definiteness
c              print*,'noption=',noption,ncalhes 
 54              IF (NOPTION.LT.0) THEN
C    factorisation already done and stored in fspakf90.ord
                 idim=-hess_ija%n
c                  print*,' reading of fspak90.ord',idim
                  call fspak90('factor',hess_ija,rank=idim)
c                 noption=-noption
                else
                  call fspak90('factor',hess_ija)
                  noption=-noption
                endif
                if (mu_add.GT.1.d-4) then
		     print'(''mu_add = '',G12.4)',mu_add
                endif
                if (mu_add.lt.0.d0) then
                     print*,'very ill-conditioned Hessian - Return'
                     do i= 1, NDIM1
                       j1= hess_ija%ia(i)
                       x=hess_ija%a(j1)
                       if (x.gt.1.d-4) then
                          delta(i)=gradf(i)/x
                       else
                          delta(i)=0.d0
                       endif 
                     enddo
c                    return
                   endif
                if (mu_add.gt.0.d0) then
c               else if (mu_add.gt.0.d0) then
                  print'('' need to add:'',G12.4,'' to hessian'')',mu_add
                  do i=1,NDIM1
                    X=getm(i,i,hess)
                    if (x.ne.0.d0) call addm(mu_add,i,i,hess) 
                  enddo
                  call reset(hess_ija)
                  call init(hess_ija)
                  hess_ija=hess
                  idim=-hess_ija%n
                  print*,' reading of fspak90.ord',idim
                  call fspak90('factor',hess_ija,rank=idim)
               endif      
               call fspak90('solve',hess_ija,gradf,delta)
               call reset(hess_ija)
             else
               hess_str=hess
               p_ic=2
               call reset(hess)
 
               cal_icho=.true.
               zerosol=.false.
               call default_iter(decomp=cal_icho,zerosol=zerosol,
     +              p_ic=p_ic)
               call solve_iterm(hess_str,gradf,delta)
               call reset(hess_str)
             endif        
           TIM1=SECOND()
           TIM0 = TIM1 - TIM0
c          WRITE(6,9010) TIM0
c9010  FORMAT(1X,' TIME FOR NUMERICAL FACTORIZATION = ',F8.2,' SECONDS')
c          TIM0 = TIM1
        else 
           call init(hess_ija)
           hess_ija=hess
           call reset(hess)
           IF (NOPTION.LT.0) THEN
C    factorisation already done and stored in fspakf90.ord
              idim=-hess_ija%n
c             call reset(hess_ija)
c              print*,' reading of fspak90.ord',idim
              call fspak90('factor',hess_ija,rank=idim)
              noption=-noption
           else
             call fspak90('factor',hess_ija)
             TIM1=SECOND()
             TIM0 = TIM1 - TIM0
c            print '('' TIME FOR FACTORIZATION = '',F10.2)',TIM0
             TIM0 = TIM1
            endif
          endif
C-----------------------------------------------------------------------
C  IF NOPTION = 1 ==> COMPUTATION OF THE LOG-DETERMINANT
C-----------------------------------------------------------------------
      IF (NOPTION.EQ.1.OR.ICHECK.GT.0) THEN
          call fspak90('ldet',hess_ija,det=dldet)
          TIM1=SECOND()
          TIM0 = TIM1 - TIM0
c         print'('' TIME TO COMPUTE LOG-DETERMINANT = '',F10.2)',TIM0
          noption=0
          TIM0 = TIM1
      ENDIF
C----------------------------------------------------------------------
C  IF NOPTION = 2 ==> COMPUTATION OF THE STANDARD DEVIATIONS
C----------------------------------------------------------------------
      IF (NOPTION.EQ.2.OR.ICHECK.GT.0) THEN
          call fspak90('ldet',hess_ija,det=dldet)
         call fspak90('invert',hess_ija,rank=JRANK)
        DO 550 I=1,NDIM1
          DO 555 J=hess_ija%ia(I),hess_ija%ia(i+1)-1
            if (i.eq.hess_ija%ja(j)) then
               std(i)=hess_ija%a(j)
               IF (STD(I).GT.1.d-8) THEN
                 STD(I)= DSQRT(STD(I))
               ELSE
                 STD(I)=0.D0
               ENDIF
            ENDIF
  555     CONTINUE
  550   CONTINUE
      ENDIF

      deallocate(kfirst,klast,listys,point,domeg,diag2om) 
	  
      RETURN
C***********************************************************************
      END
      FUNCTION GARDE(I1,J1)
C***********************************************************************
C COMPUTES AN INDICATOR TELLING WHETHER THE ELEMENT I1,J1 OF THE HESSIAN
C SHOULD BE KEPT FOR THE COMPUTATION OF THE PRECONDITIONED GRADIENT
C***********************************************************************
c
      use parinclu
c
      INTEGER GARDE,I,J,K,I1,J1
C
C
      GARDE=0
 
      IF (I1.EQ.J1)  THEN
        GARDE=1
        RETURN
      ENDIF
      DO 10 I=1,NCOVMOD
        K = IMOD(I)
        IF (ISAME(K).EQ.1) GOTO 10
        IF (I1.GE.IFIRST(K).AND.I1.LE.ILAST(K))  THEN
           IF (J1.GE.IFIRST(K).AND.J1.LE.ILAST(K))  THEN
              GARDE=1
c             if (I1.lt.11) print*,'garde ',I1,J1
           ELSE
              GARDE=0
           ENDIF
           RETURN
        ENDIF
 10   CONTINUE

      RETURN
C***********************************************************************
      END 
