c      ----------------
       subroutine fspak
c      ----------------
     +                  (option,n,ia,ja,a,b,flag,iout,ioor,
     +                   available,needed,is,fnode,bnode,
     +                   fnseg,bnseg,fx,feqb,jrank)
c -----------------------------------------------------------
c Public Sparse Matrix Package for Symmetric Matrices
c Authors: Miguel Perez-Enciso, Ignacy Misztal, Mauricio Elzo
c Mon Aug 24, 1992 12:39:46 - Jan 17, 1995
c -----------------------------------------------------------
      implicit none
      integer order,symfac,numfac,solve,sinit,ssolve,constrai
     +       ,det,ldet,check,spin,spin1,restart,stat,equal,mx_st
      parameter (order=10,  symfac=20,  numfac=40, solve=50,
     +           sinit=51,  ssolve=52,  det=54,    ldet =55,
     +           check=56,  spin=60,  spin1=61, restart=70,
     +           stat=80,  equal=1,   mx_st=50,  constrai=90 )
      integer available
     +       ,delta,flag,ioor,iout,n,ia(1),ja(1),is(available)
     +       ,fnode(1),bnode(1),fnseg,bnseg,feqb,jrank,ratio,fratio
     +       ,path,found,fpath,fstart,fpnode,bpath,bstart,bpnode
     +       ,maxju,maxu,needed,maxneed,i,adjncy,d,invp,iu,iju,ju,u
     +       ,maxint,nza,nzad,option,perm,iap,jap,ap,xadj,first,ios
     +       ,zja,za,zd,utia,utja,work1,work2,work3,work4,work5
     +       ,even
      integer opt(8),numflag,k
      character*26 jour
c 
      real*8 a(1),b(1),fx(1),st(mx_st),t_t,t0,tol
      real*4 second
      equivalence (st(1),maxju),(st(2),maxu),(st(3),maxneed),(st(4),nza)
c     this is to avoid that the value of ratio is lost
c     with dynamic allocation memory
      save ratio
      data st/mx_st*0./,first/0/
c..   tolerance for accuracy in solution (in options numfac and check)
     +    ,tol/1.d-9/

c function to ensure that real*8 variables are assigned an even address.
      even(i)=2*(i/2)+1

      flag=0
      t_t=second()
c     -----------------------------------------------
c     first time it checks whether ratio equal 1 or 2
c     -----------------------------------------------
      if (first.eq.0) then
         ratio=fratio()
         first=1
      endif
c     -------------------------------------------
c     no. of off-diagonal NZE_HESS in upper triangular
c     -------------------------------------------
c ----comment either line; first one is faster but takes more memory
      nza=(ia(n+1)-1)
c      nza=count_nza(n,ia,ja,iout)
c     --------------------
c     no. of NZE_HESS in adjncy
c     --------------------
      nzad=2*nza
c     ----------------
c     allocate storage
c     ----------------
      perm   = 1
      invp   = perm + n
c     -------------------------
      if (option.eq.order) then
c     -------------------------
         xadj   = invp   + n
         adjncy = xadj   + n+1
         work1  = adjncy + nzad
         work2  = work1 + n
         work3  = work2 + n
         work4  = work3 + n
         needed = work4 + n
         call checkst (option,needed,maxneed,available,iout,flag)
         if (flag.ne.0) return
c        --------------------------------------------------
c        max integer (used as flag in the ordering routine)
c        --------------------------------------------------
         maxint=9999999
c        ---------------------------------------------------------
c        parameter for type of ordering -1=MD, 0=MMD, >0=slack MMD
c        ---------------------------------------------------------
         delta=0
         call unfold
     +               (n,ia,ja,is(xadj),is(adjncy),is(work1))
         t0=second()
c        -------------------------------
c        order: ordering rountines of METIS
c        -------------------------------
c           numflag=1
c           opt=0
c           opt(1)=1
c           opt(2)=3
c           opt(3)=1
c           opt(4)=2
c           opt(5)=0
c           opt(6)=0
c           opt(7)=0
c           opt(8)=3
c           call fdate_(jour)
c           print*,' start METIS at ',jour
c           print*,'options',opt
c           call METIS_NodeND
c    +        (n,is(xadj),is(adjncy),numflag,opt,is(perm),is(invp))
c            maxju=2* is(xadj+n)
c            print*,'maxju=',maxju
c            call fdate_(jour)
c            print*,' METIS done at ',jour
c        -------------------------------
c        if mmd ordering routines by Liu
c        -------------------------------
         call genmmd
     +             (n,is(xadj),is(adjncy),is(invp),is(perm),delta,
     +              is(work1),is(work2),is(work3),is(work4),maxint,
     +              maxju)
c        ---------------------------
c        elseif md sparspak routines
c        ---------------------------
c        work5 = work4 + n
c        work6 = work5 + n
c        needed= work6 + n
c        call checkst (option,needed,maxneed,available,iout,flag)
c        if(flag.ne.0) return
c        call genqmd
c    +               (n,is(xadj),is(adjncy),is(perm),is(invp),
c    +                is(work1),is(work2),is(work3),is(work4),
c    +                is(work5),is(work6),maxju)
         st(21)=st(21)+second()-t0
c        ------------------------------
c        write down permutation vectors
c        ------------------------------
         rewind ioor
c 3 ci-dessous est une estimation !
         needed=3*needed
         write(ioor,*) n,maxju,needed
         write(ioor,'(10i7)') (is(i),i=perm,perm+n-1),
     +                        (is(i),i=invp,invp+n-1)
c     -------------------------------
      elseif (option.eq.restart) then
c     -------------------------------
         rewind ioor
         i=0
         read(ioor,*,end=1) i,maxju,needed
1        if(i.eq.n) then
            read(ioor,'(10i7)',end=2) (is(i),i=perm,perm+n-1),
     +                                (is(i),i=invp,invp+n-1)
2           inquire(ioor,iostat=ios)
            if (ios.ne.0) then
               write(iout,*) 'error in unit IOOR '
               flag=-2
            endif
         else
            if (i.ne.0) then
            write(iout,*) 'incorrect size of permutation vector'
            write(iout,*) 'size ',i,' found; size ',n, ' required'
            endif
            flag=-1
         endif
c     ------------------------------
      elseif (option.eq.symfac) then
c     ------------------------------
         iu     = invp   + n
         iju    = iu     + n+1
         ju     = iju    + n+1
         xadj   = ju     + maxju
         adjncy = xadj   + n+1
         work1  = adjncy + nzad
         work2  = work1  + n
         work3  = work2  + n
         needed = work3  + n
         call checkst (option,needed,maxneed,available,iout,flag)
         if (flag.ne.0) return
         t0=second()
         call unfold
     +               (n,ia,ja,is(xadj),is(adjncy),is(work1))
         call smbfct
     +               (n,is(xadj),is(adjncy),is(perm),is(invp),is(iu),
     +                maxu,is(iju),is(ju),maxju,is(work1),is(work2),
     +                is(work3),flag)
         st(22)=st(22)+second()-t0
      else
         iu        = invp  + n
         iju       = iu    + n+1
         ju        = iju   + n+1
         d         = even(ju    + maxju)
         u         = even(d     + n*ratio)
c        --------------------------
         if (option.eq.numfac) then
c        --------------------------
            iap    = u     + maxu*ratio
            jap    = iap   + n+1
            ap     = even(jap   + nza)
            work1  = even(ap    + nza*ratio)
            needed = work1 + n*ratio
            call checkst (option,needed,maxneed,available,iout,flag)
            if (flag.ne.0) return
            t0=second()
c           ---------------------------------------
c           first load numerical values of a into u
c           ---------------------------------------
            call loadap
     +                (n,ia,ja,a,is(iap),is(jap),is(ap),is(d),is(invp),
     +                 is(work1))
            call loadu
     +                (n,is(iap),is(jap),is(ap),is(iu),is(ju),is(iju),
     +                 is(u),is(work1))
            work1  = u     + maxu*ratio
            work2  = work1 + n
            work3  = even(work2 + n)
            needed = work3 + n*ratio
            call checkst (option,needed,maxneed,available,iout,flag)
            if (flag.ne.0) return
c           -----------------------
c           numerical factorization (slightly modified sparspak routine)
c           ----------------------------------
            call fgsfct
     +                 (n,is(iu),is(u),is(iju),is(ju),is(d),is(work1),
     +                  is(work2),is(work3),flag,tol,jrank)
c            print*,'fgsfct jrank=',jrank
            call merlin (n,is(iu),is(u),is(d),tol)
            st(24)=st(24)+second()-t0
            st(11)=st(11)+1
c           ----------
c           zero pivot
c           ----------
            if(flag.ne.0) flag=numfac*1000000 + flag
c        -----------------------------
         elseif (option.eq.solve) then
c        -----------------------------
            work1  = even(u     + maxu*ratio)
            needed = work1 + n*ratio
            t0=second()
            call permute (n,b,is(work1),is(invp))
            call fullfb
     +                   (n,is(iu),is(ju),is(iju),is(u),is(d),is(work1))
            call permute (n,is(work1),b,is(perm))
            st(25)=st(25)+second()-t0
            st(12)=st(12)+1
c        --------------------------------------------------
         elseif (option.ge.sinit.and.option.le.ssolve) then
c        --------------------------------------------------
            path  = u     + maxu*ratio
            found = path  + n
            work1 = even(found + n)
            fstart= work1 + n*ratio
            fpnode= fstart+ fnseg+1
            needed= fpnode+ fnseg
            call checkst
c                        ------------------------------------------
c                        allows a safety margin for fpath and bpath
c                        ------------------------------------------
     +                   (option,needed+200,maxneed,available,iout,
     +                    flag)
            if(flag.ne.0) return
c           -------------------------
            if (option.eq.sinit) then
c           -------------------------
c              initialize and computes factorization table
c              -------------------------------------------
               call rzero (n,is(work1))
               call lzero (n,is(found))
               call makepath (n,is(path),is(iu),is(ju),is(iju))
c           ------------------------------
            elseif (option.eq.ssolve) then
c           ------------------------------
               t0=second()
               fpath = fpnode + fnseg
c              ------------------------------------------------------
c              obtains forward path (in the permuted vector of nodes)
c              ------------------------------------------------------
               call spermute (fnseg,fnode,is(fpnode),is(invp))
               call segpath
     +                      (n,is(fpnode),fnseg,is(fstart),is(fpath),
     +                       is(path),is(found))
               st(34)=st(34)+is(fstart+fnseg)-1
               if(feqb.eq.equal) then
                  needed= fpath + is(fstart+fnseg)-1
                  call checkst
     +                        (option,needed,maxneed,available,iout,
     +                         flag)
                  if (flag.ne.0) return
c                 -----------------------------
c                 initialize working rhs vector
c                 -----------------------------
                  call zerout (is(work1),is(fpath),is(fstart),fnseg)
c                 ----------------
c                 input rhs values
c                 ----------------
                  call expand (fnseg,is(fpnode),fx,is(work1))
c                 -----
c                 solve
c                 -----
                  call fastfb
     +                        (is(fpath),is(fstart),fnseg,is(fpath),
     +                         is(fstart),fnseg,is(iu),is(ju),is(iju),
     +                         is(u),is(d),is(work1),jrank)
c                 ---------------------
c                 stores solutions in b
c                 ---------------------
                  call compressf (fnseg,is(fpnode),b,is(work1))
                  st(31)= max0(int(st(31)),is(fstart+fnseg)-1)
                  st(35)=st(35)+is(fstart+fnseg)-1
               else
                  bstart = fpath + is(fstart+fnseg)-1
                  bpnode = bstart+ bnseg+1
                  bpath  = bpnode+ bnseg
c                 ----------------------------------
c                 obtains backward path if necessary
c                 ----------------------------------
                  call spermute (bnseg,bnode,is(bpnode),is(invp))
                  call segpath
     +                         (n,is(bpnode),bnseg,is(bstart),
     +                          is(bpath),is(path),is(found))
                  needed= bpath + is(bstart+bnseg)-1
                  call checkst
     +                        (option,needed,maxneed,available,iout,
     +                         flag)
                  if (flag.ne.0) return
                  call zerout (is(work1),is(bpath),is(bstart),bnseg)
                  call zerout (is(work1),is(fpath),is(fstart),fnseg)
                  call expand (fnseg,is(fpnode),fx,is(work1))
                  call fastfb
     +                        (is(fpath),is(fstart),fnseg,is(bpath),
     +                         is(bstart),bnseg,is(iu),is(ju),is(iju),
     +                         is(u),is(d),is(work1),jrank)
                  call compressf (bnseg,is(bpnode),b,is(work1))
                  st(31)=max(int(st(31)),is(bstart+bnseg)-1)
                  st(35)=st(35)+is(bstart+bnseg)-1
               endif
               st(13)=st(13)+1
               st(27)=st(27)+second()-t0
               st(30)=max(int(st(30)),fnseg)
               st(31)=max(int(st(31)),bnseg)
               st(32)=st(32)+fnseg
               st(33)=st(33)+bnseg
            endif
c        ---------------------------
         elseif (option.eq.det) then
c        ---------------------------
            call mkdet (n,is(d),b,jrank,tol,iout,flag)
            st(14)=st(14)+1
c        ----------------------------
         elseif (option.eq.ldet) then
c        ----------------------------
            call mkldet (n,is(d),b,jrank,tol,iout,flag)
            st(14)=st(14)+1
c        ------------------------------
         elseif (option.eq.constrai) then
c        ------------------------------
            call const(n,is(d),is(invp),is(perm))
c        ----------------------------
         elseif (option.eq.check) then
c        ----------------------------
            work1  = u     + maxu*ratio
            call checkb
     +                  (n,ia,ja,a,is(d),b,fx,tol,is(work1),is(invp)
     +                  ,iout,flag)
c        ----------------------------
         elseif (option.eq.spin) then
c        ----------------------------
            zja    = u     + maxu*ratio
            za     = even(zja   + maxu+n)
            zd     = even(za    + (maxu+n)*ratio)
            utia   = zd    + n*ratio
            utja   = utia  + n+1
            work1  = utja  + maxu+n
            work2  = work1 + n
            work3  = even(work2 + n)
            needed = work3 + n*ratio
            call checkst (option,needed,maxneed,available,iout,flag)
            if (flag.ne.0) return
            t0=second()
            call fsinverse
     +                    (n,is(perm),is(invp),is(d),is(iju),is(ju),
     +                     is(iu),is(u),is(work3),is(za),is(zd),
     +                     is(zja),is(utia),is(utja),
     +                     is(work1),is(work2),ia,ja,a)
            st(26)=st(26)+second()-t0
            st(15)=st(15)+1
c        ----------------------------
         elseif (option.eq.spin1) then
c        ----------------------------
            work1  = even(u     + maxu*ratio)
            work2  = even(work1 + n*ratio)
            work5  = even(work2 + n*ratio)
            needed = work5 + nza+n
            call checkst (option,needed,maxneed,available,iout,flag)
            if (flag.ne.0) return
            t0=second()
            call fsinverse1
     +                    (n,is(perm),is(invp),is(d),is(iju),is(ju),
     +                     is(iu),is(u),is(work1),is(work2),is(work1),
     +                     is(work2),is(work5),ia,ja,a)
            st(26)=st(26)+second()-t0
            st(15)=st(15)+1
c        ----------------------------
         elseif (option.eq.stat) then
c        ----------------------------
            call figureout (n,available,iout,st,jrank)
c        ----
         else
c        ----
            write(iout,*) 'option no. ',option,' not implemented'
            flag=-99
         endif
      endif
      st(20)=st(20)+second()-t_t
      return
      end

      SUBROUTINE SBINI ( N, NZ, IA, JA, A, IWORK )
C
C***********************************************************************
C
C     SBINI IS THE FIRST OF A SUITE OF THREE SUBROUTINES TO AID
C     THE USER TO CONSTRUCT THE IA, JA, A DATA STRUCTURE USED
C     IN ITPACK.
C
C     SBINI INITIALIZES THE ARRAYS IA, JA, IWORK, AND A.  THE OTHER
C     SUBROUTINES IN THE SUITE ARE SBSIJ ( WHICH BUILDS A LINKED
C     LIST REPRESENTATION OF THE MATRIX STRUCTURE ) AND SBEND ( WHICH
C     RESTRUCTURE THE LINKED LIST FORM INTO THE FINAL FORM ).
C
C ... PARAMETERS
C
C ...... INPUT
C
C     N          THE ORDER OF THE LINEAR SYSTEM
C
C     NZ         THE MAXIMUM NUMBER OF NONZEROES ALLOWED IN THE
C                LINEAR SYSTEM.
C
C ...... OUTPUT
C
C     IA         INTEGER ARRAY OF LENGTH N+1.  SBINI SETS THIS ARRAY
C                TO -I FOR I = 1 THRU N.  IA(N+1) IS SET TO NZ.
C
C     JA         INTEGER ARRAY OF LENGTH NZ.  INITIALIZED TO ZERO HERE.
C
C     A          REAL ARRAY OF LENGTH NZ.  INITIALIZED TO ZERO HERE.
C
C     IWORK       INTEGER ARRAY OF LENGTH NZ.  INITIALIZED TO ZERO HERE.
C
C***********************************************************************
C
         INTEGER  N, NZ, IA(N+1), JA(NZ), IWORK(NZ), I
         REAL*8   A(NZ),ZERO
C
C***********************************************************************
C
         ZERO=0.D0
         DO 10 I = 1, N
            IA(I) = -I
   10    CONTINUE
         IA(N+1) = NZ
C
         CALL IVFILL ( NZ, JA  , 0 )
         CALL IVFILL ( NZ, IWORK, 0 )
         CALL VFILL  ( NZ, A   , ZERO )
C
         RETURN
      END
      SUBROUTINE SBSIJ(N,NZ,IA,JA,A,IWORK,II,JJ,VALL,MODE,LEVELL,
     A                                            NOUTT,IERR)
C
C***********************************************************************
C
C     SBSIJ IS THE SECOND OF A SUITE OF THREE SUBROUTINES TO AID IN
C     THE CONSTRUCTION OF THE IA, JA, A DATA STRUCTURE USED IN
C     ITPACK.
C
C     SBSIJ TAKES THE INDIVIDUAL ENTRIES OF THE SPARSE MATRIX AS
C     GIVEN TO IT AT EACH CALL VIA  (I,J,VAL) AND INSERTS IT INTO
C     A LINKED LIST REPRESENTATION OF THE SPARSE MATRIX.
C
C     EACH ROW OF THE SPARSE MATRIX IS ASSOCIATED WITH A CIRCULAR
C     LINKED LIST BEGINNING AT IA(I).  THE LAST ENTERED ELEMENT IN
C     EACH LIST POINTS BACK TO IA(I) WITH THE VALUE -I.  THE LINKS
C     ARE STORED IN THE ARRAY IWORK, WHILE JA AND A STORE THE COLUMN
C     NUMBER AND VALUE IN PARALLEL TO IWORK.  THE LINKED LISTED ARE
C     STORED BEGINNING AT ENTRY NZ AND WORKING BACKWARDS TOWARDS 1.
C
C ... PARAMETERS
C
C ...... INPUT
C
C     N       THE ORDER OF THE LINEAR SYSTEM
C
C     NZ      THE LENGTH OF THE ARRAYS  JA, A, AND IWORK
C
C     I, J    THE ROW AND COLUMN NUMBERS OF THE ENTRY OF THE SPARSE
C             LINEAR SYSTEM TO BE ENTERED IN THE DATA STRUCTURE(=II,JJ)
C
C     VAL     THE NONZERO VALUE ASSOCIATED WITH (I,J)  (= VALL)
C
C     MODE    IF THE (I,J) ENTRY HAS ALREADY BEEN SET, MODE SPECIFIES
C             THE WAY IN WHICH THE ENTRY IS TO BE TREATED.
C             IF   MODE .LT. 0  LET THE VALUE REMAIN AS IS
C                       .EQ. 0  RESET IT TO THE NEW VALUE
C                       .GT. 0  ADD THE NEW VALUE TO THE OLD VALUE
C
C     NOUT  OUTPUT FILE NUMBER (= NOUTT)
C
C     LEVEL   OUTPUT FILE SWITCH (= LEVELL)
C ... INPUT/OUTPUT
C
C     IA      INTEGER ARRAY OF LENGTH N+1.  THE FIRST N ENTRIES
C             POINT TO THE BEGINNING OF THE LINKED LIST FOR EACH
C             ROW.  IA(N+1) POINTS TO THE NEXT ENTRY AVAILABLE FOR
C             STORING THE CURRENT ENTRY INTO THE LINKED LIST.
C
C     JA      INTEGER ARRAY OF LENGTH NZ.  JA STORES THE COLUMN
C             NUMBERS OF THE NONZERO ENTRIES.
C
C     A       REAL ARRAY OF LENGTH NZ.  A STORES THE VALUE OF THE
C             NONZERO ENTRIES.
C
C     IWORK   INTEGER ARRAY OF LENGTH NZ. IWORK STORES THE LINKS.
C
C     IER     ERROR FLAG.(= IERR)  POSSIBLE RETURNS ARE
C             IER =    0   SUCCESSFUL COMPLETION
C                 =  700   ENTRY WAS ALREADY SET,  VALUE HANDLED
C                          AS SPECIFIED BY MODE.
C                 =  701   IMPROPER VALUE OF EITHER I OR J INDEX
C                 =  702   NO ROOM REMAINING, NZ TOO SMALL.
C
C***********************************************************************
C
C
      INTEGER  N, NZ, IA(N+1), JA(NZ), IWORK(NZ), II, JJ, MODE,
     A         LEVELL, NOUTT, IERR
      REAL*8   A(NZ), VALL
C
      INTEGER  LINK, NEXT, NPL1, I, J, LEVEL, NOUT, IER
      REAL*8   VAL, TEMP
C
C***********************************************************************
C
C ... CHECK THE VALIDITY OF THE (I,J) ENTRY
C
      I = II
      J = JJ
      VAL = VALL
      LEVEL = LEVELL
      NOUT= NOUTT
         IER = 0
         IF ( I .LE. 0  .OR.  I .GT. N ) IER = 701
         IF ( J .LE. 0  .OR.  J .GT. N ) IER = 701
      IF (IER .EQ. 0) GO TO 5
      IF(LEVEL .GE. 0) WRITE(NOUT,3) IER,I,J
    3 FORMAT(1H0, 40H*** F A T A L     E R R O R ************
     A     / 1H0, 30H    IN ITPACK ROUTINE SBSIJ
     B     / 1H , 10H    IER = ,I10
     C     / 1H ,  6H    ( ,I10,3H , ,I10,2H )
     D     / 1H , 30H    IMPROPER VALUE FOR I OR J     )
      GO TO 60
C
C ... TRAVERSE THE LINK LIST POINTED TO BY IA(I) UNTIL EITHER
C ... THE J ENTRY OR THE END OF THE LIST HAS BEEN FOUND.
C
    5    NPL1 = N + 1
         LINK = IA(I)
C
C ...... SPECIAL CASE FOR THE FIRST ENTRY IN THE ROW
C
         IF ( LINK .GT. 0 ) GO TO 10
            NEXT = IA(NPL1)
            IF ( NEXT .LT. 1 ) GO TO 50
C
            IA(I)      = NEXT
            JA(NEXT)   = J
            A(NEXT)    = VAL
            IWORK(NEXT) = -I
            IA(NPL1)   = NEXT - 1
            GO TO 60
C
C ... FOLLOW THE LINK LIST UNTIL J OR THE END OF THE LIST IS FOUND
C
   10    IF ( JA(LINK) .EQ. J ) GO TO 20
         IF ( IWORK(LINK) .LE. 0 ) GO TO 30
            LINK = IWORK(LINK)
            GO TO 10
C:
C ... ENTRY (I,J) ALREADY HAS BEEN SET.  RESET VALUE DEPENDING ON MODE
C
   20    IER = 700
      IF(MODE .GE. 0) GO TO 22
      IF(LEVEL .GE. 1) WRITE(NOUT,21) IER,I,J,A(LINK)
   21 FORMAT(1H0, 30H*** W A R N I N G ************
     A     / 1H0, 30H    IN ITPACK ROUTINE SBSIJ
     B     / 1H , 10H    IER = ,I10
     C     / 1H ,  6H    ( ,I10,3H , ,I10,2H )
     D     / 1H , 37H    ENTRY ALREADY SET AND IS LEFT AS ,E15.8 )
      GO TO 60
   22 IF(MODE .GE. 1) GO TO 24
      IF(LEVEL .GE. 1) WRITE(NOUT,23) IER,I,J,A(LINK),VAL
   23 FORMAT(1H0, 30H*** W A R N I N G ************
     A     / 1H0, 30H    IN ITPACK ROUTINE SBSIJ
     B     / 1H , 10H    IER = ,I10
     C     / 1H ,  6H    ( ,I10,3H , ,I10,2H )
     D     / 1H , 40H    ENTRY ALREADY SET - CURRENT VALUE OF ,E15.8
     E     / 1H , 40H                                RESET TO ,E15.8 )
      A(LINK) = VAL
      GO TO 60
   24 TEMP = A(LINK) + VAL
      IF(LEVEL .GE. 1) WRITE(NOUT,25) IER,I,J,A(LINK),TEMP
   25 FORMAT(1H0, 30H*** W A R N I N G ************
     A     / 1H0, 30H    IN ITPACK ROUTINE SBSIJ
     B     / 1H , 10H    IER = ,I10
     C     / 1H ,  6H    ( ,I10,3H , ,I10,2H )
     D     / 1H , 40H    ENTRY ALREADY SET - CURRENT VALUE OF ,E15.8
     E     / 1H , 40H                                RESET TO ,E15.8 )
      A(LINK) = TEMP
      GO TO 60
C
C ... ENTRY (I,J) HAS NOT BEEN SET.  ENTER IT INTO THE LINKED LIST
C
   30    NEXT = IA(NPL1)
         IF ( NEXT .LT. 1 ) GO TO 50
C
         IWORK(LINK)    = NEXT
         JA(NEXT)      = J
         A(NEXT)       = VAL
         IWORK(NEXT)    = -I
         IA(NPL1)      = NEXT - 1
         GO TO 60
C
C***********************************************************************
C
C ... ERROR TRAP FOR NO ROOM REMAINING
C
   50    IER = 702
      IF(LEVEL .GE. 0) THEN
         WRITE(NOUT,55) IER
   55 FORMAT(1H0, 40H*** F A T A L     E R R O R ************
     A     / 1H0, 30H    IN ITPACK ROUTINE SBSIJ
     B     / 1H , 10H    IER = ,I10
     C     / 1H , 50H    INCREASE PARAMETERS AVAILABLE AND NEEDED
     D     / 1H , 40H    NZ TOO SMALL - NO ROOM FOR NEW ENTRY   )
         STOP
      ENDIF
C
   60 CONTINUE
      IERR = IER
      RETURN
      END
      SUBROUTINE SBEND ( N, NZ, IA, JA, A, IWORK )
C
C***********************************************************************
C
C     SBEND IS THE THIRD OF A SUITE OF SUBROUTINES TO AID THE
C     USER TO CONSTRUCT THE  IA, JA, A DATA STRUCTURE USED IN
C     ITPACK.
C
C     SBEND RESTRUCTURES THE LINKED LIST DATA STRUCTURE BUILT BY
C     SBINI AND SBSIJ INTO THE FINAL DATA STRUCTURE REQUIRE BY
C     ITPACK.  THE RESTRUCTURING CAN TAKE PLACE IN THE MINIMUM
C     AMOUNT OF MEMORY REQUIRED TO HOLD THE NONZERO STRUCTURE OF
C     THE SPARSE MATRIX BUT WILL RUN QUICKER IF MORE STORAGE
C     IS ALLOWED.
C
C     SBEND IS BASED ON SUBROUTINE BUILD OF THE SPARSE MATRIX
C     PACKAGE SPARSPAK DEVELOPED BY ALAN GEORGE AND JOSEPH LUI
C     OF THE UNIVERSITY OF WATERLOO, WATERLOO, ONTARIO.
C
C ... PARAMETERS
C
C ...... INPUT
C
C     N       THE ORDER OF THE LINEAR SYSTEM
C
C     NZ      THE LENGTH OF THE ARRAYS JA, IWORK, AND A.
C
C ...... INPUT/OUTPUT
C
C     IA      INTEGER ARRAY OF LENGTH N+1.  THE FIRST N ENTRIES
C             POINT TO THE BEGINNING OF THE LINKED LIST FOR EACH
C             ROW.  IA(N+1)-1 IS THE TOP OF THE LINKED LISTS
C             CONTAINED IN JA, IWORK, AND A.  ON OUTPUT IA WILL
C             POINT TO THE FIRST ENTRY OF EACH ROW IN THE FINAL
C             DATA STRUCTURE.
C
C     JA      INTEGER ARRAY OF LENGTH NZ.  ON INPUT JA STORES THE
C             COLUMN NUMBERS OF THE NONZERO ENTRIES AS INDICATED
C             BY THE LINKED LISTS.  ON OUTPUT JA STORES THE
C             COLUMN NUMBERS IN ROW ORDERED FORM.
C
C     A       REAL ARRAY OF LENGTH NZ.  ON INPUT A STORES THE
C             VALUE OF THE NOZERO ENTRIES AS INDICATED BY THE
C             LINKED LISTS.  ON OUTPUT A STORES THE VALUES IN
C             ROW ORDERED FORM.
C
C     IWORK    INTEGER ARRAY OF LENGTH NZ.  ON INPUT IWORK STORES THE
C             THE LINKS OF THE LINKED LISTS.  ON OUTPUT IT IS
C             DESTROYED.
C
C***********************************************************************
C
         INTEGER   N, NZ, IA(N+1), JA(NZ), IWORK(NZ)
         REAL*8    A(NZ)

C
         INTEGER   MAXTOP, NEXT, TOP, IDEG, NULINK, JAJ, HLINK,
     A             OHLINK, L, I, LINK, MHLINK
         REAL*8    VAL
C
C***********************************************************************
C
C ... INITIALIZATION
C
C ...... THE VARIABLES NEXT AND TOP RESPECTIVELY POINT TO THE
C        NEXT AVAILABLE ENTRY FOR THE FINAL DATA STRUCTURE AND
C        THE TOP OF THE REMAINDER OF THE LINKED LISTS.
C
         NEXT = 1
         TOP  = IA(N+1) + 1
         MAXTOP = NZ - IA(N+1) + 1
C
C***********************************************************************
C
C ... CONVERT EACH ROW INTO FINAL FORM
C
         DO 90 I = 1, N
            IDEG = 0
            NULINK = IA(I)
C
C ... LOOP OVER EACH NODE IN THE LINKED LIST OF ROW I
C
   10       LINK = NULINK
            IF ( LINK .LE. 0 ) GO TO 80
            NULINK = IWORK(LINK)
            JAJ    = JA(LINK)
            VAL    = A(LINK)
C
C ... CHECK TO SEE IF A COLLISION BETWEEN THE LINKED LISTS
C     AND THE FINAL FORM HAS OCCURRED.
C
            IF ( NEXT .GE. TOP  .AND.  LINK .NE. TOP ) GO TO 20
C
C ... COLLISION HAS NOT OCCURRED.  FREE THE SPACE FOR THE TRIPLE
C     (JA(LINK), A(LINK), IWORK(LINK))
C
            JA(LINK)   = 0
            A(LINK)    = 0.D0
            IWORK(LINK) = 0
C
C ... SPECIAL CASE TO MOVE  TOP  DOWN IF LINK .EQ. TOP
C
          IF ( LINK .EQ. TOP ) GO TO 60
          GO TO 70
C
C***********************************************************************
C
C ... COLLISION HAS OCCURRED.  CLEAR OFF SOME SPACE FOR THE CURRENT
C     ENTRY BY MOVING THE TRIPLE ( JA(TOP),A(TOP),IWORK(TOP) )
C     DOWNWARDS TO THE FREED TRIPLE ( JA(LINK),A(LINK),IWORK(LINK) ).
C     THEN ADJUST THE LINK FIELDS.
C
C ...... PATCH UP THE LINKED LIST FOR THE CURRENT ROW I.  THEN
C        TRAVERSE THE LINKED LIST CONTAINING TOP UNTIL THE POINTER
C        POINTER BACK TO IA IS FOUND.
C
   20     IA(I) = LINK
          HLINK = TOP
C
   30        HLINK = IWORK(HLINK)
             IF ( HLINK .GT. 0 ) GO TO 30
C
C ...... NOW FOLLOW THE LINKED LIST BACK TO TOP KEEPING TRACK
C        OF THE OLD LINK.
C
C ......... SPECIAL CASE IF IA(-HLINK) = TOP
C
             MHLINK = -HLINK
             IF ( IA(MHLINK) .NE. TOP ) GO TO 40
C
             IWORK(LINK) = IWORK(TOP)
             JA(LINK)   = JA(TOP)
             A(LINK)    = A(TOP)
             IA(MHLINK) = LINK
             IF ( NULINK .EQ. TOP ) NULINK = LINK
             GO TO 60
C
C ......... USUAL CASE.
C
   40        HLINK = IA(MHLINK)
   50        OHLINK = HLINK
             HLINK = IWORK(OHLINK)
                IF ( HLINK .NE. TOP ) GO TO 50
C
             IWORK(LINK)   = IWORK(TOP)
             JA(LINK)     = JA(TOP)
             A(LINK)      = A(TOP)
             IF ( OHLINK .NE. LINK ) IWORK(OHLINK) = LINK
             IF ( NULINK .EQ. TOP ) NULINK = LINK
C
C ... COLLAPSE TOP OF LINK LIST BY AS MUCH AS POSSIBLE
C
   60       TOP = TOP + 1
            IF ( TOP .GE. MAXTOP ) GO TO 70
            IF ( IWORK(TOP) .NE. 0 ) GO TO 70
            GO TO 60
C
C***********************************************************************
C
C ... PUT THE CURRENT TRIPLE INTO THE FINAL DATA STRUCTURE
C
   70       JA(NEXT) = JAJ
            A(NEXT)  = VAL
            NEXT     = NEXT + 1
            IDEG     = IDEG + 1
            GO TO 10
C
C ... FINAL STRUCTURE FOR ROW I IS COMPLETE.  LINKED LIST IS
C     DESTROYED AND WILL BE RECAPTURED AS NECESSARY BY THE
C     LOOP ON LABEL 60
C
   80       IA(I) = IDEG
C
   90    CONTINUE
C
C***********************************************************************
C
C ... FINALIZE THE DATA STRUCTURE BY BUILDING THE FINAL VERSION OF
C     IA.
C
         L     = IA(1) + 1
         IA(1) = 1
         DO 100 I = 1, N
            IDEG = IA(I+1)
            IA(I+1) = L
            L = L + IDEG
  100    CONTINUE
C
C ... FINAL IA, JA, A DATA STRUCTURE BUILT.
C
         RETURN
      END
      SUBROUTINE IVFILL(N,IV,IVAL)
C
C     FILLS AN INTEGER VECTOR, IV, WITH AN INTEGER VALUE, IVAL.
C
C ... PARAMETER LIST:
C
C          N      INTEGER LENGTH OF VECTOR IV
C          IV     INTEGER VECTOR
C          IVAL   INTEGER CONSTANT THAT FILLS FIRST N LOCATIONS OF IV
C
C ... SPECIFICATIONS FOR ARGUMENTS
C
      INTEGER N, IVAL, IV(N)
C
C ... SPECIFICATIONS FOR LOCAL VARIABLES
C
      INTEGER I, M, MP1
C
         IF (N .LE. 0) RETURN
C
C     CLEAN UP LOOP SO REMAINING VECTOR LENGTH IS A MULTIPLE OF 10
C
      M = MOD(N,10)
         IF (M .EQ. 0) GO TO 20
            DO 10 I = 1,M
   10         IV(I) = IVAL
         IF (N .LT. 10) RETURN
C
   20 MP1 = M + 1
         DO 30 I = MP1,N,10
            IV(I  ) = IVAL
            IV(I+1) = IVAL
            IV(I+2) = IVAL
            IV(I+3) = IVAL
            IV(I+4) = IVAL
            IV(I+5) = IVAL
            IV(I+6) = IVAL
            IV(I+7) = IVAL
            IV(I+8) = IVAL
            IV(I+9) = IVAL
   30    CONTINUE
C
      RETURN
      END
      SUBROUTINE VFILL(N,V,VAL)
C
C     FILLS A VECTOR, V, WITH A CONSTANT VALUE, VAL.
C
C ... PARAMETER LIST:
C
C          N      INTEGER LENGTH OF VECTOR V
C          V      REAL VECTOR
C          VAL    REAL CONSTANT THAT FILLS FIRST N LOCATIONS OF V
C
C ... SPECIFICATIONS FOR ARGUMENTS
C
      INTEGER N
      REAL*8  V(N),
     A        VAL
C
C ... SPECIFICATIONS FOR LOCAL VARIABLES
C
      INTEGER I, M, MP1
C
         IF (N .LE. 0) RETURN
C
C     CLEAN UP LOOP SO REMAINING VECTOR LENGTH IS A MULTIPLE OF 10
C
      M = MOD(N,10)
         IF (M .EQ. 0) GO TO 20
            DO 10 I = 1,M
   10         V(I) = VAL
         IF (N .LT. 10) RETURN
C
   20 MP1 = M + 1
         DO 30 I = MP1,N,10
            V(I  ) = VAL
            V(I+1) = VAL
            V(I+2) = VAL
            V(I+3) = VAL
            V(I+4) = VAL
            V(I+5) = VAL
            V(I+6) = VAL
            V(I+7) = VAL
            V(I+8) = VAL
            V(I+9) = VAL
   30    CONTINUE
C
      RETURN
      END
      SUBROUTINE SBAGN (N,NZ,IA,JA,A,IWORK,LEVELL,NOUTT,IERR)
C
C ... THE ROUTINES SBINI, SBSIJ, AND SBEND CREATE A SPARSE
C     MATRIX STRUCTURE BY MEANS OF A LINKED LIST WHICH IS
C     DESTROYED BY SBEND. SBAGN CREATES A NEW LINKED LIST
C     SO THAT ELEMENTS MAY BE ADDED TO THE MATRIX AFTER SBEND
C     HAS BEEN CALLED. SBAGN SHOULD BE CALLED WITH THE APPRO-
C     PRIATE PARAMETERS, AND THEN SBSIJ AND SBEND CAN BE CALLED
C     TO ADD THE ELEMENTS AND COMPLETE THE SPARSE MATRIX STRUC-
C     TURE.
C
C ... PARAMETER LIST:
C
C           N       ORDER OF THE SYSTEM
C           NZ      MAXIMUM NUMBER OF NON-ZERO ELEMENTS
C                   IN THE SYSTEM
C           IA, JA  INTEGER ARRAYS OF THE SPARSE
C                   MATRIX STRUCTURE
C           A       REAL ARRAY OF THE SPARSE MATRIX
C                   STRUCTURE
C           IWORK   WORK ARRAY OF DIMENSION NZ
C           LEVEL   OUTPUT LEVEL CONTROL (= LEVELL)
C           NOUT  OUTPUT FILE NUMBER (= NOUTT)
C           IER     ERROR FLAG (= IERR). POSSIBLE RETURNS ARE
C                      IER = 0, SUCCESSFUL COMPLETION
C                          = 703, NZ TOO SMALL - NO MORE
C                                 ELEMENTS CAN BE ADDED
C
C ... SPECIFICTIONS FOR ARGUMENTS
C
      INTEGER NZ, IA(1), JA(1), IWORK(NZ),
     A        N, LEVELL, NOUTT, IERR
      REAL*8   A(NZ)
C
C ... SPECIFICATIONS FOR LOCAL VARIABLES
C
      INTEGER I, IER, J, LEVEL, NOUT, NADD, NADDP1, NOW, NP1,
     A        NTO, NTN
C
C ... INITIALIZE LOCAL VARIABLES AND MAKE ERROR CHECK
C
      NOW = IA(N+1) - 1
      NADD = NZ - NOW
      IER = 0
      LEVEL = LEVELL
      NOUT = NOUTT
      IF (NADD .LE. 0) IER = 703
      IF (IER .EQ. 0) GO TO 5
      IF (LEVEL .GE. 0) THEN
         WRITE (NOUT,3) IER
    3 FORMAT(1H0, 40H*** F A T A L     E R R O R ************
     A     / 1H0, 30H    IN ITPACK ROUTINE SBAGN
     B     / 1H , 10H    IER = ,I10
     C     / 1H , 50H    INCREASE PARAMETERS AVAILABLE AND NEEDED
     D     / 1H , 40H    NZ TOO SMALL - NO ROOM FOR NEW ENTRY   )
        STOP
      ENDIF
      GO TO 60
C
C ... SHIFT ELEMENTS OF A AND JA DOWN AND ADD ZERO FILL
C
   5  NTO = NOW
      NTN = NZ
      DO 10 I=1,NOW
         JA(NTN) = JA(NTO)
         A(NTN) = A(NTO)
         NTO = NTO - 1
         NTN = NTN - 1
  10     CONTINUE
      DO 20 I=1,NADD
         JA(I) = 0
         A(I) = 0.0
  20     CONTINUE
C
C ... UPDATE IA TO REFLECT DOWNWARD SHIFT IN A AND JA
C
      NP1 = N + 1
      DO 30 I=1,NP1
  30     IA(I) = IA(I) + NADD
C
C ... CREATE LINKED LIST
C
      NADDP1 = NADD + 1
      DO 40 I=NADDP1,NZ
  40     IWORK(I) = I + 1
      DO 45 I=1,NADD
  45     IWORK(I) = 0
      DO 50 I=1,N
         J = IA(I+1) - 1
  50     IWORK(J) = -I
C
C ... INDICATE IN LAST POSITION OF IA HOW MANY SPACES
C     ARE LEFT IN A AND JA FOR ADDITION OF ELEMENTS
C
      IA(N+1) = NADD
      RETURN
C
C ... ERROR RETURN
C
  60  IERR = IER
      RETURN
      END
