      subroutine parchange
      use parinclu
      implicit none
! subroutine to change values of former parameters from parinclu
      integer :: NWORD,errflag,changed,IUNIT,hessflag
      INTEGER :: NFIG(0:MAXWORD),LFIG(0:MAXWORD),IFIG(MAXFIG)
      real :: XFIG(MAXFIG)
      CHARACTER*8 :: w8
      character*16 :: NFILE
      CHARACTER WORD(MAXLENG,0:MAXWORD),TITLE(70)
!      CHARACTER*100 parm2

!starting values
      errflag=0
      hessflag=0
      outflag=0
      wn=0
!reading input files
      IF (SUPPLY_INPUT1) THEN
        print *,'name of first parameter file (=output from prepare) ?'
        read(*,'(A20)') parm1
      ELSE
        print *,'first parameter file (=output from prepare) ',
     +   trim(PARM1),' ( = default)'
      ENDIF
      IF (SUPPLY_INPUT2) THEN
        print *,'name of second parameter file (=model specification)?'
        read(*,'(A20)') parm2
      ELSE
        print *,'second parameter file (=model specification) ',
     +    trim(PARM2),' ( = default)'
      ENDIF
	  
!reading parameter file for weibull
 !       parm2=INPUT_FILE2   !! (for now) works only if parameter file set in parinclu by default
       IUNIT=11
       CALL READPARM(IUNIT,NWORD,TITLE,WORD,NFIG,LFIG,IFIG,XFIG,parm2)
	  
!search for keywords
      do
        wn=wn+1
        if (wn >= NWORD) exit
          W8=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +  //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)

      select case (W8)
C-----------------------------------------------------------------------
C         * KEYWORD = FILES
C kn = 60 * reads the name of 3 or 4 files LATER
C         * here for the error message and to write out the LOGFILE name
C-----------------------------------------------------------------------
      case ('FILES   ')
c keywords for parameter change should appear before FILES
         errflag=1
c writes out information about the LOGFILE
      IF (SUPPLY_OUTPUT) THEN
        print *,'name of output file (=NONE if output=terminal)?'
        read(*,'(A20)') parmout
      ELSE
        if (outflag.eq.0) then
           print *,'detailed output file ',trim(PARMOUT),
     +             ' ( = default)'
        else
           print *,'detailed output file ',trim(PARMOUT),
     +             ' ( = user defined)'
        endif
      ENDIF 
		 
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NTIMMAX
C kn = 68 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NTIMMAX ')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,ntimmax)
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NSTIMAX
C kn = 69 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NSTIMAX ')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,nstimax)
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NLEVOUT
C kn = 70 * default value in MODULE PARINCLU mxlvout
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NLEVOUT ')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,mxlvout)
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NVEC_BF
C kn = 71 * default value in MODULE PARINCLU mvec_bf
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NVEC_BF ')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,mvec_bf)
c values for MVEC_BF should be between 3 and 20
                 if (MVEC_BF .ge. 0 .and. MVEC_BF .le. 2
     +           .or. MVEC_BF .ge. 21) then
                     write(6,9551)
 9551                FORMAT(1X,' Error in the NVEC_BF statement',
     +                  /1X,' Values should be between 3 and 20',
     +                  /1X,' Negative values in parameter file ignored',
     +                  /1X,' Check parameter file')
                     STOP
                 endif
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NO_LOGAR(ITHM)
C kn = 72 * default value in MODULE PARINCLU no_log
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NO_LOGAR')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,no_log)
c values for NO_LOG should be 0 or 1
                 if (NO_LOG .ge. 2) then
                     write(6,9552)
 9552                FORMAT(1X,' Error in the NO_LOGARITHM statement',
     +             /1X,' Please state 0 to use log(rho) ',
     +                 'or 1 to use rho',
     +             /1X,'   in the WEIBULL maximalization routine',
     +             /1X,' Negative values in parameter file are ignored',
     +             /1X,' Check parameter file')
                     STOP
                 endif
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NPGAUSS
C kn = 73 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NPGAUSS ')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,npgauss)
c values for NPGAUSS should be between 3 and 5
                 if (NPGAUSS .ge. 0 .and. NPGAUSS .le. 2
     +           .or. NPGAUSS .ge. 6) then
                     write(6,9553)
 9553                FORMAT(1X,' Error in the NPGAUSS statement',
     +                  /1X,' Values should be between 3 and 5',
     +                  /1X,' Negative values in parameter file ignored',
     +                  /1X,' Check parameter file')
                     STOP
                 endif
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NITER_GA(USS)
C kn = 74 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NITER_GA')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,niter_gauss)
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NRECMAX
C kn = 75 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NRECMAX ')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,nrecmax)
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NEFMAX
C kn = 76 * default value in MODULE PARINCLU mxef
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NEFMAX  ')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,mxef)
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NSTRAMAX
C kn = 77 * default value in MODULE PARINCLU mxstra
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NSTRAMAX')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,mxstra)
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NDIMAX
C kn = 78 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NDIMAX  ')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user + sets new default value for NDIMAX2
         call thechange(w8,nfig,lfig,ifig,ndimax)
         ndimax2=ndimax
c keyword should appear before NO_HESS statement
         if (hessflag .eq. 1) then
             WRITE(6,9501)
 9501        FORMAT(1X,' Error in the NDIMAX statement',
     +             /1X,' It should appear before NO_HESS statement',
     +             /1X,' Check parameter file')
             STOP
         endif
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = NO_HESSI(AN)
C kn = 79 * default value at beginning of main
C         * sets NDIMAX2=1 i.e. Hessian martix not needed
C-----------------------------------------------------------------------
      case ('NO_HESSI')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c error flag for keyword NDIMAX
         hessflag=1
c reads in new value specified by user
         NDIMAX2=1
         print*,'NDIMAX2 set to 1 => Hessian matrix not stored'
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = WITH_MGD
C kn = 80 * default value in MODULE PARINCLU
C         * changes variable NCOLPED if maternal granddam is present
C-----------------------------------------------------------------------
      case ('WITH_MGD')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c maternal granddam present in the recoded pedigree file
         ncolped=4
         print*,'Maternal granddam present in the recoded pedigree file'
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = LOGFILE
C kn = 81 * specifies if the name of the output file should be given at
C         *   runtime or pre-specified by the user in the parameter file
C         * interacts with variables SUPPLY_OUTPUT and parmout
C-----------------------------------------------------------------------
      case ('LOGFILE ')
c check if appears before FILES statement
         call firstpos(w8,errflag)	  
c if keyword is specified, name of output file taken by default
         SUPPLY_OUTPUT=.false.
cc two options here ...
ccc only LOGFILE; is specified => default filename from parinclu.f is used
        IF (WORD(1,wn+1).EQ.';') THEN
           wn=wn+1
        ELSE
ccc LOGFILE <filename>; is used => reads in the user specified file name
           wn=wn+1;
           outflag=1
ccc        the name of the new file
           PARMOUT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)//
     +            WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)//
     +            WORD(9,wn)//WORD(10,wn)//WORD(11,wn)//WORD(12,wn)//
     +            WORD(13,wn)//WORD(14,wn)//WORD(15,wn)//WORD(16,wn) 
ccc        next word has to be ";"
               call semicol(w8,word)
               wn = wn+1
        ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NZE_HESS(IAN)
C kn = 82 *  default value in MODULE PARINCLU
C         *  with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------
      case ('NZE_HESS')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechange(w8,nfig,lfig,ifig,nze_hess)
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = USE_R 
C kn = 83 * specifies if the user wants to use the R interface (available 
C         *   from v6.07. This creates additional files which can be 
C         *   plotted using the R function
C-----------------------------------------------------------------------
      case ('USE_R   ')
c check if appears before FILES statement
         call firstpos(w8,errflag)	
c turns the R switch on
         useR=.true.
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1
C-----------------------------------------------------------------------
C         * KEYWORD = PRECISIO(N)
C kn = 75 * This keyword is to increase or dectrease the precision of 
C         *  the varinace of the random effects when using the simplex 
C         *  subroutine AND the estimated correlation coefficient when 
C         *  estimating correlated random effects. At the same time it 
C         *  also increases or decreases and the computional time. 
C         *  Permitted real numbers are between 0 and 100, with values below 
C         *  and above 1 decreasing/increasing the precision. If you going 
C         *  to estimate the correlaton coefficient, DO NOT decrease the 
C         *  precision more than 10 times, preferably not at all, 
C         *  as this would lead to incorrect results. 
C         *  Use this keyword at your own risk.
C
C  variance:    DELMIN(NPARMI)=0.0001*(1.d0/precorr_mul)
C  correlation: DELMIN(NPARMI)=0.01*(1.d0/precorr_mul)
C
C Values above 1 increase precision, values below 1 decrease precision. 
C Usage: PRECISION value;
C-----------------------------------------------------------------------		   
      case ('PRECISIO')
c check if appears before FILES statement
         call firstpos(w8,errflag)
c reads in new value specified by user
         call thechangeR(w8,nfig,lfig,ifig,xfig,precorr_mul)	
c check for error
         if (precorr_mul.le.0 .or. precorr_mul.gt.100) then
           WRITE(6,9502)
 9502      FORMAT(1X,' Error in the PRECISION statement',
     +           /1X,' The specified value should be between 0 and 100',
     +           /1X,' Check parameter file')
           STOP
         endif
c next word has to be ";"
         call semicol(w8,word)
         wn = wn+1		
C-----------------------------------------------------------------------
C         * KEYWORD = 
C kn =    *  
C         *
C-----------------------------------------------------------------------
      end select
      end do

      contains

!***********************************************************************
      subroutine semicol(anykw,wordx)
! to check if there is a semicolon after the statement
!***********************************************************************
      implicit none
      CHARACTER WORDX(MAXLENG,0:MAXWORD)
      CHARACTER*8 anykw

                 IF (WORDX(1,wn+1).NE.';') THEN
                     WRITE(6,9510) anykw
 9510                FORMAT(1X,' Error in the ',A8,' statement',
     +                     /1X,' There is a semi-colon missing',
     +                     /1X,' Check parameter file')
                     STOP
                 ENDIF
      end subroutine semicol
	  
!***********************************************************************
       subroutine thechange(anykw2,nfigx,lfigx,ifigx,thevariable)
! subroutine to change values, if keyword is specified
!***********************************************************************
      implicit none
      INTEGER :: NFIGX(0:MAXWORD),LFIGX(0:MAXWORD),IFIGX(MAXFIG)
      integer :: actual,thevariable
      CHARACTER*8 anykw2

c reads in new value specified by user
         if (nfigx(wn) .gt. 0) then
             actual = lfigx(wn)
             if (ifigx(actual) .ge. 0) then
                 thevariable = ifigx(actual)
                 WRITE(6,9511) anykw2,thevariable
 9511            FORMAT(1X,A8,' changed to ',I8)
             endif
         endif

      end subroutine thechange

!*************************************************
       subroutine thechangeR(anykw2,nfigx,lfigx,ifigx,xfigx,thevariable)
! subroutine to change values, if keyword is specified
!*************************************************
      implicit none
      INTEGER :: NFIGX(0:MAXWORD),LFIGX(0:MAXWORD),IFIGX(MAXFIG)
      integer :: actual
      real*8 :: thevariable
      real :: XFIGX(MAXFIG)
      CHARACTER*8 anykw2
	  
c reads in new value specified by user
         if (nfigx(wn) .gt. 0) then
           actual = lfigx(wn)
           IF (XFIG(LFIG(wn)).NE.0.) THEN
             thevariable = XFIG(actual)
           ELSE
             thevariable = DBLE(IFIG(actual))
           ENDIF
           WRITE(6,9511) anykw2,thevariable
 9511      FORMAT(1X,A8,' changed to ',F8.4)
         endif
	  
      end subroutine thechangeR
	  
!***********************************************************************
      subroutine firstpos(anykw3,dummyflag)
! to check if keyword appears before FILES statement
!***********************************************************************
      implicit none
      integer dummyflag
      CHARACTER*8 anykw3

      if (dummyflag .eq. 1) then
         WRITE(6,9512) anykw3
 9512    FORMAT(1X,' Error in the ',A8,' statement',
     +         /1X,' It should appear before FILES statement',
     +         /1X,' Check parameter file')
        STOP
       endif

       end subroutine firstpos

!-----------------------------------------------------------------------	   
      end subroutine parchange
	  
