      SUBROUTINE PREDICTED(BETA1)
C***********************************************************************
C  PREDICTED   *                                      *  22 / 02 /1996 *
C***********************************************************************
C  COMPUTE THE VALUES OF S(T) FOR GIVEN T or T FOR GIVEN S(T) FOR DUMMY*
C     RECORDS DEFINED BY THE "FUTURE" STATEMENT IN PREPARE             *
C***********************************************************************
c
      use parinclu
      implicit none
c
      integer,allocatable:: irest(:)   !IREST(NSTIMAX)
      integer,allocatable:: iresq(:)   !IRESQ(NSTIMAX)
      real*8,allocatable:: rest(:)     !REST(NSTIMAX)
c
      INTEGER ICODE,IS,IQ,IT,ITIM,ITIMV,ITIMMO,ITIMMOPR,ITIMDIF
      INTEGER I,J,JJ,K,ISTR,IPRSTR
      INTEGER LTAB
      INTEGER NDCOV0,NDCOV1,NDCOVP1,NDIM2
      INTEGER NDIMBPS
      INTEGER IANI,IANIPREV
C
      REAL*8 CUM_RISK,X,U,W1,W2,W3,TRHO,XRHO,OMEG
      REAL*8 SX,RHO,XCOV,DLXST
      REAL*8 BETA1(*)
      REAL*8 TPRERHO,XPRRHO,TPRRHO,LRHO,DLTIM
C
C
      allocate( IREST(NSTIMAX) )
      allocate( IRESQ(NSTIMAX) )
      allocate( REST(NSTIMAX) )
	  
C
C-----------------------------------------------------------------------
C  INITIALIZATION
C-----------------------------------------------------------------------
C
      NDCOV0 = NCCOV + 1
      NDCOV1 = NCCOV + NDCOV
      NDCOVP1 = NDCOV1 + 1
      OMEG=0.D0
      NDIMBPS= NDIMB + NSTRATA
C-----------------------------------------------------------------------
C  Added on Jan 11 2013: chnage the first dimension of blockb2%info2
C  from
c  4 to 5 if KORIGIN..NE.0
C-----------------------------------------------------------------------
C
      NDIM2=4
      IF (ITDEPSTR.NE.0)  NDIM2=NDIM2+2
C----------------------------------------------------------------------
c<<<<<<<< modified on April 17, 1997 for ICRHO=0 >>>>>>>>>>>>>>>>>>>>>>>
C  READ THE VALUE(S) OF RHO IF ICRHO=1
C----------------------------------------------------------------------
      IF (ICRHO.EQ.1) THEN
        K = NSTRATA
        IF (NO_LOG.EQ.1) THEN
          DO 11 I=1,NSTRATA
            VALRHO(I) = BETA1(NDIMBPS+I)
            DLOGRHO(I) = DLOG(VALRHO(I))
  11      CONTINUE
        ELSE
          DO 12 I=1,NSTRATA
            DLOGRHO(I) = BETA1(NDIMBPS+I)
            VALRHO(I) = DEXP(DLOGRHO(I))
  12      CONTINUE
        ENDIF
      ELSE IF (ICRHO.EQ.99) THEN
        DO 16 I=1,NSTRATA
          DLOGRHO(I) = 0.D0
          VALRHO(I) =  1.D0
  16    CONTINUE
      ENDIF
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      VECLOG(1)=0.D0
      DO 13 I=1,NSTRATA
         VECEXP(1,I) =  1.D0
         DO 14 J=2,MAXTIM(I)
           VECLOG(J)=DLOG(DBLE(J))
           IF (ICRHO.EQ.99) THEN
              VECEXP(J,I)=DBLE(J)
           ELSE
              IF (VECLOG(J).NE.0.D0) THEN
                VECEXP(J,I) =  DEXP(VALRHO(I)*VECLOG(J))
              ENDIF
           ENDIF
  14    CONTINUE
  13  CONTINUE
C-----------------------------------------------------------------------
C  COMPUTATION OF (PART OF) THE SURVIVOR CURVE FOR INDIVIDUALS IN FILE(10)
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IANIPREV=-999
      IT = 1
      IS=1
      IQ=1
      TPRERHO=0.D0
      WRITE(13,9100)
  300 IF (NSTOR.NE.1) THEN
          OPEN(7,file=FILE(10),FORM='UNFORMATTED')
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on December 12, 1996
c partie a changer pour blocked unformatted et compress
C NDIM2 added on Jan 11 2013:
cc##################################################
        IF (IOMODE.NE.4) THEN
c          READ(7,END=399) NREC2,LTAB,(KREC2(I),I=1,LTAB)
c        ELSE
          READ(7,END=399) NREC2,LTAB,
     + ((blockb2%info2(i,j),i=1,NDIM2),j=1,nrecmax2), 
     + ((blockb2%idata2(i,j),i=1,mxef_used),j=1,nrecmax2),
     + ((blockb2%xdata2(i,j),i=1,mxef_used),j=1,nrecmax2)
        ENDIF
      ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C
C-----------------------------------------------------------------------
C   FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
       DO 390 I=1,NREC2
         ITIM=blockb2%info2(1,I)
         ICODE=blockb2%info2(2,I)
         ISTR=blockb2%info2(3,I)
         IANI=blockb2%info2(4,I)
C ITIMV added on Jan 11 2013: true time (not deviation from any origin)
C IPRSTR: stratum number of previous elementary record  
         IF (IPRSTR.EQ.0) THEN
            IPRSTR=ISTR
            ITIMMOPR=0
         ENDIF 
         IF (ITDEPSTR.NE.0) THEN
            ITIMV=blockb2%info2(NDIM2,I)
            ITIMMO=blockb2%info2(NDIM2-1,I)
            ITIMDIF=ITIMV-ITIMMO
         ELSE
            ITIMV=ITIM
         ENDIF
         if (I.EQ.1)  print*,'ITIM,ICODE,IPRSTR,ISTR,IANI,ITIMV,ITIMDIF'
         if (I.LT.20) then 
             print*,' '
           print*,'new rec',ITIM,ICODE,IPRSTR,ISTR,IANI,ITIMV,
     +       ITIMDIF,ITIMMOPR
         endif
         RHO = VALRHO(IPRSTR)
         LRHO = DLOGRHO(IPRSTR)
         IF (IANI.NE.IANIPREV) THEN
            IF (IANIPREV.NE.-999) THEN
              WRITE(13,*) ' '
              DO 270 J = 1,IT-1
                WRITE(13,9120) IANIPREV,IREST(J),REST(J)
                REST(J)=0.D0
  270         CONTINUE
              DO 275 J = 1,NQUANT
                WRITE(13,9110) IANIPREV,SQUANT(J),IRESQ(J)
                IRESQ(J)=0
  275         CONTINUE
              OMEG = 0.D0
              TPRERHO=0.D0
              IS = 1
              IQ = 1
              IT = 1
            ENDIF
         ENDIF
         IANIPREV = IANI
C----------------------------------------------------------------------
C     W1 = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C     FIRST, NCCOV CONTINUOUS COVARIATES, THEN NDCOV DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => W2 = EXP(W1) WILL BE = 0
C----------------------------------------------------------------------
         W1 = 0.D0
         DO 25 J=1,NCCOV
           XCOV = blockb2%xdata2(J,I)
           W1 = W1 + BETA1(J) * XCOV
           IF (BETA1(J).LE.-999.D0) W1 = -999.9D0
   25    CONTINUE
         DO 30 J=NDCOV0,NDCOV1
           K = blockb2%idata2(J,I)
           W1 = W1 + BETA1(K)
   30    CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         DO 31 J=1,NCOEF(0)
           JJ=NCOEF(J)
           K = blockb2%idata2(I,JJ)
           IF (K.NE.0) W1 = W1 + (XCOEF(JJ) - 1.D0) * BETA1(K)
   31  CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         W1 = W1 + BETA1(NDIMB+ISTR)
C
C-----------------------------------------------------------------------
C   COMPUTE W2 = EXP(W1) AND W3 = W2 * (ITIM**RHO - PREVIOUS TIME**RHO)
C-----------------------------------------------------------------------
         W2 = 0.D0
         IF (W1.GT.-25.D0) W2 = DEXP(W1)
         DLTIM = VECLOG(ITIM)
C TRHO modified on Jan 11 2013: at time ITIM value of weibull hazard
C for new (?) stratum
C TSTRRHO: same from previous stratum 
C the two are identical if no change in stratum  
         TRHO = VECEXP(ITIMDIF,ISTR)
         TPRRHO = VECEXP(ITIM,IPRSTR)
         X = (TPRRHO - TPRERHO)
         W3 = W2 * (TPRRHO - TPRERHO)
c
         OMEG = OMEG + W3
         IF (I.LT.1) THEN
           PRINT*,'ITIM,ISTR,IPRSTR,TRHO,TPRRHO,W2,W3,OMEG'
         ENDIF
         IF (I.LT.30) THEN
           IF (X.LT.0) print*,'attention'
           PRINT*,ITIM,ISTR,IPRSTR,W2,W3,OMEG,X
           PRINT*,'TRHO,TPRRHO,TPRERHO',TRHO,TPRRHO,TPRERHO
         ENDIF
C
C-----------------------------------------------------------------------
C  IF THERE ARE SPECIFIC TIMES IN VECTOR ISTIME FOR WHICH S(T) IS TO
C        BE COMPUTED (I.E., IF NSTIME>0)
C    ==> CHECK WHETHER THE FIRST ONE (ISTIME(IS)) IS LESS THAN ITIMV
C-----------------------------------------------------------------------
  310    IF ((NSTIME.EQ.0).OR.(IS.GT.NSTIME)) GOTO 320
         IF (ISTIME(IS).LE.ITIMV) THEN
           DLXST = VECLOG(ISTIME(IS)-ITIMMOPR)
C XPRRHO modified on Jan 11 2013: at time ITIM value of weibull hazard
C with value of (possibly previous) stratum. 
           XPRRHO = VECEXP(ISTIME(IS)-ITIMMOPR,IPRSTR)
c          XRHO = VECEXP(ISTIME(IS),ISTR)
           CUM_RISK= OMEG - W2 * (TPRRHO - XPRRHO)
           SX = DEXP( - CUM_RISK)
           IREST(IT) = ISTIME(IS)
           REST(IT) = SX
         if (I.LT.20)  print*,'==>',ISTIME(IS),ITIMMOPR,CUM_RISK,SX,
     +        TPRRHO,XPRRHO
           IT = IT + 1
           IS = IS+1
           GOTO 310
         ENDIF
C
  320    IF ((NQUANT.EQ.0).OR.(IQ.GT.NQUANT)) GOTO 380
         SX = DEXP( - OMEG)
         IF (SX.LE.SQUANT(IQ)) THEN
            IF (SX.EQ.SQUANT(IQ).OR.W2.EQ.0.D0) THEN
               IRESQ(IQ) = ITIMV
            ELSE
               U = TRHO - (OMEG + DLOG(SQUANT(IQ))) / W2
               U = DEXP(DLOG(U)/RHO)
               IRESQ(IQ) = NINT(U)
            ENDIF
            IQ = IQ + 1
            GOTO 320
          ENDIF
C
  380    IF (ICODE.GE.0) THEN
            TPRERHO = 0.D0
            IPRSTR=0
            ITIMMOPR=0
          ELSE
            TPRERHO = TRHO
            IPRSTR=ISTR
            ITIMMOPR=ITIMMO
          ENDIF
  390   CONTINUE
        IF (NSTOR.NE.1) GOTO 300
C
  399   IF (NSTOR.NE.1) CLOSE(7)
        WRITE(13,*) ' '
        DO 370 J = 1,IT-1
          WRITE(13,9120) IANI,IREST(J),REST(J)
  370   CONTINUE
        DO 375 J = 1,NQUANT
         WRITE(13,9110) IANI,SQUANT(J),IRESQ(J)
  375   CONTINUE
C
 9100   FORMAT(/1X,' ANIMAL  //  AT TIME T =    S(T) =   //   S(T)',
     +    ' REACHES:   AT TIME T = // ')
 9110   FORMAT(1X,I8,35X,F8.5,8X,I6)
 9120   FORMAT(1X,I8,8X,I6,3X,F8.5)
 9130 FORMAT(1X,'WARNING: AT THE LARGEST TIME =',I6,' FOR S0(T) OF ',
     + 'THIS STRATUM, THE SURVIVOR CURVE HAS A VALUE = ',
     + F8.5,' LARGER THAN THE QUANTILE VALUE REQUESTED = ',F8.5,
     +' FOR ANIMAL ',I8)
 9140 FORMAT(1X,'WARNING: TIME T =',I6,' FOR WHICH S(T) IS REQUIRED',
     + ' IS LARGER THAN THE LARGEST TIME = ',I6,' FOR S0(T)')
C
      deallocate(irest,iresq,rest)
	 
      RETURN
C***********************************************************************
      END
