 
      subroutine sortqr(a,n,m,ix,iy,col,icol)
c sorts matrix of reals by icol columns given by col, in ascending
c order. Matrix a is n x m, only first ix rows and iy columns are sorted
c !! same as sortqm except rows and columns switched 
      use kinds
      implicit none
      integer :: i,j,s,l,r,j1,j2,k,a1,a2,iy,icol,ix,m,n
      real (rh) ::a(:,:),x(20),x1
      integer :: stack(50,2),col(:)

      s=1
      stack(1,1)=1
      stack(1,2)=ix
10    l=stack(s,1)
      r=stack(s,2)
      s=s-1
20    i=l
      j=r
      j1=(l+r)/2
      do  k=1,icol
         x(k)=a(col(k),j1)
      enddo
30    do  k=1,icol
         a1=a(col(k),i)
         a2=x(k)
         if (a1.lt.a2) then
            i=i+1
            goto 30
         else if(a1.gt.a2) then
            goto 40
         endif
      enddo
40    do k=1,icol
         a1=a(col(k),j)
         a2=x(k)
         if (a1.gt.a2) then
            j=j-1
            goto 40
         else if(a1.lt.a2) then
            goto 47
         endif
      enddo
47    if (i.le.j) then
         do j2=1,iy
            x1=a(j2,i)
            a(j2,i)=a(j2,j)
            a(j2,j)=x1
         enddo
         i=i+1
         j=j-1
      endif
      if (i.le.j) goto 30
      if (i.lt.r) then
         s=s+1
         stack(s,1)=i
         stack(s,2)=r
      endif
      r=j
      if (l.lt.r) goto 20
      if (s.ne.0) goto 10
      end
 
      integer function hashvr(dat,r,ind,m,n,mode,nr)
c returns address of  element of ind()  containing real vector dat.
c Searching goes with a HASH technique. When mode=1 and dat was not
c there before, dat is written  into ind("hash",1..r). When mod=0
c and dat is not found, this function returns 0.
c rank of ind is m x n,
c dat contains r numbers.
c !! same as hashvec except that rows and columns switched !!
c !! same as hashves except that on low memory returns -1 and reals
      use kinds
      implicit none
      integer r,mode,nr,m,n
      integer,save :: hit,ncall
      real (rh) :: ind(:,:),dat(r),rate
      integer iaddr,prime(20),ie,iaddress,k,izer,ieq,i1,i,K1
      data ie/17/,prime/433,53,761,197,1039,31,887,389,277,97,
     + 977,881,701,739,457,449,113,167,83,71/
c        
      iaddr=0
      k1=r 
      do  i=1,r
         iaddr=iaddr+prime(i)*dat(i)
      enddo
      iaddress=abs(mod(iaddr,m))+1
 
      do  k=1,max(100,min(10000, m/100))
         izer=0
         ieq=0
         do  i=1,r
            i1=ind(i,iaddress)
            if (i1.ne.dat(i)) ieq=1
            if (ind(i,iaddress).ne.0) izer=1
          enddo
 
         if (izer.eq.0 .or. ieq.eq.0) then
             if (izer.eq.0 .and. mode.eq.1) then
                 do  i=1,r
                    ind(i,iaddress)=dat(i)
                 enddo
                 nr=nr+1
             endif
             if (mode.eq.0 .and.izer.eq.0) then
                 hashvr=0
               else
                 hashvr=iaddress
             endif
             hit=hit+k
             ncall=ncall+1
             if (ncall.eq.5000000) then 
               rate=dble(hit)/dble(ncall)
               print*,' call to hash:',ncall,' hits:',hit,' = ',rate
               hit=0
               ncall=0
             endif  
             return
         endif
c         k1=abs(mod(iaddress,ie))+1
c         iaddress=mod(iaddress+ie-1,m)+1
         k1=mod(k1+1,20)+1
         iaddress=abs(mod(iaddress * prime(k1)+ie,m))+1
      enddo
c      ENDDO
      print *,' izer,ieq,mode,m,k',izer,ieq,mode,m,k    
      print *,' r,iaddress,dat,iaddr',r,iaddress,dat(1),dat(2),iaddr   
      hashvr=-1
      return
      end                              
      
      integer function hashvri(dat,idim,m,n,mode,nr)
c      integer function hashvri(xlist,dat,ind,m,n,mode,nr)
c returns address of  element of ind()  containing integer vector dat.
c Searching goes with a HASH technique. When mode=1 and dat was not
c there before, dat is written  into ind("hash",1..2). When mod=0
c and dat is not found, this function returns 0.
c rank of ind is m x n,
c dat contains nl numbers.
      use kinds
      implicit none
      integer nl,mode,nr,m,n,idim
      integer levcod(2),indl,idmurn
      integer idmurl,new,ipla
      integer,save:: rtopl,lastil
      integer :: dat(2)
c      real (rh) :: ind(:,:),dat(2)
      integer iaddress,i
c      
      integer,allocatable,save:: itopl(:)
      if (nr.eq.0) then
         lastil=-idim
         if (allocated(itopl)) then
           deallocate (itopl)
         endif
         allocate (itopl(idim))
         itopl=0 
         lastil=idmurn(levcod,itopl,idim,m,lastil,new)
         lastil=0
      endif
      ipla=3
      indl=1 
      do i=1,2
        levcod(i)=dat(i)
      enddo
      nl=levcod(1)
      iaddress=idmurn(levcod,itopl(nl),idim,m,lastil,new)

      if (iaddress.ne.0.and. mode.eq.1.and.new.eq.1) then
          hashvri=iaddress
          nr=nr+1
      else if (mode.eq.0) then
          hashvri=0
      else
          hashvri=iaddress
      endif
      return
      end                              

      INTEGER FUNCTION IDMURL(XLIST,LEVCOD,NL,RTOPL,IPLA,
     *        ID1,ID2,LASTIL,NEW)
c+++
c
c     Function IDMURL.
c     Author: Just Jensen
c     Last revision: 12.06.93.
c     Modified by Hans Soelkner: 05.10.93.
c
c+++
c
C     FUNCTION TO UPDATE A LIST OF CODES IN A RADIX TREE.
c     The function can update and search a list with up to 2**31
c     elements. The Maximum number of IF-statements executed in
c     order ot find an element is 31, and is in most cases much
c     lower.

c     The routine first find the binary representation of the input
c     level code. I.e. a vector of zeros and ones. These are then
c     used to decide whether to go left(0) or right(1) in the
c     search tree.

c     Description of parameters.

c     LEVCOD(2) Vector of (maximum) 2 Integers to either include
c               in the list or to update
c               (check for existence) in the list.
c
c     NL        Number of elements of LEVCOD used in this search
c
c     RTOPL     Integer pointing to the first element in the current
c               list. The top pointer is necessary because several
c               lists can be stored in the same array.
c
c     XLIST     an integer array of dimension ID1*ID2.
c               IDMURL uses the coloums of XLIST as described in the
c               following. Other coloums might be used for other
c               purposes by other routines.
c
c               Column  Description
c               -------  ---------------------------------------------
c                1       element identification of LEVCOD(1).
c                2       Element identification of LEVCOD(2).
c                        number of observations per class level.
c                IPLA    These two coloums are used for pointers in
c                IPLA+1  the binary search tree. The actual coloums
c                        used are decided by the user.
c
c     IPLA      Integer input variable that indicates the first col
c               in XLIST that is used to store the pointers in the
c               binary tree.
c
c     ID1       First dimension of integer array XLIST. Must be
c               equal to or larger then  the maximum number of
c               elements in the list(s).
c
c     ID2       Second dimension (No of coloums) of integer array
c               XLIST. Must be 4 or greater.
c
c     LASTIL    Input/output variable that keeps track of the
c               last used element/row in XLIST.
c
c     NEW       Output variable thet indicates if a new element have
c               been added to the list. NEW = 1 if a new element
c               was added, otherwise NEW = 0.

c---------------------------------------------------------------------
C     DECLARE PARAMETERS.
      implicit none
      INTEGER LEVCOD(2),ID1,ID2,RTOPL,IPLA,LASTIL
      INTEGER NEW,NL,LEVEL,IB

C     DECLARE LOCAL VARIABLES.
      INTEGER IBITS(64),NBDIG,I,J
      INTEGER PTR,FPTR,XLIST(ID2,ID1)

C     FIND BINARY STRUCTURE OF "LEVCOD"
      CALL BITSTR3(LEVCOD,NL,IBITS,NBDIG)
      PTR=RTOPL
      FPTR=0
      LEVEL=0
      NEW=0

    1 IF (PTR.EQ.0) THEN
C       ELEMENT TO BE ADDED. BOTTOM OF TREE FOUND.
        LASTIL=LASTIL+1
        IF (LASTIL .GT. ID1) THEN
          PRINT *,'DIMENSION PROBLEM IN IDMURL'
          PRINT *,'PARAMETER NDIMAX = ',ID1,' MUST BE ENLARGED'
          PRINT *,'COMPUTATIONS ABORTED'
          STOP 16
        ENDIF
        DO 2 I=1,ID2
          XLIST(I,LASTIL)=0
    2   CONTINUE
        IF (FPTR.EQ.0) THEN
          RTOPL=LASTIL
        ELSE
          XLIST(IB,FPTR)=LASTIL
        ENDIF
        PTR=LASTIL
        DO I=1,NL
          XLIST(I,PTR)=LEVCOD(I)
        ENDDO

        NEW=1
      ELSE
        J=0
        DO I=1,MIN(2,NL)
          IF (XLIST(I,PTR).NE.LEVCOD(I)) J=J+1
        ENDDO
        IF (J.GT.0) THEN
c         Element not found yet. Goto next element in tree.
          LEVEL=LEVEL+1
          IB=IBITS(LEVEL)+IPLA
          FPTR=PTR
          PTR=XLIST(IB,PTR)
          GOTO 1
        ENDIF
      ENDIF

C
C     "LEVCOD" ALREADY IN TREE
C
c     Update counter.
      IDMURL=PTR

c      write(*,*) lastil,ptr,fptr
      RETURN
      END
c
      SUBROUTINE BITSTR3(LEVCOD,NLEV,IBITS,NBDIG)
C***********************************************************************
C     SUBROUTINE TO RETURN THE BINARY STRUCTURE OF AN INTEGER          *
C***********************************************************************
C     DECLARE PARAMETERS
      implicit none
      INTEGER LEVCOD(2),IBITS(64),NBDIG,NLEV
C     DECLARE LOCAL VARIABLES
      INTEGER II,K,L,I,IBEG,IEND,IEND2
      DO I=1,NLEV
        IBEG=1+32*(I-1)
        IEND=32*I
        IEND2=32*(I-1)
        II=Abs(LEVCOD(I))
        DO 1 K=IBEG,IEND
    1   IBITS(K)=0

        NBDIG=0
        DO 2 K=31,1,-1
         L=2**(K-1)
         IF (L .LE. II) THEN
            IF (NBDIG .NE. 0) NBDIG=K+IEND2
            IBITS(K+IEND2)=1
            II=II-L
            ENDIF
    2  CONTINUE

       IF (II .NE. 0) THEN
         PRINT *,'BITSTR ERROR',LEVCOD(I),II,IBITS,NBDIG
         STOP
       ENDIF
      ENDDO
      RETURN
      END
      subroutine clusterr(x,m1,m2,ix)
c clusters ix rows of real x containing nonzero last element
c at the beginning of the matrix
c !! same as cluster except rows and columns switched !!
      use kinds
      integer :: m1,m2,i,ix,j1,k1,k2
      real (rh):: x(:,:)


      j1=1
      k1=1
      do  i=1,ix

130      if (j1.le.m1) then
             if (x(1,j1).ne.0 ) then
                j1=j1+1
                goto 130
              endif
         endif

140      if (k1.le.m1) then
             if (x(1,k1).eq.0 ) then
                k1=k1+1
                goto 140
             endif
         endif

         if (k1.gt.j1) then
           do  k2=1,m2
             x(k2,j1)=x(k2,k1)
             x(k2,k1)=0
           enddo
         else
           k1=k1+1
         endif
      enddo
      end

      subroutine hashia1(x,nhash,n,ia,ja,a,m)
c copies data from hash to ia-ja-a form
c Entries are sorted within rows
      use kinds
      implicit none
      integer nhash,n,m,ia(:),ja(:),tmp(n)
      real (rh):: x(:,:)
      real (r8):: a(:)
      integer i,j,k,cut

      cut=0
c
c count the number of entries in each column of a
      do i=1,n
         tmp(i)=0
      enddo
      do i=1,nhash
         j=x(1,i)
         if (j.ne.0) then
            if (j.gt.n) then
                 x(1,i)=0
                 cut=cut+1
            elseif (x(2,i).gt.n) then
                 x(1,i)=0
                 cut=cut+1
            else
                 tmp(j)=tmp(j)+1
            endif
         endif
      enddo

c create the row count for b
      ia(1)=1
      do i=1,n
         ia(i+1)=ia(i)+tmp(i)
      enddo

      if (ia(n+1)-1.gt.m) then
         print*,'Too small parameter m in hashia:should be > ', ia(n+1)
         stop
      endif

c load a into b
      do i=1,n
         tmp(i)=0
      enddo
      do i=1,nhash
            j=x(1,i)
            if (j.ne.0) then
            k=ia(j)+tmp(j)
            ja(k)=x(2,i)
            a(k)=x(3,i)
            tmp(j)=tmp(j)+1
         endif
      enddo
c
      if (cut.gt.0) then
          print*,cut,
     +        ' elements in HASH->IJA conversion had index(es) over ',n
      endif
      end


      subroutine hashia2(x,nhash,n,ia,ja,adiag,a,m)
c copies data from hash to ia-ja-adiag-a form
c Entries are sorted within rows
      use kinds
      implicit none
      integer nhash,n,m,ia(:),ja(:),tmp(n)
      real (rh):: x(:,:)
      real (r8):: adiag(:)
      real (r8):: a(:)
      integer i,j,k,cut

      cut=0
c
c count the number of entries in each column of a
c
      do i=1,n
         tmp(i)=0
      enddo
      do i=1,nhash
         j=x(1,i)
         if (j.ne.0) then
            if (j.gt.n) then
                 x(1,i)=0
                 cut=cut+1
            elseif (x(2,i).gt.n) then
                 x(1,i)=0
                 cut=cut+1
            elseif (j.ne.x(2,i)) then
                 tmp(j)=tmp(j)+1
            endif
         endif
      enddo

c create the row count for b
      ia(1)=1
      do i=1,n
         ia(i+1)=ia(i)+tmp(i)
      enddo

      if (ia(n+1)-1.gt.m) then
         print*,'Too small parameter m in hashia:should be > ', ia(n+1)
         stop
      endif

c load a into b
      do i=1,n
         tmp(i)=0
      enddo
      do i=1,nhash
         j=x(1,i)
         if (j.ne.0) then
           if (x(2,i).eq.j) then
              adiag(j) = x(3,i)
           else
c  load diagonal elements into adiag
            k=ia(j)+tmp(j)
            ja(k)=x(2,i)
            a(k)=x(3,i)
            tmp(j)=tmp(j)+1
           endif
         endif
      enddo
c
      if (cut.gt.0) then
          print*,cut,
     +        ' elements in HASH->IJA conversion had index(es) over ',n
      endif
      end

      INTEGER FUNCTION IDMURN(LEVCOD,ITOPL,NDIM1,ID1,LASTIL,NEW)
c+++
c
c     Function IDMURN (initially IDMURL, "N" for MODIFIED).
c     Author: Just Jensen: 12.06.93.
c     Modified by Hans Soelkner: 05.10.93.
c                    by Vincent Ducrocq : 14.04.96
c
c+++
c
C     FUNCTION TO UPDATE A LIST OF CODES IN A RADIX TREE.
c     The function can update and search a list with up to 2**24
c     elements. The Maximum number of IF-statements executed in
c     order or find an element is 24, and is in most cases much
c     lower.
c   NOTE !!! this version is specifically designed for the efficient
C      storage of elements (row,col) of a square matrix of dimension
C      NDIM (entered as LASTIL=-NDIM as a first call)
C      It is assumed that NDIM<2**25 OTHERWISE all "24"s should be
C      increased
c
c     The routine first find the binary representation of the input
c     level code. I.e. a vector of zeros and ones. These are then
c     used to decide whether to go left(0) or right(1) in the
c     search tree.

c     Description of parameters.

c     LEVCOD=ICOL,IROW Integer to either include in the list or to update
c               (check for existence) in the list.
c
c     XLIST
c              -------  ---------------------------------------------
c                1,2       element identification of ICOL,IROW
c
c                3      These two coloums are used for pointers in
c                4      the binary search tree. The actual coloums
c                        used are decided by the user.
c
c     ITOPL     Input/output index
c     LASTIL    Input/output variable that keeps track of the
c               last used element/row in XLIST.
c
c     NEW       Output variable thet indicates if a new element have
c               been added to the list. NEW = 1 if a new element
c               was added, otherwise NEW = 0.

c---------------------------------------------------------------------
C     DECLARE PARAMETERS.
c
      use parinclu
      implicit none
c
      INTEGER ID1,ID2,NDIM1
      PARAMETER (ID2=4)
      INTEGER K,ICOL,IROW,LASTIL
      INTEGER LEVCOD(2)
      INTEGER NEW,IB,LEVEL

C     DECLARE LOCAL VARIABLES.
      INTEGER IBITS(25),NBDIG,I,J,ITOPL
      logical,allocatable,save:: ttab(:,:)
      integer,allocatable,save:: xlist(:,:)

      INTEGER PTR,FPTR
c
c
C     IF FIRST CALL (LASTIL < 0) , FILL UP ttab FROM 1 TO  -LASTIL=NDIM1
      IF (LASTIL.LT.0) THEN
        if (allocated(ttab)) then
           deallocate (ttab)
        endif
        allocate (ttab(25,ndim1))
        if (allocated(xlist)) then
           print *,'reallocate xlist'
           deallocate (xlist)
        endif
        allocate (xlist(id1,4))
        xlist(:,1)=0
        DO 10 I=1,-LASTIL
c FIND BINARY STRUCTURE OF I
          CALL BITSTR2(I,IBITS,NBDIG)
          DO 11 K=1,25
            IF (IBITS(K).EQ.1) THEN
              ttab(K,I)=.TRUE.
            ELSE
              ttab(K,I)=.FALSE.
            ENDIF
  11      CONTINUE
  10    CONTINUE
        IDMURN=0
c        do i=1,ndim1
c        print*,i,(ttab(k,i),k=1,25)
c       enddo
        RETURN
      ELSE
        ICOL=LEVCOD(1)
        IROW=LEVCOD(2)
        PTR=ITOPL
        FPTR=0
        LEVEL=0
        NEW=0
c       if (icol.eq.1.And.irow.eq.1) then
c        print*,icol,irow,(ttab(k,1),k=1,25)
c       endif
    1   IF (PTR.EQ.0) THEN
C         ELEMENT TO BE ADDED. BOTTOM OF TREE FOUND.
         LASTIL=LASTIL+1
         if (mod(lastil,1000000).EQ.1) print*,'lastil=',lastil
         IF (LASTIL .GT. ID1) THEN
           PRINT *,'DIMENSION PROBLEM IN IDMURN'
           PRINT *,'PARAMETER NZE_HESS= ',ID1,' MUST BE ENLARGED'
           PRINT *,'COMPUTATIONS ABORTED'
           STOP 16
         ENDIF
         DO 2 I=1,ID2
           XLIST(LASTIL,I)=0
    2    CONTINUE
         IF (FPTR.EQ.0) THEN
           ITOPL=LASTIL
         ELSE
           XLIST(FPTR,IB)=LASTIL
         ENDIF
         PTR=LASTIL
         XLIST(PTR,1)=ICOL
         XLIST(PTR,2)=IROW
         NEW=1
       ELSE
         J=0
         IF ((XLIST(PTR,1).NE.ICOL).OR.(XLIST(PTR,2).NE.IROW)) J=J+1
         IF (J.GT.0) THEN
c         Element not found yet. Goto next element in tree.
           LEVEL=LEVEL+1
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C modified for better efficiency on January 9, 1997
           IF (ttab(LEVEL,IROW)) THEN
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              IB=3
           ELSE
              IB=4
           ENDIF
           FPTR=PTR
           PTR=XLIST(PTR,IB)
           GOTO 1
         ENDIF
        ENDIF
C
C     "ICOL" ALREADY IN TREE
C
       IDMURN=PTR
c       WRITE(6,*) 'IROW,ICOL',IROW,ICOL,IDMURM,'lastil=',LASTIL
       RETURN
      ENDIF
      END
      SUBROUTINE BITSTR2(ICOL,IBITS,NBDIG)
C***********************************************************************
C     SUBROUTINE TO RETURN THE BINARY STRUCTURE OF AN INTEGER          *
C***********************************************************************
C     DECLARE PARAMETERS
      implicit none
      INTEGER ICOL,IBITS(25),NBDIG

C     DECLARE LOCAL VARIABLES
      INTEGER II,K,L
      II=ICOL
      DO 1 K=1,25
    1 IBITS(K)=0

      NBDIG=0
      DO 2 K=24,1,-1
       L=2**(K-1)
       IF (L .LE. II) THEN
         IF (NBDIG .NE. 0) NBDIG=K
         IBITS(K)=1
         II=II-L
       ENDIF
    2 CONTINUE

       IF (II .NE. 0) THEN
         PRINT *,'BITSTR2 ERROR',ICOL,II,IBITS,NBDIG
         PRINT *,'IN BITSTR2 SUBROUTINE, INCREASE THE VALUE "24"',
     +      ' IN ALL LOOPS TO A HIGHER VALUE AND RECOMPILE'
         STOP
       ENDIF
      RETURN
      END
