      real function second()
c      integer mclock                                     
c      real*4 etime,tarray(2)                          
c      second = mclock()/100.
c with DEC ALPHA (Fabiola Canavesi), comment out the above line and
c replace it by
c      second = etime ( tarray )
c if it still doesn't work (system dependent), replace it or zero it
c as:
      second=0.0
      return
      end


      INTEGER FUNCTION IDMURM(LEVCOD,ITOPL,LASTIL,NEW)
c+++
c
c     Function IDMURM (initially IDMURL, "M" for MODIFIED).
c     Author: Just Jensen: 12.06.93.
c     Modified by Hans Soelkner: 05.10.93.
c                    by Vincent Ducrocq : 14.04.96
c
c+++
c
C     FUNCTION TO UPDATE A LIST OF CODES IN A RADIX TREE.
c     The function can update and search a list with up to 2**20
c     elements. The Maximum number of IF-statements executed in
c     order or find an element is 20, and is in most cases much
c     lower.
c   NOTE !!! this version is specifically designed for the efficient
C      storage of elements (row,col) of a square matrix of dimension
C      NDIM (entered as LASTIL=-NDIM as a first call)
C      It is assumed that NDIM<2**21 OTHERWISE all "20"s should be
C      increased
C   ANOTHER NOTE: related parameter in the parinclu: TABFIRST=21
c
c     The routine first find the binary representation of the input
c     level code. I.e. a vector of zeros and ones. These are then
c     used to decide whether to go left(0) or right(1) in the
c     search tree.

c     Description of parameters.

c     LEVCOD=ICOL,IROW Integer to either include in the list or to update
c               (check for existence) in the list.
c
c     YLIST      in module parinclu
c              -------  ---------------------------------------------
c                1,2       element identification of ICOL,IROW
c
c                3      These two coloums are used for pointers in
c                4      the binary search tree. The actual coloums
c                        used are decided by the user.
c
c     ITOPL     Input/output index
c     LASTIL    Input/output variable that keeps track of the
c               last used element/row in YLIST.
c
c     NEW       Output variable thet indicates if a new element have
c               been added to the list. NEW = 1 if a new element
c               was added, otherwise NEW = 0.

c---------------------------------------------------------------------
C     DECLARE PARAMETERS.
c
      use parinclu
c
      implicit none

      INTEGER K,ICOL,IROW,ITOPL,LASTIL
      INTEGER LEVCOD(2)
      INTEGER NEW,IB,LEVEL

C     DECLARE LOCAL VARIABLES.
      INTEGER IBITS(tabfirst),NBDIG,I,J
      INTEGER PTR,FPTR
c
c
C     IF FIRST CALL (LASTIL < 0) , FILL UP TAB FROM 0 TO  -LASTIL=NDIM1
      IF (LASTIL.LT.0) THEN
        DO 10 I=1,-LASTIL
c FIND BINARY STRUCTURE OF I
          CALL BITSTR(I,IBITS,NBDIG)
          DO 11 K=1,tabfirst
            IF (IBITS(K).EQ.1) THEN
              TAB(K,I)=.TRUE.
            ELSE
              TAB(K,I)=.FALSE.
            ENDIF
  11      CONTINUE
  10    CONTINUE
        IDMURM=0
        RETURN
      ELSE
        ICOL=LEVCOD(1)
        IROW=LEVCOD(2)
        PTR=ITOPL
        FPTR=0
        LEVEL=0
        NEW=0

    1   IF (PTR.EQ.0) THEN
C         ELEMENT TO BE ADDED. BOTTOM OF TREE FOUND.
         LASTIL=LASTIL+1

         IF (LASTIL .GT. NZE_HESS) THEN
          PRINT *,'DIMENSION PROBLEM IN IDMURM'
          PRINT *,'PARAMETER NZE_HESS= ',NZE_HESS,' MUST BE ENLARGED'
          PRINT *,'COMPUTATIONS ABORTED'
          STOP 16
         ENDIF
         DO 2 I=1,4      !4 => 2nd dimension of YLIST 
           YLIST(I,LASTIL)=0
    2    CONTINUE
         IF (FPTR.EQ.0) THEN
           ITOPL=LASTIL
         ELSE
           YLIST(IB,FPTR)=LASTIL
         ENDIF
         PTR=LASTIL
         YLIST(1,PTR)=ICOL
         YLIST(2,PTR)=IROW
         NEW=1
       ELSE
         J=0
         IF ((YLIST(1,PTR).NE.ICOL).OR.(YLIST(2,PTR).NE.IROW)) J=J+1
         IF (J.GT.0) THEN
c         Element not found yet. Goto next element in tree.
           LEVEL=LEVEL+1
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C modified for better efficiency on January 9, 1997
           IF (TAB(LEVEL,IROW)) THEN
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              IB=3
           ELSE
              IB=4
           ENDIF
           FPTR=PTR
           PTR=YLIST(IB,PTR)
           GOTO 1
         ENDIF
        ENDIF
C
C     "ICOL" ALREADY IN TREE
C
       IDMURM=PTR
c       WRITE(6,*) 'IROW,ICOL',IROW,ICOL,IDMURM,'lastil=',LASTIL
       RETURN
      ENDIF
      END
      SUBROUTINE BITSTR(ICOL,IBITS,NBDIG)
C***********************************************************************
C     SUBROUTINE TO RETURN THE BINARY STRUCTURE OF AN INTEGER          *
C***********************************************************************
C     DECLARE PARAMETERS
      use parinclu
	  
      implicit none
      INTEGER ICOL,IBITS(tabfirst),NBDIG

C     DECLARE LOCAL VARIABLES
      INTEGER II,K,L
      II=ICOL
      DO 1 K=1,tabfirst-1
    1 IBITS(K)=0

      NBDIG=0
      DO 2 K=tabfirst-1,1,-1
       L=2**(K-1)
       IF (L .LE. II) THEN
         IF (NBDIG .NE. 0) NBDIG=K
         IBITS(K)=1
         II=II-L
       ENDIF
    2 CONTINUE

       IF (II .NE. 0) THEN
         PRINT *,'BITSTR ERROR',ICOL,II,IBITS,NBDIG
         PRINT *,'INCREASE THE VALUE OF TABFIRST= ', tabfirst,
     +      ' IN PARINCLU TO A HIGHER VALUE AND RECOMPILE'
         STOP
       ENDIF
      RETURN
      END

c     ------------------
      subroutine const(n,d,p,pinv)
c     ------------------
      use parinclu
	  
      implicit none
      integer n,i,j,ic,p(1),pinv(1)
      real*8 d(1)

      do 5 i=1,n
        if (dabs(d(i)).lt.1.d-8) then
          ic=0
          do 7 j=1,icons(0)
             if (icons(j).eq.pinv(i)) ic=1
   7      continue
          if (ic.eq.1) goto 5
          icons(0)=icons(0)+1
          icons(icons(0)) = pinv(i)
        endif
   5  continue

      return
      end

C     ----------------------------------------------------------------------
      SUBROUTINE CHSCDF(X,NU,CDF)
C     PURPOSE--THIS SUBROUTINE COMPUTES THE CUMULATIVE DISTRIBUTION
C              FUNCTION VALUE FOR THE CHI-SQUARED DISTRIBUTION
C              WITH INTEGER DEGREES OF FREEDOM PARAMETER = NU.
C              THIS DISTRIBUTION IS DEFINED FOR ALL NON-NEGATIVE X.
C              THE PROBABILITY DENSITY FUNCTION IS GIVEN
C              IN THE REFERENCES BELOW.
C     INPUT  ARGUMENTS--X      = THE SINGLE PRECISION VALUE AT
C                                WHICH THE CUMULATIVE DISTRIBUTION
C                                FUNCTION IS TO BE EVALUATED.
C                                X SHOULD BE NON-NEGATIVE.
C                     --NU     = THE INTEGER NUMBER OF DEGREES
C                                OF FREEDOM.
C                                NU SHOULD BE POSITIVE.
C     OUTPUT ARGUMENTS--CDF    = THE SINGLE PRECISION CUMULATIVE
C                                DISTRIBUTION FUNCTION VALUE.
C     OUTPUT--THE SINGLE PRECISION CUMULATIVE DISTRIBUTION
C             FUNCTION VALUE CDF FOR THE CHI-SQUARED DISTRIBUTION
C             WITH DEGREES OF FREEDOM PARAMETER = NU.
C     PRINTING--NONE UNLESS AN INPUT ARGUMENT ERROR CONDITION EXISTS.
C     RESTRICTIONS--X SHOULD BE NON-NEGATIVE.
C                 --NU SHOULD BE A POSITIVE INTEGER VARIABLE.
C     OTHER DATAPAC   SUBROUTINES NEEDED--NORCDF.
C     FORTRAN LIBRARY SUBROUTINES NEEDED--DSQRT, DEXP.
C---------------------------------------------------------------------
C
      IMPLICIT DOUBLE PRECISION(A-H,P-Z)
      REAL*8 DX,PI,CHI,SUM,TERM,AI,DCDFN
      REAL*8 DNU
      REAL*8 DSQRT,DEXP
      REAL*8 DLOG
      REAL*8 DFACT,DPOWER
      REAL*8 DW
      REAL*8 D1,D2,D3
      REAL*8 TERM0,TERM1,TERM2,TERM3,TERM4
      REAL*8 B11
      REAL*8 B21
      REAL*8 B31,B32
      REAL*8 B41,B42,B43
      DATA NUCUT/1000/
      DATA PI/3.14159265358979D0/
      DATA DPOWER/0.33333333333333D0/
      DATA B11/0.33333333333333D0/
      DATA B21/-0.02777777777778D0/
      DATA B31/-0.00061728395061D0/
      DATA B32/-13.0D0/
      DATA B41/0.00018004115226D0/
      DATA B42/6.0D0/
      DATA B43/17.0D0/
C
      IPR=6
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF(NU.LE.0)GOTO50
      IF(X.LT.0.0D0)GOTO55
      GOTO90
   50 WRITE(IPR,15)
      WRITE(IPR,47)NU
      CDF=0.0D0
      RETURN
   55 WRITE(IPR,4)
      WRITE(IPR,46)X
      CDF=0.0D0
      RETURN
   90 CONTINUE
    4 FORMAT(1H , 96H***** NON-FATAL DIAGNOSTIC--THE FIRST  INPUT ARGUME
     1NT TO THE CHSCDF SUBROUTINE IS NEGATIVE *****)
   15 FORMAT(1H , 91H***** FATAL ERROR--THE SECOND INPUT ARGUMENT TO THE
     1 CHSCDF SUBROUTINE IS NON-POSITIVE *****)
   46 FORMAT(1H , 35H***** THE VALUE OF THE ARGUMENT IS ,E15.8,6H *****)
   47 FORMAT(1H , 35H***** THE VALUE OF THE ARGUMENT IS ,I8   ,6H *****)
C
C-----START POINT-----------------------------------------------------
C
      DX=X
      ANU=NU
      DNU=NU
C
C     IF X IS NON-POSITIVE, SET CDF = 0.0 AND RETURN.
C     IF NU IS SMALLER THAN 10 AND X IS MORE THAN 200
C     STANDARD DEVIATIONS BELOW THE MEAN,
C     SET CDF = 0.0 AND RETURN.
C     IF NU IS 10 OR LARGER AND X IS MORE THAN 100
C     STANDARD DEVIATIONS BELOW THE MEAN,
C     SET CDF = 0.0 AND RETURN.
C     IF NU IS SMALLER THAN 10 AND X IS MORE THAN 200
C     STANDARD DEVIATIONS ABOVE THE MEAN,
C     SET CDF = 1.0 AND RETURN.
C     IF NU IS 10 OR LARGER AND X IS MORE THAN 100
C     STANDARD DEVIATIONS ABOVE THE MEAN,
C     SET CDF = 1.0 AND RETURN.
C
      IF(X.LE.1.D-20)GOTO105
      AMEAN=ANU
      SD=SQRT(2.0*ANU)
      Z=(X-AMEAN)/SD
      IF(NU.LT.10.AND.Z.LT.-200.D0)GOTO105
      IF(NU.GE.10.AND.Z.LT.-100.D0)GOTO105
      IF(NU.LT.10.AND.Z.GT.200.D0)GOTO107
      IF(NU.GE.10.AND.Z.GT.100.D0)GOTO107
      GOTO109
  105 CDF=0.0D0
      RETURN
  107 CDF=1.0
      RETURN
  109 CONTINUE
C
C     DISTINGUISH BETWEEN 3 SEPARATE REGIONS
C     OF THE (X,NU) SPACE.
C     BRANCH TO THE PROPER COMPUTATIONAL METHOD
C     DEPENDING ON THE REGION.
C     NUCUT HAS THE VALUE 1000.
C
      IF(NU.LT.NUCUT)GOTO1000
      IF(NU.GE.NUCUT.AND.X.LE.ANU)GOTO2000
      IF(NU.GE.NUCUT.AND.X.GT.ANU)GOTO3000
      IBRAN=1
      WRITE(IPR,99)IBRAN
   99 FORMAT(1H ,42H*****INTERNAL ERROR IN CHSCDF SUBROUTINE--,
     146HIMPOSSIBLE BRANCH CONDITION AT BRANCH POINT = ,I8)
      RETURN
C
C     TREAT THE SMALL AND MODERATE DEGREES OF FREEDOM CASE
C     (THAT IS, WHEN NU IS SMALLER THAN 1000).
C     METHOD UTILIZED--EXACT FINITE SUM
C     (SEE AMS 55, PAGE 941, FORMULAE 26.4.4 AND 26.4.5).
C
 1000 CONTINUE
      CHI=DSQRT(DX)
      IEVODD=NU-2*(NU/2)
      IF(IEVODD.EQ.0)GOTO120
C
      SUM=0.0D0
      TERM=1.0/CHI
      IMIN=1
      IMAX=NU-1
      GOTO130
C
  120 SUM=1.0D0
      TERM=1.0D0
      IMIN=2
      IMAX=NU-2
  130 IF(IMIN.GT.IMAX)GOTO160
      DO100I=IMIN,IMAX,2
      AI=I
      TERM=TERM*(DX/AI)
      SUM=SUM+TERM
  100 CONTINUE
  160 CONTINUE
      SUM=SUM*DEXP(-DX/2.0D0)
      IF(IEVODD.EQ.0)GOTO170
      SUM=(DSQRT(2.0D0/PI))*SUM
      SPCHI=CHI
      CALL NORCDF(SPCHI,CDFN)
      DCDFN=CDFN
      SUM=SUM+2.0D0*(1.0D0-DCDFN)
  170 CDF=1.0D0-SUM
      RETURN
C
C     TREAT THE CASE WHEN NU IS LARGE
C     (THAT IS, WHEN NU IS EQUAL TO OR GREATER THAN 1000)
C     AND X IS LESS THAN OR EQUAL TO NU.
C     METHOD UTILIZED--WILSON-HILFERTY APPROXIMATION
C     (SEE JOHNSON AND KOTZ, VOLUME 1, PAGE 176, FORMULA 28).
C
 2000 CONTINUE
      DFACT=4.5D0*DNU
      U=(((DX/DNU)**DPOWER)-1.0D0+(1.0D0/DFACT))*DSQRT(DFACT)
      CALL NORCDF(U,CDFN)
      CDF=CDFN
      RETURN
C
C     TREAT THE CASE WHEN NU IS LARGE
C     (THAT IS, WHEN NU IS EQUAL TO OR GREATER THAN 1000)
C     AND X IS LARGER THAN NU.
C     METHOD UTILIZED--HILL'S ASYMPTOTIC EXPANSION
C     (SEE JOHNSON AND KOTZ, VOLUME 1, PAGE 180, FORMULA 33.1).
C
 3000 CONTINUE
      DW=DSQRT(DX-DNU-DNU*DLOG(DX/DNU))
      DANU=DSQRT(2.0D0/DNU)
      D1=DW
      D2=DW**2
      D3=DW**3
      TERM0=DW
      TERM1=B11*DANU
      TERM2=B21*D1*(DANU**2)
      TERM3=B31*(D2+B32)*(DANU**3)
      TERM4=B41*(B42*D3+B43*D1)*(DANU**4)
      U=TERM0+TERM1+TERM2+TERM3+TERM4
      CALL NORCDF(U,CDFN)
      CDF=CDFN
      RETURN
C
      END
      SUBROUTINE NORCDF(X,CDF)
C
C     PURPOSE--THIS SUBROUTINE COMPUTES THE CUMULATIVE DISTRIBUTION
C              FUNCTION VALUE FOR THE NORMAL (GAUSSIAN)
C              DISTRIBUTION WITH MEAN = 0 AND STANDARD DEVIATION = 1.
C              THIS DISTRIBUTION IS DEFINED FOR ALL X AND HAS
C              THE PROBABILITY DENSITY FUNCTION
C              F(X) = (1/SQRT(2*PI))*EXP(-X*X/2).
C     INPUT  ARGUMENTS--X      = THE SINGLE PRECISION VALUE AT
C                                WHICH THE CUMULATIVE DISTRIBUTION
C                                FUNCTION IS TO BE EVALUATED.
C     OUTPUT ARGUMENTS--CDF    = THE SINGLE PRECISION CUMULATIVE
C                                DISTRIBUTION FUNCTION VALUE.
C     OUTPUT--THE SINGLE PRECISION CUMULATIVE DISTRIBUTION
C             FUNCTION VALUE CDF.
C
C---------------------------------------------------------------------
C
      IMPLICIT DOUBLE PRECISION(A-H,P-Z)
      DATA B1,B2,B3,B4,B5,P/.319381530,-0.356563782,1.781477937,-1.82125
     15978,1.330274429,.2316419/
C
      IPR=6
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS.
C     NO INPUT ARGUMENT ERRORS POSSIBLE
C     FOR THIS DISTRIBUTION.
C
C-----START POINT-----------------------------------------------------
C
      Z=X
      IF(X.LT.0.0D0)Z=-Z
      T=1.0/(1.0+P*Z)
      CDF=1.0-((0.39894228040143  )*EXP(-0.5*Z*Z))*(B1*T+B2*T**2+B3*T**3
     1+B4*T**4+B5*T**5)
      IF(X.LT.0.0D0)CDF=1.0D0-CDF
C
      RETURN
      END
      SUBROUTINE JSORT(IX,N,IY,IW,ORD)
C
C     PURPOSE--THIS SUBROUTINE SORTS
C              THE N ELEMENTS OF THE VECTOR IX
C              AND PUTS THE RESULTING N SORTED VALUES INTO THE
C              SINGLE PRECISION VECTOR IY.
C     INPUT  ARGUMENTS--IX      = THE  VECTOR OF
C                                OBSERVATIONS TO BE SORTED.
C                     --N      = THE INTEGER NUMBER OF OBSERVATIONS
C                                IN THE VECTOR IX.
C                     --IW     = WORKING VECTOR OF SIZE AT LEAST 2*N
C                     --ORD    = CHARACTER 'A' FOR ASCENDING
C                                          'D' FOR DESCENDING
C     OUTPUT ARGUMENTS--IY      = THE VECTOR
C                                INTO WHICH THE SORTED DATA VALUES
C                                FROM IX WILL BE PLACED.
C---------------------------------------------------------------------
C
      use parinclu
	  
      implicit none
      integer iw(*),ix(*),iy(*)
      INTEGER I,J,K,L,M,N,JMI,JMK,MID,NM1,IP1,IPR,LMI
      INTEGER IT,IMED,IHOLD
      CHARACTER ORD
C
C
      IPR=6
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF (N.LT.1)  GOTO  50
      IF (N.EQ.1)  GOTO  55
      IHOLD=IX(1)
      DO 60 I=2,N
        IF (IX(I).NE.IHOLD)  GOTO  90
   60 CONTINUE
      WRITE(IPR, 9) IHOLD
      DO 61 I=1,N
        IY(I)=IX(I)
   61 CONTINUE
      GOTO 500
   50 WRITE(IPR,15)
      WRITE(IPR,47) N
      GOTO 500
c   55 WRITE(IPR,18)
   55 IY(1)=IX(1)
      GOTO 500
   90 CONTINUE
    9 FORMAT(1X,'**** NON-FATAL DIAGNOSTIC--THE FIRST  INPUT ARGUME',
     1 'NT (A VECTOR) TO THE SORT ',/1X,
     1 ' SUBROUTINE HAS ALL ELEMENTS = ',E15.8,' ****')
   15 FORMAT(1H , 91H***** FATAL ERROR--THE SECOND INPUT ARGUMENT TO THE
     1 SORT   SUBROUTINE IS NON-POSITIVE *****)
   18 FORMAT(1H ,100H***** NON-FATAL DIAGNOSTIC--THE SECOND INPUT ARGUME
     1NT TO THE SORT   SUBROUTINE HAS THE VALUE 1 *****)
   47 FORMAT(1H , 35H***** THE VALUE OF THE ARGUMENT IS ,I8   ,6H *****)
C
C-----START POINT-----------------------------------------------------
C
C     COPY THE VECTOR X INTO THE VECTOR Y
      DO 100 I=1,N
        IY(I)=IX(I)
  100 CONTINUE
C
C     CHECK TO SEE IF THE INPUT VECTOR IS ALREADY SORTED
C
      NM1=N-1
      DO 200 I=1,NM1
        IP1=I+1
        IF (IY(I).LE.IY(IP1))  GOTO  200
        GOTO  250
  200 CONTINUE
      GOTO 500
  250 M=1
      I=1
      J=N
  305 IF (I.GE.J)  GOTO  370
  310 K=I
      MID=(I+J)/2
      IMED=IY(MID)
      IF (IY(I).LE.IMED)  GOTO  320
      IY(MID)=IY(I)
      IY(I)=IMED
      IMED=IY(MID)
  320 L=J
      IF (IY(J).GE.IMED)  GOTO  340
      IY(MID)=IY(J)
      IY(J)=IMED
      IMED=IY(MID)
      IF (IY(I).LE.IMED)  GOTO  340
      IY(MID)=IY(I)
      IY(I)=IMED
      IMED=IY(MID)
      GOTO  340
  330 IY(L)=IY(K)
      IY(K)=IT
  340 L=L-1
      IF (IY(L).GT.IMED)  GOTO  340
      IT=IY(L)
  350 K=K+1
      IF (IY(K).LT.IMED)  GOTO  350
      IF (K.LE.L)  GOTO  330
      LMI=L-I
      JMK=J-K
      IF (LMI.LE.JMK)  GOTO  360
      IW(M)=I
      IW(M+N)=L
      I=K
      M=M+1
       GOTO 380
  360 IW(M)=K
      IW(M+N)=J
      J=L
      M=M+1
       GOTO 380
  370 M=M-1
      IF (M.EQ.0) GOTO 500
      I=IW(M)
      J=IW(M+N)
  380 JMI=J-I
      IF (JMI.GE.11)  GOTO 310
      IF (I.EQ.1) GOTO 305
       I=I-1
  390  I=I+1
      IF (I.EQ.J) GOTO 370
      IMED=IY(I+1)
      IF (IY(I).LE.IMED)  GOTO 390
      K=I
  395 IY(K+1)=IY(K)
      K=K-1
      IF (IMED.LT.IY(K)) GOTO 395
      IY(K+1)=IMED
      GOTO  390
C  REORDER IF DESCENDING ORDER
  500 IF (ORD.EQ.'D') THEN
        DO 510 I=1,N/2
	      IT= IY(I)
	      J=N-I+1
	      IY(I) = IY(J)
	      IY(J) = IT
  510   CONTINUE
      ENDIF
	  
      RETURN
      END
      SUBROUTINE XSORT(X,N,Y,IW,ORD)
C---------------------------------------------------------------------
C AS FOR JSORT BUT X AND Y ARE REAL*8 VECTORS
C---------------------------------------------------------------------
C
      use parinclu
	  
      implicit none
      INTEGER I,J,K,L,M,N,JMI,JMK,MID,NM1,IP1,IPR,LMI
      REAL*8 T,AMED,HOLD
      CHARACTER ORD
C
      integer iw(*)      !IW(NDIMAX)
      real*8 x(*),y(*)   !all NDIMAX
C
      IPR=6
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF (N.LT.1)  GOTO  50
      IF (N.EQ.1)  GOTO  55
      HOLD=X(1)
      DO 60 I=2,N
        IF (X(I).NE.HOLD)  GOTO  90
   60 CONTINUE
      WRITE(IPR, 9) HOLD
      DO 61 I=1,N
        Y(I)=X(I)
   61 CONTINUE
      GOTO 500
   50 WRITE(IPR,15)
      WRITE(IPR,47) N
      GOTO 500
c   55 WRITE(IPR,18)
   55 Y(1)=X(1)
      GOTO 500
   90 CONTINUE
    9 FORMAT(1X,'**** NON-FATAL DIAGNOSTIC--THE FIRST  INPUT ARGUME',
     1 'NT (A VECTOR) TO THE SORT ',/1X,
     1 ' SUBROUTINE HAS ALL ELEMENTS = ',E15.8,' ****')
   15 FORMAT(1H , 91H***** FATAL ERROR--THE SECOND INPUT ARGUMENT TO THE
     1 SORT   SUBROUTINE IS NON-POSITIVE *****)
   18 FORMAT(1H ,100H***** NON-FATAL DIAGNOSTIC--THE SECOND INPUT ARGUME
     1NT TO THE SORT   SUBROUTINE HAS THE VALUE 1 *****)
   47 FORMAT(1H , 35H***** THE VALUE OF THE ARGUMENT IS ,I8   ,6H *****)
C
C-----START POINT-----------------------------------------------------
C
C     COPY THE VECTOR X INTO THE VECTOR Y
      DO 100 I=1,N
        Y(I)=X(I)
  100 CONTINUE
C
C     CHECK TO SEE IF THE INPUT VECTOR IS ALREADY SORTED
C
      NM1=N-1
      DO 200 I=1,NM1
        IP1=I+1
        IF (Y(I).LE.Y(IP1))  GOTO  200
        GOTO  250
  200 CONTINUE
      GOTO 500
  250 M=1
      I=1
      J=N
  305 IF (I.GE.J)  GOTO  370
  310 K=I
      MID=(I+J)/2
      AMED=Y(MID)
      IF (Y(I).LE.AMED)  GOTO  320
      Y(MID)=Y(I)
      Y(I)=AMED
      AMED=Y(MID)
  320 L=J
      IF (Y(J).GE.AMED)  GOTO  340
      Y(MID)=Y(J)
      Y(J)=AMED
      AMED=Y(MID)
      IF (Y(I).LE.AMED)  GOTO  340
      Y(MID)=Y(I)
      Y(I)=AMED
      AMED=Y(MID)
      GOTO  340
  330 Y(L)=Y(K)
      Y(K)=T
  340 L=L-1
      IF (Y(L).GT.AMED)  GOTO  340
      T=Y(L)
  350 K=K+1
      IF (Y(K).LT.AMED)  GOTO  350
      IF (K.LE.L)  GOTO  330
      LMI=L-I
      JMK=J-K
      IF (LMI.LE.JMK)  GOTO  360
      IW(M)=I
      IW(M+N)=L
      I=K
      M=M+1
       GOTO 380
  360 IW(M)=K
      IW(M+N)=J
      J=L
      M=M+1
       GOTO 380
  370 M=M-1
      IF (M.EQ.0) GOTO 500
      I=IW(M)
      J=IW(M+N)
  380 JMI=J-I
      IF (JMI.GE.11)  GOTO 310
      IF (I.EQ.1) GOTO 305
       I=I-1
  390  I=I+1
      IF (I.EQ.J) GOTO 370
      AMED=Y(I+1)
      IF (Y(I).LE.AMED)  GOTO 390
      K=I
  395 Y(K+1)=Y(K)
      K=K-1
      IF (AMED.LT.Y(K)) GOTO 395
      Y(K+1)=AMED
      GOTO  390
C  REORDER IF DESCENDING ORDER
  500 IF (ORD.EQ.'D') THEN
        DO 510 I=1,N/2
	    T= Y(I)
	    J=N-I+1
	    Y(I) = Y(J)
	    Y(J) = T
  510   CONTINUE
      ENDIF

      RETURN
      END

      SUBROUTINE JRANK(IX,N,IR,IW,ORD)
C
C     PURPOSE--THIS SUBROUTINE RANKS THE N ELEMENTS OF VECTOR IX,
C              AND PUTS THE RESULTING N RANKS INTO THE INTEGER VECTOR IR.

C     INPUT  ARGUMENTS--IX      = THE INTEGER VECTOR OF
C                                OBSERVATIONS TO BE RANKED.
C                     --N      = THE INTEGER NUMBER OF OBSERVATIONS
C                                IN THE VECTOR X.
C                     --IW     = WORKING INTEGER VECTOR OF SIZE AT LEAST 3N
C                     --ORD    = CHARACTER 'A' FOR ASCENDING
C                                          'D' FOR DESCENDING
C     OUTPUT ARGUMENTS--IR     = THE INTEGER VECTOR INTO WHICH THE RANKS
C                                FROM X WILL BE PLACED.
C
C---------------------------------------------------------------------
C
      use parinclu
	  
      implicit none
      integer iw(*),ix(*),ir(*)
      INTEGER I,J,JP1,K,N,IPR,JMIN,NM1
      INTEGER AN,AVRANK,IRPREV,IUPPER,IBRAN
      INTEGER IHOLD,IXPREV
      CHARACTER ORD
C
C
      AN=N
      IPR=6
      IUPPER=N
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF (N.LT.1.OR.N.GT.IUPPER) GOTO 50
      IF (N.EQ.1) GOTO 55
      IHOLD=IX(1)
      DO 60 I=2,N
        IF (IX(I).NE.IHOLD) GOTO 90
   60 CONTINUE
      WRITE(IPR, 9) IHOLD
        AVRANK=(AN+1)/2
      DO 61 I=1,N
        IR(I)=AVRANK
   61 CONTINUE
      GOTO 500
   50 WRITE(IPR,17) IUPPER
      WRITE(IPR,47) N
      GOTO 500
C   55 WRITE(IPR,18)
   55 IR(1)=1
      GOTO 500
   90 CONTINUE
    9 FORMAT(1X,'**** NON-FATAL DIAGNOSTIC--THE FIRST  INPUT ARGUME',
     1 'NT (A VECTOR) TO THE SORT ',/1X,
     1 ' SUBROUTINE HAS ALL ELEMENTS = ',E15.8,' ****')
   17 FORMAT(1H , 98H***** FATAL ERROR--THE SECOND INPUT ARGUMENT TO THE
     1 RANK   SUBROUTINE IS OUTSIDE THE ALLOWABLE (1,,I6,16H) INTERVAL *
     1****)
   18 FORMAT(1H ,100H***** NON-FATAL DIAGNOSTIC--THE SECOND INPUT ARGUME
     1NT TO THE RANK   SUBROUTINE HAS THE VALUE 1 *****)
   47 FORMAT(1H , 35H***** THE VALUE OF THE ARGUMENT IS ,I8   ,6H *****)
C
C-----START POINT-----------------------------------------------------
C
C     FIRST SORT THE DATA FROM THE INPUT VECTOR X
C     INTO THE INTERMEDIATE STORAGE VECTOR XS.
C
      CALL JSORT(IX,N,IW(1),IW(AN+1),'A')
C
C     NOW DETERMINE THE RANKS. THE ALGORITHM IS TO TAKE A GIVEN ELEMENT
C     IN THE ORIGINAL VECTOR X, SCAN THE SORTED VALUES IN THE XS VECTOR
C     UNTIL A MATCH IS FOUND; THEN THE RANK FOR THAT
C     VALUE IN THE XS VECTOR IS DETERMINED.
C     THAT RANK IS THEN WRITTEN INTO THAT POSITION
C     IN THE OUTPUT Y VECTOR WHICH CORRESPONDS TO THE POSITION OF THE
C     GIVEN ELEMENT OF INTEREST IN THE ORIGINAL X VECTOR.
C     THE CODE IS LENGTHENED FROM THIS BASIC ALGORITHM
C     BY A SECTION WHICH CUTS DOWN THE SEARCH IN THE XS VECTOR,
C     AND BY A SECTION WHICH OBVIATES (UNDER CERTAIN CIRCUMSTANCES)
C     THE NEED FOR RECALCULATING THE RANK OF AN ELEMENT IN XS.
C
      NM1=N-1
      IXPREV=IX(1)
      DO 700 I=1,N
      JMIN=1
      IF (IX(I).GT.IXPREV) GOTO 770
      IF (I.EQ.1) GOTO 790
      IF (IX(I).EQ.IXPREV) GOTO 750
       GOTO 790
  750 CONTINUE
      IR(I)=IRPREV
       GOTO 880
  770 CONTINUE
      JMIN=K
      IF (JMIN.LT.N) GOTO 790
      IF (JMIN.EQ.N) GOTO 820
      IBRAN=1
      WRITE(IPR,109)IBRAN
      WRITE(IPR,101)JMIN
  109 FORMAT(1H ,40H*****INTERNAL ERROR IN RANK SUBROUTINE--,
     146HIMPOSSIBLE BRANCH CONDITION AT BRANCH POINT = ,I8)
  101 FORMAT(1H ,'JMIN = ',I8)
      STOP
  790 CONTINUE
      DO800J=JMIN,NM1
      IF (IX(I).NE.IW(J)) GOTO 800
      JP1=J+1
      DO 900 K=JP1,N
      IF (IW(K).NE.IW(J)) GOTO 950
  900 CONTINUE
      K=N+1
  950 CONTINUE
      AVRANK=J+K-1
      AVRANK=AVRANK/2
      IR(I)=AVRANK
       GOTO 880
  800 CONTINUE
  820 CONTINUE
      J=N
      K=N+1
      IF (IX(I).EQ.IW(J)) GOTO 850
      IBRAN=2
      WRITE(IPR,109) IBRAN
      WRITE(IPR,102) IX(I),IW(J)
  102 FORMAT(1H ,'IX(I) = ',I9,'   IW(J) = ',I9)
      STOP
  850 CONTINUE
      IR(I)=N
  880 CONTINUE
      IXPREV=IX(I)
      IRPREV=IR(I)
  700 CONTINUE
C  REORDER IF DESCENDING ORDER
  500 IF (ORD.EQ.'D') THEN
        DO 510 I=1,N/2
	      K= IR(I)
	      J=N-I+1
	      IR(I) = IR(J)
	      IR(J) = K
  510   CONTINUE
	  ENDIF
	  
      RETURN
      END
C***********************************************
      REAL*8 FUNCTION GAMLOG(XVALUE)
C
C     ALGORITHM AS245  APPL. STATIST. (1989) VOL. 38, NO. 2
C
C     Calculation of the logarithm of the gamma function
C
      IMPLICIT NONE
      INTEGER IFAULT
      REAL*8 ALR2PI, FOUR, HALF, ONE, ONEP5, R1(9), R2(9),
     +          R3(9), R4(5), TWELVE, X, X1, X2, XLGE, XLGST, XVALUE,
     +          Y, ZERO
C
C     Coefficients of rational functions
C
      DATA R1/-2.66685 51149 5D0, -2.44387 53423 7D1,
     +        -2.19698 95892 8D1,  1.11667 54126 2D1,
     +         3.13060 54762 3D0,  6.07771 38777 1D-1,
     +         1.19400 90572 1D1,  3.14690 11574 9D1,
     +         1.52346 87407 0D1/
      DATA R2/-7.83359 29944 9D1, -1.42046 29668 8D2,
     +         1.37519 41641 6D2,  7.86994 92415 4D1,
     +         4.16438 92222 8D0,  4.70668 76606 0D1,
     +         3.13399 21589 4D2,  2.63505 07472 1D2,
     +         4.33400 02251 4D1/
      DATA R3/-2.12159 57232 3D5,  2.30661 51061 6D5,
     +         2.74647 64470 5D4, -4.02621 11997 5D4,
     +        -2.29660 72978 0D3, -1.16328 49500 4D5,
     +        -1.46025 93751 1D5, -2.42357 40962 9D4,
     +        -5.70691 00932 4D2/
      DATA R4/ 2.79195 31791 8525D-1, 4.91731 76105 05968D-1,
     +         6.92910 59929 1889D-2, 3.35034 38150 22304D0,
     +         6.01245 92597 64103D0/
C
C     Fixed constants
C
      DATA ALR2PI/9.18938 53320 4673D-1/, FOUR/4.D0/, HALF/0.5D0/,
     +     ONE/1.D0/, ONEP5/1.5D0/, TWELVE/12.D0/, ZERO/0.D0/
C
C     Machine-dependant constants.
C     A table of values is given at the top of page 399 of the paper.
C     These values are for the IEEE double-precision format for which
C     B = 2, t = 53 and U = 1023 in the notation of the paper.
C
      DATA XLGE/5.10D6/, XLGST/1.D+305/
C
      X = XVALUE
      GAMLOG = ZERO
C
C     Test for valid function argument
C
      IFAULT = 2
      IF (X .GE. XLGST) GOTO 99
      IFAULT = 1
      IF (X .LE. ZERO) GOTO 99
      IFAULT = 0
C
C     Calculation for 0 < X < 0.5 and 0.5 <= X < 1.5 combined
C
      IF (X .LT. ONEP5) THEN
        IF (X .LT. HALF) THEN
          GAMLOG = -LOG(X)
          Y = X + ONE
C
C     Test whether X < machine epsilon
C
          IF (Y .EQ. ONE) RETURN
        ELSE
          GAMLOG = ZERO
          Y = X
          X = (X - HALF) - HALF
        END IF
        GAMLOG = GAMLOG + X * ((((R1(5)*Y + R1(4))*Y + R1(3))*Y
     +                + R1(2))*Y + R1(1)) / ((((Y + R1(9))*Y + R1(8))*Y
     +                + R1(7))*Y + R1(6))
        RETURN
      END IF
C
C     Calculation for 1.5 <= X < 4.0
C
      IF (X .LT. FOUR) THEN
        Y = (X - ONE) - ONE
        GAMLOG = Y * ((((R2(5)*X + R2(4))*X + R2(3))*X + R2(2))*X
     +              + R2(1)) / ((((X + R2(9))*X + R2(8))*X + R2(7))*X
     +              + R2(6))
        RETURN
      END IF
C
C     Calculation for 4.0 <= X < 12.0
C
      IF (X .LT. TWELVE) THEN
        GAMLOG = ((((R3(5)*X + R3(4))*X + R3(3))*X + R3(2))*X + R3(1)) /
     +            ((((X + R3(9))*X + R3(8))*X + R3(7))*X + R3(6))
        RETURN
      END IF
C
C     Calculation for X >= 12.0
C
      Y = LOG(X)
      GAMLOG = X * (Y - ONE) - HALF * Y + ALR2PI
      IF (X .GT. XLGE) RETURN
      X1 = ONE / X
      X2 = X1 * X1
      GAMLOG = GAMLOG + X1 * ((R4(3)*X2 + R4(2))*X2 + R4(1)) /
     +              ((X2 + R4(5))*X2 + R4(4))
      RETURN
  99  write(6,100) IFAULT,X
 100  FORMAT(1X,'PROBLEM WITH FUNCTION GAMLOG ',
     +   /1X,'IFAULT =',I3,' X =',G12.5)
      STOP
      END
C**************************************************************************
      FUNCTION DIGAMA(X)
      IMPLICIT NONE
C
C     ALGORITHM AS 103  APPL. STATIST. (1976) VOL.25, NO.3
C
C     Calculates DIGAMMA(X) = D( LOG( GAMMA(X))) / DX
C
      INTEGER IFAULT
      REAL*8 DIGAMA,ZERO, HALF, ONE
      REAL*8 R,S,C,S3,S4,S5,D1,Y,X
C
C     Set constants, SN = Nth Stirling coefficient, D1 = DIGAMMA(1.0)
C
      DATA ZERO/0.0D0/, HALF/0.5D0/, ONE/1.0D0/
      DATA S, C, S3, S4, S5, D1 /1.D-05, 8.5D0, 8.333333333D-02,
     *    8.3333333333D-03, 3.96825 3968D-03, -0.57721 56649D0/
C
C     Check argument is positive
C
      DIGAMA = ZERO
      Y = X
      IFAULT = 1
      IF (Y .LE. ZERO) GOTO 99
      IFAULT = 0
C
C     Use approximation if argument <= S
C
      IF (Y .LE. S) THEN
        DIGAMA = D1 - ONE / Y
        RETURN
      END IF
C
C     Reduce to DIGAMA(X + N) where (X + N) >= C
C
    1 IF (Y .GE. C) GO TO 2
      DIGAMA = DIGAMA - ONE/Y
      Y = Y + ONE
      GO TO 1
C
C     Use Stirling's (actually de Moivre's) expansion if argument > C
C
    2 R = ONE / Y
      DIGAMA = DIGAMA + DLOG(Y) - HALF*R
      R = R * R
      DIGAMA = DIGAMA - R*(S3 - R*(S4 - R*S5))
      RETURN
  99  write(6,100) IFAULT
 100  FORMAT(1X,'PROBLEM WITH FUNCTION DIGAMA ',/1X,'IFAULT =',I3)
      STOP
      END
C*******************************************************
      function trigam(x)
      implicit none
c
c        algorithm as121   Appl. Statist. (1978) vol 27, no. 1
c
c        calculates trigamma(x) = d**2(log(gamma(x))) / dx**2
c
      integer ifault
      real*8 trigam,a, b, one, half, b2, b4, b6,b8, x, y, z, zero
      data a, b, one, half /1.0d-4, 5.0d0, 1.0d0, 0.5d0/
      data zero /0.0d0/
c
c        b2, b4, b6 and b8 are Bernoulli numbers
c
      data b2, b4, b6,b8
     */0.1666666667d0, -0.03333333333d0,
     *    0.02380952381d0, -0.03333333333d0/
c
c        check for positive value of x
c
      trigam = zero
      ifault = 1
      if (x.le.zero) goto 99
      ifault = 0
      z = x
c
c        use small value approximation if x .le. a
c
      if (z .gt. a) goto 10
      trigam = one / (z * z)
      return
c
c        increase argument to (x+i) .ge. b
c
   10 if (z .ge. b) goto 20
      trigam = trigam + one / (z * z)
      z = z + one
      goto 10
c
c        apply asymptotic formula if argument .ge. b
c
   20 y = one / (z * z)
      trigam = trigam + half * y +
     * (one + y * (b2 + y * (b4 + y * (b6 + y * b8)))) / z
      return
  99  write(6,100) IFAULT
 100  FORMAT(1X,'PROBLEM WITH FUNCTION TRIGAMA ',/1X,'IFAULT =',I3)
      STOP
      end
      SUBROUTINE CHOLESKY(A, LDA, N, INFO,ICODE)
C   (INITIALLY CALLED DPOFA)
C***PURPOSE  Factor a real symmetric positive definite matrix.
C      Modified (vpd 16/12/95) to accept semi-positive definite matrix
C***LIBRARY   SLATEC (LINPACK) (with CHANGES)
C
C***
C     CHOLESKY factors a double precision symmetric positive definite
C     matrix.
C
C     On Entry
C
C        A       DOUBLE PRECISION(LDA, N)
C                the symmetric matrix to be factored.  Only the
C                diagonal and upper triangle are used.
C
C        LDA     INTEGER
C                the leading dimension of the array  A .
C
C        N       INTEGER
C                the order of the matrix  A .
C
C     On Return
C
C        A       an upper triangular matrix  R  so that  A = TRANS(R)*R
C                where  TRANS(R)  is the transpose.
C                The strict lower triangle is unaltered.
C                If  INFO .NE. 0 , the factorization is not complete.
C
C        INFO    INTEGER
C                = 0  for normal return.
C                = K  signals an error condition.  The leading minor
C                     of order  K  is not positive definite.
C
      use parinclu
c
      implicit none
      REAL*8 TOL
      PARAMETER(TOL=1.D-6)
C
      INTEGER LDA,N,INFO,I,J,JJ,JM1,K,ICODE
      REAL*8  A(LDA,*),DDOT,T,S
C

C***
         DO 30 J = 1, N
            INFO = J
            S = 0.0D0
            JM1 = J - 1
            IF (JM1 .LT. 1) GO TO 20
            DO 10 K = 1, JM1
               IF (A(K,K).EQ.0.D0) THEN
                    A(K,J)=0.D0
               ELSE
                   T = A(K,J) - DDOT(K-1,A(1,K),1,A(1,J),1)
                   T = T/A(K,K)
                   A(K,J) = T
                   S = S + T*T
                 ENDIF
   10       CONTINUE
   20       CONTINUE
            S = A(J,J) - S
            IF (S .LE. -TOL) THEN
                WRITE(6,100) J,S
  100         FORMAT( 'THE MATRIX IS NOT SEMI-POSITIVE DEFINITE',/1X,
     +        ' IN LIGN ', I5,' THE SQUARE ROOT OF ',D12.4,
     +        ' IS COMPUTED',/1X,
     +        ' THIS MAY BE DUE TO INCORRECTLY SPECIFIED CONSTRAINTS')
               RETURN
             ELSE IF (S.LE.TOL) THEN
                A(J,J) = 0.D0
                DO 28 I=1,N
                  A(J,I)=0.D0
                  A(I,J)=0.D0
  28            CONTINUE
                IF (ICODE.EQ.1) THEN		
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                   JJ=0
                   DO 25 I=1,ICONS(0)
                     IF (ICONS(I).EQ.J) JJ=1
  25               CONTINUE
                   IF (JJ.EQ.0) THEN
                     ICONS(0) = ICONS(0) + 1
                     ICONS(ICONS(0))= J
                   ENDIF
                ENDIF
             ELSE
                A(J,J) = SQRT(S)
            ENDIF
30    CONTINUE
         INFO = 0
   40 CONTINUE

      RETURN
      END
       SUBROUTINE INVDET(A, LDA, N, DLDET, JOB)
C***(initially called DPODI)
C***PURPOSE  Compute the log-determinant and/or inverse of a certain real
C            symmetric positive definite matrix using the factors
C            computed by CHOLESKY.
C***LIBRARY   SLATEC (LINPACK) (with CHANGES)
C
C     INVDET computes the (non zero) logdeterminant and (generalized) inverse of a certain
C     double precision symmetric positive definite matrix (see below)
C     using the factor CHOLESKY.
C
C     On Entry
C
C        A       DOUBLE PRECISION(LDA, N)
C                the output  A  from CHOLESKY
C
C        LDA     INTEGER
C                the leading dimension of the array  A .
C
C        N       INTEGER
C                the order of the matrix  A .
C
C        JOB     INTEGER
C                = 11   both determinant and inverse.
C                = 01   inverse only.
C                = 10   determinant only.
C
C     On Return
C
C        A     INVDET produces the upper half of INVERSE(A) .
C                Elements of  A  below the diagonal are unchanged.
C                If the units digit of JOB is zero,  A  is unchanged.
C
C        DLDET     DOUBLE PRECISION
C                determinant of  A if requested.
C                Otherwise not referenced.)
C
      use parinclu
	  
      implicit none
      INTEGER LDA,N,JOB, I,J,JM1,K,KP1
      DOUBLE PRECISION A(LDA,*), DLDET,T
C
C     COMPUTE LOG DETERMINANT SKIPPING ZERO DIAGONALS
C
      IF (JOB.GE.10) THEN
         DLDET=0.0D0
         DO 50 I = 1, N
           IF (A(I,I).GT.0.D0) DLDET = DLDET+DLOG(A(I,I))
   50    CONTINUE
         DLDET = 2.D0 * DLDET
      ENDIF
        IF (MOD(JOB,10) .EQ. 0) RETURN
C
C     COMPUTE INVERSE(R)
C
         DO 100 K = 1, N
            IF (A(K,K).NE.0.D0) THEN
               A(K,K) = 1.0D0/A(K,K)
               T = -A(K,K)
               CALL DSCAL(K-1,T,A(1,K),1)
               KP1 = K + 1
               IF (N .LT. KP1) GO TO 70
               DO 60 J = KP1, N
                 T = A(K,J)
                 A(K,J) = 0.0D0
                 CALL DAXPY(K,T,A(1,K),1,A(1,J),1)
   60         CONTINUE
   70       CONTINUE
              ELSE
                KP1 = K + 1
                IF (N .LT. KP1) GO TO 90
                DO 80 J = KP1, N
                  A(K,J) = 0.0D0
   80         CONTINUE
             ENDIF
   90       CONTINUE

  100    CONTINUE
C
C        FORM  INVERSE(R) * TRANS(INVERSE(R))
C
         DO 130 J = 1, N
            JM1 = J - 1
            IF (JM1 .LT. 1) GO TO 120
            DO 110 K = 1, JM1
               T = A(K,J)
               CALL DAXPY(K,T,A(1,J),1,A(1,K),1)
  110       CONTINUE
  120       CONTINUE
            T = A(J,J)
            CALL DSCAL(J,T,A(1,J),1)
  130    CONTINUE
  140 CONTINUE
      RETURN
      END
      SUBROUTINE DSCAL (N, DA, DX, INCX)
C***
C***PURPOSE  Multiply a vector by a constant.
C***LIBRARY   SLATEC (BLAS)
C
C                B L A S  Subprogram
C    Description of Parameters
C
C     --Input--
C        N  number of elements in input vector(s)
C       DA  double precision scale factor
C       DX  double precision vector with N elements
C     INCX  storage spacing between elements of DX
C
C     --Output--
C       DX  double precision result (unchanged if N.LE.0)
C
C     Replace double precision DX by double precision DA*DX.
C     For I = 0 to N-1, replace DX(IX+I*INCX) with  DA * DX(IX+I*INCX),
C     where IX = 1 if INCX .GE. 0, else IX = 1+(1-N)*INCX.
C
      implicit none
       DOUBLE PRECISION DA, DX(*)
      INTEGER I, INCX, IX, M, MP1, N
C
      IF (N .LE. 0) RETURN
      IF (INCX .EQ. 1) GOTO 20
C
C     Code for increment not equal to 1.
C
      IX = 1
      IF (INCX .LT. 0) IX = (-N+1)*INCX + 1
      DO 10 I = 1,N
        DX(IX) = DA*DX(IX)
        IX = IX + INCX
   10 CONTINUE
      RETURN
C
C     Code for increment equal to 1.
C
C     Clean-up loop so remaining vector length is a multiple of 5.
C
   20 M = MOD(N,5)
      IF (M .EQ. 0) GOTO 40
      DO 30 I = 1,M
        DX(I) = DA*DX(I)
   30 CONTINUE
      IF (N .LT. 5) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        DX(I) = DA*DX(I)
        DX(I+1) = DA*DX(I+1)
        DX(I+2) = DA*DX(I+2)
        DX(I+3) = DA*DX(I+3)
        DX(I+4) = DA*DX(I+4)
   50 CONTINUE
      RETURN
      END

      subroutine  dcopy(n,dx,incx,dy,incy)
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      implicit none
      double precision dx(*),dy(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,7)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dy(i) = dx(i)
   30 continue
      if( n .lt. 7 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,7
        dy(i) = dx(i)
        dy(i + 1) = dx(i + 1)
        dy(i + 2) = dx(i + 2)
        dy(i + 3) = dx(i + 3)
        dy(i + 4) = dx(i + 4)
        dy(i + 5) = dx(i + 5)
        dy(i + 6) = dx(i + 6)
   50 continue
      return
      end

      double precision function dnrm2 ( n, dx, incx)
      implicit none
      integer next,n,nn,incx,i,j
      double precision dx(*), cutlo, cuthi, hitest, sum, xmax,zero,one
      data   zero, one /0.0d0, 1.0d0/
c
c     euclidean norm of the n-vector stored in dx() with storage
c     increment incx .
c     if    n .le. 0 return with result = 0.
c     if n .ge. 1 then incx must be .ge. 1
c
c           c.l.lawson, 1978 jan 08
c
c     four phase method     using two built-in constants that are
c     hopefully applicable to all machines.
c         cutlo = maximum of  dsqrt(u/eps)  over all known machines.
c         cuthi = minimum of  dsqrt(v)      over all known machines.
c     where
c         eps = smallest no. such that eps + 1. .gt. 1.
c         u   = smallest positive no.   (underflow limit)
c         v   = largest  no.            (overflow  limit)
c
c     brief outline of algorithm..
c
c     phase 1    scans zero components.
c     move to phase 2 when a component is nonzero and .le. cutlo
c     move to phase 3 when a component is .gt. cutlo
c     move to phase 4 when a component is .ge. cuthi/m
c     where m = n for x() real and m = 2*n for complex.
c
c     values for cutlo and cuthi..
c     from the environmental parameters listed in the imsl converter
c     document the limiting values are as follows..
c     cutlo, s.p.   u/eps = 2**(-102) for  honeywell.  close seconds are
c                   univac and dec at 2**(-103)
c                   thus cutlo = 2**(-51) = 4.44089e-16
c     cuthi, s.p.   v = 2**127 for univac, honeywell, and dec.
c                   thus cuthi = 2**(63.5) = 1.30438e19
c     cutlo, d.p.   u/eps = 2**(-67) for honeywell and dec.
c                   thus cutlo = 2**(-33.5) = 8.23181d-11
c     cuthi, d.p.   same as s.p.  cuthi = 1.30438d19
c     data cutlo, cuthi / 8.232d-11,  1.304d19 /
c     data cutlo, cuthi / 4.441e-16,  1.304e19 /
      data cutlo, cuthi / 8.232d-11,  1.304d19 /
c
      if(n .gt. 0) go to 10
         dnrm2  = zero
         go to 300
c
   10 assign 30 to next
      sum = zero
      nn = n * incx
c                                                 begin main loop
      i = 1
   20    go to next,(30, 50, 70, 110)
   30 if( dabs(dx(i)) .gt. cutlo) go to 85
      assign 50 to next
      xmax = zero
c
c                        phase 1.  sum is zero
c
   50 if( dx(i) .eq. zero) go to 200
      if( dabs(dx(i)) .gt. cutlo) go to 85
c
c                                prepare for phase 2.
      assign 70 to next
      go to 105
c
c                                prepare for phase 4.
c
  100 i = j
      assign 110 to next
      sum = (sum / dx(i)) / dx(i)
  105 xmax = dabs(dx(i))
      go to 115
c
c                   phase 2.  sum is small.
c                             scale to avoid destructive underflow.
c
   70 if( dabs(dx(i)) .gt. cutlo ) go to 75
c
c                     common code for phases 2 and 4.
c                     in phase 4 sum is large.  scale to avoid overflow.
c
  110 if( dabs(dx(i)) .le. xmax ) go to 115
         sum = one + sum * (xmax / dx(i))**2
         xmax = dabs(dx(i))
         go to 200
c
  115 sum = sum + (dx(i)/xmax)**2
      go to 200
c
c
c                  prepare for phase 3.
c
   75 sum = (sum * xmax) * xmax
c
c
c     for real or d.p. set hitest = cuthi/n
c     for complex      set hitest = cuthi/(2*n)
c
   85 hitest = cuthi/float( n )
c
c                   phase 3.  sum is mid-range.  no scaling.
c
      do 95 j =i,nn,incx
      if(dabs(dx(j)) .ge. hitest) go to 100
      sum = sum + dx(j)**2
   95 continue     
      dnrm2 = dsqrt( sum )
      go to 300
c
  200 continue
      i = i + incx
      if ( i .le. nn ) go to 20
c
c              end of main loop.
c
c              compute square root and adjust for scaling.
c
      dnrm2 = xmax * dsqrt(sum)
  300 continue
      return
      end

