      PROGRAM WEIBULL
C//////////////////////////////////////////////////////////////////////*
C  WEIBULL       *                                                     *
C                *                       Version 6.2 of December 2013  *
C//////////////////////////////////////////////////////////////////////*
      use parinclu
c
      implicit none

      integer,allocatable:: idf(:,:)       !IDF(0:MXEF,2)
      real*8,allocatable:: xlik(:,:)       !XLIK(0:MXEF,2)
      real*8,allocatable:: storbeta(:,:,:) !STORBETA(NDIMAX,0:NPGAUSS,0:NPGAUSS)
      real*8,allocatable:: gradf(:),std(:) !gradf(NDIMAX),std(NDIMAX2) 
c
      INTEGER I,I2,II,IM1,IW,IWL,J,J1,J2,JJ,K,KK,L,ISUP,N,N1
      INTEGER IFAIL,NCTEST,NSTD,NBASE,NSURV,NCONS,NSTATE,NALPHA
      INTEGER NSTATUS,NOPTION,IUSER(3),IRK,IRK0
      INTEGER NDF,NCOVMOD2,NOLDS,ICODE
      INTEGER ITGAUSS,KITER,IBACKS
! 2 estimates
      INTEGER INDXS(20)
	  
      REAL*8 GVAL,T(2,2),JACOB,ERR(20,21),XS(20)
      logical flag
	  
C
      REAL TIM00,TIM1,SECOND
      REAL*8 F,W,VARW,XINTER,BSOL,OBJ,LOB,UPB,BEST(20),DFMIN
      REAL*8 DLDET,DLDET0,R2M,TRIGAM
      REAL*8 XNORM,XCHI2,XCHI2L,XPROB,XPROBL,XSTD,XRISK
      REAL*8 WGAUSS(5,5),XGAUSS(5,5),XMOM(0:3,0:3),XMOMP(0:2,0:2),W2
      REAL*8 OBJ0,XMUK(2),XMUKM1(2),SIGK(3),SIGKM1(3),R1,R2,VAL(2,2)
      REAL*8 XALPHA,XALPH1,XUP,XDOWN,W1,W3
C
      EXTERNAL FTOMIN,FTOMIN2
      CHARACTER*8 PARNAME,PARNAME2(2),PARLAB(2)
      CHARACTER*12 VARTYP,LABEL2(3)
C
C-----------------------------------------------------------------------
C   ROOTS USED IN THE GAUSS-HERMITE QUADRATURE
C-----------------------------------------------------------------------
      DATA((WGAUSS(J,I),J=1,5),I=3,5)/
     + 0.417771379105166318,1.67108551642066683,0.417771379105166318,
     + 0.D0,0.D0,0.114993714684505977,1.13832042263099442,
     + 1.13832042263099487,0.114993714684505977,0.D0,
     + 0.0282181455332160026,0.556661785214017657,
     + 1.33686841313653382,0.556661785214018656,0.02821814553321600266/
      DATA((XGAUSS(J,I),J=1,5),I=3,5)/
     + -1.73205080756887786,0.D0,1.73205080756887786,0.D0,0.D0,
     + -2.33441421833897689,-0.741963784302725915,
     + 0.741963784302725360,2.33441421833897689,0.D0,
     + -2.85697001387280558,-1.35562617997426593,0.D0,
     + 1.35562617997426460,2.85697001387280558/
C
C-----------------------------------------------------------------------
C   SPECIFICATION AND CHANGE OF FORMER PARAMETERS WITH KEYWORDS
C-----------------------------------------------------------------------
! default value for NDIMAX2
      NDIMAX2=NDIMAX
! changing values if keyword specified
      call parchange
C-----------------------------------------------------------------------
C   Allocation of variables after their final value is known  - more in init
C----------------------------------------------------------------------
!Allocated ONLY locally
      allocate( IDF(0:MXEF,2) )
      allocate( XLIK(0:MXEF,2) )
      allocate( STORBETA(NDIMAX,0:NPGAUSS,0:NPGAUSS) )
      allocate( gradf(NDIMAX),std(NDIMAX2) )
! Allocation of variables from module parinclu
      allocate( BETAWOC(2*MXSTRA+3) )
      allocate ( DELTA(NDIMAX) )
      allocate(icorr(MXEF,2))
      allocate (XGAM(0:MXEF),XNOR(0:MXEF),BOUND(MXEF,3),LABEL(0:MXEF))	
	  
C-----------------------------------------------------------------------
C STEP 1 : READ MODEL SPECIFICATION , INITIALIZATION
C          CHECK INPUT FILE, COMPUTES ELEMENTARY STATISTICS
C          PREPARE WORKING FILE FOR SUBROUTINE FWEIB
C-----------------------------------------------------------------------
      IF (NKEYW.NE.85) THEN
           WRITE(6,9099)
 9099    FORMAT(/1X,'THIS VERSION OF WEIBULL.F WAS COMPILED WITH AN',
     +   ' INCORRECT PARINCLU FILE',/1X,' PARINCLU SHOULD HAVE NKEYW=',
     +   '85',/)
         STOP
      ENDIF
      NOPTION=-999
      NSTATUS=0
      ndim=ndimax
      Ndens=1
      TIM00 = SECOND()
      CALL INIT(NDIM,NCTEST,NSTD,NBASE,NSURV,NCONS,NOLDS,NSTATUS,IBACKS)

      LABEL2(1)='(CONTINUOUS)'
      LABEL2(2)='(DISCRETE)  '
      LABEL2(3)='NO COVARIATE'
      NOPTION=0
      ICHECK=0
C
      NCOVMOD2 = NCOVMOD
      IF (INTEGAM.NE.0) NCOVMOD2 = NCOVMOD2-1
      IF (NCOVMOD.EQ.0) GOTO  80
C-----------------------------------------------------------------------
C STEP 2 : FIND OR CHECK CONSTRAINTS
C-----------------------------------------------------------------------
      WRITE(6,9100)
      WRITE(12,9100)
C-----------------------------------------------------------------------
C IF NCONS = -1, LOOK FOR CONSTRAINTS
C-----------------------------------------------------------------------
      IF (NCONS.EQ.-1) THEN
        DO 10 I=1,NDIMB
          IF (NFAIL(I).NE.0) BETA(I) = 0.005D0*MOD(I,10)
  10    CONTINUE
        NOPTION=90
        DO 6252 J=1,NCCOV+NDCOV
          IANAL(J)=1
 6252   CONTINUE
        IF (NDIM.GT.NDIMAX) WRITE(6,9102)
        CALL FWEIB2(BETA,F,GRADF,STD,DLDET,NDF,NOPTION,NDIM)
        ICHECK=0
C----------------------------------------------------------------------
C IF NCONS = 2, CHECK THAT THE CONSTRAINTS SUPPLIED BY THE USER ARE
C VALID
C-----------------------------------------------------------------------
      ELSE IF (NCONS.GE.2) THEN
        DO 20 I=1,NDIMB
          IF (NFAIL(I).NE.0) BETA(I) = 0.005D0*MOD(I,10)
   20   CONTINUE
         DO 6254 J=1,NCCOV+NDCOV
          IANAL(J)=1
 6254    CONTINUE
C
C COMPUTATION OF DLDET AND IRK WITH SUPPLIED CONSTRAINTS
C
        ICHECK = 2
        IRK=0
        CALL FWEIB2(BETA,F,GRADF,STD,DLDET,NDF,NOPTION,NDIM)
        DO 22 I=1,NDIM
	  IF (STD(I).GT.1.d-8.AND.BETA(I).GT.-999.D0) IRK=IRK+1
C REINITIALIZATION OF VECTOR BETA
          IF (NFAIL(I).NE.0.AND.I.LE.NDIMB) BETA(I) = 0.005D0*MOD(I,10)
   22   CONTINUE
C
C COMPUTATION OF DLDET0 AND IRK0 WITH CORRECT SET OF CONSTRAINTS
C
        NOPTION = 100
        CALL FWEIB2(BETA,F,GRADF,STD,DLDET0,NDF,NOPTION,NDIM)
        ICHECK=0
        IRK0=0
        DO 24 I=1,NDIM
          IF (STD(I).LT.1.d-8.AND.BETA(I).GT.-999.D0) THEN
	      ICHECK=ICHECK+1
            GRADF(ICHECK)=I
          ELSE
            IRK0 = IRK0 +1
          ENDIF
   24   CONTINUE
C-----------------------------------------------------------------------
C  COMPARE RESULTS
C-----------------------------------------------------------------------
        W = (DLDET-DLDET0)/DLDET
        IF (DABS(W).LT.1.D-8) THEN
          IF (IRK.EQ.IRK0) THEN
            ICHECK=0
          ELSE
            ICHECK=-ICHECK
          ENDIF
        ENDIF
      ENDIF
C
C-----------------------------------------------------------------------
C PRINT CONSTRAINTS
C-----------------------------------------------------------------------
      IF ((NCONS.EQ.-2).OR.(ICONS(0).EQ.0)) THEN
        WRITE(6,9105)
        WRITE(12,9105)
      ELSE IF (NCONS.EQ.-1) THEN
        WRITE(6,9110)
        WRITE(12,9110)
      ELSE IF (NCONS.EQ.0) THEN
        WRITE(6,9112)
        WRITE(12,9112)
      ELSE IF (NCONS.GT.0) THEN
        WRITE(6,9115)
        WRITE(12,9115)
      ENDIF
      IF (NCONS.NE.-1.AND.NCONS.LT.2) WRITE(6,9117)
      IF (NCONS.NE.-1.AND.NCONS.LT.2) WRITE(12,9117)
      DO 100 K=1,ICONS(0)
        I = ICONS(K)
        DO 110 J=1,NCOVMOD
        II = IMOD(J)
c        IF (ISAME(II).NE.0) GOTO 110
        IF (I.LT.IFIRST(II).OR.I.GT.ILAST(II)) GOTO 110
          KK = IRANK(I)
          IF (NCOL(II).EQ.1) THEN
            WRITE(6,9120) LABEL(II),IOLDCODE(KK,1)
            WRITE(12,9120) LABEL(II),IOLDCODE(KK,1)
          ELSE IF (NCOL(II).EQ.2) THEN
            WRITE(6,9121) LABEL(II),IOLDCODE(KK,1),IOLDCODE(KK,2)
            WRITE(12,9121) LABEL(II),IOLDCODE(KK,1),IOLDCODE(KK,2)
          ELSE
            WRITE(6,9122) LABEL(II),(IOLDCODE(KK,JJ),JJ=1,3)
            WRITE(12,9122) LABEL(II),(IOLDCODE(KK,JJ),JJ=1,3)
          ENDIF
  110   CONTINUE
  100 CONTINUE
C-----------------------------------------------------------------------
C PRINT IF PROBLEMS
C-----------------------------------------------------------------------
      IF (NCONS.GE.2) THEN
       IF (ICHECK.EQ.0) THEN
         WRITE(6,9116)
         WRITE(12,9116)
       ELSE IF (ICHECK.LT.0) THEN
         ISUP = (-ICHECK)-ICONS(0)
         WRITE(6,9130) ISUP
         WRITE(12,9130) ISUP
       ELSE
         WRITE(6,9135)
         WRITE(12,9135)
       ENDIF
C
       DO 115  K=1,ABS(ICHECK)
        I = NINT(GRADF(K))
        DO 120 J=1,NCOVMOD
        II = IMOD(J)
        IF (I.LT.IFIRST(II).OR.I.GT.ILAST(II).OR.ISAME(II).NE.0)
     +             GOTO 120
          KK = IRANK(I)
          IF (NCOL(II).EQ.1) THEN
            WRITE(6,9120) LABEL(II),IOLDCODE(KK,1)
            WRITE(12,9120) LABEL(II),IOLDCODE(KK,1)
          ELSE IF (NCOL(II).EQ.2) THEN
            WRITE(6,9121) LABEL(II),IOLDCODE(KK,1),IOLDCODE(KK,2)
            WRITE(12,9121) LABEL(II),IOLDCODE(KK,1),IOLDCODE(KK,2)
          ELSE
            WRITE(6,9122) LABEL(II),(IOLDCODE(KK,JJ),JJ=1,3)
            WRITE(12,9122) LABEL(II),(IOLDCODE(KK,JJ),JJ=1,3)
          ENDIF
  120   CONTINUE
  115  CONTINUE
       IF (ICHECK.GT.0) THEN
         STOP
       ELSE
         ICHECK=0
       ENDIF
       DO 95 I=1,NDIMB
         IF (NFAIL(I).NE.0) THEN
            BETA(I) = 0.D0
         ELSE
            BETA(I) = -999.99D0
         ENDIF
   95  CONTINUE
      ENDIF
C
 9100 FORMAT(/7X,'******* CONSTRAINTS ******')
 9102 FORMAT(/1X,' IF THE PROGRAM DOES NOT WORK PROPERLY AT THIS POINT',
     + /1X,' IT MAY BE DUE TO INSUFFICIENT MEMORY',
     + /1X,' OR A PARAMETER ',
     + 'NDIMAX2 NOT EQUAL TO NDIMAX',/1X,' OR NDIMAX IS TOO LARGE',
     + /1X,' CHECK THE PARINCLU FILE')
 9105 FORMAT(/1X,' NO CONSTRAINTS IMPOSED')
 9110 FORMAT(/1X,' THE SOLUTION FOR THE FOLLOWING (RECODED)',
     +   ' LEVELS IS SET TO 0:'/)
 9112 FORMAT(/1X,' THE SOLUTION FOR THE FOLLOWING (RECODED)',
     +   ' LEVELS IS SET TO 0:',
     + /1X,' (= LEVEL WITH LARGEST NUMBER OF UNCENSORED FAILURES ',
     + 'FOR EACH EFFECT)',/)
 9115 FORMAT(/1X,' THE SOLUTION FOR THE FOLLOWING (RECODED)',
     +   ' LEVELS IS SET TO 0:')
 9116 FORMAT(/1X,'( THE COHERENCY OF THESE CONSTRAINTS IS VERIFIED)',/)
 9117 FORMAT(1X,'(WARNING : THE VALIDITY OF THESE CONSTRAINTS ',
     +'IS NOT CHECKED.',
     + /1X,' IF THEY ARE MORE DEPENDENCIES, DEGREES ',
     +'OF FREEDOM IN TEST(S) BELOW ARE INCORRECT)'/)
 9120 FORMAT(1X,' EFFECT ',A8,' LEVEL ',I8)
 9121 FORMAT(1X,' EFFECT ',A8,' LEVEL ',I8,' * ',I6)
 9122 FORMAT(1X,' EFFECT ',A8,' LEVEL ',I8,' * ',I6,' *',I6)
 9130 FORMAT(/1X,' EXTRA CONSTRAINTS COULD HAVE BEEN ADDED ',/
     + 1X,'   SPECIFY ',I3,' NEW CONSTRAINTS TO GET CORRECT NUMBERS',
     + ' OF DEGREES OF FREEDOM',
     +  /1X,' AS AN INDICATION, THE "FIND" OPTION IDENTIFIES THE ',
     + ' FOLLOWING CONSTRAINTS:'/1X)
 9135 FORMAT(1X,' INCORRECT CONSTRAINTS IMPOSED  ==> STOP')
 9136 FORMAT(//1X,' THE "FIND" OPTION IDENTIFIES THE FOLLOWING',
     + ' CONSTRAINTS:'/1X)
C
C-----------------------------------------------------------------------
C STEP 3 : CALL THE MAXIMIZATION SUBROUTINE
C-----------------------------------------------------------------------
   80  IFAIL = 0
C-----------------------------------------------------------------------
C COMPUTE FWEIB WITH NO COVARIATE
C-----------------------------------------------------------------------
      IF (NOLDS.LT.2) THEN
        IUSER(3)=-2
        DO 125 J=1,NCCOV+NDCOV
          IANAL(J)=0
  125   CONTINUE
        DO 15 I=1,NDIMB
          IF (NFAIL(I).NE.0.AND.BETA(I).LT.10.D0)
     +          BETA(I) = 0.D0
   15   CONTINUE
        CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
c         IF (NOLDS.EQ.1) THEN
          DO 128 I=NDIMB+1,NDIM
            BETAWOC(I-NDIMB) = BETA(I)
  128     CONTINUE
c        ENDIF
        IF (NCOVMOD.EQ.0) THEN
           K= 0
           GOTO 750
        ENDIF
      ELSE
        IUSER(3)=-1
        ICODE=2
        CALL RWBACKUP(ICODE,FILE(7))
        write(6,*) 'read "NOCOVARIATE" file'
        write(6,844) (BETA(I),I=MAX(1,NDIMB,NDIM-30),NDIM)
  844   FORMAT(1X,10F7.2)
        DO 849 I=1,NDIMB-1
           BETA(I)=0.D0
  849   CONTINUE
        CALL FWEIB(BETA,F,GRADF,NDIM,NSTATE,IUSER)
        ICODE=3
        WRITE(6,*) 'READ OLD SOLUTIONS'
        CALL RWBACKUP(ICODE,FILE(7))
	  WRITE(6,844) (BETA(I),I=1,50)
          WRITE(6,*) ' ... '
	  WRITE(6,844) (BETA(I),I=NDIM-3,NDIM)
        DO 17 J=1,NCCOV+NDCOV
          IANAL(J)=1
   17   CONTINUE
      ENDIF
c
      IUSER(3)=0
      IDF(0,1) = IUSER(1)
      XLIK(0,1) = 2.D0 * F
C-----------------------------------------------------------------------
C IF TEST = SEQUENTIAL, ADD ONE EFFECT AT A TIME
C-----------------------------------------------------------------------
      IF (NCTEST.GE.2.AND.NCTEST.LE.4) THEN
        IF (NCTEST.LT.4) THEN
          JJ=1
        ELSE
          JJ=NCOVMOD
          DO 148 I=1,NCOVMOD
            K=IMOD(I)
            IF (ITEST(K).NE.0) JJ=MIN(I,JJ)
  148     CONTINUE
          DO 150 I=1,JJ-1
            K = IMOD(I)
            DO 152 J=1,IR1
              IF (ITRAIT1(J).EQ.K) THEN
                IANAL(IORDR1(J))=1
              ENDIF
  152       CONTINUE
            DO 154 J=1,IR2
              IF (ITRAIT2(J).EQ.K) THEN
                IANAL(NCCOV+IORDR2(J))=1
              ENDIF
  154       CONTINUE
  150     CONTINUE
        ENDIF
        IF (NCTEST.EQ.4) THEN
          CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
          WRITE(6,9030) ITOEV,ITOEV2,TOTIM
          WRITE(12,9030) ITOEV,ITOEV2,TOTIM
        ENDIF
        IF (NJOINT.EQ.1) THEN
          W = DEXP(BETA(NDIM))
          VARW=TRIGAM(1./W)
          WRITE(6,9028) W,VARW
          WRITE(12,9028) W,VARW
        ENDIF
        IDF(K,1) = IUSER(1)
        XLIK(K,1) = 2.D0 * F
        DO 158 I=JJ,NCOVMOD
          K = IMOD(I)
          DO 160 J=1,IR1
            IF (ITRAIT1(J).EQ.K) THEN
              IANAL(IORDR1(J))=1
            ENDIF
  160     CONTINUE
          DO 161 J=1,IR2
            IF (ITRAIT2(J).EQ.K) THEN
              IANAL(NCCOV+IORDR2(J))=1
            ENDIF
  161     CONTINUE
c
          IF (I.LT.NCOVMOD) THEN
             CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
             WRITE(6,9030) ITOEV,ITOEV2,TOTIM
             WRITE(12,9030) ITOEV,ITOEV2,TOTIM
             IF (NJOINT.EQ.1) THEN
               W = DEXP(BETA(NDIM))
               WRITE(6,9028) W
               WRITE(12,9028) W
             ENDIF
             IDF(K,1) = IUSER(1)
             XLIK(K,1) = 2.D0 * F
             IF (I.EQ.NCOVMOD-1) THEN
c               KK = IMOD(NCOVMOD2)
               KK = IMOD(NCOVMOD)
               IDF(KK,2) = IDF(K,1)
               XLIK(KK,2) = XLIK(K,1)
             ENDIF
           ENDIF
  158    CONTINUE
       ENDIF
C-----------------------------------------------------------------------
C IF TEST = LAST, DELETE ONE EFFECT AT A TIME
C-----------------------------------------------------------------------
       IF ((NCTEST.EQ.1).OR.(NCTEST.GE.3)) THEN
         DO 170 I=1,NCOVMOD
           K = IMOD(I)
           IF (NCTEST.EQ.3.AND.I.EQ.NCOVMOD
     +            .AND.I.GT.1) GOTO 170
           IF (ITEST(K).NE.0.OR.NCTEST.EQ.1) THEN
             DO 180 J=1,IR1
              IF (ITRAIT1(J).EQ.K) THEN
                IANAL(IORDR1(J))=0
                DO 185 JJ=IFIRST(K),ILAST(K)
                  IF (NFAIL(JJ).NE.0) BETA(JJ)=0.D0
  185           CONTINUE
              ELSE
                IANAL(IORDR1(J))=1
              ENDIF
  180       CONTINUE
            DO 190 J=1,IR2
              IF (ITRAIT2(J).EQ.K) THEN
                IANAL(NCCOV+IORDR2(J))=0
                DO 195 JJ=IFIRST(K),ILAST(K)
                  IF (NFAIL(JJ).NE.0) BETA(JJ)=0.D0
  195           CONTINUE
              ELSE
               if (NCCOV+IORDR2(J).ne.0) then
                IANAL(NCCOV+IORDR2(J))=1
               endif
              ENDIF
  190       CONTINUE
            CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
            WRITE(6,9030) ITOEV,ITOEV2,TOTIM
            WRITE(12,9030) ITOEV,ITOEV2,TOTIM
            IF (NJOINT.EQ.1) THEN
              W = DEXP(BETA(NDIM))
              WRITE(6,9028) W
              WRITE(12,9028) W
            ENDIF
            IDF(K,2) = IUSER(1)
            XLIK(K,2) = 2.D0 * F
          ENDIF
  170   CONTINUE
      ENDIF
C-----------------------------------------------------------------------
C LAST ONE = FULL MODEL
C-----------------------------------------------------------------------
      DO 200 J=1,NCCOV+NDCOV
       IANAL(J)=1
  200 CONTINUE
      IF (NPEST.EQ.0) THEN
        CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
      ELSE IF (NPEST.GE.1) THEN
        JJ=0
        DO 202 J=1,MAXRAND
          IF (BOUND(J,1).GT.0.D0) JJ=J
  202   CONTINUE
        IF (NPEST.GE.100) IUSER(3)=1
C        CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
        IF (JJ.NE.0) THEN
          LOB=BOUND(JJ,1)
          UPB=BOUND(JJ,2)
        ENDIF
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        NTRACE=+2
        NFMAX=200
        NFLAT=1
        NXTRA=1
        KW=12
        NPARMI=0
	flag=.false.
        DO J=1,MAXRAND
           IF (IGAM(J,1).GE.1.AND. NJOINT.EQ.0) THEN
             NPARMI=NPARMI+1
             XS(NPARMI)=XGAM(J)
             INDXS(NPARMI)=J
             IF (IGAM(J,1).EQ.2) THEN
                MASK(NPARMI)=0
             ELSE
                MASK(NPARMI)=1
             ENDIF
c            XMAX(NPARMI)=10000.
c            XMIN(NPARMI)=1.
c            DELTX(NPARMI)=5.
c            DELMIN(NPARMI)=0.1
             XMAX(NPARMI)=1.
             XMIN(NPARMI)=0.
             DELTX(NPARMI)=0.05
             DELMIN(NPARMI)=0.0001
           ENDIF
           IF (INOR(J,1).GE.1) THEN
             NPARMI=NPARMI+1
             XS(NPARMI)=XNOR(J)
             INDXS(NPARMI)=J
             IF (INOR(J,1).EQ.2) THEN
                MASK(NPARMI)=0
             ELSE
                MASK(NPARMI)=1
             ENDIF
             XMAX(NPARMI)=1.
             XMIN(NPARMI)=0.
             DELTX(NPARMI)=0.05
             DELMIN(NPARMI)=0.0001*(1.d0/precorr_mul)
C TWO EFFECTS WITH NORMAL DISTRIBUTIONS ARE CORRELATED
C ==> FIND BEST zeta (=log((1-corr)/(2*(1+corr)))
             IF (ICORR(J,1).GT.0) THEN
c                NPARMI=NPARMI+1
		flag=.true.
                XS(3)=zeta
                INDXS(3)=0
                IF (estcor) THEN
                  MASK(3)=0
                ELSE
                  MASK(3)=1
                ENDIF  
c [-5,+5] for zeta <=> ([-0.99,+0.99] for corr (more or less!)
                XMAX(3)=5.
                XMIN(3)=-5.
                DELTX(3)=0.1
                DELMIN(3)=0.01*(1.d0/precorr_mul)
             ENDIF   
           ENDIF
        ENDDO
        IF (NPARMI.EQ.1.AND.BOUND(JJ,3).NE.0.) THEN
           BEST(JJ)=DFMIN(LOB,UPB,FTOMIN,BOUND(JJ,3),OBJ)
           XS(1)=BEST(JJ)
           IF (IGAM(JJ,1).GE.1) THEN
             PARNAME='LOGGAMMA'
             XGAM(JJ)=BEST(JJ)
             VARW=TRIGAM(XGAM(JJ))
             IF (BEST(JJ).NE.0.D0) THEN
               WRITE(6,205) PARNAME,LOB,UPB,BEST(JJ),VARW
               WRITE(12,205) PARNAME,LOB,UPB,BEST(JJ),VARW
             ENDIF
           ELSE
             PARNAME='NORMAL  '
             XNOR(JJ)=BEST(JJ)
             IF (BEST(JJ).NE.0.D0) THEN
               WRITE(6,206) PARNAME,LOB,UPB,BEST(JJ)
               WRITE(12,206) PARNAME,LOB,UPB,BEST(JJ)
             ENDIF
           ENDIF
  205   FORMAT(1X,' THE ESTIMATED GAMMA PARAMETER FOR THE ',A9,
     +      ' DISTRIBUTION ',/10X,' IS BETWEEN ',F10.5,
     +    ' AND ',F10.5,/1X,' THE BEST VALUE FOUND IS ',F10.5,/10X,
     +    ' ASSOCIATED VARIANCE: ',F10.5)
  206   FORMAT(1X,' THE ESTIMATED VARIANCE PARAMETER FOR THE ',A9,
     +      ' DISTRIBUTION ',/10X,' IS BETWEEN ',F10.5,
     +    ' AND ',F10.5,/1X,' THE BEST VALUE FOUND IS ',F10.5)
        ELSE
	 IF (flag) NPARMI=NPARMI+1
         CALL DFMIN2(NPARMI,INDXS,XS,OBJ)
c        CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
          NPARMI=0
          DO J=1,MAXRAND
             IF (IGAM(J,1).EQ.2) THEN
               NPARMI=NPARMI+1
               XGAM(INDXS(NPARMI))=XS(NPARMI)
               BEST(J)=XGAM(INDXS(NPARMI))
               PARNAME='LOGGAMMA'
               PARNAME2(NPARMI)='LOGGAMMA'
               PARLAB(NPARMI)=LABEL(J)
               WRITE(6,266) PARNAME,BEST(J),PARLAB(NPARMI)
               WRITE(12,266) PARNAME,BEST(J),PARLAB(NPARMI)
             ENDIF
  266   FORMAT(1X,' THE ESTIMATED VARIANCE PARAMETER FOR THE ',A9,
     +      ' DISTRIBUTION IS ',F10.5,' (EFFECT ',A8,')')
             IF (INOR(J,1).EQ.2) THEN
               NPARMI=NPARMI+1
               XNOR(INDXS(NPARMI))=XS(NPARMI)
               BEST(J)=XNOR(INDXS(NPARMI))
               PARNAME='NORMAL'
               PARNAME2(NPARMI)='NORMAL'
               PARLAB(NPARMI)=LABEL(J)
               WRITE(6,266) PARNAME,BEST(J),PARLAB(NPARMI)
               WRITE(12,266) PARNAME,BEST(J),PARLAB(NPARMI)
             ENDIF
           ENDDO
           if (corrflag) then
             W=exp(zeta)
             corr= (1.d0-2.d0*W)/(1.d0+2.d0*W)
             WRITE(6,267) corr 
             WRITE(12,267) corr 
  267   FORMAT(1X,' THE CORRELATION BETWEEN THE TWO EFFECTS IS ',F10.5)
           endif  
         ENDIF
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C
       IF (NPEST.GE.100) THEN
         DO 690 J=1,NDIM
           STORBETA(J,0,0)=BETA(J)
  690    CONTINUE
       OBJ0= OBJ
c#
         IF (NPARMI.EQ.1) THEN 
          XMUKM1(1)=DLOG(BEST(JJ))
          SIGKM1(1)= DABS(XMUKM1(1)/10.D0)
       WRITE(6,207) PARNAME,NPGAUSS
       WRITE(12,207) PARNAME,NPGAUSS
  207  FORMAT(/1X,' ESTIMATION OF THE MOMENTS OF THE MARGINAL ',
     +  'POSTERIOR DISTRIBUTION ',/1X,' OF THE ',A8,' DISTRIBUTION',
     +  ' USING GAUSS-HERMITE INTEGRATION WITH',I2,' POINTS')
       WRITE(6,*) ' INITIAL ESTIMATE OF MU =   ',XMUKM1(NPARMI)
       WRITE(6,*) ' INITIAL ESTIMATE OF SIGMA =',SIGKM1(NPARMI)
       KITER=0
       DO 700 ITGAUSS=1,NITER_GAUSS
         IF (KITER.EQ.1) GOTO 700
         WRITE(6,704) ITGAUSS
         WRITE(12,704) ITGAUSS
 704     FORMAT(/1X,' ITERATION ',I2,' OF GAUSS-HERMITE INTEGRATION')
         DO 705 N=0,3
           XMOM(N,0)=0.D0
 705     CONTINUE
         XMUK(1)=0.D0
         SIGK(1)=0.D0
         DO 710 I=1,NPGAUSS
           VAL(1,1)=XMUKM1(1)+ SIGKM1(1) * XGAUSS(I,NPGAUSS)
           VAL(2,1) = 0.5D0 * XGAUSS(I,NPGAUSS) * XGAUSS(I,NPGAUSS)
           W= DEXP(VAL(1,1))
           IF (IGAM(JJ,1).GE.1) THEN
             XGAM(JJ) = W
           ELSE
             XNOR(JJ) = W
           ENDIF
           WRITE(6,716) W
           WRITE(12,716) W
  716      FORMAT(1X,' EVALUATION AT VARIANCE PARAMETER = ',F10.5)
           IF (ITGAUSS.GT.1) THEN
             DO 712 J=1,NDIM
               BETA(J)=STORBETA(J,I,0)
  712        CONTINUE
           ENDIF
           CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
           DO 714 J=1,NDIM
             STORBETA(J,I,0)=BETA(J)
  714      CONTINUE
           GVAL =  OBJ0 - OBJ
           WRITE(6,*) 'PARAMETER ',W,' OBJ= ',OBJ
           R1= SIGKM1(1) * VAL(1,1) * DEXP(VAL(1,1) + VAL(2,1) + GVAL)
           R2= R1 * VAL(1,1)
           XMUK(1) = XMUK(1) + WGAUSS(I,NPGAUSS) * R1
           SIGK(1) = SIGK(1) + WGAUSS(I,NPGAUSS) * R2
           DO 720 N=0,3
              W = SIGKM1(1)
     +           *DEXP((N+1.D0) * VAL(1,1) + VAL(2,1) + GVAL)
              XMOM(N,0)=XMOM(N,0) + WGAUSS(I,NPGAUSS) * W
 720       CONTINUE
 710       CONTINUE
           XMUK(1) =XMUK(1) / XMOM(0,0)
           SIGK(1) =SIGK(1) / XMOM(0,0)
           SIGK(1) = DSQRT(SIGK(1) - XMUK(1) * XMUK(1))
           WRITE(6,711) XMUK(1),SIGK(1)
 711       FORMAT(1X,' STANDARDIZING PARAMETERS:',2F15.4)
           WRITE(6,*)' INTEGRATION CONSTANT = ',XMOM(0,0)
           DO 730 N=1,3
              XMOM(N,0)=XMOM(N,0)/XMOM(0,0)
 730       CONTINUE
           XMOM(3,0) = XMOM(3,0) - 3.D0 * XMOM(1,0)* XMOM(2,0)
     +          + 2.D0 * XMOM(1,0)**3
           XMOM(2,0) = DSQRT(XMOM(2,0) - XMOM(1,0) * XMOM(1,0))
           XMOM(3,0) = XMOM(3,0) / (XMOM(2,0)**3)
           WRITE(6,734) (XMOM(I,0),I=1,3)
           WRITE(12,734) (XMOM(I,0),I=1,3)
 734       FORMAT(/1X,'      MEAN     STANDARD DEVIATION',
     +      '  SKEWNESS   ',/1X,2(F13.5,1X),F12.3)
           W = DABS(XMOM(1,0) - XMOMP(1,0))/XMOM(1,0)
           W2 = DABS(XMOM(2,0) - XMOMP(2,0))/XMOM(2,0)
           IF (MAX(W,W2).LT.1.D-3) THEN
            WRITE(6,*) 'CONVERGENCE REACHED, EVALUATION AT THE MODE'
            KITER=1
           ENDIF
           XMOMP(1,0) = XMOM(1,0)
           XMOMP(2,0) = XMOM(2,0)
           XMUKM1(1)=XMUK(1)
           SIGKM1(1)=SIGK(1)
 700    CONTINUE
         DO 740 J=1,NDIM
           BETA(J)=STORBETA(J,0,0)
  740    CONTINUE
         IF (IGAM(JJ,1).GE.1) THEN
           XGAM(JJ) = BEST(JJ)
         ELSE
           XNOR(JJ) = BEST(JJ)
         ENDIF
C
        ELSE IF (NPARMI.EQ.2) THEN
             WRITE(6,209) (PARNAME2(J),J=1,2),NPGAUSS
  209      FORMAT(/1X,' ESTIMATION OF THE MOMENTS OF THE MARGINAL ',
     +     'POSTERIOR DISTRIBUTIONS ',/1X,' OF THE ',A8,' AND ',A8,
     +' DISTRIBUTION USING GAUSS-HERMITE INTEGRATION WITH',I2,' POINTS')
           DO 800 I=1,NPARMI
             XMUKM1(I)=DLOG(XS(I))
             SIGKM1(I)= DABS(XMUKM1(I)/10.D0)
             WRITE(6,*) ' INITIAL ESTIMATE OF MU(',I,' =   ',XMUKM1(I)
             WRITE(6,*) ' INITIAL ESTIMATE OF SIGMA(',I,' =',SIGKM1(I)
  800      CONTINUE
           SIGKM1(3)= 0.D0
           T(1,1)=SIGKM1(1)
           T(2,1)=SIGKM1(3)/T(1,1)
           T(2,2)=DSQRT(SIGKM1(2)*SIGKM1(2)-T(2,1)*T(2,1))
           JACOB=T(1,1)*T(2,2)
c          print*,'T=',T(1,1),T(2,1),T(2,2)
c         ENDIF
       KITER=0
       DO 801 ITGAUSS=1,NITER_GAUSS
         IF (KITER.EQ.1) GOTO 801
         WRITE(6,704) ITGAUSS
         WRITE(12,704) ITGAUSS
         DO 805 N=0,3
           IF (N.NE.0) THEN
             IF (N.NE.3) XMUK(N)=0.D0
             SIGK(N)=0.D0
           ENDIF
           DO 805 N1=0,3
             XMOM(N,N1)=0.D0
 805     CONTINUE
         DO 810 I=1,NPGAUSS
           DO 811 I2=1,NPGAUSS
             VAL(1,1)=XMUKM1(1)+ T(1,1) * XGAUSS(I,NPGAUSS)
             VAL(1,2)=XMUKM1(2)+ T(2,1) * XGAUSS(I,NPGAUSS) 
     +                      +T(2,2)* XGAUSS(I2,NPGAUSS)
             VAL(2,1)= 0.5D0 * XGAUSS(I,NPGAUSS) * XGAUSS(I,NPGAUSS)
             VAL(2,2)= 0.5D0 * XGAUSS(I2,NPGAUSS) * XGAUSS(I2,NPGAUSS)

             W1= DEXP(VAL(1,1))
             IF (PARNAME2(1).EQ.'LOGGAMMA') THEN
               XGAM(INDXS(1))=W1 
             ELSE
               XNOR(INDXS(1))=W1 
             ENDIF
             W2= DEXP(VAL(1,2))
             IF (PARNAME2(2).EQ.'LOGGAMMA') THEN
               XGAM(INDXS(2))=W2 
             ELSE
               XNOR(INDXS(2))=W2 
             ENDIF

           WRITE(6,816) W1,W2
           WRITE(12,816) W1,W2
  816      FORMAT(1X,' EVALUATION AT VARIANCE PARAMETER = ',2(F10.5,2X))
           IF (ITGAUSS.GT.1) THEN
             DO 812 J=1,NDIM
               BETA(J)=STORBETA(J,I,I2)
  812        CONTINUE
           ENDIF
           CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
           DO 814 J=1,NDIM
             STORBETA(J,I,I2)=BETA(J)
  814      CONTINUE
           GVAL =  OBJ0 - OBJ
           WRITE(6,*) 'PARAMETERS ',W1,W2,' OBJ= ',OBJ
           W = DEXP(VAL(1,1) + VAL(2,1) + VAL(1,2) + VAL(2,2) + GVAL)
           W = W * WGAUSS(I,NPGAUSS) * WGAUSS(I2,NPGAUSS)
           R1= JACOB * VAL(1,1) * W 
           R2= R1 * VAL(1,1)
           XMUK(1) = XMUK(1) +  R1
           SIGK(1) = SIGK(1) +  R2
           R1= JACOB * VAL(1,2) * W 
           R2= R1 * VAL(1,2)
           XMUK(2) = XMUK(2) + R1
           SIGK(2) = SIGK(2) + R2
           R2= JACOB * VAL(1,1) * VAL(1,2) * W
           SIGK(3) = SIGK(3) + R2
           DO 820 N=0,3
             DO 820 N1=0,3
              W = JACOB  * DEXP((N+1.D0) * VAL(1,1) + VAL(2,1) 
     +               + (N1+1.D0) * VAL(1,2) + VAL(2,2) + GVAL)
              XMOM(N,N1)=XMOM(N,N1) + WGAUSS(I,NPGAUSS) 
     +                * WGAUSS(I2,NPGAUSS) * W 
 820       CONTINUE
 811       CONTINUE
 810       CONTINUE
           DO 861 I=1,NPARMI
             XMUK(I) =XMUK(I) / XMOM(0,0)
             SIGK(I) =SIGK(I) / XMOM(0,0)
 861       CONTINUE
           SIGK(1) = DSQRT(SIGK(1) - XMUK(1) * XMUK(1))
           SIGK(2) = DSQRT(SIGK(2) - XMUK(2) * XMUK(2))
           SIGK(3) = SIGK(3) / XMOM(0,0)
           SIGK(3) = SIGK(3) - XMUK(1) * XMUK(2)
           W = SIGK(3)/(SIGK(1)*SIGK(2))
           T(1,1)=SIGK(1)
           T(2,1)=SIGK(3)/T(1,1)
           T(2,2)=DSQRT(SIGK(2)*SIGK(2)-T(2,1)*T(2,1))
           JACOB=T(1,1)*T(2,2)
           WRITE(6,819) XMUK(1),SIGK(1)
           WRITE(6,819) XMUK(2),SIGK(2)
 819       FORMAT(1X,' STANDARDIZING PARAMETERS:',2F15.4)
           WRITE(6,*) ' CORRELATION ',W
           WRITE(6,*)' INTEGRATION CONSTANT = ',XMOM(0,0)
           DO 830 N=0,3
             DO 831 N1=0,3
              IF (N.EQ.0.AND.N1.EQ.0) cycle
              XMOM(N,N1)=XMOM(N,N1)/XMOM(0,0)
 831       CONTINUE
 830       CONTINUE
           XMOM(3,0) = XMOM(3,0) - 3.D0 * XMOM(1,0)* XMOM(2,0)
     +          + 2.D0 * XMOM(1,0)**3
           XMOM(2,0) = DSQRT(XMOM(2,0) - XMOM(1,0) * XMOM(1,0))
           XMOM(3,0) = XMOM(3,0) / (XMOM(2,0)**3)
           XMOM(0,3) = XMOM(0,3) - 3.D0 * XMOM(0,1)* XMOM(0,2)
     +          + 2.D0 * XMOM(0,1)**3
           XMOM(0,2) = DSQRT(XMOM(0,2) - XMOM(0,1) * XMOM(0,1))
           XMOM(0,3) = XMOM(0,3) / (XMOM(0,2)**3)
           XMOM(1,1) = XMOM(1,1) - XMOM(1,0) * XMOM(0,1)
           XMOM(1,1) = XMOM(1,1) /(XMOM(2,0) * XMOM (0,2))
 835   FORMAT(/1X,'MOMENTS OF THE MARGINAL POSTERIOR DISTRIBUTIONS',
     +       /1X,'      MEAN       STD    SKEWNESS       ',
     +      'MEAN       STD     SKEWNESS CORRELATION',
     +        /1X,7(F10.4,1X))
        WRITE(6,835) (XMOM(I,0),I=1,3),(XMOM(0,I),I=1,3),XMOM(1,1)
        WRITE(12,835) (XMOM(I,0),I=1,3),(XMOM(0,I),I=1,3),XMOM(1,1)

           W = DABS(XMOM(1,0) - XMOMP(1,0))/XMOM(1,0)
           W1 = DABS(XMOM(2,0) - XMOMP(2,0))/XMOM(2,0)
           W2 = DABS(XMOM(0,1) - XMOMP(0,1))/XMOM(0,1)
           W3 = DABS(XMOM(0,2) - XMOMP(0,2))/XMOM(0,2)
           IF (MAX(W,W1,W2,W3).LT.1.D-2) THEN
               WRITE(6,*) 'CONVERGENCE REACHED, EVALUATION AT THE MODE'
               KITER=1
           ENDIF
           XMOMP(1,0) = XMOM(1,0)
           XMOMP(2,0) = XMOM(2,0)
           XMOMP(0,1) = XMOM(0,1)
           XMOMP(0,2) = XMOM(0,2)
           XMUKM1(1)=XMUK(1)
           XMUKM1(2)=XMUK(2)
           SIGKM1(1)=SIGK(1)
           SIGKM1(2)=SIGK(2)
           SIGKM1(3)=SIGK(3)
 801    CONTINUE
         DO 840 J=1,NDIM
           BETA(J)=STORBETA(J,0,0)
 840     CONTINUE
         DO J=1,MAXRAND
            IF (IGAM(J,1).GE.1) THEN
               XGAM(J)=BEST(J)
            ENDIF
            IF (INOR(J,1).GE.1) THEN
               NPARMI=NPARMI+1
               XNOR(J)=BEST(J)
            ENDIF
         ENDDO
C
       ENDIF
       CALL OPTIMIZE(NDIM,F,OBJ,GRADF,BETA,EPS_BF,IUSER)
      ENDIF
         ENDIF
C
      WRITE(6,9030) ITOEV,ITOEV2,TOTIM
      WRITE(12,9030) ITOEV,ITOEV2,TOTIM
      IF (NJOINT.EQ.1) THEN
        W = DEXP(BETA(NDIM))
        VARW=TRIGAM(W)
        WRITE(6,9028) W,VARW
        WRITE(12,9028) W,VARW
      ENDIF
      K = IMOD(NCOVMOD)
 750  XLIK(K,1) = 2.D0 * F
      IDF(K,1) = IUSER(1)
      XCHI2 = XLIK(0,1) - XLIK(K,1)
      IW = IDF(K,1)
      W = DBLE(IW)
      IF (XCHI2.LE.0.D0) THEN
        XPROB = 0.D0
      ELSE
        CALL CHSCDF(XCHI2,IW,XPROB)
        XPROB = 1.D0 - XPROB
      ENDIF
C
C-----------------------------------------------------------------------
C PRINT RESULTS
C-----------------------------------------------------------------------
CR prints out results to a file to plot them in R
      if (useR .and. NPEST.ge.100) then
        OPEN(52,file='RMoments.txt' ,status='unknown')
        write(52,*) (XMOM(I,0),I=1,3),(XMOM(0,I),I=1,3)
        close(52)
      endif
	  
      XNORM = 0.D0
      DO 300 J=1,NDIM
       XNORM = XNORM + GRADF(J) * GRADF(J)
  300 CONTINUE
      XNORM = 2.D0 * DSQRT(XNORM)/MAX(1.D0,DBLE(NDIM))
      WRITE(12,9000)
      F = 2.D0 * F
      WRITE(12,9005) F
      WRITE(12,9010) XNORM
      WRITE(12,9012) XCHI2,IW,XPROB
      JJ=1
      DO 308 K=1,NCOVMOD
        KK = IMOD(K)
        IF (KK.NE.I.AND.(IGAM(KK,1).GE.1.OR.INOR(KK,1).GE.1)) JJ=0
  308 CONTINUE
      IF (JJ.EQ.1) THEN
        R2M = 1.D0 - DEXP (- XCHI2 /MAX(1.D0,DBLE(NTOT)))
        WRITE(12,9013) R2M
      ENDIF
      IF (NCTEST.GE.2.AND.NCTEST.LE.4) THEN
        WRITE(12,9015)
        WRITE(12,9018) LABEL2(3),IDF(0,1),XLIK(0,1)
        IM1=0
        DO 310 J=1,NCOVMOD
          I = IMOD(J)
          IF (J.GT.1) THEN
           IM1 = IMOD(J-1)
          ELSE
           IM1 = 0
          ENDIF
         IF (XLIK(I,1).EQ.0.D0) THEN
             WRITE(12,9022) LABEL(I)
             IDF(I,1) = IDF(IM1,1)
             XLIK(I,1) = XLIK(IM1,1)
             GOTO 310
          ENDIF
          IW = IDF(I,1) - IDF(IM1,1)
          XCHI2 = XLIK(IM1,1) - XLIK(I,1)
          IF (IW.EQ.0) XCHI2=0.D0
          W = DBLE(IW)
          IF (XCHI2.LE.0.D0) THEN
            XPROB = 0.D0
          ELSE
            CALL CHSCDF(XCHI2,IW,XPROB)
            XPROB = 1.D0 - XPROB
          ENDIF
          IF (IGAM(I,1).EQ.0.AND.INOR(I,1).EQ.0.AND.I.NE.INTEGAM) THEN
            R2M = XLIK(0,1) - XLIK(I,1)
            R2M = 1.D0 - DEXP (- R2M /MAX(1.D0,DBLE(NTOT)))
            WRITE(12,9019) LABEL(I),IDF(I,1),XLIK(I,1),XCHI2,IW,XPROB,
     +               R2M
          ELSE
            WRITE(12,9021) LABEL(I),IDF(I,1),XLIK(I,1),XCHI2
          ENDIF
          IF (J.EQ.NCOVMOD) THEN
             XCHI2L=XCHI2
             IWL = IW
             XPROBL=XPROB
          ENDIF
          IM1=I
  310   CONTINUE
      ENDIF
      IF ((NCTEST.EQ.1).OR.(NCTEST.GE.3)) THEN
        WRITE(12,9016)
        DO 320 J=1,NCOVMOD
          I = IMOD(J)
          IF (IDF(I,2).EQ.0) GOTO 320
          II = IMOD(NCOVMOD)
          IW= IDF(II,1) - IDF(I,2)
          XCHI2 = XLIK(I,2) - XLIK(II,1)
          IF (IW.EQ.0) XCHI2=0.D0
          W = DBLE(IW)
          IF (XCHI2.LE.0.D0) THEN
             XPROB = 0.D0
          ELSE
             CALL CHSCDF(XCHI2,IW,XPROB)
             XPROB = 1.D0 - XPROB
          ENDIF
          IF (IGAM(I,1).EQ.0.AND.INOR(I,1).EQ.0.AND.I.NE.INTEGAM) THEN
            R2M = XLIK(0,1) - XLIK(I,2)
            R2M = 1.D0 - DEXP (- R2M /MAX(1.D0,DBLE(NTOT)))
            WRITE(12,9019) LABEL(I),IDF(I,2),XLIK(I,2),XCHI2,IW,XPROB,
     +               R2M
          ELSE
            WRITE(12,9021) LABEL(I),IDF(I,2),XLIK(I,2),XCHI2
          ENDIF
  320   CONTINUE
      ENDIF
 9000 FORMAT(/7X,'*******  RESULTS  ********',/1X,
     +' WARNING: IF THE MODEL INCLUDES RANDOM EFFECT(S), '
     +,'THE QUANTITIES BELOW',/1X,
     +' ARE ** NOT ** LIKELIHOOD VALUES, LIKELIHOOD RATIO',
     +' TEST STATITICS AND SO ON...',/1X,
     +' INTERPRET THEM AT YOUR OWN RISK')
 9005 FORMAT(/1X,' -2 LOG LIKELIHOOD                       ',G20.10)
 9010 FORMAT(1X,' STANDARDIZED NORM OF GRAD(-2 LOG L) = ',F15.5)
 9012 FORMAT(/7X,'*******  TESTS    ********',//1X,
     +' LIKELIHOOD RATIO TEST FOR H0: BETA = 0 ',/1X,
     +' MODEL CHI2 = ',G15.7,'  WITH ',I7,' DF   (PROB >CHI2 =',F10.4,
     +')')
 9013 FORMAT('  R2 OF MADDALA (=MEASURE OF EXPLAINED VARIATION) = ',
     + F7.4)
 9015 FORMAT(/1X,' LIKELIHOOD RATIO TESTS : SEQUENTIAL ',/1X,
     +' VARIABLE    TOTAL        -2 LOG LIK     CHI2    ',
     +' DELTA    PROB   R2 OF  ',/1X,
     +'   Z          DF          INCLUDING Z             ',
     +'  DF     >CHI2  MADDALA'/)
 9016 FORMAT(/1X,' LIKELIHOOD RATIO TESTS : LAST       ',/1X,
     +' VARIABLE    TOTAL        -2 LOG LIK     CHI2    ',
     +' DELTA    PROB   R2 OF',/1X,
     +'   Z         DF          EXCLUDING Z              ',
     +'  DF     >CHI2  MADDALA'/)
 9018 FORMAT(3X,A12,I2,9X,G15.10)
 9019 FORMAT(3X,A8,I6,9X,G15.10,1X,G10.5,I4,2X,F6.4,2X,F6.4)
 9021 FORMAT(3X,A8,I6,9X,G15.10,1X,G10.5,'   *  (RANDOM)')
 9022 FORMAT(3X,A8,' +')
 9028 FORMAT(1X,' GAMMA FOR THE LOG-GAMMA DISTRIBUTION ALGEBRAICALLY',
     +    ' INTEGRATED OUT = ',F10.5,/,1X,
     +    ' SO THE ASSOCIATED VARIANCE IS ',F10.5)
 9030 FORMAT(/1X,' CONVERGENCE AFTER',I5,
     +    ' EVALUATIONS OF FUNCTION FWEIB ',/16X,'AND  ',I3,
     +    ' EVALUATIONS OF FUNCTION FWEIB2 IN ',F10.2,' SECONDS')
C
      XINTER = 0.D0
      DO 322 J=1,NCOVMOD
        II = IMOD(J)
        IF (ICOVTYP(II).GT.0) GOTO 322
        BSOL = BETA(IFIRST(II))
        BSOL = BSOL / XSQ(J)
        XINTER = XINTER + XAV(J) * BSOL
  322 CONTINUE
      XINTER=-XINTER
      IF (NSTD.NE.1) THEN
C-----------------------------------------------------------------------
C NSTD <>1 ==> DO NOT COMPUTE STANDARD ERRORS
C-----------------------------------------------------------------------
C
       WRITE(12,9037)
       IF (ICRHO.EQ.99) THEN
         WRITE(12,9231)
 9231  FORMAT(5X,'DISCRETE ESTIMATION OF THE BASELINE SURVIVOR',
     + ' CURVE:',/4X,' ESTIMATE ON THE TRANSFORMED SCALE',
     + ' (TRANSFORMED FROM -INF to +INF)',/4X,
     + ' CONDITIONAL SURVIVAL (FROM T-1 TO T) AND RESULTING BASELINE:')
         KK=0
         DO 221 J=1,NCOVMOD
           II = IMOD(J)
           IF (LABEL(II).EQ.'tim_unit'.AND.ICRHO.EQ.99) KK=II
  221    CONTINUE
         NALPHA=(ILAST(KK)-IFIRST(KK)+1)/NSTRATA
         DO 223 J=1,NSTRATA
         IF (NSTRATA.GT.1) WRITE(12,9230) J,TRIM(LABEL(ISTRVAR)),
     +           (IOLCODST(J,I),I=1,NCOL(0))
         WRITE(12,9232)
 9230    FORMAT(/1X,' FOR STRATUM',I4,' (',A,'=',I2,2(' *',I2) )
 9232    FORMAT(/8X,'TIME        ESTIMATE     CONDITIONAL  ',
     +     '   BASELINE   UNCENSORED',
     +       /31X,'   SURVIVAL        SURVIVOR    FAILURES',
     +       /31X,'   T-1 => T       FUNCTION')
             J1=IFIRST(II)+(J-1)*NALPHA
             J2 = J1 + NALPHA -1
             K = NDIMB + J
             XALPHA=1.D0
             DO 224 I=J1,J2
               N = I - J1 + 1
               BSOL = BETA(I)+ BETA(K) + XINTER
               XALPH1=DEXP(-DEXP(BSOL))
               XALPHA=XALPHA*XALPH1
               IF (BSOL.GT.10.D0) BSOL=999.9D0
               WRITE(12,9224) N,BSOL,XALPH1,XALPHA,NFAIL(I)
 9224    FORMAT(4X,I8,6X,F10.4,6X,F8.5,7X,F8.5,5X,I6)
  224        CONTINUE
  223      CONTINUE
           GOTO 624
         ENDIF
C
       IF (ICRHO.EQ.1) THEN
         WRITE(12,9034)
         DO 325 I=NDIMB+NSTRATA+1,NDIM-NJOINT
           J = I - NDIMB -NSTRATA
           IF (NSTRATA.EQ.1) THEN
             IF (NO_LOG.NE.1) THEN
               BSOL = DEXP(BETA(I))
               WRITE(12,9035) J,BSOL,BETA(I)
             ELSE
               WRITE(12,9235) J,BETA(I)
             ENDIF
           ELSE
             IF (NO_LOG.NE.1) THEN
               BSOL = DEXP(BETA(I))
               WRITE(12,8035) BSOL,BETA(I),J,TRIM(LABEL(ISTRVAR)),
     +              (IOLCODST(J,L),L=1,NCOL(0))
             ELSE
               WRITE(12,8235) BETA(I),J,TRIM(LABEL(ISTRVAR)),
     +              (IOLCODST(J,L),L=1,NCOL(0))
             ENDIF
           ENDIF
  325    CONTINUE
       ENDIF
       IF (NSTRATA.EQ.1) THEN
         BSOL = BETA(NDIMB+1) + XINTER
         WRITE(12,9036) BSOL
       ELSE
         DO 328 J=1,NSTRATA
           BSOL = BETA(NDIMB+J) + XINTER
           WRITE(12,8039) BSOL,J,TRIM(LABEL(ISTRVAR)),
     +              (IOLCODST(J,I),I=1,NCOL(0))
           WRITE(12,8040) NFAIL(NDIMB+J)

  328    CONTINUE
       ENDIF
       IF (NJOINT.EQ.1) THEN
          BSOL = DEXP(BETA(NDIM))
          WRITE(12,9032) LABEL(INTEGAM),BSOL,VARW
       ENDIF
  624  IF (ICRHO.EQ.99) THEN
         IF (NCOVMOD.GT.1) WRITE(12,9038)
       ELSE
         IF (NCOVMOD.GT.0) WRITE(12,9038)
       ENDIF
       DO 330 J=1,NCOVMOD
            II = IMOD(J)
            IF (ISAME(II).NE.0.OR.
     +        (ICRHO.EQ.99.AND.LABEL(II).EQ.'tim_unit')) GOTO 330
            IF (ICOVTYP(II).LE.0) THEN
             VARTYP = LABEL2(1)
            ELSE
             VARTYP = LABEL2(2)
            ENDIF
            WRITE(12,9040) J,LABEL(II),VARTYP
            DO 335 I=IFIRST(II),ILAST(II)
             KK = IOLDCODE(I,4)
             K = IFIRST(II) + KK - 1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on october 21, 1996 (= group of unknown parents)
             IF (IOLDCODE(I,4).LT.0) K = ILAST(II) + IOLDCODE(I,4) +1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             BSOL = BETA(K)
             IF (ICOVTYP(II).LE.0) BSOL = BSOL / XSQ(J)
             IF (BSOL.GT.-20.D0) THEN
               XRISK = DEXP(BSOL)
             ELSE
               XRISK = 0.D0
             ENDIF
             IF (NCOL(II).EQ.1) THEN
               IF (ICOVTYP(II).LE.0) THEN
                  WRITE(12,9045) IOLDCODE(I,1),BSOL,NFAIL(K)
               ELSE
                  WRITE(12,9044) IOLDCODE(I,1),BSOL,XRISK,NFAIL(K)
               ENDIF
             ELSE IF (NCOL(II).EQ.2) THEN
               WRITE(12,9043) IOLDCODE(I,1),IOLDCODE(I,2),
     +                       BSOL,XRISK,NFAIL(K)
             ELSE
              WRITE(12,9042) IOLDCODE(I,1),IOLDCODE(I,2),IOLDCODE(I,3)
     +                      ,BSOL,XRISK,NFAIL(K)
             ENDIF
  335       CONTINUE
  330    CONTINUE
 9037    FORMAT(/7X,'******* SOLUTIONS ********'/)
 9038    FORMAT(/2X,
     +' COVARIATE                           ESTIMATE        RISK   ',
     +'     UNCENSORED ',/1X,
     +  '                                                      RATIO ',
     +'       FAILURES ')
c
 9032    FORMAT(/1X,'GAMMA PARAMETER OF EFFECT ',A8,' WHICH WAS ',
     +   'INTEGRATED OUT: ',G12.6,/1X,' VARIANCE = ',G12.6)
 9034    FORMAT(/7X,'WEIBULL PARAMETER(S):'/)
 8035    FORMAT(5X,' RHO = ',G12.6,3x,' LOG(RHO) = ',G12.6,/8X,
     +        'FOR STRATUM ',I3,' | ',A,' =',I2,2(' | ',I4) )
 8235    FORMAT(5X,' RHO = ',G12.6,
     +        'FOR STRATUM ',I3,' | ',A,' =',I2,2(' | ',I4) )
 9035    FORMAT(5X,' FOR STRATUM ',I3,'  RHO = ',G12.6,3x,
     +              ' LOG(RHO) = ',G12.6)
 9235    FORMAT(5X,' FOR STRATUM ',I3,'  RHO = ',G12.6)
 9036    FORMAT(/5X,'INTERCEPT',/10X,G13.7)
 8039    FORMAT(5X,' INTERCEPT =',3X,G13.7,3X,'FOR STRATUM ',I3,
     +  ' | ',A,'=',I2,2(' | ',I4))
 8040    FORMAT(35X,I8,' OBSERVED FAILURES')
 9040    FORMAT(/1X,I3,3X,A8,1X,A12)
 9042    FORMAT(4X,I9,' *',I8,' * ',I8,3X,G12.5,3X,G12.5,3X,I8)
 9043    FORMAT(4X,I9,' *',I8,14X,G12.5,3X,G12.5,3X,I8)
 9044    FORMAT(4X,I8,25X,G12.5,3X,G12.5,3X,I8)
 9045    FORMAT(4X,I8,25X,G12.5,9X,'*',8X,I8)
      ELSE
C-----------------------------------------------------------------------
C NSTD = 1 ==> COMPUTE STANDARD ERRORS
C-----------------------------------------------------------------------
  334  ICHECK = 0
       NOPTION=2
       IF (ITBNEW.LT.0) NOPTION=-NOPTION
       IF (NDIM.GT.NDIMAX) WRITE(6,9102)
       CALL FWEIB2(BETA,F,GRADF,STD,DLDET,NDF,NOPTION,NDIM)
       IF (ICHECK.EQ.-1) GOTO 334
c
       WRITE(12,9037)
       IF (ICRHO.EQ.99) THEN
         WRITE(12,9234)
 9234    FORMAT(5X,'DISCRETE ESTIMATION OF THE BASELINE SURVIVOR',
     +   ' CURVE:',/4X,' ESTIMATE ON THE TRANSFORMED SCALE',
     +   ' (TRANSFORMED FROM -INF to +INF)',/4X,
     +   ' STANDARD ERROR, CONDITIONAL SURVIVAL (FROM T-1 TO T)',
     +    /4X,' AND RESULTING BASELINE:')
         KK=0
         DO 232 J=1,NCOVMOD
           II = IMOD(J)
           IF (ICRHO.EQ.99.AND.LABEL(II).EQ.'tim_unit') KK=II
  232    CONTINUE
         NALPHA=(ILAST(KK)-IFIRST(KK)+1)/NSTRATA
         DO 233 J=1,NSTRATA
         IF (NSTRATA.GT.1) WRITE(12,9230) J,TRIM(LABEL(ISTRVAR)),
     +           (IOLCODST(J,I),I=1,NCOL(0))
         WRITE(12,9242)
 9242    FORMAT(/2X,
     +  'TIME       ESTIMATE    STD  CONDITIONAL   LOWER    UPPER',
     +  '    BASELINE UNCENSORED',
     +   /27X,'    SURVIVAL     BOUND    BOUND    SURVIVOR  FAILURES',
     +   /27X,'    T-1 => T     OF COND. SURV.    FUNCTION')
             J1=IFIRST(II)+(J-1)*NALPHA
             J2 = J1 + NALPHA -1
             K = NDIMB + J
             XALPHA=1.D0
             DO 234 I=J1,J2
               N = I - J1 + 1
               BSOL = BETA(I)+ BETA(K) + XINTER
               XSTD = STD(I)
               XDOWN= BSOL + 1.96D0 * XSTD
               XUP= BSOL - 1.96D0 * XSTD
               XALPH1=DEXP(-DEXP(BSOL))
               XDOWN=DEXP(-DEXP(XDOWN))
               XUP=DEXP(-DEXP(XUP))
               XALPHA=XALPHA*XALPH1
               IF (BSOL.GT.10.D0) BSOL=999.9D0
               WRITE(12,9254) N,BSOL,XSTD,XALPH1,XDOWN,XUP,
     +            XALPHA,NFAIL(I)
 9254         FORMAT(1X,I8,X,F10.4,1X,F8.4,
     +          2X,3(F8.5,2X),F9.5,2X,I7)
  234        CONTINUE
  233      CONTINUE
           GOTO 634
         ENDIF
C
       IF (ICRHO.EQ.1) THEN
         WRITE(12,9034)
         DO 625 I=NDIMB+NSTRATA+1,NDIM-NJOINT
           J = I - NDIMB -NSTRATA
           IF (NSTRATA.EQ.1) THEN
             IF (NO_LOG.NE.1) THEN
               BSOL = DEXP(BETA(I))
               XSTD = STD(I)
               WRITE(12,9047) J,BSOL,BETA(I),XSTD
             ELSE
               XSTD = STD(I)
               WRITE(12,9147) J,BETA(I),XSTD
             ENDIF
           ELSE
             IF (NO_LOG.NE.1) THEN
               BSOL = DEXP(BETA(I))
               XSTD = STD(I)
               WRITE(12,8047) BSOL,BETA(I),XSTD,
     +              J,TRIM(LABEL(ISTRVAR)),
     +              (IOLCODST(J,L),L=1,NCOL(0))
             ELSE
               XSTD = STD(I)
               WRITE(12,8147) BETA(I),XSTD,J,TRIM(LABEL(ISTRVAR)),
     +              (IOLCODST(J,L),L=1,NCOL(0))
             ENDIF
           ENDIF

  625    CONTINUE
       ENDIF
       DO 628 J=1,NSTRATA
         K = NDIMB+J
         BSOL = BETA(K) + XINTER
         XSTD = STD(K)
         IF (NSTRATA.EQ.1) THEN
           IF (XSTD.NE.0.D0) THEN
             WRITE(12,9046) BSOL,XSTD
           ELSE
             WRITE(12,9146) BSOL
           ENDIF
         ELSE
           BSOL = BETA(NDIMB+J) + XINTER
           IF (XSTD.NE.0.D0) THEN
              WRITE(12,8144) BSOL,XSTD,J,TRIM(LABEL(ISTRVAR)),
     +              (IOLCODST(J,I),I=1,NCOL(0))
           ELSE
              WRITE(12,8145) BSOL,J,TRIM(LABEL(ISTRVAR)),
     +              (IOLCODST(J,I),I=1,NCOL(0))
           ENDIF
           WRITE(12,8040) NFAIL(NDIMB+J)
         ENDIF
  628  CONTINUE
       IF (NJOINT.EQ.1) THEN
          BSOL=DEXP(BETA(NDIM))
          VARW=TRIGAM(BSOL)
          WRITE(12,9041) LABEL(INTEGAM),BSOL,VARW,BETA(NDIM),STD(NDIM)
       ENDIF
  634  IF (ICRHO.EQ.99) THEN
         IF (NCOVMOD.GT.1) WRITE(12,9048)
       ELSE
         IF (NCOVMOD.GT.0) WRITE(12,9048)
       ENDIF
       DO 340 J=1,NCOVMOD
            II = IMOD(J)
            IF (ISAME(II).NE.0.OR.
     +          (ICRHO.EQ.99.AND.LABEL(II).EQ.'tim_unit')) GOTO 340
            IF (ICOVTYP(II).LE.0) THEN
             VARTYP = LABEL2(1)
            ELSE
             VARTYP = LABEL2(2)
            ENDIF
            WRITE(12,9040) J,LABEL(II),VARTYP
            DO 345 I=IFIRST(II),ILAST(II)
             KK = IOLDCODE(I,4)
             IF (KK.EQ.0) GOTO 345
             K = IFIRST(II) + KK - 1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on october 21, 1996 (= group of unknown parents)
             IF (IOLDCODE(I,4).LT.0) K = ILAST(II) + IOLDCODE(I,4) +1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             BSOL = BETA(K)
             IF (ICOVTYP(II).LE.0) THEN
                BSOL = BSOL / XSQ(J)
c                XINTER = XINTER + XAV(J) * BSOL
             ENDIF
             IF (BSOL.GT.-20.D0) THEN
               XRISK = DEXP(BSOL)
             ELSE
               XRISK = 0.D0
             ENDIF
             IF (STD(K).GT.1.D-8) THEN
               XSTD = STD(K)
               IF (ICOVTYP(II).LE.0) XSTD=XSTD / XSQ(J)
               XCHI2 = BSOL / XSTD
               XCHI2 = XCHI2 * XCHI2
               IFAIL=0
               CALL CHSCDF(XCHI2,1,XPROB)
               XPROB = 1.D0 - XPROB
               IF (NCOL(II).EQ.1) THEN
                   IF (ICOVTYP(II).LE.0) THEN
                   WRITE(12,9055) IOLDCODE(I,1),BSOL,
     +                         XSTD,XCHI2,XPROB,NFAIL(K)
                   ELSE
                   WRITE(12,9054) IOLDCODE(I,1),BSOL,
     +                         XSTD,XCHI2,XPROB,XRISK,NFAIL(K)
                   ENDIF
               ELSE IF (NCOL(II).EQ.2) THEN
                   WRITE(12,9052) IOLDCODE(I,1),IOLDCODE(I,2),
     +                  BSOL,XSTD,XCHI2,XPROB,XRISK,NFAIL(K)
               ELSE
                   WRITE(12,9050) IOLDCODE(I,1),IOLDCODE(I,2),
     +            IOLDCODE(I,3),BSOL,XSTD,XCHI2,XPROB,XRISK,NFAIL(K)
               ENDIF
             ELSE
               IF (NCOL(II).EQ.1) THEN
                    WRITE(12,9064) IOLDCODE(I,1),BSOL,
     +                   XRISK,NFAIL(K)
               ELSE IF (NCOL(II).EQ.2) THEN
                   WRITE(12,9062) IOLDCODE(I,1),IOLDCODE(I,2),
     +                  BSOL,XRISK,NFAIL(K)
               ELSE
                   WRITE(12,9060) IOLDCODE(I,1),IOLDCODE(I,2),
     +            IOLDCODE(I,3),BSOL,XRISK,NFAIL(K)
               ENDIF
             ENDIF
  345      CONTINUE
  340    CONTINUE
 9041    FORMAT(/1X,'GAMMA PARAMETER OF EFFECT ',A8,' WHICH WAS ',
     +   'INTEGRATED OUT: ',G12.5,
     +    ' AND ASSOCIATED VARIANCE ',F9.5,
     +   /10X,'LOG(GAMMA) =',G12.6,' +/- ',G12.6)
 8047    FORMAT(5X,' RHO = ',G12.6,3x,' LOG(RHO) = ',G12.6,
     +        ' STE(LOG(RHO)) = ',G12.6,/8X,
     +        'FOR STRATUM ',I3,'  | ',A,' =',I2,2(' | ',I4) )
 8147    FORMAT(5X,' RHO = ',G12.6,' STE = ',G11.5,
     +     3X,' FOR STRATUM ',I3,'  | ',A,' =',I2,2(' | ',I4) )
 9047    FORMAT(4X,'FOR STRATUM ',I3,' RHO = ',G12.6,3x,
     +     ' LOG(RHO) = ',G12.6,/41X,' STE(LOG(RHO)) = ',G12.6)
 9147    FORMAT(4X,'FOR STRATUM ',I3,' RHO = ',G12.6,7x,
     +     ' STE = ',F10.5)
 8144    FORMAT(5X,' INTERCEPT =',3X,G12.5,'  STE =',F10.5,
     +     '  FOR STRATUM ',I3,' | ',A,' =',I2,2(' | ',I4))
 8145    FORMAT(5X,' INTERCEPT =',3X,G12.5,'  STE =',9X,'*',
     +     '  FOR STRATUM ',I3,' | ',A,' =',I2,2(' | ',I4))

 9046    FORMAT(/7X,'INTERCEPT = ',F10.5,'    STE = ',F10.5)
 9146    FORMAT(/7X,'INTERCEPT = ',F10.5,'    STE =    *  ')
C
 9048    FORMAT(/1X,
     +  ' COVARIATE :                ESTIMATE STANDARD',
     +  '    CHI2    PROB   RISK UNCENSORED',/1X,
     +  '                                      ERROR ',
     +  '            >CHI2   RATIO FAILURES')
c
 9050    FORMAT(1X,I8,' *',I6,' *',I6,1X,F10.4,1X,F8.4,
     +          1X,F8.2,2X,F6.4,1X,F8.3,2X,I6)
 9052    FORMAT(1X,I8,' *',I6,9X,F10.4,1X,F8.4,
     +          1X,F8.2,2X,F6.4,1X,F8.3,2X,I6)
 9054    FORMAT(1X,I8,17X,F10.4,1X,F8.4,
     +          1X,F8.2,2X,F6.4,1X,F8.3,2X,I6)
 9055    FORMAT(1X,I8,14X,G12.4,1X,G11.4,
     +          F9.2,2X,F6.4,6X,'*',2X,I6)
 9060    FORMAT(1X,I8,' *',I6,' *',I6,1X,F10.4,
     + '      *        *       *   ',F8.3,2X,I6)
 9062    FORMAT(1X,I8,' *',I6,9X,F10.4,
     + '      *        *       *   ',F8.3,2X,I6)
 9064    FORMAT(1X,I8,17X,F10.4,
     + '      *        *       *   ',F8.3,2X,I6)

      ENDIF
c
      IF (IBACKS.NE.0)  CALL BACKSOL(BETA,NDIM,IBACKS)
      IF (NSURV.NE.0)  CALL PREDICTED(BETA)
c
      TIM1= SECOND() - TIM00
      WRITE(6,9190) TIM1
      WRITE(12,9190) TIM1
 9190 FORMAT(/1X,' TOTAL TIME = ',F10.2,' SECONDS'//)
C
C STORE RESULTS
C
      IF (NOLDS.EQ.1.OR.NOLDS.EQ.3) THEN
        ICODE=1
        CALL RWBACKUP(ICODE,FILE(8))
      ENDIF
	  
      if (parmout.ne.'NONE'.and.parmout.ne.' ') then
        print*,'Computation details are in file: ', trim(parmout)
      else
        print*,'Computation details were printed to the screen.'
      endif	  
      WRITE(6,9200) file(3)
 9200 FORMAT(1X, 'Results are in file: ',A40,
     +      //1X, 'Computations finished.')
C
C-----------------------------------------------------------------------
C DELETE TEMPORARY FILE(S)
C-----------------------------------------------------------------------
      IF (NSTOR.NE.1) THEN
        OPEN(4,FILE=FILE(9),FORM='UNFORMATTED')
        CLOSE(4,STATUS='DELETE')
        IF (NSURV.NE.0) THEN
          OPEN(4,FILE=FILE(10),FORM='UNFORMATTED')
          CLOSE(4,STATUS='DELETE')
        ENDIF
      ENDIF
C	  
      STOP
C
      END

