      PROGRAM DIG
      IMPLICIT NONE
C
C     ALGORITHM AS 103  APPL. STATIST. (1976) VOL.25, NO.3
C
C     Calculates DIGAMMA(X) = D( LOG( GAMMA(X))) / DX
C
      INTEGER IFAULT
      REAL*8 DIGAMA,TRIGAM,ZERO, HALF, ONE

      REAL*8 R,S,C,S3,S4,S5,D1,Y,X ,XM
C
C     Set constants, SN = Nth Stirling coefficient, D1 = DIGAMMA(1.0)
C
      DATA ZERO/0.0D0/, HALF/0.5D0/, ONE/1.0D0/  
      DATA S, C, S3, S4, S5, D1 /1.D-05, 8.5D0, 8.333333333D-02,
     *    8.3333333333D-03, 3.96825 3968D-03, -0.57721 56649D0/
C
C     Check argument is positive
C
      write(6,*) ' GAMMA ? '
      READ(5,*) X
      DIGAMA = ZERO
      Y = X
      IFAULT = 1
      IF (Y .LE. ZERO) GOTO 99 
      IFAULT = 0
C
C     Use approximation if argument <= S
C
      IF (Y .LE. S) THEN
        DIGAMA = D1 - ONE / Y
        GOTO 98
      END IF
C
C     Reduce to DIGAMA(X + N) where (X + N) >= C
C
    1 IF (Y .GE. C) GO TO 2
      DIGAMA = DIGAMA - ONE/Y
      Y = Y + ONE
      GO TO 1
C
C     Use Stirling's (actually de Moivre's) expansion if argument > C
C
    2 R = ONE / Y
      DIGAMA = DIGAMA + DLOG(Y) - HALF*R
      R = R * R
      DIGAMA = DIGAMA - R*(S3 - R*(S4 - R*S5))
  98  write(6,*) 'Digamma(gamma)=',DIGAMA
      XM=DIGAMA-DLOG(X)
      write(6,*) 'E(loggamma variable)=',XM 
      XM=TRIGAM(X)
      write(6,*) 'Trigamma(gamma)=',XM
      stop    
  99  write(6,100) IFAULT
 100  FORMAT(1X,'PROBLEM WITH FUNCTION DIGAMA ',/1X,'IFAULT =',I3)
      STOP
      END
C*******************************************************         
      function trigam(x)
      implicit none  
c
c        algorithm as121   Appl. Statist. (1978) vol 27, no. 1
c
c        calculates trigamma(x) = d**2(log(gamma(x))) / dx**2
c
      integer ifault
      real*8 trigam,a, b, one, half, b2, b4, b6,b8, x, y, z, zero
      data a, b, one, half /1.0d-4, 5.0d0, 1.0d0, 0.5d0/
      data zero /0.0d0/
c
c        b2, b4, b6 and b8 are Bernoulli numbers
c
      data b2, b4, b6,b8
     */0.1666666667d0, -0.03333333333d0,
     *    0.02380952381d0, -0.03333333333d0/
c
c        check for positive value of x
c
      trigam = zero
      ifault = 1
      if (x.le.zero) goto 99 
      ifault = 0
      z = x
c
c        use small value approximation if x .le. a
c
      if (z .gt. a) goto 10
      trigam = one / (z * z)
      return
c
c        increase argument to (x+i) .ge. b
c
   10 if (z .ge. b) goto 20
      trigam = trigam + one / (z * z)
      z = z + one
      goto 10
c
c        apply asymptotic formula if argument .ge. b
c
   20 y = one / (z * z)
      trigam = trigam + half * y +
     * (one + y * (b2 + y * (b4 + y * (b6 + y * b8)))) / z
      return
  99  write(6,100) IFAULT
 100  FORMAT(1X,'PROBLEM WITH FUNCTION TRIGAMA ',/1X,'IFAULT =',I3)
      STOP
      end
