package at.boku.survivalkit.skonstructor.export;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.io.BufferedWriter;
import java.text.MessageFormat;
import java.util.Map;

import at.boku.survivalkit.skonstructor.form.support.Utils;

public class FileExporter {

	private final static String OUTPUT_ROW_FORMAT = "{0} {1};";
	private final static String OUTPUT_ROW_FORMAT_ONE_ATTR = "{0};";

	public void doExport(File file, Map<String, String> params)
			throws IOException {

		Writer output = null;

		try {
			output = new BufferedWriter(new FileWriter(file));

			for (String key : params.keySet()) {
				String value = params.get(key);
				if (Utils.isStringEmpty(key)) {
					output
							.write(MessageFormat.format(
									OUTPUT_ROW_FORMAT_ONE_ATTR,
									new Object[] { value }));
				} else if (Utils.isStringEmpty(value)) {
					output.write(MessageFormat.format(
							OUTPUT_ROW_FORMAT_ONE_ATTR, new Object[] { key }));
				} else {
					output.write(MessageFormat.format(OUTPUT_ROW_FORMAT,
							new Object[] { key, value }));
				}
				output.write(Utils.getNewLineChar());
			}

		} catch (IOException e) {
			e.printStackTrace();
			throw e;
		} finally {
			if (output != null) {
				try {
					output.close();
				} catch (IOException e) {
					e.printStackTrace();
					throw e;
				}
			}
		}

	}

}
