package at.boku.survivalkit.skonstructor.form.support;

import java.util.LinkedHashMap;
import java.util.Map;

public class Utils {

	public static boolean isStringEmpty(String text) {
		if (text != null && !text.trim().equals("")) {
			return false;
		} else {
			return true;
		}
	}

	public static boolean isStringNotEmpty(String text) {
		return !isStringEmpty(text);
	}

	public static String getNewLineChar() {
		return System.getProperty("line.separator");
	}

	public static Map<String, String> prepareResultTransformer(
			Map<String, String> input) {
		Map<String, String> result = new LinkedHashMap<String, String>();

		if (input.containsKey("nrecmax"))
			result.put("nrecmax", input.get("nrecmax"));
		if (input.containsKey("nefmax"))
			result.put("nefmax", input.get("nefmax"));
		if (input.containsKey("ndimax"))
			result.put("ndimax", input.get("ndimax"));
		if (input.containsKey("FILES"))
			result.put("FILES", input.get("FILES"));
		if (input.containsKey("INPUT"))
			result.put("INPUT", input.get("INPUT"));
		if (input.containsKey("TIME"))
			result.put("TIME", input.get("TIME"));
		if (input.containsKey("CENSCODE"))
			result.put("CENSCODE", input.get("CENSCODE"));
		if (input.containsKey("discrete_scale"))
			result.put("discrete_scale", input.get("discrete_scale"));
		if (input.containsKey("idrec"))
			result.put("idrec", input.get("idrec"));
		if (input.containsKey("truncate"))
			result.put("truncate", input.get("truncate"));
		if (input.containsKey("timecov"))
			result.put("timecov", input.get("timecov"));
		if (input.containsKey("convdt"))
			result.put("convdt", input.get("convdt"));
		if (input.containsKey("class"))
			result.put("class", input.get("class"));
		if (input.containsKey("joincode"))
			result.put("joincode", input.get("joincode"));
		if (input.containsKey("timedep"))
			result.put("timedep", input.get("timedep"));
		if (input.containsKey("combine"))
			result.put("combine", input.get("combine"));
		if (input.containsKey("OUTPUT"))
			result.put("OUTPUT", input.get("OUTPUT"));
		if (input.containsKey("future"))
			result.put("future", input.get("future"));
		if (input.containsKey("pedigree"))
			result.put("pedigree", input.get("pedigree"));
		if (input.containsKey("formout"))
			result.put("formout", input.get("formout"));

		return result;
	}

	public static Map<String, String> weibullResultTransformer(
			Map<String, String> input) {
		Map<String, String> result = new LinkedHashMap<String, String>();

		if (input.containsKey("nrecmax"))
			result.put("nrecmax", input.get("nrecmax"));
		if (input.containsKey("ndimax"))
			result.put("ndimax", input.get("ndimax"));
		if (input.containsKey("nefmax"))
			result.put("nefmax", input.get("nefmax"));
		if (input.containsKey("nstramax"))
			result.put("nstramax", input.get("nstramax"));
		if (input.containsKey("ntimmax"))
			result.put("ntimmax", input.get("ntimmax"));
		if (input.containsKey("nstimax"))
			result.put("nstimax", input.get("nstimax"));
		if (input.containsKey("nlevout"))
			result.put("nlevout", input.get("nlevout"));
		if (input.containsKey("npgauss"))
			result.put("npgauss", input.get("npgauss"));
		if (input.containsKey("niter_gauss"))
			result.put("niter_gauss", input.get("niter_gauss"));
		if (input.containsKey("nvec_bf"))
			result.put("nvec_bf", input.get("nvec_bf"));
		if (input.containsKey("no_logarithm"))
			result.put("no_logarithm", input.get("no_logarithm"));
		if (input.containsKey("no_hessian"))
			result.put("no_hessian", input.get("no_hessian"));
		if (input.containsKey("nze_hessian"))
			result.put("nze_hessian", input.get("nze_hessian"));
		if (input.containsKey("with_mgd"))
			result.put("with_mgd", input.get("with_mgd"));
		if (input.containsKey("logfile"))
			result.put("logfile", input.get("logfile"));
		if (input.containsKey("FILES"))
			result.put("FILES", input.get("FILES"));
		if (input.containsKey("title"))
			result.put("title", input.get("title"));
		if (input.containsKey("ite_quasi"))
			result.put("ite_quasi", input.get("ite_quasi"));
		if (input.containsKey("strata"))
			result.put("strata", input.get("strata"));
		if (input.containsKey("origin"))
			result.put("origin", input.get("origin"));
		if (input.containsKey("rho_fixed"))
			result.put("rho_fixed", input.get("rho_fixed"));
		if (input.containsKey("MODEL"))
			result.put("MODEL", input.get("MODEL"));
		if (input.containsKey("coefficient"))
			result.put("coefficient", input.get("coefficient"));
		if (input.containsKey(""))
			result.put("statistics", input.get("statistics"));
		
		if (input.containsKey("random"))
			result.put("random", input.get("random"));
		if (input.containsKey("integrate_out"))
			result.put("integrate_out", input.get("integrate_out"));
		if (input.containsKey("animal_solution"))
			result.put("animal_solution", input.get("animal_solution"));
		if (input.containsKey("test"))
			result.put("test", input.get("test"));
		if (input.containsKey("std_error"))
			result.put("std_error", input.get("std_error"));
		if (input.containsKey("dense_hessian"))
			result.put("dense_hessian", input.get("dense_hessian"));
		if (input.containsKey("force_positive"))
			result.put("force_positive", input.get("force_positive"));
		if (input.containsKey("baseline"))
			result.put("baseline", input.get("baseline"));
		if (input.containsKey("kaplan"))
			result.put("kaplan", input.get("kaplan"));
		if (input.containsKey("survival"))
			result.put("survival", input.get("survival"));
		if (input.containsKey("residual"))
			result.put("residual", input.get("residual"));
		if (input.containsKey("constraints"))
			result.put("constraints", input.get("constraints"));
		if (input.containsKey("convergence_criterion"))
			result.put("convergence_criterion", input
					.get("convergence_criterion"));
		if (input.containsKey("storage"))
			result.put("storage", input.get("storage"));
		if (input.containsKey("store_solutions"))
			result.put("store_solutions", input.get("store_solutions"));
		if (input.containsKey("read_old_solutions"))
			result.put("read_old_solutions", input.get("read_old_solutions"));

		return result;
	}
}
