package at.boku.survivalkit.skonstructor.panels;

import javax.swing.JPanel;
import javax.swing.JDesktopPane;
import java.awt.BorderLayout;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.swing.UIManager;
import javax.swing.JButton;
import javax.swing.border.TitledBorder;

import at.boku.survivalkit.skonstructor.form.ApplicationForm;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class Prepare1Panel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1065930945734412835L;
	private JTextField nrecmaxTextField;
	private JTextField nefmaxTextField;
	private JTextField ndimaxTextField;
	private JCheckBox nrecmaxCheckbox;
	private JCheckBox nefmaxCheckbox;
	private JCheckBox ndimaxCheckbox;

	/**
	 * Create the panel.
	 */
	public Prepare1Panel(final ApplicationForm appForm) {
		setLayout(new BorderLayout(0, 0));
		
		JDesktopPane desktopPane = new JDesktopPane();
		desktopPane.setBackground(UIManager.getColor("Button.background"));
		add(desktopPane, BorderLayout.CENTER);
		
		JButton prepare1PanelNextButton = new JButton("Next");
		prepare1PanelNextButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				appForm.getPrepareMainPanel().remove(appForm.getPrepare1Panel());
				appForm.getPrepareMainPanel().add(appForm.getPrepare2Panel(), BorderLayout.CENTER);
				appForm.getFrame().repaint();
			}
		});
		prepare1PanelNextButton.setBounds(501, 567, 89, 23);
		desktopPane.add(prepare1PanelNextButton);
		
		JPanel panel = new JPanel();
		panel.setBounds(160, 88, 255, 122);
		desktopPane.add(panel);
		panel.setLayout(new BorderLayout(0, 0));
		panel.setBorder(new TitledBorder(null, "Parameters", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		
		JDesktopPane desktopPane_1 = new JDesktopPane();
		desktopPane_1.setBackground(UIManager.getColor("Button.background"));
		panel.add(desktopPane_1, BorderLayout.CENTER);
		
		nrecmaxTextField = new JTextField();
		nrecmaxTextField.setBounds(84, 10, 145, 19);
		desktopPane_1.add(nrecmaxTextField);
		nrecmaxTextField.setColumns(10);
		
		nrecmaxCheckbox = new JCheckBox("nrecmax");
		nrecmaxCheckbox.setBounds(10, 10, 68, 23);
		desktopPane_1.add(nrecmaxCheckbox);
		
		nefmaxTextField = new JTextField();
		nefmaxTextField.setBounds(84, 36, 145, 19);
		desktopPane_1.add(nefmaxTextField);
		nefmaxTextField.setColumns(10);
		
		nefmaxCheckbox = new JCheckBox("nefmax");
		nefmaxCheckbox.setBounds(10, 34, 68, 23);
		desktopPane_1.add(nefmaxCheckbox);
		
		ndimaxTextField = new JTextField();
		ndimaxTextField.setBounds(85, 62, 144, 19);
		desktopPane_1.add(ndimaxTextField);
		ndimaxTextField.setColumns(10);
		
		ndimaxCheckbox = new JCheckBox("ndimax");
		ndimaxCheckbox.setBounds(10, 58, 59, 23);
		desktopPane_1.add(ndimaxCheckbox);
		
	}
	
	public Map<String, String> getAsMap() {
		Map<String, String> result = new LinkedHashMap<String, String>();
		if(nrecmaxCheckbox.isSelected()) {
			result.put(nrecmaxCheckbox.getText(), nrecmaxTextField.getText());
		}
		if(nefmaxCheckbox.isSelected()) {
			result.put(nefmaxCheckbox.getText(), nefmaxTextField.getText());
		}
		if(ndimaxCheckbox.isSelected()) {
			result.put(ndimaxCheckbox.getText(), ndimaxTextField.getText());
		}
		return result;
	}
}
