package at.boku.survivalkit.skonstructor.panels;

import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JDesktopPane;
import javax.swing.UIManager;
import javax.swing.JCheckBox;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JButton;

import at.boku.survivalkit.skonstructor.form.ApplicationForm;
import at.boku.survivalkit.skonstructor.form.support.ExportAction;
import at.boku.survivalkit.skonstructor.form.support.Utils;

public class Prepare3Panel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3279349398559193849L;
	private JCheckBox discreteScaleCheckBox;
	private JTextField truncateTextField;
	private JCheckBox timecovCheckBox;
	private JTextField timecovTextField1;
	private JTextField timecovTextField2;
	private JComboBox timecovComboBox1;
	private JCheckBox truncateCheckBox;
	private JCheckBox convdtCheckBox;
	private JTextField convdtTextField11;
	private JLabel label;
	private JTextField convdtTextField12;
	private JLabel label_1;
	private JTextField convdtTextField13;
	private JTextField convdtTextField21;
	private JLabel label_2;
	private JTextField convdtTextField22;
	private JLabel label_3;
	private JTextField convdtTextField23;
	private JCheckBox joincodeCheckBox;
	private JTextField joincodeTextField1;
	private JTextField joincodeTextField2;
	private JCheckBox combineCheckBox;
	private JTextField combineTextField11;
	private JLabel label_4;
	private JTextField combineTextField12;
	private JLabel label_5;
	private JTextField combineTextField13;
	private JTextField combineTextField21;
	private JLabel label_6;
	private JTextField combineTextField22;
	private JLabel label_7;
	private JTextField combineTextField23;
	private JCheckBox futureCheckBox;
	private JTextField futureTextField1;
	private JTextField futureTextField2;
	private JCheckBox pedigreeCheckBox;
	private JTextField pedigreeTextField1;
	private JTextField pedigreeTextField2;
	private JTextField pedigreeTextField3;
	private JTextField pedigreeTextField4;
	private JCheckBox withMgdCheckBox;
	private JCheckBox formoutCheckBox;
	private JTextField formoutTextField;

	/**
	 * Create the panel.
	 */
	public Prepare3Panel(final ApplicationForm appForm) {
		setLayout(new BorderLayout(0, 0));

		JDesktopPane desktopPane = new JDesktopPane();
		desktopPane.setBackground(UIManager.getColor("Button.background"));
		add(desktopPane, BorderLayout.CENTER);

		discreteScaleCheckBox = new JCheckBox("discrete_scale");
		discreteScaleCheckBox.setBounds(10, 10, 97, 23);
		desktopPane.add(discreteScaleCheckBox);

		truncateCheckBox = new JCheckBox("truncate");
		truncateCheckBox.setBounds(10, 39, 79, 23);
		desktopPane.add(truncateCheckBox);

		truncateTextField = new JTextField();
		truncateTextField.setBounds(96, 39, 91, 19);
		desktopPane.add(truncateTextField);
		truncateTextField.setColumns(10);

		timecovCheckBox = new JCheckBox("timecov");
		timecovCheckBox.setBounds(10, 68, 79, 23);
		desktopPane.add(timecovCheckBox);

		timecovTextField1 = new JTextField();
		timecovTextField1.setColumns(10);
		timecovTextField1.setBounds(96, 66, 91, 19);
		desktopPane.add(timecovTextField1);

		timecovComboBox1 = new JComboBox();
		timecovComboBox1.setBounds(193, 64, 46, 22);
		timecovComboBox1.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timecovComboBox1);

		timecovTextField2 = new JTextField();
		timecovTextField2.setColumns(10);
		timecovTextField2.setBounds(245, 66, 91, 19);
		desktopPane.add(timecovTextField2);

		convdtCheckBox = new JCheckBox("convdt");
		convdtCheckBox.setBounds(10, 118, 79, 23);
		desktopPane.add(convdtCheckBox);

		convdtTextField11 = new JTextField();
		convdtTextField11.setBounds(96, 118, 91, 19);
		desktopPane.add(convdtTextField11);
		convdtTextField11.setColumns(10);

		label = new JLabel("=");
		label.setBounds(203, 119, 14, 14);
		desktopPane.add(label);

		convdtTextField12 = new JTextField();
		convdtTextField12.setBounds(238, 118, 91, 19);
		desktopPane.add(convdtTextField12);
		convdtTextField12.setColumns(10);

		label_1 = new JLabel("-");
		label_1.setBounds(345, 119, 14, 14);
		desktopPane.add(label_1);

		convdtTextField13 = new JTextField();
		convdtTextField13.setBounds(387, 118, 91, 19);
		desktopPane.add(convdtTextField13);
		convdtTextField13.setColumns(10);

		convdtTextField21 = new JTextField();
		convdtTextField21.setColumns(10);
		convdtTextField21.setBounds(96, 143, 91, 19);
		desktopPane.add(convdtTextField21);

		label_2 = new JLabel("=");
		label_2.setBounds(203, 144, 14, 14);
		desktopPane.add(label_2);

		convdtTextField22 = new JTextField();
		convdtTextField22.setColumns(10);
		convdtTextField22.setBounds(238, 143, 91, 19);
		desktopPane.add(convdtTextField22);

		label_3 = new JLabel("-");
		label_3.setBounds(345, 144, 14, 14);
		desktopPane.add(label_3);

		convdtTextField23 = new JTextField();
		convdtTextField23.setColumns(10);
		convdtTextField23.setBounds(387, 143, 91, 19);
		desktopPane.add(convdtTextField23);

		joincodeCheckBox = new JCheckBox("joincode");
		joincodeCheckBox.setBounds(10, 168, 65, 23);
		desktopPane.add(joincodeCheckBox);

		joincodeTextField1 = new JTextField();
		joincodeTextField1.setBounds(96, 168, 91, 19);
		desktopPane.add(joincodeTextField1);
		joincodeTextField1.setColumns(10);

		joincodeTextField2 = new JTextField();
		joincodeTextField2.setBounds(193, 168, 91, 19);
		desktopPane.add(joincodeTextField2);
		joincodeTextField2.setColumns(10);

		combineCheckBox = new JCheckBox("combine");
		combineCheckBox.setBounds(10, 197, 84, 23);
		desktopPane.add(combineCheckBox);

		combineTextField11 = new JTextField();
		combineTextField11.setColumns(10);
		combineTextField11.setBounds(96, 193, 91, 19);
		desktopPane.add(combineTextField11);

		label_4 = new JLabel("=");
		label_4.setBounds(203, 194, 14, 14);
		desktopPane.add(label_4);

		combineTextField12 = new JTextField();
		combineTextField12.setColumns(10);
		combineTextField12.setBounds(238, 193, 91, 19);
		desktopPane.add(combineTextField12);

		label_5 = new JLabel("+");
		label_5.setBounds(345, 194, 14, 14);
		desktopPane.add(label_5);

		combineTextField13 = new JTextField();
		combineTextField13.setColumns(10);
		combineTextField13.setBounds(387, 193, 91, 19);
		desktopPane.add(combineTextField13);

		combineTextField21 = new JTextField();
		combineTextField21.setColumns(10);
		combineTextField21.setBounds(96, 218, 91, 19);
		desktopPane.add(combineTextField21);

		label_6 = new JLabel("=");
		label_6.setBounds(203, 219, 14, 14);
		desktopPane.add(label_6);

		combineTextField22 = new JTextField();
		combineTextField22.setColumns(10);
		combineTextField22.setBounds(238, 218, 91, 19);
		desktopPane.add(combineTextField22);

		label_7 = new JLabel("+");
		label_7.setBounds(345, 219, 14, 14);
		desktopPane.add(label_7);

		combineTextField23 = new JTextField();
		combineTextField23.setColumns(10);
		combineTextField23.setBounds(387, 218, 91, 19);
		desktopPane.add(combineTextField23);

		futureCheckBox = new JCheckBox("future");
		futureCheckBox.setBounds(10, 243, 65, 23);
		desktopPane.add(futureCheckBox);

		futureTextField1 = new JTextField();
		futureTextField1.setColumns(10);
		futureTextField1.setBounds(96, 243, 91, 19);
		desktopPane.add(futureTextField1);

		futureTextField2 = new JTextField();
		futureTextField2.setColumns(10);
		futureTextField2.setBounds(193, 243, 91, 19);
		desktopPane.add(futureTextField2);

		pedigreeCheckBox = new JCheckBox("pedigree");
		pedigreeCheckBox.setBounds(10, 272, 79, 23);
		desktopPane.add(pedigreeCheckBox);

		pedigreeTextField1 = new JTextField();
		pedigreeTextField1.setColumns(10);
		pedigreeTextField1.setBounds(96, 272, 91, 19);
		desktopPane.add(pedigreeTextField1);

		pedigreeTextField2 = new JTextField();
		pedigreeTextField2.setColumns(10);
		pedigreeTextField2.setBounds(193, 272, 91, 19);
		desktopPane.add(pedigreeTextField2);

		pedigreeTextField3 = new JTextField();
		pedigreeTextField3.setBounds(290, 272, 91, 19);
		desktopPane.add(pedigreeTextField3);
		pedigreeTextField3.setColumns(10);

		pedigreeTextField4 = new JTextField();
		pedigreeTextField4.setBounds(387, 272, 91, 19);
		desktopPane.add(pedigreeTextField4);
		pedigreeTextField4.setColumns(10);

		withMgdCheckBox = new JCheckBox("with_mgd");
		withMgdCheckBox.setBounds(485, 272, 97, 23);
		desktopPane.add(withMgdCheckBox);

		formoutCheckBox = new JCheckBox("formout");
		formoutCheckBox.setBounds(10, 301, 65, 23);
		desktopPane.add(formoutCheckBox);

		formoutTextField = new JTextField();
		formoutTextField.setColumns(10);
		formoutTextField.setBounds(96, 301, 91, 19);
		desktopPane.add(formoutTextField);

		JButton prepare3PanelCreateParamFileButton = new JButton(
				"Create parameter file");
		prepare3PanelCreateParamFileButton
				.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {

						Map<String, String> params = new LinkedHashMap<String, String>();
						params.putAll(appForm.getPrepare1Panel().getAsMap());
						params.putAll(appForm.getPrepare2Panel().getAsMap());
						params.putAll(getAsMap());
						
						params = Utils.prepareResultTransformer(params);
						
						ExportAction exporter = new ExportAction();
						exporter.exportToFile(appForm.getPrepare3Panel(),
								params);

					}
				});
		prepare3PanelCreateParamFileButton.setBounds(440, 567, 142, 23);
		desktopPane.add(prepare3PanelCreateParamFileButton);

		JButton prepare3PanelPrevButton = new JButton("Previous");
		prepare3PanelPrevButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				appForm.getPrepareMainPanel()
						.remove(appForm.getPrepare3Panel());
				appForm.getPrepareMainPanel().add(appForm.getPrepare2Panel(),
						BorderLayout.CENTER);
				appForm.getFrame().repaint();
			}
		});
		prepare3PanelPrevButton.setBounds(345, 567, 89, 23);
		desktopPane.add(prepare3PanelPrevButton);

	}

	public Map<String, String> getAsMap() {
		Map<String, String> result = new LinkedHashMap<String, String>();

		if (discreteScaleCheckBox.isSelected()) {
			result.put(discreteScaleCheckBox.getText(), "");
		}
		if (truncateCheckBox.isSelected()) {
			result.put(truncateCheckBox.getText(), truncateTextField.getText());
		}
		if (timecovCheckBox.isSelected()) {
			result.put(timecovCheckBox.getText(), getTimecovValue());
		}
		if (convdtCheckBox.isSelected()) {
			result.put(convdtCheckBox.getText(), getConvdtValue());
		}
		if (joincodeCheckBox.isSelected()) {
			result.put(joincodeCheckBox.getText(), joincodeTextField1.getText()
					+ " " + joincodeTextField2.getText());
		}
		if (combineCheckBox.isSelected()) {
			result.put(combineCheckBox.getText(), getCombineValue());
		}
		if (futureCheckBox.isSelected()) {
			result.put(futureCheckBox.getText(), futureTextField1.getText()
					+ " " + futureTextField2.getText());
		}
		if (pedigreeCheckBox.isSelected()) {
			result.put(pedigreeCheckBox.getText(), getPedigreeValue());
		}
		if (formoutCheckBox.isSelected()) {
			result.put(formoutCheckBox.getText(), formoutTextField.getText());
		}
		return result;
	}

	private String getPedigreeValue() {
		StringBuilder sb = new StringBuilder();
		if (pedigreeTextField1.getText() != null && !pedigreeTextField1.getText().equals("")) {
			sb.append(pedigreeTextField1.getText());
		}
		if (pedigreeTextField2.getText() != null && !pedigreeTextField2.getText().equals("")) {
			sb.append(" " + pedigreeTextField2.getText());
		}
		if (pedigreeTextField3.getText() != null && !pedigreeTextField3.getText().equals("")) {
			sb.append(" " + pedigreeTextField3.getText());
		}
		if (pedigreeTextField4.getText() != null && !pedigreeTextField4.getText().equals("")) {
			sb.append(" " + pedigreeTextField4.getText());
		}
		if (withMgdCheckBox.isSelected()) {
			sb.append(" " + withMgdCheckBox.getText());
		}
		return sb.toString();
	}

	private String getCombineValue() {
		StringBuilder sb = new StringBuilder();
		if (combineTextField11.getText() != null && !combineTextField11.getText().equals("")) {
			sb.append(combineTextField11.getText());
			if (combineTextField12.getText() != null && !combineTextField12.getText().equals("")) {
				sb.append("=" + combineTextField12.getText() + "+" + combineTextField13.getText());
			}
		}
		
		if (combineTextField21.getText() != null && !combineTextField21.getText().equals("")) {
			sb.append(" ");
			sb.append(combineTextField21.getText());
			if (combineTextField22.getText() != null && !combineTextField22.getText().equals("")) {
				sb.append("=" + combineTextField22.getText() + "+" + combineTextField23.getText());
			}
		}
		return sb.toString();
	}

	private String getConvdtValue() {
		StringBuilder sb = new StringBuilder();
		if (convdtTextField11.getText() != null && !convdtTextField11.getText().equals("")) {
			sb.append(convdtTextField11.getText());
			if (convdtTextField12.getText() != null && !convdtTextField12.getText().equals("")) {
				sb.append("=" + convdtTextField12.getText() + "-" + convdtTextField13.getText());
			}
		}
		
		if (convdtTextField21.getText() != null && !convdtTextField21.getText().equals("")) {
			sb.append(" ");
			sb.append(convdtTextField21.getText());
			if (convdtTextField22.getText() != null && !convdtTextField22.getText().equals("")) {
				sb.append("=" + convdtTextField22.getText() + "-" + convdtTextField23.getText());
			}
		}
		
		return sb.toString();
	}

	private String getTimecovValue() {
		StringBuilder sb = new StringBuilder();
		if (timecovTextField1.getText() != null && !timecovTextField1.getText().equals("")) {
			sb.append(timecovTextField1.getText() + " "
					+ timecovComboBox1.getSelectedItem());
		}
		if (timecovTextField2.getText() != null && !timecovTextField2.getText().equals("")) {
			sb.append(" " + timecovTextField2.getText());
		}
		
		return sb.toString();
	}
}
