package at.boku.survivalkit.skonstructor.panels;

import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JDesktopPane;
import javax.swing.UIManager;
import javax.swing.JCheckBox;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.border.TitledBorder;
import javax.swing.JButton;

import at.boku.survivalkit.skonstructor.form.ApplicationForm;

public class Weibull1Panel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -2283381498748427046L;
	private JCheckBox nrecmaxCheckBox;
	private JTextField nrecmaxTextField;
	private JTextField ndimaxTextField;
	private JCheckBox ndimaxCheckBox;
	private JCheckBox nefmaxCheckBox;
	private JTextField nefmaxTextField;
	private JCheckBox nstramaxCheckBox;
	private JTextField nstramaxTextField;
	private JCheckBox ntimmaxCheckBox;
	private JTextField ntimmaxTextField;
	private JCheckBox nstimaxCheckBox;
	private JTextField nstimaxTextField;
	private JCheckBox nlevoutCheckBox;
	private JTextField nlevoutTextField;
	private JCheckBox niterGaussCheckBox;
	private JTextField niterGaussTextField;
	private JCheckBox logfileCheckBox;
	private JTextField logfileTextField;
	private JCheckBox npgaussCheckBox;
	private JComboBox npgaussComboBox;
	private JCheckBox nvecBfCheckBox;
	private JComboBox nvecBfComboBox;
	private JCheckBox noLogarithmCheckBox;
	private JComboBox noLogarithmComboBox;
	private JCheckBox withMgdCheckBox;
	private JRadioButton noHessianRadioButton;
	private JRadioButton nzeHessianRadioButton;
	private final ButtonGroup hessianButtonGroup = new ButtonGroup();
	private JPanel panel;
	private JTextField nzeHessianTextField;

	/**
	 * Create the panel.
	 */
	public Weibull1Panel(final ApplicationForm appForm) {
		setLayout(new BorderLayout(0, 0));
		
		JDesktopPane desktopPane = new JDesktopPane();
		desktopPane.setBackground(UIManager.getColor("Button.background"));
		add(desktopPane, BorderLayout.CENTER);
		
		panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Parameters", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(160, 30, 261, 479);
		desktopPane.add(panel);
		panel.setLayout(null);
		
		nrecmaxCheckBox = new JCheckBox("nrecmax");
		nrecmaxCheckBox.setBounds(8, 22, 67, 23);
		panel.add(nrecmaxCheckBox);
		
		nrecmaxTextField = new JTextField();
		nrecmaxTextField.setBounds(102, 24, 145, 19);
		panel.add(nrecmaxTextField);
		nrecmaxTextField.setColumns(10);
		
		ndimaxCheckBox = new JCheckBox("ndimax");
		ndimaxCheckBox.setBounds(8, 51, 67, 23);
		panel.add(ndimaxCheckBox);
		
		ndimaxTextField = new JTextField();
		ndimaxTextField.setBounds(102, 53, 145, 19);
		panel.add(ndimaxTextField);
		ndimaxTextField.setColumns(10);
		
		nefmaxCheckBox = new JCheckBox("nefmax");
		nefmaxCheckBox.setBounds(8, 80, 67, 23);
		panel.add(nefmaxCheckBox);
		
		nefmaxTextField = new JTextField();
		nefmaxTextField.setBounds(102, 82, 145, 19);
		panel.add(nefmaxTextField);
		nefmaxTextField.setColumns(10);
		
		nstramaxCheckBox = new JCheckBox("nstramax");
		nstramaxCheckBox.setBounds(8, 109, 88, 23);
		panel.add(nstramaxCheckBox);
		
		nstramaxTextField = new JTextField();
		nstramaxTextField.setBounds(102, 111, 145, 19);
		panel.add(nstramaxTextField);
		nstramaxTextField.setColumns(10);
		
		ntimmaxCheckBox = new JCheckBox("ntimmax");
		ntimmaxCheckBox.setBounds(8, 138, 67, 23);
		panel.add(ntimmaxCheckBox);
		
		ntimmaxTextField = new JTextField();
		ntimmaxTextField.setBounds(102, 140, 145, 19);
		panel.add(ntimmaxTextField);
		ntimmaxTextField.setColumns(10);
		
		nstimaxCheckBox = new JCheckBox("nstimax");
		nstimaxCheckBox.setBounds(8, 167, 67, 23);
		panel.add(nstimaxCheckBox);
		
		nstimaxTextField = new JTextField();
		nstimaxTextField.setBounds(102, 169, 145, 19);
		panel.add(nstimaxTextField);
		nstimaxTextField.setColumns(10);
		
		nlevoutCheckBox = new JCheckBox("nlevout");
		nlevoutCheckBox.setBounds(8, 196, 67, 23);
		panel.add(nlevoutCheckBox);
		
		nlevoutTextField = new JTextField();
		nlevoutTextField.setBounds(102, 198, 145, 19);
		panel.add(nlevoutTextField);
		nlevoutTextField.setColumns(10);
		
		niterGaussCheckBox = new JCheckBox("niter_gauss");
		niterGaussCheckBox.setBounds(8, 257, 88, 23);
		panel.add(niterGaussCheckBox);
		
		niterGaussTextField = new JTextField();
		niterGaussTextField.setBounds(102, 259, 145, 19);
		panel.add(niterGaussTextField);
		niterGaussTextField.setColumns(10);
		
		logfileCheckBox = new JCheckBox("logfile");
		logfileCheckBox.setBounds(8, 445, 67, 23);
		panel.add(logfileCheckBox);
		
		logfileTextField = new JTextField();
		logfileTextField.setBounds(102, 447, 145, 19);
		panel.add(logfileTextField);
		logfileTextField.setColumns(10);
		
		npgaussCheckBox = new JCheckBox("npgauss");
		npgaussCheckBox.setBounds(8, 225, 67, 23);
		panel.add(npgaussCheckBox);
		
		npgaussComboBox = new JComboBox();
		npgaussComboBox.setBounds(102, 223, 36, 22);
		npgaussComboBox.setModel(new DefaultComboBoxModel(new String[] { "3", "4", "5" }));
		panel.add(npgaussComboBox);
		
		nvecBfCheckBox = new JCheckBox("nvec_bf");
		nvecBfCheckBox.setBounds(8, 286, 67, 23);
		panel.add(nvecBfCheckBox);
		
		nvecBfComboBox = new JComboBox();
		nvecBfComboBox.setBounds(102, 284, 36, 22);
		nvecBfComboBox.setModel(new DefaultComboBoxModel(new String[] { "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20"  }));
		panel.add(nvecBfComboBox);
		
		noLogarithmCheckBox = new JCheckBox("no_logarithm");
		noLogarithmCheckBox.setBounds(8, 317, 88, 23);
		panel.add(noLogarithmCheckBox);
		
		noLogarithmComboBox = new JComboBox();
		noLogarithmComboBox.setBounds(102, 317, 36, 22);
		noLogarithmComboBox.setModel(new DefaultComboBoxModel(new String[] { "0", "1" }));
		panel.add(noLogarithmComboBox);
		
		withMgdCheckBox = new JCheckBox("with_mgd");
		withMgdCheckBox.setBounds(8, 416, 97, 23);
		panel.add(withMgdCheckBox);
		
		noHessianRadioButton = new JRadioButton("no_hessian");
		noHessianRadioButton.setBounds(8, 346, 109, 23);
		panel.add(noHessianRadioButton);
		hessianButtonGroup.add(noHessianRadioButton);
		
		nzeHessianRadioButton = new JRadioButton("nze_hessian");
		nzeHessianRadioButton.setBounds(8, 375, 88, 23);
		panel.add(nzeHessianRadioButton);
		hessianButtonGroup.add(nzeHessianRadioButton);
		
		nzeHessianTextField = new JTextField();
		nzeHessianTextField.setBounds(102, 375, 145, 19);
		panel.add(nzeHessianTextField);
		nzeHessianTextField.setColumns(10);
		
		JButton weibull1PanelNextButton = new JButton("Next");
		weibull1PanelNextButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				appForm.getWeibullMainPanel().remove(appForm.getWeibull1Panel());
				appForm.getWeibullMainPanel().add(appForm.getWeibull2Panel(), BorderLayout.CENTER);
				appForm.getFrame().repaint();
			}
		});
		weibull1PanelNextButton.setBounds(501, 567, 89, 23);
		desktopPane.add(weibull1PanelNextButton);

	}
	
	public Map<String, String> getAsMap() {
		Map<String, String> result = new LinkedHashMap<String, String>();
		if(nrecmaxCheckBox.isSelected()) {
			result.put(nrecmaxCheckBox.getText(), nrecmaxTextField.getText());
		}
		if(ndimaxCheckBox.isSelected()) {
			result.put(ndimaxCheckBox.getText(), ndimaxTextField.getText());
		}
		if(nefmaxCheckBox.isSelected()) {
			result.put(nefmaxCheckBox.getText(), nefmaxTextField.getText());
		}
		if(nstramaxCheckBox.isSelected()) {
			result.put(nstramaxCheckBox.getText(), nstramaxTextField.getText());
		}
		if(ntimmaxCheckBox.isSelected()) {
			result.put(ntimmaxCheckBox.getText(), ntimmaxTextField.getText());
		}
		if(nstimaxCheckBox.isSelected()) {
			result.put(nstimaxCheckBox.getText(), nstimaxTextField.getText());
		}
		if(nlevoutCheckBox.isSelected()) {
			result.put(nlevoutCheckBox.getText(), nlevoutTextField.getText());
		}
		if(npgaussCheckBox.isSelected()) {
			result.put(npgaussCheckBox.getText(), (String)npgaussComboBox.getSelectedItem());
		}
		if(niterGaussCheckBox.isSelected()) {
			result.put(niterGaussCheckBox.getText(), niterGaussTextField.getText());
		}
		if(nvecBfCheckBox.isSelected()) {
			result.put(nvecBfCheckBox.getText(), (String)nvecBfComboBox.getSelectedItem());
		}
		if(noLogarithmCheckBox.isSelected()) {
			result.put(noLogarithmCheckBox.getText(), (String)noLogarithmComboBox.getSelectedItem());
		}
		//radiobutton
		if (noHessianRadioButton.isSelected()) {
			result.put(noHessianRadioButton.getText(), "");
		} else if (nzeHessianRadioButton.isSelected()) {
			result.put(nzeHessianRadioButton.getText(), nzeHessianTextField.getText());
		}
		
		if(withMgdCheckBox.isSelected()) {
			result.put(withMgdCheckBox.getText(), "");
		}
		if(logfileCheckBox.isSelected()) {
			result.put(logfileCheckBox.getText(), logfileTextField.getText());
		}
		return result;
	}
}
