package at.boku.survivalkit.skonstructor.panels;

import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JDesktopPane;
import javax.swing.UIManager;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JButton;

import at.boku.survivalkit.skonstructor.form.ApplicationForm;
import at.boku.survivalkit.skonstructor.form.support.DialogUtils;
import at.boku.survivalkit.skonstructor.form.support.Utils;

public class Weibull2Panel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 208332399553202348L;
	private JTextField filesTextField11;
	private JTextField filesTextField12;
	private JTextField filesTextField13;
	private JTextField filesTextField14;
	private JTextField filesTextField21;
	private JTextField filesTextField22;
	private JTextField titleTextField;
	private JLabel modelLabel;
	private JTextField modelTextField11;
	private JTextField modelTextField12;
	private JTextField modelTextField13;
	private JTextField modelTextField14;
	private JTextField modelTextField21;
	private JTextField modelTextField22;
	private JTextField modelTextField23;
	private JTextField modelTextField24;
	private JCheckBox statisticsCheckBox;
	private JComboBox statisticsComboBox;
	private JCheckBox randomCheckBox;
	private JTextField randomTextField1;
	private JCheckBox estimateCheckBox1;
	private JCheckBox momentsCheckBox1;
	private JComboBox momentsComboBox11;
	private JComboBox momentsComboBox12;
	private JTextField momentsTextField1;
	private JTextField randomTextField2;
	private JCheckBox estimateCheckBox2;
	private JCheckBox momentsCheckBox2;
	private JComboBox momentsComboBox21;
	private JComboBox momentsComboBox22;
	private JTextField momentsTextField2;
	private JCheckBox integrateOutCheckBox;
	private JCheckBox jointModeCheckBox;
	private JCheckBox backSolveCheckBox;
	private JTextField backSolveTextField;
	private JCheckBox withinCheckBox;
	private JTextField withinTextField;
	private JCheckBox stdErrorCheckBox;
	private JCheckBox convergenceCriterionCheckBox;
	private JTextField convergenceCriterionTextField;
	private JCheckBox storageCheckBox;
	private JComboBox storageComboBox;
	private JCheckBox titleCheckBox;

	/**
	 * Create the panel.
	 */
	public Weibull2Panel(final ApplicationForm appForm) {
		setLayout(new BorderLayout(0, 0));

		JDesktopPane desktopPane = new JDesktopPane();
		desktopPane.setBackground(UIManager.getColor("Button.background"));
		add(desktopPane, BorderLayout.CENTER);

		JLabel filesLabel = new JLabel("FILES");
		filesLabel.setBounds(10, 12, 46, 14);
		desktopPane.add(filesLabel);

		filesTextField11 = new JTextField();
		filesTextField11.setColumns(10);
		filesTextField11.setBounds(97, 10, 91, 19);
		desktopPane.add(filesTextField11);

		filesTextField12 = new JTextField();
		filesTextField12.setColumns(10);
		filesTextField12.setBounds(194, 10, 91, 19);
		desktopPane.add(filesTextField12);

		filesTextField13 = new JTextField();
		filesTextField13.setColumns(10);
		filesTextField13.setBounds(291, 10, 91, 19);
		desktopPane.add(filesTextField13);

		filesTextField14 = new JTextField();
		filesTextField14.setColumns(10);
		filesTextField14.setBounds(388, 10, 91, 19);
		desktopPane.add(filesTextField14);

		filesTextField21 = new JTextField();
		filesTextField21.setColumns(10);
		filesTextField21.setBounds(97, 35, 91, 19);
		desktopPane.add(filesTextField21);

		filesTextField22 = new JTextField();
		filesTextField22.setColumns(10);
		filesTextField22.setBounds(194, 35, 91, 19);
		desktopPane.add(filesTextField22);

		titleCheckBox = new JCheckBox("title");
		titleCheckBox.setBounds(10, 60, 54, 23);
		desktopPane.add(titleCheckBox);

		titleTextField = new JTextField();
		titleTextField.setColumns(10);
		titleTextField.setBounds(97, 60, 382, 19);
		desktopPane.add(titleTextField);

		modelLabel = new JLabel("MODEL");
		modelLabel.setBounds(10, 91, 46, 14);
		desktopPane.add(modelLabel);

		modelTextField11 = new JTextField();
		modelTextField11.setColumns(10);
		modelTextField11.setBounds(97, 89, 91, 19);
		desktopPane.add(modelTextField11);

		modelTextField12 = new JTextField();
		modelTextField12.setColumns(10);
		modelTextField12.setBounds(194, 89, 91, 19);
		desktopPane.add(modelTextField12);

		modelTextField13 = new JTextField();
		modelTextField13.setColumns(10);
		modelTextField13.setBounds(291, 89, 91, 19);
		desktopPane.add(modelTextField13);

		modelTextField14 = new JTextField();
		modelTextField14.setColumns(10);
		modelTextField14.setBounds(388, 89, 91, 19);
		desktopPane.add(modelTextField14);

		modelTextField21 = new JTextField();
		modelTextField21.setColumns(10);
		modelTextField21.setBounds(97, 114, 91, 19);
		desktopPane.add(modelTextField21);

		modelTextField22 = new JTextField();
		modelTextField22.setColumns(10);
		modelTextField22.setBounds(194, 114, 91, 19);
		desktopPane.add(modelTextField22);

		modelTextField23 = new JTextField();
		modelTextField23.setColumns(10);
		modelTextField23.setBounds(291, 114, 91, 19);
		desktopPane.add(modelTextField23);

		modelTextField24 = new JTextField();
		modelTextField24.setColumns(10);
		modelTextField24.setBounds(388, 114, 91, 19);
		desktopPane.add(modelTextField24);

		statisticsCheckBox = new JCheckBox("");
		statisticsCheckBox.setBounds(10, 139, 54, 23);
		desktopPane.add(statisticsCheckBox);

		statisticsComboBox = new JComboBox();
		statisticsComboBox.setBounds(97, 139, 188, 22);
		statisticsComboBox.setModel(new DefaultComboBoxModel(new String[] {
				"statistics", "only_statistics" }));
		desktopPane.add(statisticsComboBox);

		randomCheckBox = new JCheckBox("random");
		randomCheckBox.setBounds(10, 168, 61, 23);
		desktopPane.add(randomCheckBox);

		randomTextField1 = new JTextField();
		randomTextField1.setBounds(97, 167, 91, 19);
		desktopPane.add(randomTextField1);
		randomTextField1.setColumns(10);

		estimateCheckBox1 = new JCheckBox("estimate");
		estimateCheckBox1.setBounds(188, 167, 67, 23);
		desktopPane.add(estimateCheckBox1);

		momentsCheckBox1 = new JCheckBox("moments");
		momentsCheckBox1.setBounds(259, 167, 74, 23);
		desktopPane.add(momentsCheckBox1);

		momentsComboBox11 = new JComboBox();
		momentsComboBox11.setBounds(339, 168, 85, 22);
		momentsComboBox11.setModel(new DefaultComboBoxModel(new String[] {
				"loggamma", "normal", "multinormal" }));
		desktopPane.add(momentsComboBox11);

		momentsComboBox12 = new JComboBox();
		momentsComboBox12.setBounds(430, 168, 80, 22);
		momentsComboBox12.setModel(new DefaultComboBoxModel(new String[] { "",
				"mgs_rules", "usual_rules" }));
		desktopPane.add(momentsComboBox12);

		momentsTextField1 = new JTextField();
		momentsTextField1.setBounds(516, 170, 74, 19);
		desktopPane.add(momentsTextField1);
		momentsTextField1.setColumns(10);

		randomTextField2 = new JTextField();
		randomTextField2.setColumns(10);
		randomTextField2.setBounds(97, 197, 91, 19);
		desktopPane.add(randomTextField2);

		estimateCheckBox2 = new JCheckBox("estimate");
		estimateCheckBox2.setBounds(188, 197, 67, 23);
		desktopPane.add(estimateCheckBox2);

		momentsCheckBox2 = new JCheckBox("moments");
		momentsCheckBox2.setBounds(259, 197, 74, 23);
		desktopPane.add(momentsCheckBox2);

		momentsComboBox21 = new JComboBox();
		momentsComboBox21.setBounds(339, 198, 85, 22);
		momentsComboBox21.setModel(new DefaultComboBoxModel(new String[] {
				"loggamma", "normal", "multinormal" }));
		desktopPane.add(momentsComboBox21);

		momentsComboBox22 = new JComboBox();
		momentsComboBox22.setBounds(430, 195, 80, 22);
		momentsComboBox22.setModel(new DefaultComboBoxModel(new String[] { "",
				"mgs_rules", "usual_rules" }));
		desktopPane.add(momentsComboBox22);

		momentsTextField2 = new JTextField();
		momentsTextField2.setColumns(10);
		momentsTextField2.setBounds(516, 197, 74, 19);
		desktopPane.add(momentsTextField2);

		integrateOutCheckBox = new JCheckBox("integrate_out");
		integrateOutCheckBox.setBounds(10, 224, 97, 23);
		desktopPane.add(integrateOutCheckBox);

		jointModeCheckBox = new JCheckBox("joint_mode");
		jointModeCheckBox.setBounds(107, 224, 80, 23);
		desktopPane.add(jointModeCheckBox);

		backSolveCheckBox = new JCheckBox("back_solve");
		backSolveCheckBox.setBounds(193, 224, 80, 23);
		desktopPane.add(backSolveCheckBox);

		backSolveTextField = new JTextField();
		backSolveTextField.setBounds(279, 224, 91, 19);
		desktopPane.add(backSolveTextField);
		backSolveTextField.setColumns(10);

		withinCheckBox = new JCheckBox("within");
		withinCheckBox.setBounds(376, 224, 61, 23);
		desktopPane.add(withinCheckBox);

		withinTextField = new JTextField();
		withinTextField.setBounds(441, 224, 91, 19);
		desktopPane.add(withinTextField);
		withinTextField.setColumns(10);

		stdErrorCheckBox = new JCheckBox("std_error");
		stdErrorCheckBox.setBounds(10, 251, 74, 23);
		desktopPane.add(stdErrorCheckBox);

		convergenceCriterionCheckBox = new JCheckBox("convergence_criterion");
		convergenceCriterionCheckBox.setBounds(10, 280, 142, 23);
		desktopPane.add(convergenceCriterionCheckBox);

		convergenceCriterionTextField = new JTextField();
		convergenceCriterionTextField.setBounds(167, 282, 91, 19);
		desktopPane.add(convergenceCriterionTextField);
		convergenceCriterionTextField.setColumns(10);

		storageCheckBox = new JCheckBox("storage");
		storageCheckBox.setBounds(10, 309, 74, 23);
		desktopPane.add(storageCheckBox);

		storageComboBox = new JComboBox();
		storageComboBox.setBounds(97, 309, 64, 22);
		storageComboBox.setModel(new DefaultComboBoxModel(new String[] {
				"in_core", "on_disk" }));
		desktopPane.add(storageComboBox);

		JButton weibull2PanelNextButton = new JButton("Next");
		weibull2PanelNextButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (checkMandatoryInputs()) {
					appForm.getWeibullMainPanel().remove(
							appForm.getWeibull2Panel());
					appForm.getWeibullMainPanel().add(
							appForm.getWeibull3Panel(), BorderLayout.CENTER);
					appForm.getFrame().repaint();
				} else {
					DialogUtils.displayErrorMessageDialog(appForm
							.getWeibull2Panel(),
							"The CAPITALIZED inputs are mandatory!");
				}
			}
		});
		weibull2PanelNextButton.setBounds(501, 567, 89, 23);
		desktopPane.add(weibull2PanelNextButton);

		JButton weibull2PanelPrevButton = new JButton("Previous");
		weibull2PanelPrevButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				appForm.getWeibullMainPanel()
						.remove(appForm.getWeibull2Panel());
				appForm.getWeibullMainPanel().add(appForm.getWeibull1Panel(),
						BorderLayout.CENTER);
				appForm.getFrame().repaint();
			}
		});
		weibull2PanelPrevButton.setBounds(406, 567, 89, 23);
		desktopPane.add(weibull2PanelPrevButton);

	}

	public Map<String, String> getAsMap() {
		Map<String, String> result = new LinkedHashMap<String, String>();
		result.put("FILES", getFilesValue());
		if (titleCheckBox.isSelected()) {
			result.put(titleCheckBox.getText(), titleTextField.getText());
		}

		if (titleCheckBox.isSelected()) {
			result.put(titleCheckBox.getText(), titleTextField.getText());
		}
		result.put("MODEL", getModelValue());
		if (statisticsCheckBox.isSelected()) {
			result.put("", (String) statisticsComboBox.getSelectedItem());
		}
		if (randomCheckBox.isSelected()) {
			result.put(randomCheckBox.getText(), getRandomValue());
		}
		if (integrateOutCheckBox.isSelected()) {
			result.put(integrateOutCheckBox.getText(), getIntegrateOutValue());
		}
		/*String jointModeValue = getIntegrateOutValue();
		if (Utils.isStringNotEmpty(jointModeValue)) {
			result.put(" ", jointModeValue);
		}*/

		if (stdErrorCheckBox.isSelected()) {
			result.put(stdErrorCheckBox.getText(), "");
		}
		if (convergenceCriterionCheckBox.isSelected()) {
			result.put(convergenceCriterionCheckBox.getText(),
					convergenceCriterionTextField.getText());
		}
		if (storageCheckBox.isSelected()) {
			result.put(storageCheckBox.getText(), (String) storageComboBox
					.getSelectedItem());
		}

		return result;
	}

	private String getIntegrateOutValue() {
		StringBuilder sb = new StringBuilder();
		if (jointModeCheckBox.isSelected()) {
			sb.append(jointModeCheckBox.getText());

			if (Utils.isStringNotEmpty(sb.toString())) {
				sb.append(" ");
			}
			if (backSolveCheckBox.isSelected()) {
				sb.append(backSolveCheckBox.getText() + " "
						+ backSolveTextField.getText());
			}
			if (Utils.isStringNotEmpty(sb.toString())) {
				sb.append(" ");
			}
			if (withinCheckBox.isSelected()) {
				sb.append(withinCheckBox.getText() + " "
						+ withinTextField.getText());
			}
		}
		return sb.toString();
	}

	private String getRandomValue() {
		StringBuilder sb = new StringBuilder();
		sb.append(randomTextField1.getText());
		if (estimateCheckBox1.isSelected()) {
			sb.append(" " + estimateCheckBox1.getText());
		}
		if (momentsCheckBox1.isSelected()) {
			sb.append(" " + momentsCheckBox1.getText());
		}
		
		if (Utils.isStringNotEmpty(momentsComboBox11.getSelectedItem().toString())) {
			sb.append(" " + momentsComboBox11.getSelectedItem());
		}
		
		if (Utils.isStringNotEmpty(momentsComboBox12.getSelectedItem().toString())) {
			sb.append(" " + momentsComboBox12.getSelectedItem());
		}
		
		if (Utils.isStringNotEmpty(momentsTextField1.getText())) {
			sb.append(" " + momentsTextField1.getText());
		}
		
		if (Utils.isStringNotEmpty(randomTextField2.getText())) {
			sb.append(" " + randomTextField2.getText());
		}
		if (estimateCheckBox2.isSelected()) {
			sb.append(" " + estimateCheckBox2.getText());
		}
		if (momentsCheckBox2.isSelected()) {
			sb.append(" " + momentsCheckBox2.getText());
		}
		
		if (Utils.isStringNotEmpty(momentsComboBox21.getSelectedItem().toString())) {
			sb.append(" " + momentsComboBox21.getSelectedItem());
		}
		
		if (Utils.isStringNotEmpty(momentsComboBox22.getSelectedItem().toString())) {
			sb.append(" " + momentsComboBox22.getSelectedItem());
		}
		
		if (Utils.isStringNotEmpty(momentsTextField2.getText())) {
			sb.append(" " + momentsTextField2.getText());
		}
		return sb.toString();
	}

	private String getModelValue() {
		StringBuilder sb = new StringBuilder();
		if (modelTextField11.getText() != null
				&& !modelTextField11.getText().equals("")) {
			sb.append(modelTextField11.getText());
		}
		if (modelTextField12.getText() != null
				&& !modelTextField12.getText().equals("")) {
			sb.append(" " + modelTextField12.getText());
		}
		if (modelTextField13.getText() != null
				&& !modelTextField13.getText().equals("")) {
			sb.append(" " + modelTextField13.getText());
		}
		if (modelTextField14.getText() != null
				&& !modelTextField14.getText().equals("")) {
			sb.append(" " + modelTextField14.getText());
		}
		if (modelTextField21.getText() != null
				&& !modelTextField21.getText().equals("")) {
			sb.append(" " + modelTextField21.getText());
		}
		if (modelTextField22.getText() != null
				&& !modelTextField22.getText().equals("")) {
			sb.append(" " + modelTextField22.getText());
		}
		if (modelTextField23.getText() != null
				&& !modelTextField23.getText().equals("")) {
			sb.append(" " + modelTextField23.getText());
		}
		if (modelTextField24.getText() != null
				&& !modelTextField24.getText().equals("")) {
			sb.append(" " + modelTextField24.getText());
		}
		return sb.toString();
	}

	private String getFilesValue() {
		StringBuilder sb = new StringBuilder();
		if (filesTextField11.getText() != null
				&& !filesTextField11.getText().equals("")) {
			sb.append(filesTextField11.getText());
		}
		if (filesTextField12.getText() != null
				&& !filesTextField12.getText().equals("")) {
			sb.append(" " + filesTextField12.getText());
		}
		if (filesTextField13.getText() != null
				&& !filesTextField13.getText().equals("")) {
			sb.append(" " + filesTextField13.getText());
		}
		if (filesTextField14.getText() != null
				&& !filesTextField14.getText().equals("")) {
			sb.append(" " + filesTextField14.getText());
		}
		if (filesTextField21.getText() != null
				&& !filesTextField21.getText().equals("")) {
			sb.append(" " + filesTextField21.getText());
		}
		if (filesTextField22.getText() != null
				&& !filesTextField22.getText().equals("")) {
			sb.append(" " + filesTextField22.getText());
		}

		return sb.toString();
	}

	private boolean checkMandatoryInputs() {
		boolean mandatoriesFilled = true;

		if (Utils.isStringEmpty(filesTextField11.getText())
				&& Utils.isStringEmpty(filesTextField12.getText())
				&& Utils.isStringEmpty(filesTextField13.getText())
				&& Utils.isStringEmpty(filesTextField14.getText())
				&& Utils.isStringEmpty(filesTextField21.getText())
				&& Utils.isStringEmpty(filesTextField22.getText())) {
			return false;
		}

		if (Utils.isStringEmpty(modelTextField11.getText())
				&& Utils.isStringEmpty(modelTextField12.getText())
				&& Utils.isStringEmpty(modelTextField13.getText())
				&& Utils.isStringEmpty(modelTextField14.getText())
				&& Utils.isStringEmpty(modelTextField21.getText())
				&& Utils.isStringEmpty(modelTextField22.getText())
				&& Utils.isStringEmpty(modelTextField23.getText())
				&& Utils.isStringEmpty(modelTextField24.getText())) {
			return false;
		}

		return mandatoriesFilled;
	}
}
